;(--------------Constants and arrays Declarations-------------
(declare-const T_RF (Array Int Int))
(declare-const T_DM (Array Int Int))
(declare-const T_IM (Array Int Int))

(declare-const T_Cache_Tag (Array (_ BitVec 2) Int))
(declare-const T_Cache_Data (Array (_ BitVec 2) Int))
(declare-const T_Cache_Valid (Array (_ BitVec 2) (_ BitVec 1)))

(declare-const T_PC (Int))
(declare-const X (Int))
(declare-const T_IP (_ BitVec 6))
(declare-const T_CP (_ BitVec 6))

(declare-const T_ROB_busy (Array (_ BitVec 6) (_ BitVec 1)))
(declare-const T_ROB_op_type (Array (_ BitVec 6) Int))
(declare-const T_ROB_destination (Array (_ BitVec 6) Int))
(declare-const T_ROB_result (Array (_ BitVec 6) Int))
(declare-const T_ROB_exception (Array (_ BitVec 6) (_ BitVec 1)))
(declare-const T_ROB_done (Array (_ BitVec 6) (_ BitVec 1)))

(declare-const T_RS_op_type (Array (_ BitVec 3) Int))
(declare-const T_RS_op (Array (_ BitVec 3) Int))
(declare-const T_RS_ROB_dst (Array (_ BitVec 3) (_ BitVec 6)))
(declare-const T_RS_vj (Array (_ BitVec 3) Int))
(declare-const T_RS_vk (Array (_ BitVec 3) Int))
(declare-const T_RS_qj (Array (_ BitVec 3) (_ BitVec 6)))
(declare-const T_RS_qk (Array (_ BitVec 3) (_ BitVec 6)))
(declare-const T_RS_imm (Array (_ BitVec 3) Int))
(declare-const T_RS_dis (Array (_ BitVec 3) (_ BitVec 1)))
(declare-const T_RS_busy (Array (_ BitVec 3) (_ BitVec 1)))
(declare-const T_RS_Ltag (Array (_ BitVec 3) (_ BitVec 6)))

(declare-const T_LSQ_op_type (Array (_ BitVec 3) Int))
(declare-const T_LSQ_op (Array (_ BitVec 3) Int))
(declare-const T_LSQ_ROB_dst (Array (_ BitVec 3) (_ BitVec 6)))
(declare-const T_LSQ_vj (Array (_ BitVec 3) Int))
(declare-const T_LSQ_vk (Array (_ BitVec 3) Int))
(declare-const T_LSQ_qj (Array (_ BitVec 3) (_ BitVec 6)))
(declare-const T_LSQ_qk (Array (_ BitVec 3) (_ BitVec 6)))
(declare-const T_LSQ_imm (Array (_ BitVec 3) Int))
(declare-const T_LSQ_dis (Array (_ BitVec 3) (_ BitVec 1)))
(declare-const T_LSQ_busy (Array (_ BitVec 3) (_ BitVec 1)))
(declare-const T_LSQ_Ltag (Array (_ BitVec 3) (_ BitVec 6)))


(declare-const T_Main_Ltag (_ BitVec 6))

(declare-const Rtype (Int))
(declare-const Branch (Int))
(declare-const Mul_div (Int))
(declare-const Load (Int))
(declare-const Store (Int))
(declare-const Jump (Int))
(declare-const Lfence (Int))

(declare-const U_path_stall (_ BitVec 1))

(declare-const int_bit_index (Int))
(declare-const int_bit_index2 (Int))

(declare-const empty_ROB_1bit (Array (_ BitVec 6) (_ BitVec 1)))
(declare-const empty_ROB_int (Array (_ BitVec 6) Int))

(declare-const empty_RS_LSQ_int (Array (_ BitVec 3) Int))
(declare-const empty_RS_LSQ_3bit (Array (_ BitVec 3) (_ BitVec 6)))
(declare-const empty_RS_LSQ_1bit (Array (_ BitVec 3) (_ BitVec 1)))

(declare-const any_rob (_ BitVec 6))
(declare-const any_rob_plus (_ BitVec 6))
(declare-const U4_any_rob (_ BitVec 6))
(declare-const T_any_rob_adder (_ BitVec 6))
(declare-const U4_any_rob_adder (_ BitVec 6))
(declare-const state_T_any_rob (_ BitVec 6))
(declare-const state_T_any_rob_plus (_ BitVec 6))
;)

;(--------------Functions--------------------------
(declare-fun Inst_op (Int) Int)
(declare-fun Inst_op_type (Int) Int)
(declare-fun Inst_rs (Int) Int)
(declare-fun Inst_rt (Int) Int)
(declare-fun Inst_rd (Int) Int)
(declare-fun Inst_imm (Int) Int)

(declare-fun ALU1 (Int Int Int Int) Int)
;(declare-fun ALU2_BR (Int Int Int Int) Int)
(declare-fun MUL_DIV (Int Int Int Int) Int)
(declare-fun LOAD_Unit (Int Int Int) Int)
(declare-fun STORE_Unit (Int Int Int) Int)

(define-fun subtract ((input (_ BitVec 6)) ) (_ BitVec 6)
	(let
		(
			(sub_one (bvsub input (_ bv1 6)))
		)
	(let
		(
			(output 
				(ite (= sub_one #b000000) (_ bv63 6)
					sub_one
				)
			)
		)
	))
)
(define-fun addition ((input (_ BitVec 6)) ) (_ BitVec 6)
	(let
		(
			(add_one (bvadd input (_ bv1 6)))
		)
	(let
		(
			(output 
				(ite (= add_one #b111111) (_ bv63 6)
					add_one
				)
			)
		)
	))
)

(define-fun ALU2_BR ((rs Int) (rt Int) (imm Int) (op Int)) Int
	(let
		(
			(output (ite (= op 1) 1 0))
		)
	)
)

(define-fun oldest_lfence ((rob_op_type (Array (_ BitVec 6) Int)) (CP (_ BitVec 6)) (IP (_ BitVec 6)) ) (_ BitVec 6)
	(let
		(
			(CP_p1 (bvadd (_ bv1 6) CP))
			(CP_p2 (bvadd (_ bv2 6) CP))
			(CP_p3 (bvadd (_ bv3 6) CP))
			(CP_p4 (bvadd (_ bv4 6) CP))
			(CP_p5 (bvadd (_ bv5 6) CP))
			(CP_p6 (bvadd (_ bv6 6) CP))
			(CP_p7 (bvadd (_ bv7 6) CP))
			(CP_p8 (bvadd (_ bv8 6) CP))
			(CP_p9 (bvadd (_ bv9 6) CP))
			(CP_p10 (bvadd (_ bv10 6) CP))
			(CP_p11 (bvadd (_ bv11 6) CP))
			(CP_p12 (bvadd (_ bv12 6) CP))
			(CP_p13 (bvadd (_ bv13 6) CP))
			(CP_p14 (bvadd (_ bv14 6) CP))
			(CP_p15 (bvadd (_ bv15 6) CP))
			(CP_p16 (bvadd (_ bv16 6) CP))
			(CP_p17 (bvadd (_ bv17 6) CP))
			(CP_p18 (bvadd (_ bv18 6) CP))
			(CP_p19 (bvadd (_ bv19 6) CP))
			(CP_p20 (bvadd (_ bv20 6) CP))
			(CP_p21 (bvadd (_ bv21 6) CP))
			(CP_p22 (bvadd (_ bv22 6) CP))
			(CP_p23 (bvadd (_ bv23 6) CP))
			(CP_p24 (bvadd (_ bv24 6) CP))
			(CP_p25 (bvadd (_ bv25 6) CP))
			(CP_p26 (bvadd (_ bv26 6) CP))
			(CP_p27 (bvadd (_ bv27 6) CP))
			(CP_p28 (bvadd (_ bv28 6) CP))
			(CP_p29 (bvadd (_ bv29 6) CP))
			(CP_p30 (bvadd (_ bv30 6) CP))
			(CP_p31 (bvadd (_ bv31 6) CP))
			(CP_p32 (bvadd (_ bv32 6) CP))
			(CP_p33 (bvadd (_ bv33 6) CP))
			(CP_p34 (bvadd (_ bv34 6) CP))
			(CP_p35 (bvadd (_ bv35 6) CP))
			(CP_p36 (bvadd (_ bv36 6) CP))
			(CP_p37 (bvadd (_ bv37 6) CP))
			(CP_p38 (bvadd (_ bv38 6) CP))
			(CP_p39 (bvadd (_ bv39 6) CP))
			(CP_p40 (bvadd (_ bv40 6) CP))
			(CP_p41 (bvadd (_ bv41 6) CP))
			(CP_p42 (bvadd (_ bv42 6) CP))
			(CP_p43 (bvadd (_ bv43 6) CP))
			(CP_p44 (bvadd (_ bv44 6) CP))
			(CP_p45 (bvadd (_ bv45 6) CP))
			(CP_p46 (bvadd (_ bv46 6) CP))
			(CP_p47 (bvadd (_ bv47 6) CP))
			(CP_p48 (bvadd (_ bv48 6) CP))
			(CP_p49 (bvadd (_ bv49 6) CP))
			(CP_p50 (bvadd (_ bv50 6) CP))
			(CP_p51 (bvadd (_ bv51 6) CP))
			(CP_p52 (bvadd (_ bv52 6) CP))
			(CP_p53 (bvadd (_ bv53 6) CP))
			(CP_p54 (bvadd (_ bv54 6) CP))
			(CP_p55 (bvadd (_ bv55 6) CP))
			(CP_p56 (bvadd (_ bv56 6) CP))
			(CP_p57 (bvadd (_ bv57 6) CP))
			(CP_p58 (bvadd (_ bv58 6) CP))
			(CP_p59 (bvadd (_ bv59 6) CP))
			(CP_p60 (bvadd (_ bv60 6) CP))
			(CP_p61 (bvadd (_ bv61 6) CP))
			(CP_p62 (bvadd (_ bv62 6) CP))
			(CP_p63 (bvadd (_ bv63 6) CP))
		)
	(let ((CP_p1 (ite (= CP_p1 IP) CP CP_p1)))
	(let ((CP_p2 (ite (= CP_p2 IP) CP_p1 CP_p2)))
	(let ((CP_p3 (ite (= CP_p3 IP) CP_p2 CP_p3)))
	(let ((CP_p4 (ite (= CP_p4 IP) CP_p3 CP_p4)))
	(let ((CP_p5 (ite (= CP_p5 IP) CP_p4 CP_p5)))
	(let ((CP_p6 (ite (= CP_p6 IP) CP_p5 CP_p6)))
	(let ((CP_p7 (ite (= CP_p7 IP) CP_p6 CP_p7)))
	(let ((CP_p8 (ite (= CP_p8 IP) CP_p7 CP_p8)))
	(let ((CP_p9 (ite (= CP_p9 IP) CP_p8 CP_p9)))
	(let ((CP_p10 (ite (= CP_p10 IP) CP_p9 CP_p10)))
	(let ((CP_p11 (ite (= CP_p11 IP) CP_p10 CP_p11)))
	(let ((CP_p12 (ite (= CP_p12 IP) CP_p11 CP_p12)))
	(let ((CP_p13 (ite (= CP_p13 IP) CP_p12 CP_p13)))
	(let ((CP_p14 (ite (= CP_p14 IP) CP_p13 CP_p14)))
	(let ((CP_p15 (ite (= CP_p15 IP) CP_p14 CP_p15)))
	(let ((CP_p16 (ite (= CP_p16 IP) CP_p15 CP_p16)))
	(let ((CP_p17 (ite (= CP_p17 IP) CP_p16 CP_p17)))
	(let ((CP_p18 (ite (= CP_p18 IP) CP_p17 CP_p18)))
	(let ((CP_p19 (ite (= CP_p19 IP) CP_p18 CP_p19)))
	(let ((CP_p20 (ite (= CP_p20 IP) CP_p19 CP_p20)))
	(let ((CP_p21 (ite (= CP_p21 IP) CP_p20 CP_p21)))
	(let ((CP_p22 (ite (= CP_p22 IP) CP_p21 CP_p22)))
	(let ((CP_p23 (ite (= CP_p23 IP) CP_p22 CP_p23)))
	(let ((CP_p24 (ite (= CP_p24 IP) CP_p23 CP_p24)))
	(let ((CP_p25 (ite (= CP_p25 IP) CP_p24 CP_p25)))
	(let ((CP_p26 (ite (= CP_p26 IP) CP_p25 CP_p26)))
	(let ((CP_p27 (ite (= CP_p27 IP) CP_p26 CP_p27)))
	(let ((CP_p28 (ite (= CP_p28 IP) CP_p27 CP_p28)))
	(let ((CP_p29 (ite (= CP_p29 IP) CP_p28 CP_p29)))
	(let ((CP_p30 (ite (= CP_p30 IP) CP_p29 CP_p30)))
	(let ((CP_p31 (ite (= CP_p31 IP) CP_p30 CP_p31)))
	(let ((CP_p32 (ite (= CP_p32 IP) CP_p31 CP_p32)))
	(let ((CP_p33 (ite (= CP_p33 IP) CP_p32 CP_p33)))
	(let ((CP_p34 (ite (= CP_p34 IP) CP_p33 CP_p34)))
	(let ((CP_p35 (ite (= CP_p35 IP) CP_p34 CP_p35)))
	(let ((CP_p36 (ite (= CP_p36 IP) CP_p35 CP_p36)))
	(let ((CP_p37 (ite (= CP_p37 IP) CP_p36 CP_p37)))
	(let ((CP_p38 (ite (= CP_p38 IP) CP_p37 CP_p38)))
	(let ((CP_p39 (ite (= CP_p39 IP) CP_p38 CP_p39)))
	(let ((CP_p40 (ite (= CP_p40 IP) CP_p39 CP_p40)))
	(let ((CP_p41 (ite (= CP_p41 IP) CP_p40 CP_p41)))
	(let ((CP_p42 (ite (= CP_p42 IP) CP_p41 CP_p42)))
	(let ((CP_p43 (ite (= CP_p43 IP) CP_p42 CP_p43)))
	(let ((CP_p44 (ite (= CP_p44 IP) CP_p43 CP_p44)))
	(let ((CP_p45 (ite (= CP_p45 IP) CP_p44 CP_p45)))
	(let ((CP_p46 (ite (= CP_p46 IP) CP_p45 CP_p46)))
	(let ((CP_p47 (ite (= CP_p47 IP) CP_p46 CP_p47)))
	(let ((CP_p48 (ite (= CP_p48 IP) CP_p47 CP_p48)))
	(let ((CP_p49 (ite (= CP_p49 IP) CP_p48 CP_p49)))
	(let ((CP_p50 (ite (= CP_p50 IP) CP_p49 CP_p50)))
	(let ((CP_p51 (ite (= CP_p51 IP) CP_p50 CP_p51)))
	(let ((CP_p52 (ite (= CP_p52 IP) CP_p51 CP_p52)))
	(let ((CP_p53 (ite (= CP_p53 IP) CP_p52 CP_p53)))
	(let ((CP_p54 (ite (= CP_p54 IP) CP_p53 CP_p54)))
	(let ((CP_p55 (ite (= CP_p55 IP) CP_p54 CP_p55)))
	(let ((CP_p56 (ite (= CP_p56 IP) CP_p55 CP_p56)))
	(let ((CP_p57 (ite (= CP_p57 IP) CP_p56 CP_p57)))
	(let ((CP_p58 (ite (= CP_p58 IP) CP_p57 CP_p58)))
	(let ((CP_p59 (ite (= CP_p59 IP) CP_p58 CP_p59)))
	(let ((CP_p60 (ite (= CP_p60 IP) CP_p59 CP_p60)))
	(let ((CP_p61 (ite (= CP_p61 IP) CP_p60 CP_p61)))
	(let ((CP_p62 (ite (= CP_p62 IP) CP_p61 CP_p62)))

	
		
	(let
		(
			(output
				(ite (= Lfence (select rob_op_type CP)) CP
				(ite (= Lfence (select rob_op_type CP_p1))  CP_p1
				(ite (= Lfence (select rob_op_type CP_p2))   CP_p2
				(ite (= Lfence (select rob_op_type CP_p3))   CP_p3
				(ite (= Lfence (select rob_op_type CP_p4))   CP_p4
				(ite (= Lfence (select rob_op_type CP_p5))   CP_p5
				(ite (= Lfence (select rob_op_type CP_p6))   CP_p6
				(ite (= Lfence (select rob_op_type CP_p7))   CP_p7
				(ite (= Lfence (select rob_op_type CP_p8))   CP_p8
				(ite (= Lfence (select rob_op_type CP_p9))   CP_p9
				(ite (= Lfence (select rob_op_type CP_p10))   CP_p10
				(ite (= Lfence (select rob_op_type CP_p11))   CP_p11
				(ite (= Lfence (select rob_op_type CP_p12))   CP_p12
				(ite (= Lfence (select rob_op_type CP_p13))   CP_p13
				(ite (= Lfence (select rob_op_type CP_p14))   CP_p14
				(ite (= Lfence (select rob_op_type CP_p15))   CP_p15
				(ite (= Lfence (select rob_op_type CP_p16))   CP_p16
				(ite (= Lfence (select rob_op_type CP_p17))   CP_p17
				(ite (= Lfence (select rob_op_type CP_p18))   CP_p18
				(ite (= Lfence (select rob_op_type CP_p19))   CP_p19
				(ite (= Lfence (select rob_op_type CP_p20))   CP_p20
				(ite (= Lfence (select rob_op_type CP_p21))   CP_p21
				(ite (= Lfence (select rob_op_type CP_p22))   CP_p22
				(ite (= Lfence (select rob_op_type CP_p23))   CP_p23
				(ite (= Lfence (select rob_op_type CP_p24))   CP_p24
				(ite (= Lfence (select rob_op_type CP_p25))   CP_p25
				(ite (= Lfence (select rob_op_type CP_p26))   CP_p26
				(ite (= Lfence (select rob_op_type CP_p27))   CP_p27
				(ite (= Lfence (select rob_op_type CP_p28))   CP_p28
				(ite (= Lfence (select rob_op_type CP_p29))   CP_p29
				(ite (= Lfence (select rob_op_type CP_p30))   CP_p30
				(ite (= Lfence (select rob_op_type CP_p31))   CP_p31
				(ite (= Lfence (select rob_op_type CP_p32))   CP_p32
				(ite (= Lfence (select rob_op_type CP_p33))   CP_p33
				(ite (= Lfence (select rob_op_type CP_p34))   CP_p34
				(ite (= Lfence (select rob_op_type CP_p35))   CP_p35
				(ite (= Lfence (select rob_op_type CP_p36))   CP_p36
				(ite (= Lfence (select rob_op_type CP_p37))   CP_p37
				(ite (= Lfence (select rob_op_type CP_p38))   CP_p38
				(ite (= Lfence (select rob_op_type CP_p39))   CP_p39
				(ite (= Lfence (select rob_op_type CP_p40))   CP_p40
				(ite (= Lfence (select rob_op_type CP_p41))   CP_p41
				(ite (= Lfence (select rob_op_type CP_p42))   CP_p42
				(ite (= Lfence (select rob_op_type CP_p43))   CP_p43
				(ite (= Lfence (select rob_op_type CP_p44))   CP_p44
				(ite (= Lfence (select rob_op_type CP_p45))   CP_p45
				(ite (= Lfence (select rob_op_type CP_p46))   CP_p46
				(ite (= Lfence (select rob_op_type CP_p47))   CP_p47
				(ite (= Lfence (select rob_op_type CP_p48))   CP_p48
				(ite (= Lfence (select rob_op_type CP_p49))   CP_p49
				(ite (= Lfence (select rob_op_type CP_p50))   CP_p50
				(ite (= Lfence (select rob_op_type CP_p51))   CP_p51
				(ite (= Lfence (select rob_op_type CP_p52))   CP_p52
				(ite (= Lfence (select rob_op_type CP_p53))   CP_p53
				(ite (= Lfence (select rob_op_type CP_p54))   CP_p54
				(ite (= Lfence (select rob_op_type CP_p55))   CP_p55
				(ite (= Lfence (select rob_op_type CP_p56))   CP_p56
				(ite (= Lfence (select rob_op_type CP_p57))   CP_p57
				(ite (= Lfence (select rob_op_type CP_p58))   CP_p58
				(ite (= Lfence (select rob_op_type CP_p59))   CP_p59
				(ite (= Lfence (select rob_op_type CP_p60))   CP_p60
				(ite (= Lfence (select rob_op_type CP_p61))   CP_p61
				(ite (= Lfence (select rob_op_type CP_p62))   CP_p62
				(_ bv0 6)
				)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
			)
		)
	))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
)
;)


;(--------------Visual Declarations-------------
(declare-const T_state_Cache0_Tag (Int))
(declare-const T_state_Cache1_Tag (Int))
(declare-const T_state_Cache2_Tag (Int))
(declare-const T_state_Cache3_Tag (Int))
(declare-const T_state_Cache0_Data (Int))
(declare-const T_state_Cache1_Data (Int))
(declare-const T_state_Cache2_Data (Int))
(declare-const T_state_Cache3_Data (Int))
(declare-const T_state_Cache0_Valid (_ BitVec 1))
(declare-const T_state_Cache1_Valid (_ BitVec 1))
(declare-const T_state_Cache2_Valid (_ BitVec 1))
(declare-const T_state_Cache3_Valid (_ BitVec 1))

(declare-const T_state_IP (_ BitVec 6))
(declare-const T_state_CP (_ BitVec 6))
(declare-const T_state_Main_Ltag (_ BitVec 6))
(declare-const T_state_PC (Int))

(declare-const T_state_ROB0_busy (_ BitVec 1))
(declare-const T_state_ROB0_op_type (Int))
(declare-const T_state_ROB0_destination (Int))
(declare-const T_state_ROB0_result (Int))
(declare-const T_state_ROB0_exception (_ BitVec 1))
(declare-const T_state_ROB0_done (_ BitVec 1))

(declare-const T_state_ROB1_busy (_ BitVec 1))
(declare-const T_state_ROB1_op_type (Int))
(declare-const T_state_ROB1_destination (Int))
(declare-const T_state_ROB1_result (Int))
(declare-const T_state_ROB1_exception (_ BitVec 1))
(declare-const T_state_ROB1_done (_ BitVec 1))

(declare-const T_state_ROB2_busy (_ BitVec 1))
(declare-const T_state_ROB2_op_type (Int))
(declare-const T_state_ROB2_destination (Int))
(declare-const T_state_ROB2_result (Int))
(declare-const T_state_ROB2_exception (_ BitVec 1))
(declare-const T_state_ROB2_done (_ BitVec 1))

(declare-const T_state_ROB3_busy (_ BitVec 1))
(declare-const T_state_ROB3_op_type (Int))
(declare-const T_state_ROB3_destination (Int))
(declare-const T_state_ROB3_result (Int))
(declare-const T_state_ROB3_exception (_ BitVec 1))
(declare-const T_state_ROB3_done (_ BitVec 1))

(declare-const T_state_ROB4_busy (_ BitVec 1))
(declare-const T_state_ROB4_op_type (Int))
(declare-const T_state_ROB4_destination (Int))
(declare-const T_state_ROB4_result (Int))
(declare-const T_state_ROB4_exception (_ BitVec 1))
(declare-const T_state_ROB4_done (_ BitVec 1))

(declare-const T_state_ROB5_busy (_ BitVec 1))
(declare-const T_state_ROB5_op_type (Int))
(declare-const T_state_ROB5_destination (Int))
(declare-const T_state_ROB5_result (Int))
(declare-const T_state_ROB5_exception (_ BitVec 1))
(declare-const T_state_ROB5_done (_ BitVec 1))

(declare-const T_state_ROB6_busy (_ BitVec 1))
(declare-const T_state_ROB6_op_type (Int))
(declare-const T_state_ROB6_destination (Int))
(declare-const T_state_ROB6_result (Int))
(declare-const T_state_ROB6_exception (_ BitVec 1))
(declare-const T_state_ROB6_done (_ BitVec 1))

(declare-const T_state_ROB7_busy (_ BitVec 1))
(declare-const T_state_ROB7_op_type (Int))
(declare-const T_state_ROB7_destination (Int))
(declare-const T_state_ROB7_result (Int))
(declare-const T_state_ROB7_exception (_ BitVec 1))
(declare-const T_state_ROB7_done (_ BitVec 1))

(declare-const T_state_RS0_op_type (Int))
(declare-const T_state_RS0_op (Int))
(declare-const T_state_RS0_ROB_dst (_ BitVec 6))
(declare-const T_state_RS0_vj (Int))
(declare-const T_state_RS0_vk (Int))
(declare-const T_state_RS0_qj (_ BitVec 6))
(declare-const T_state_RS0_qk (_ BitVec 6))
(declare-const T_state_RS0_imm (Int))
(declare-const T_state_RS0_dis (_ BitVec 1))
(declare-const T_state_RS0_busy (_ BitVec 1))
(declare-const T_state_RS0_Ltag (_ BitVec 6))

(declare-const T_state_RS1_op_type (Int))
(declare-const T_state_RS1_op (Int))
(declare-const T_state_RS1_ROB_dst (_ BitVec 6))
(declare-const T_state_RS1_vj (Int))
(declare-const T_state_RS1_vk (Int))
(declare-const T_state_RS1_qj (_ BitVec 6))
(declare-const T_state_RS1_qk (_ BitVec 6))
(declare-const T_state_RS1_imm (Int))
(declare-const T_state_RS1_dis (_ BitVec 1))
(declare-const T_state_RS1_busy (_ BitVec 1))
(declare-const T_state_RS1_Ltag (_ BitVec 6))

(declare-const T_state_RS2_op_type (Int))
(declare-const T_state_RS2_op (Int))
(declare-const T_state_RS2_ROB_dst (_ BitVec 6))
(declare-const T_state_RS2_vj (Int))
(declare-const T_state_RS2_vk (Int))
(declare-const T_state_RS2_qj (_ BitVec 6))
(declare-const T_state_RS2_qk (_ BitVec 6))
(declare-const T_state_RS2_imm (Int))
(declare-const T_state_RS2_dis (_ BitVec 1))
(declare-const T_state_RS2_busy (_ BitVec 1))
(declare-const T_state_RS2_Ltag (_ BitVec 6))

(declare-const T_state_RS3_op_type (Int))
(declare-const T_state_RS3_op (Int))
(declare-const T_state_RS3_ROB_dst (_ BitVec 6))
(declare-const T_state_RS3_vj (Int))
(declare-const T_state_RS3_vk (Int))
(declare-const T_state_RS3_qj (_ BitVec 6))
(declare-const T_state_RS3_qk (_ BitVec 6))
(declare-const T_state_RS3_imm (Int))
(declare-const T_state_RS3_dis (_ BitVec 1))
(declare-const T_state_RS3_busy (_ BitVec 1))
(declare-const T_state_RS3_Ltag (_ BitVec 6))

(declare-const T_state_RS4_op_type (Int))
(declare-const T_state_RS4_op (Int))
(declare-const T_state_RS4_ROB_dst (_ BitVec 6))
(declare-const T_state_RS4_vj (Int))
(declare-const T_state_RS4_vk (Int))
(declare-const T_state_RS4_qj (_ BitVec 6))
(declare-const T_state_RS4_qk (_ BitVec 6))
(declare-const T_state_RS4_imm (Int))
(declare-const T_state_RS4_dis (_ BitVec 1))
(declare-const T_state_RS4_busy (_ BitVec 1))
(declare-const T_state_RS4_Ltag (_ BitVec 6))

(declare-const T_state_RS5_op_type (Int))
(declare-const T_state_RS5_op (Int))
(declare-const T_state_RS5_ROB_dst (_ BitVec 6))
(declare-const T_state_RS5_vj (Int))
(declare-const T_state_RS5_vk (Int))
(declare-const T_state_RS5_qj (_ BitVec 6))
(declare-const T_state_RS5_qk (_ BitVec 6))
(declare-const T_state_RS5_imm (Int))
(declare-const T_state_RS5_dis (_ BitVec 1))
(declare-const T_state_RS5_busy (_ BitVec 1))
(declare-const T_state_RS5_Ltag (_ BitVec 6))

(declare-const T_state_RS6_op_type (Int))
(declare-const T_state_RS6_op (Int))
(declare-const T_state_RS6_ROB_dst (_ BitVec 6))
(declare-const T_state_RS6_vj (Int))
(declare-const T_state_RS6_vk (Int))
(declare-const T_state_RS6_qj (_ BitVec 6))
(declare-const T_state_RS6_qk (_ BitVec 6))
(declare-const T_state_RS6_imm (Int))
(declare-const T_state_RS6_dis (_ BitVec 1))
(declare-const T_state_RS6_busy (_ BitVec 1))
(declare-const T_state_RS6_Ltag (_ BitVec 6))

(declare-const T_state_RS7_op_type (Int))
(declare-const T_state_RS7_op (Int))
(declare-const T_state_RS7_ROB_dst (_ BitVec 6))
(declare-const T_state_RS7_vj (Int))
(declare-const T_state_RS7_vk (Int))
(declare-const T_state_RS7_qj (_ BitVec 6))
(declare-const T_state_RS7_qk (_ BitVec 6))
(declare-const T_state_RS7_imm (Int))
(declare-const T_state_RS7_dis (_ BitVec 1))
(declare-const T_state_RS7_busy (_ BitVec 1))
(declare-const T_state_RS7_Ltag (_ BitVec 6))

(declare-const T_state_LSQ0_op_type (Int))
(declare-const T_state_LSQ0_op (Int))
(declare-const T_state_LSQ0_ROB_dst (_ BitVec 6))
(declare-const T_state_LSQ0_vj (Int))
(declare-const T_state_LSQ0_vk (Int))
(declare-const T_state_LSQ0_qj (_ BitVec 6))
(declare-const T_state_LSQ0_qk (_ BitVec 6))
(declare-const T_state_LSQ0_imm (Int))
(declare-const T_state_LSQ0_dis (_ BitVec 1))
(declare-const T_state_LSQ0_busy (_ BitVec 1))
(declare-const T_state_LSQ0_Ltag (_ BitVec 6))

(declare-const T_state_LSQ1_op_type (Int))
(declare-const T_state_LSQ1_op (Int))
(declare-const T_state_LSQ1_ROB_dst (_ BitVec 6))
(declare-const T_state_LSQ1_vj (Int))
(declare-const T_state_LSQ1_vk (Int))
(declare-const T_state_LSQ1_qj (_ BitVec 6))
(declare-const T_state_LSQ1_qk (_ BitVec 6))
(declare-const T_state_LSQ1_imm (Int))
(declare-const T_state_LSQ1_dis (_ BitVec 1))
(declare-const T_state_LSQ1_busy (_ BitVec 1))
(declare-const T_state_LSQ1_Ltag (_ BitVec 6))

(declare-const T_state_LSQ2_op_type (Int))
(declare-const T_state_LSQ2_op (Int))
(declare-const T_state_LSQ2_ROB_dst (_ BitVec 6))
(declare-const T_state_LSQ2_vj (Int))
(declare-const T_state_LSQ2_vk (Int))
(declare-const T_state_LSQ2_qj (_ BitVec 6))
(declare-const T_state_LSQ2_qk (_ BitVec 6))
(declare-const T_state_LSQ2_imm (Int))
(declare-const T_state_LSQ2_dis (_ BitVec 1))
(declare-const T_state_LSQ2_busy (_ BitVec 1))
(declare-const T_state_LSQ2_Ltag (_ BitVec 6))

(declare-const T_state_LSQ3_op_type (Int))
(declare-const T_state_LSQ3_op (Int))
(declare-const T_state_LSQ3_ROB_dst (_ BitVec 6))
(declare-const T_state_LSQ3_vj (Int))
(declare-const T_state_LSQ3_vk (Int))
(declare-const T_state_LSQ3_qj (_ BitVec 6))
(declare-const T_state_LSQ3_qk (_ BitVec 6))
(declare-const T_state_LSQ3_imm (Int))
(declare-const T_state_LSQ3_dis (_ BitVec 1))
(declare-const T_state_LSQ3_busy (_ BitVec 1))
(declare-const T_state_LSQ3_Ltag (_ BitVec 6))

(declare-const T_state_LSQ4_op_type (Int))
(declare-const T_state_LSQ4_op (Int))
(declare-const T_state_LSQ4_ROB_dst (_ BitVec 6))
(declare-const T_state_LSQ4_vj (Int))
(declare-const T_state_LSQ4_vk (Int))
(declare-const T_state_LSQ4_qj (_ BitVec 6))
(declare-const T_state_LSQ4_qk (_ BitVec 6))
(declare-const T_state_LSQ4_imm (Int))
(declare-const T_state_LSQ4_dis (_ BitVec 1))
(declare-const T_state_LSQ4_busy (_ BitVec 1))
(declare-const T_state_LSQ4_Ltag (_ BitVec 6))

(declare-const T_state_LSQ5_op_type (Int))
(declare-const T_state_LSQ5_op (Int))
(declare-const T_state_LSQ5_ROB_dst (_ BitVec 6))
(declare-const T_state_LSQ5_vj (Int))
(declare-const T_state_LSQ5_vk (Int))
(declare-const T_state_LSQ5_qj (_ BitVec 6))
(declare-const T_state_LSQ5_qk (_ BitVec 6))
(declare-const T_state_LSQ5_imm (Int))
(declare-const T_state_LSQ5_dis (_ BitVec 1))
(declare-const T_state_LSQ5_busy (_ BitVec 1))
(declare-const T_state_LSQ5_Ltag (_ BitVec 6))

(declare-const T_state_LSQ6_op_type (Int))
(declare-const T_state_LSQ6_op (Int))
(declare-const T_state_LSQ6_ROB_dst (_ BitVec 6))
(declare-const T_state_LSQ6_vj (Int))
(declare-const T_state_LSQ6_vk (Int))
(declare-const T_state_LSQ6_qj (_ BitVec 6))
(declare-const T_state_LSQ6_qk (_ BitVec 6))
(declare-const T_state_LSQ6_imm (Int))
(declare-const T_state_LSQ6_dis (_ BitVec 1))
(declare-const T_state_LSQ6_busy (_ BitVec 1))
(declare-const T_state_LSQ6_Ltag (_ BitVec 6))

(declare-const T_state_LSQ7_op_type (Int))
(declare-const T_state_LSQ7_op (Int))
(declare-const T_state_LSQ7_ROB_dst (_ BitVec 6))
(declare-const T_state_LSQ7_vj (Int))
(declare-const T_state_LSQ7_vk (Int))
(declare-const T_state_LSQ7_qj (_ BitVec 6))
(declare-const T_state_LSQ7_qk (_ BitVec 6))
(declare-const T_state_LSQ7_imm (Int))
(declare-const T_state_LSQ7_dis (_ BitVec 1))
(declare-const T_state_LSQ7_busy (_ BitVec 1))
(declare-const T_state_LSQ7_Ltag (_ BitVec 6))

(declare-const U1_state_Cache0_Tag (Int))
(declare-const U1_state_Cache1_Tag (Int))
(declare-const U1_state_Cache2_Tag (Int))
(declare-const U1_state_Cache3_Tag (Int))
(declare-const U1_state_Cache0_Data (Int))
(declare-const U1_state_Cache1_Data (Int))
(declare-const U1_state_Cache2_Data (Int))
(declare-const U1_state_Cache3_Data (Int))
(declare-const U1_state_Cache0_Valid (_ BitVec 1))
(declare-const U1_state_Cache1_Valid (_ BitVec 1))
(declare-const U1_state_Cache2_Valid (_ BitVec 1))
(declare-const U1_state_Cache3_Valid (_ BitVec 1))

(declare-const U1_state_IP (_ BitVec 6))
(declare-const U1_state_CP (_ BitVec 6))
(declare-const U1_state_Main_Ltag (_ BitVec 6))
(declare-const U1_state_PC (Int))

(declare-const U1_state_ROB0_busy (_ BitVec 1))
(declare-const U1_state_ROB0_op_type (Int))
(declare-const U1_state_ROB0_destination (Int))
(declare-const U1_state_ROB0_result (Int))
(declare-const U1_state_ROB0_exception (_ BitVec 1))
(declare-const U1_state_ROB0_done (_ BitVec 1))

(declare-const U1_state_ROB1_busy (_ BitVec 1))
(declare-const U1_state_ROB1_op_type (Int))
(declare-const U1_state_ROB1_destination (Int))
(declare-const U1_state_ROB1_result (Int))
(declare-const U1_state_ROB1_exception (_ BitVec 1))
(declare-const U1_state_ROB1_done (_ BitVec 1))

(declare-const U1_state_ROB2_busy (_ BitVec 1))
(declare-const U1_state_ROB2_op_type (Int))
(declare-const U1_state_ROB2_destination (Int))
(declare-const U1_state_ROB2_result (Int))
(declare-const U1_state_ROB2_exception (_ BitVec 1))
(declare-const U1_state_ROB2_done (_ BitVec 1))

(declare-const U1_state_ROB3_busy (_ BitVec 1))
(declare-const U1_state_ROB3_op_type (Int))
(declare-const U1_state_ROB3_destination (Int))
(declare-const U1_state_ROB3_result (Int))
(declare-const U1_state_ROB3_exception (_ BitVec 1))
(declare-const U1_state_ROB3_done (_ BitVec 1))

(declare-const U1_state_ROB4_busy (_ BitVec 1))
(declare-const U1_state_ROB4_op_type (Int))
(declare-const U1_state_ROB4_destination (Int))
(declare-const U1_state_ROB4_result (Int))
(declare-const U1_state_ROB4_exception (_ BitVec 1))
(declare-const U1_state_ROB4_done (_ BitVec 1))

(declare-const U1_state_ROB5_busy (_ BitVec 1))
(declare-const U1_state_ROB5_op_type (Int))
(declare-const U1_state_ROB5_destination (Int))
(declare-const U1_state_ROB5_result (Int))
(declare-const U1_state_ROB5_exception (_ BitVec 1))
(declare-const U1_state_ROB5_done (_ BitVec 1))

(declare-const U1_state_ROB6_busy (_ BitVec 1))
(declare-const U1_state_ROB6_op_type (Int))
(declare-const U1_state_ROB6_destination (Int))
(declare-const U1_state_ROB6_result (Int))
(declare-const U1_state_ROB6_exception (_ BitVec 1))
(declare-const U1_state_ROB6_done (_ BitVec 1))

(declare-const U1_state_ROB7_busy (_ BitVec 1))
(declare-const U1_state_ROB7_op_type (Int))
(declare-const U1_state_ROB7_destination (Int))
(declare-const U1_state_ROB7_result (Int))
(declare-const U1_state_ROB7_exception (_ BitVec 1))
(declare-const U1_state_ROB7_done (_ BitVec 1))

(declare-const U1_state_RS0_op_type (Int))
(declare-const U1_state_RS0_op (Int))
(declare-const U1_state_RS0_ROB_dst (_ BitVec 6))
(declare-const U1_state_RS0_vj (Int))
(declare-const U1_state_RS0_vk (Int))
(declare-const U1_state_RS0_qj (_ BitVec 6))
(declare-const U1_state_RS0_qk (_ BitVec 6))
(declare-const U1_state_RS0_imm (Int))
(declare-const U1_state_RS0_dis (_ BitVec 1))
(declare-const U1_state_RS0_busy (_ BitVec 1))
(declare-const U1_state_RS0_Ltag (_ BitVec 6))

(declare-const U1_state_RS1_op_type (Int))
(declare-const U1_state_RS1_op (Int))
(declare-const U1_state_RS1_ROB_dst (_ BitVec 6))
(declare-const U1_state_RS1_vj (Int))
(declare-const U1_state_RS1_vk (Int))
(declare-const U1_state_RS1_qj (_ BitVec 6))
(declare-const U1_state_RS1_qk (_ BitVec 6))
(declare-const U1_state_RS1_imm (Int))
(declare-const U1_state_RS1_dis (_ BitVec 1))
(declare-const U1_state_RS1_busy (_ BitVec 1))
(declare-const U1_state_RS1_Ltag (_ BitVec 6))

(declare-const U1_state_RS2_op_type (Int))
(declare-const U1_state_RS2_op (Int))
(declare-const U1_state_RS2_ROB_dst (_ BitVec 6))
(declare-const U1_state_RS2_vj (Int))
(declare-const U1_state_RS2_vk (Int))
(declare-const U1_state_RS2_qj (_ BitVec 6))
(declare-const U1_state_RS2_qk (_ BitVec 6))
(declare-const U1_state_RS2_imm (Int))
(declare-const U1_state_RS2_dis (_ BitVec 1))
(declare-const U1_state_RS2_busy (_ BitVec 1))
(declare-const U1_state_RS2_Ltag (_ BitVec 6))

(declare-const U1_state_RS3_op_type (Int))
(declare-const U1_state_RS3_op (Int))
(declare-const U1_state_RS3_ROB_dst (_ BitVec 6))
(declare-const U1_state_RS3_vj (Int))
(declare-const U1_state_RS3_vk (Int))
(declare-const U1_state_RS3_qj (_ BitVec 6))
(declare-const U1_state_RS3_qk (_ BitVec 6))
(declare-const U1_state_RS3_imm (Int))
(declare-const U1_state_RS3_dis (_ BitVec 1))
(declare-const U1_state_RS3_busy (_ BitVec 1))
(declare-const U1_state_RS3_Ltag (_ BitVec 6))

(declare-const U1_state_RS4_op_type (Int))
(declare-const U1_state_RS4_op (Int))
(declare-const U1_state_RS4_ROB_dst (_ BitVec 6))
(declare-const U1_state_RS4_vj (Int))
(declare-const U1_state_RS4_vk (Int))
(declare-const U1_state_RS4_qj (_ BitVec 6))
(declare-const U1_state_RS4_qk (_ BitVec 6))
(declare-const U1_state_RS4_imm (Int))
(declare-const U1_state_RS4_dis (_ BitVec 1))
(declare-const U1_state_RS4_busy (_ BitVec 1))
(declare-const U1_state_RS4_Ltag (_ BitVec 6))

(declare-const U1_state_RS5_op_type (Int))
(declare-const U1_state_RS5_op (Int))
(declare-const U1_state_RS5_ROB_dst (_ BitVec 6))
(declare-const U1_state_RS5_vj (Int))
(declare-const U1_state_RS5_vk (Int))
(declare-const U1_state_RS5_qj (_ BitVec 6))
(declare-const U1_state_RS5_qk (_ BitVec 6))
(declare-const U1_state_RS5_imm (Int))
(declare-const U1_state_RS5_dis (_ BitVec 1))
(declare-const U1_state_RS5_busy (_ BitVec 1))
(declare-const U1_state_RS5_Ltag (_ BitVec 6))

(declare-const U1_state_RS6_op_type (Int))
(declare-const U1_state_RS6_op (Int))
(declare-const U1_state_RS6_ROB_dst (_ BitVec 6))
(declare-const U1_state_RS6_vj (Int))
(declare-const U1_state_RS6_vk (Int))
(declare-const U1_state_RS6_qj (_ BitVec 6))
(declare-const U1_state_RS6_qk (_ BitVec 6))
(declare-const U1_state_RS6_imm (Int))
(declare-const U1_state_RS6_dis (_ BitVec 1))
(declare-const U1_state_RS6_busy (_ BitVec 1))
(declare-const U1_state_RS6_Ltag (_ BitVec 6))

(declare-const U1_state_RS7_op_type (Int))
(declare-const U1_state_RS7_op (Int))
(declare-const U1_state_RS7_ROB_dst (_ BitVec 6))
(declare-const U1_state_RS7_vj (Int))
(declare-const U1_state_RS7_vk (Int))
(declare-const U1_state_RS7_qj (_ BitVec 6))
(declare-const U1_state_RS7_qk (_ BitVec 6))
(declare-const U1_state_RS7_imm (Int))
(declare-const U1_state_RS7_dis (_ BitVec 1))
(declare-const U1_state_RS7_busy (_ BitVec 1))
(declare-const U1_state_RS7_Ltag (_ BitVec 6))

(declare-const U1_state_LSQ0_op_type (Int))
(declare-const U1_state_LSQ0_op (Int))
(declare-const U1_state_LSQ0_ROB_dst (_ BitVec 6))
(declare-const U1_state_LSQ0_vj (Int))
(declare-const U1_state_LSQ0_vk (Int))
(declare-const U1_state_LSQ0_qj (_ BitVec 6))
(declare-const U1_state_LSQ0_qk (_ BitVec 6))
(declare-const U1_state_LSQ0_imm (Int))
(declare-const U1_state_LSQ0_dis (_ BitVec 1))
(declare-const U1_state_LSQ0_busy (_ BitVec 1))
(declare-const U1_state_LSQ0_Ltag (_ BitVec 6))

(declare-const U1_state_LSQ1_op_type (Int))
(declare-const U1_state_LSQ1_op (Int))
(declare-const U1_state_LSQ1_ROB_dst (_ BitVec 6))
(declare-const U1_state_LSQ1_vj (Int))
(declare-const U1_state_LSQ1_vk (Int))
(declare-const U1_state_LSQ1_qj (_ BitVec 6))
(declare-const U1_state_LSQ1_qk (_ BitVec 6))
(declare-const U1_state_LSQ1_imm (Int))
(declare-const U1_state_LSQ1_dis (_ BitVec 1))
(declare-const U1_state_LSQ1_busy (_ BitVec 1))
(declare-const U1_state_LSQ1_Ltag (_ BitVec 6))

(declare-const U1_state_LSQ2_op_type (Int))
(declare-const U1_state_LSQ2_op (Int))
(declare-const U1_state_LSQ2_ROB_dst (_ BitVec 6))
(declare-const U1_state_LSQ2_vj (Int))
(declare-const U1_state_LSQ2_vk (Int))
(declare-const U1_state_LSQ2_qj (_ BitVec 6))
(declare-const U1_state_LSQ2_qk (_ BitVec 6))
(declare-const U1_state_LSQ2_imm (Int))
(declare-const U1_state_LSQ2_dis (_ BitVec 1))
(declare-const U1_state_LSQ2_busy (_ BitVec 1))
(declare-const U1_state_LSQ2_Ltag (_ BitVec 6))

(declare-const U1_state_LSQ3_op_type (Int))
(declare-const U1_state_LSQ3_op (Int))
(declare-const U1_state_LSQ3_ROB_dst (_ BitVec 6))
(declare-const U1_state_LSQ3_vj (Int))
(declare-const U1_state_LSQ3_vk (Int))
(declare-const U1_state_LSQ3_qj (_ BitVec 6))
(declare-const U1_state_LSQ3_qk (_ BitVec 6))
(declare-const U1_state_LSQ3_imm (Int))
(declare-const U1_state_LSQ3_dis (_ BitVec 1))
(declare-const U1_state_LSQ3_busy (_ BitVec 1))
(declare-const U1_state_LSQ3_Ltag (_ BitVec 6))

(declare-const U1_state_LSQ4_op_type (Int))
(declare-const U1_state_LSQ4_op (Int))
(declare-const U1_state_LSQ4_ROB_dst (_ BitVec 6))
(declare-const U1_state_LSQ4_vj (Int))
(declare-const U1_state_LSQ4_vk (Int))
(declare-const U1_state_LSQ4_qj (_ BitVec 6))
(declare-const U1_state_LSQ4_qk (_ BitVec 6))
(declare-const U1_state_LSQ4_imm (Int))
(declare-const U1_state_LSQ4_dis (_ BitVec 1))
(declare-const U1_state_LSQ4_busy (_ BitVec 1))
(declare-const U1_state_LSQ4_Ltag (_ BitVec 6))

(declare-const U1_state_LSQ5_op_type (Int))
(declare-const U1_state_LSQ5_op (Int))
(declare-const U1_state_LSQ5_ROB_dst (_ BitVec 6))
(declare-const U1_state_LSQ5_vj (Int))
(declare-const U1_state_LSQ5_vk (Int))
(declare-const U1_state_LSQ5_qj (_ BitVec 6))
(declare-const U1_state_LSQ5_qk (_ BitVec 6))
(declare-const U1_state_LSQ5_imm (Int))
(declare-const U1_state_LSQ5_dis (_ BitVec 1))
(declare-const U1_state_LSQ5_busy (_ BitVec 1))
(declare-const U1_state_LSQ5_Ltag (_ BitVec 6))

(declare-const U1_state_LSQ6_op_type (Int))
(declare-const U1_state_LSQ6_op (Int))
(declare-const U1_state_LSQ6_ROB_dst (_ BitVec 6))
(declare-const U1_state_LSQ6_vj (Int))
(declare-const U1_state_LSQ6_vk (Int))
(declare-const U1_state_LSQ6_qj (_ BitVec 6))
(declare-const U1_state_LSQ6_qk (_ BitVec 6))
(declare-const U1_state_LSQ6_imm (Int))
(declare-const U1_state_LSQ6_dis (_ BitVec 1))
(declare-const U1_state_LSQ6_busy (_ BitVec 1))
(declare-const U1_state_LSQ6_Ltag (_ BitVec 6))

(declare-const U1_state_LSQ7_op_type (Int))
(declare-const U1_state_LSQ7_op (Int))
(declare-const U1_state_LSQ7_ROB_dst (_ BitVec 6))
(declare-const U1_state_LSQ7_vj (Int))
(declare-const U1_state_LSQ7_vk (Int))
(declare-const U1_state_LSQ7_qj (_ BitVec 6))
(declare-const U1_state_LSQ7_qk (_ BitVec 6))
(declare-const U1_state_LSQ7_imm (Int))
(declare-const U1_state_LSQ7_dis (_ BitVec 1))
(declare-const U1_state_LSQ7_busy (_ BitVec 1))
(declare-const U1_state_LSQ7_Ltag (_ BitVec 6))


(declare-const U2_state_Cache0_Tag (Int))
(declare-const U2_state_Cache1_Tag (Int))
(declare-const U2_state_Cache2_Tag (Int))
(declare-const U2_state_Cache3_Tag (Int))
(declare-const U2_state_Cache0_Data (Int))
(declare-const U2_state_Cache1_Data (Int))
(declare-const U2_state_Cache2_Data (Int))
(declare-const U2_state_Cache3_Data (Int))
(declare-const U2_state_Cache0_Valid (_ BitVec 1))
(declare-const U2_state_Cache1_Valid (_ BitVec 1))
(declare-const U2_state_Cache2_Valid (_ BitVec 1))
(declare-const U2_state_Cache3_Valid (_ BitVec 1))

(declare-const U2_state_IP (_ BitVec 6))
(declare-const U2_state_CP (_ BitVec 6))
(declare-const U2_state_Main_Ltag (_ BitVec 6))
(declare-const U2_state_PC (Int))

(declare-const U2_state_ROB0_busy (_ BitVec 1))
(declare-const U2_state_ROB0_op_type (Int))
(declare-const U2_state_ROB0_destination (Int))
(declare-const U2_state_ROB0_result (Int))
(declare-const U2_state_ROB0_exception (_ BitVec 1))
(declare-const U2_state_ROB0_done (_ BitVec 1))

(declare-const U2_state_ROB1_busy (_ BitVec 1))
(declare-const U2_state_ROB1_op_type (Int))
(declare-const U2_state_ROB1_destination (Int))
(declare-const U2_state_ROB1_result (Int))
(declare-const U2_state_ROB1_exception (_ BitVec 1))
(declare-const U2_state_ROB1_done (_ BitVec 1))

(declare-const U2_state_ROB2_busy (_ BitVec 1))
(declare-const U2_state_ROB2_op_type (Int))
(declare-const U2_state_ROB2_destination (Int))
(declare-const U2_state_ROB2_result (Int))
(declare-const U2_state_ROB2_exception (_ BitVec 1))
(declare-const U2_state_ROB2_done (_ BitVec 1))

(declare-const U2_state_ROB3_busy (_ BitVec 1))
(declare-const U2_state_ROB3_op_type (Int))
(declare-const U2_state_ROB3_destination (Int))
(declare-const U2_state_ROB3_result (Int))
(declare-const U2_state_ROB3_exception (_ BitVec 1))
(declare-const U2_state_ROB3_done (_ BitVec 1))

(declare-const U2_state_ROB4_busy (_ BitVec 1))
(declare-const U2_state_ROB4_op_type (Int))
(declare-const U2_state_ROB4_destination (Int))
(declare-const U2_state_ROB4_result (Int))
(declare-const U2_state_ROB4_exception (_ BitVec 1))
(declare-const U2_state_ROB4_done (_ BitVec 1))

(declare-const U2_state_ROB5_busy (_ BitVec 1))
(declare-const U2_state_ROB5_op_type (Int))
(declare-const U2_state_ROB5_destination (Int))
(declare-const U2_state_ROB5_result (Int))
(declare-const U2_state_ROB5_exception (_ BitVec 1))
(declare-const U2_state_ROB5_done (_ BitVec 1))

(declare-const U2_state_ROB6_busy (_ BitVec 1))
(declare-const U2_state_ROB6_op_type (Int))
(declare-const U2_state_ROB6_destination (Int))
(declare-const U2_state_ROB6_result (Int))
(declare-const U2_state_ROB6_exception (_ BitVec 1))
(declare-const U2_state_ROB6_done (_ BitVec 1))

(declare-const U2_state_ROB7_busy (_ BitVec 1))
(declare-const U2_state_ROB7_op_type (Int))
(declare-const U2_state_ROB7_destination (Int))
(declare-const U2_state_ROB7_result (Int))
(declare-const U2_state_ROB7_exception (_ BitVec 1))
(declare-const U2_state_ROB7_done (_ BitVec 1))

(declare-const U2_state_RS0_op_type (Int))
(declare-const U2_state_RS0_op (Int))
(declare-const U2_state_RS0_ROB_dst (_ BitVec 6))
(declare-const U2_state_RS0_vj (Int))
(declare-const U2_state_RS0_vk (Int))
(declare-const U2_state_RS0_qj (_ BitVec 6))
(declare-const U2_state_RS0_qk (_ BitVec 6))
(declare-const U2_state_RS0_imm (Int))
(declare-const U2_state_RS0_dis (_ BitVec 1))
(declare-const U2_state_RS0_busy (_ BitVec 1))
(declare-const U2_state_RS0_Ltag (_ BitVec 6))

(declare-const U2_state_RS1_op_type (Int))
(declare-const U2_state_RS1_op (Int))
(declare-const U2_state_RS1_ROB_dst (_ BitVec 6))
(declare-const U2_state_RS1_vj (Int))
(declare-const U2_state_RS1_vk (Int))
(declare-const U2_state_RS1_qj (_ BitVec 6))
(declare-const U2_state_RS1_qk (_ BitVec 6))
(declare-const U2_state_RS1_imm (Int))
(declare-const U2_state_RS1_dis (_ BitVec 1))
(declare-const U2_state_RS1_busy (_ BitVec 1))
(declare-const U2_state_RS1_Ltag (_ BitVec 6))

(declare-const U2_state_RS2_op_type (Int))
(declare-const U2_state_RS2_op (Int))
(declare-const U2_state_RS2_ROB_dst (_ BitVec 6))
(declare-const U2_state_RS2_vj (Int))
(declare-const U2_state_RS2_vk (Int))
(declare-const U2_state_RS2_qj (_ BitVec 6))
(declare-const U2_state_RS2_qk (_ BitVec 6))
(declare-const U2_state_RS2_imm (Int))
(declare-const U2_state_RS2_dis (_ BitVec 1))
(declare-const U2_state_RS2_busy (_ BitVec 1))
(declare-const U2_state_RS2_Ltag (_ BitVec 6))

(declare-const U2_state_RS3_op_type (Int))
(declare-const U2_state_RS3_op (Int))
(declare-const U2_state_RS3_ROB_dst (_ BitVec 6))
(declare-const U2_state_RS3_vj (Int))
(declare-const U2_state_RS3_vk (Int))
(declare-const U2_state_RS3_qj (_ BitVec 6))
(declare-const U2_state_RS3_qk (_ BitVec 6))
(declare-const U2_state_RS3_imm (Int))
(declare-const U2_state_RS3_dis (_ BitVec 1))
(declare-const U2_state_RS3_busy (_ BitVec 1))
(declare-const U2_state_RS3_Ltag (_ BitVec 6))

(declare-const U2_state_RS4_op_type (Int))
(declare-const U2_state_RS4_op (Int))
(declare-const U2_state_RS4_ROB_dst (_ BitVec 6))
(declare-const U2_state_RS4_vj (Int))
(declare-const U2_state_RS4_vk (Int))
(declare-const U2_state_RS4_qj (_ BitVec 6))
(declare-const U2_state_RS4_qk (_ BitVec 6))
(declare-const U2_state_RS4_imm (Int))
(declare-const U2_state_RS4_dis (_ BitVec 1))
(declare-const U2_state_RS4_busy (_ BitVec 1))
(declare-const U2_state_RS4_Ltag (_ BitVec 6))

(declare-const U2_state_RS5_op_type (Int))
(declare-const U2_state_RS5_op (Int))
(declare-const U2_state_RS5_ROB_dst (_ BitVec 6))
(declare-const U2_state_RS5_vj (Int))
(declare-const U2_state_RS5_vk (Int))
(declare-const U2_state_RS5_qj (_ BitVec 6))
(declare-const U2_state_RS5_qk (_ BitVec 6))
(declare-const U2_state_RS5_imm (Int))
(declare-const U2_state_RS5_dis (_ BitVec 1))
(declare-const U2_state_RS5_busy (_ BitVec 1))
(declare-const U2_state_RS5_Ltag (_ BitVec 6))

(declare-const U2_state_RS6_op_type (Int))
(declare-const U2_state_RS6_op (Int))
(declare-const U2_state_RS6_ROB_dst (_ BitVec 6))
(declare-const U2_state_RS6_vj (Int))
(declare-const U2_state_RS6_vk (Int))
(declare-const U2_state_RS6_qj (_ BitVec 6))
(declare-const U2_state_RS6_qk (_ BitVec 6))
(declare-const U2_state_RS6_imm (Int))
(declare-const U2_state_RS6_dis (_ BitVec 1))
(declare-const U2_state_RS6_busy (_ BitVec 1))
(declare-const U2_state_RS6_Ltag (_ BitVec 6))

(declare-const U2_state_RS7_op_type (Int))
(declare-const U2_state_RS7_op (Int))
(declare-const U2_state_RS7_ROB_dst (_ BitVec 6))
(declare-const U2_state_RS7_vj (Int))
(declare-const U2_state_RS7_vk (Int))
(declare-const U2_state_RS7_qj (_ BitVec 6))
(declare-const U2_state_RS7_qk (_ BitVec 6))
(declare-const U2_state_RS7_imm (Int))
(declare-const U2_state_RS7_dis (_ BitVec 1))
(declare-const U2_state_RS7_busy (_ BitVec 1))
(declare-const U2_state_RS7_Ltag (_ BitVec 6))

(declare-const U2_state_LSQ0_op_type (Int))
(declare-const U2_state_LSQ0_op (Int))
(declare-const U2_state_LSQ0_ROB_dst (_ BitVec 6))
(declare-const U2_state_LSQ0_vj (Int))
(declare-const U2_state_LSQ0_vk (Int))
(declare-const U2_state_LSQ0_qj (_ BitVec 6))
(declare-const U2_state_LSQ0_qk (_ BitVec 6))
(declare-const U2_state_LSQ0_imm (Int))
(declare-const U2_state_LSQ0_dis (_ BitVec 1))
(declare-const U2_state_LSQ0_busy (_ BitVec 1))
(declare-const U2_state_LSQ0_Ltag (_ BitVec 6))

(declare-const U2_state_LSQ1_op_type (Int))
(declare-const U2_state_LSQ1_op (Int))
(declare-const U2_state_LSQ1_ROB_dst (_ BitVec 6))
(declare-const U2_state_LSQ1_vj (Int))
(declare-const U2_state_LSQ1_vk (Int))
(declare-const U2_state_LSQ1_qj (_ BitVec 6))
(declare-const U2_state_LSQ1_qk (_ BitVec 6))
(declare-const U2_state_LSQ1_imm (Int))
(declare-const U2_state_LSQ1_dis (_ BitVec 1))
(declare-const U2_state_LSQ1_busy (_ BitVec 1))
(declare-const U2_state_LSQ1_Ltag (_ BitVec 6))

(declare-const U2_state_LSQ2_op_type (Int))
(declare-const U2_state_LSQ2_op (Int))
(declare-const U2_state_LSQ2_ROB_dst (_ BitVec 6))
(declare-const U2_state_LSQ2_vj (Int))
(declare-const U2_state_LSQ2_vk (Int))
(declare-const U2_state_LSQ2_qj (_ BitVec 6))
(declare-const U2_state_LSQ2_qk (_ BitVec 6))
(declare-const U2_state_LSQ2_imm (Int))
(declare-const U2_state_LSQ2_dis (_ BitVec 1))
(declare-const U2_state_LSQ2_busy (_ BitVec 1))
(declare-const U2_state_LSQ2_Ltag (_ BitVec 6))

(declare-const U2_state_LSQ3_op_type (Int))
(declare-const U2_state_LSQ3_op (Int))
(declare-const U2_state_LSQ3_ROB_dst (_ BitVec 6))
(declare-const U2_state_LSQ3_vj (Int))
(declare-const U2_state_LSQ3_vk (Int))
(declare-const U2_state_LSQ3_qj (_ BitVec 6))
(declare-const U2_state_LSQ3_qk (_ BitVec 6))
(declare-const U2_state_LSQ3_imm (Int))
(declare-const U2_state_LSQ3_dis (_ BitVec 1))
(declare-const U2_state_LSQ3_busy (_ BitVec 1))
(declare-const U2_state_LSQ3_Ltag (_ BitVec 6))

(declare-const U2_state_LSQ4_op_type (Int))
(declare-const U2_state_LSQ4_op (Int))
(declare-const U2_state_LSQ4_ROB_dst (_ BitVec 6))
(declare-const U2_state_LSQ4_vj (Int))
(declare-const U2_state_LSQ4_vk (Int))
(declare-const U2_state_LSQ4_qj (_ BitVec 6))
(declare-const U2_state_LSQ4_qk (_ BitVec 6))
(declare-const U2_state_LSQ4_imm (Int))
(declare-const U2_state_LSQ4_dis (_ BitVec 1))
(declare-const U2_state_LSQ4_busy (_ BitVec 1))
(declare-const U2_state_LSQ4_Ltag (_ BitVec 6))

(declare-const U2_state_LSQ5_op_type (Int))
(declare-const U2_state_LSQ5_op (Int))
(declare-const U2_state_LSQ5_ROB_dst (_ BitVec 6))
(declare-const U2_state_LSQ5_vj (Int))
(declare-const U2_state_LSQ5_vk (Int))
(declare-const U2_state_LSQ5_qj (_ BitVec 6))
(declare-const U2_state_LSQ5_qk (_ BitVec 6))
(declare-const U2_state_LSQ5_imm (Int))
(declare-const U2_state_LSQ5_dis (_ BitVec 1))
(declare-const U2_state_LSQ5_busy (_ BitVec 1))
(declare-const U2_state_LSQ5_Ltag (_ BitVec 6))

(declare-const U2_state_LSQ6_op_type (Int))
(declare-const U2_state_LSQ6_op (Int))
(declare-const U2_state_LSQ6_ROB_dst (_ BitVec 6))
(declare-const U2_state_LSQ6_vj (Int))
(declare-const U2_state_LSQ6_vk (Int))
(declare-const U2_state_LSQ6_qj (_ BitVec 6))
(declare-const U2_state_LSQ6_qk (_ BitVec 6))
(declare-const U2_state_LSQ6_imm (Int))
(declare-const U2_state_LSQ6_dis (_ BitVec 1))
(declare-const U2_state_LSQ6_busy (_ BitVec 1))
(declare-const U2_state_LSQ6_Ltag (_ BitVec 6))

(declare-const U2_state_LSQ7_op_type (Int))
(declare-const U2_state_LSQ7_op (Int))
(declare-const U2_state_LSQ7_ROB_dst (_ BitVec 6))
(declare-const U2_state_LSQ7_vj (Int))
(declare-const U2_state_LSQ7_vk (Int))
(declare-const U2_state_LSQ7_qj (_ BitVec 6))
(declare-const U2_state_LSQ7_qk (_ BitVec 6))
(declare-const U2_state_LSQ7_imm (Int))
(declare-const U2_state_LSQ7_dis (_ BitVec 1))
(declare-const U2_state_LSQ7_busy (_ BitVec 1))
(declare-const U2_state_LSQ7_Ltag (_ BitVec 6))


(declare-const U3_state_Cache0_Tag (Int))
(declare-const U3_state_Cache1_Tag (Int))
(declare-const U3_state_Cache2_Tag (Int))
(declare-const U3_state_Cache3_Tag (Int))
(declare-const U3_state_Cache0_Data (Int))
(declare-const U3_state_Cache1_Data (Int))
(declare-const U3_state_Cache2_Data (Int))
(declare-const U3_state_Cache3_Data (Int))
(declare-const U3_state_Cache0_Valid (_ BitVec 1))
(declare-const U3_state_Cache1_Valid (_ BitVec 1))
(declare-const U3_state_Cache2_Valid (_ BitVec 1))
(declare-const U3_state_Cache3_Valid (_ BitVec 1))

(declare-const U3_state_IP (_ BitVec 6))
(declare-const U3_state_CP (_ BitVec 6))
(declare-const U3_state_Main_Ltag (_ BitVec 6))
(declare-const U3_state_PC (Int))

(declare-const U3_state_ROB0_busy (_ BitVec 1))
(declare-const U3_state_ROB0_op_type (Int))
(declare-const U3_state_ROB0_destination (Int))
(declare-const U3_state_ROB0_result (Int))
(declare-const U3_state_ROB0_exception (_ BitVec 1))
(declare-const U3_state_ROB0_done (_ BitVec 1))

(declare-const U3_state_ROB1_busy (_ BitVec 1))
(declare-const U3_state_ROB1_op_type (Int))
(declare-const U3_state_ROB1_destination (Int))
(declare-const U3_state_ROB1_result (Int))
(declare-const U3_state_ROB1_exception (_ BitVec 1))
(declare-const U3_state_ROB1_done (_ BitVec 1))

(declare-const U3_state_ROB2_busy (_ BitVec 1))
(declare-const U3_state_ROB2_op_type (Int))
(declare-const U3_state_ROB2_destination (Int))
(declare-const U3_state_ROB2_result (Int))
(declare-const U3_state_ROB2_exception (_ BitVec 1))
(declare-const U3_state_ROB2_done (_ BitVec 1))

(declare-const U3_state_ROB3_busy (_ BitVec 1))
(declare-const U3_state_ROB3_op_type (Int))
(declare-const U3_state_ROB3_destination (Int))
(declare-const U3_state_ROB3_result (Int))
(declare-const U3_state_ROB3_exception (_ BitVec 1))
(declare-const U3_state_ROB3_done (_ BitVec 1))

(declare-const U3_state_ROB4_busy (_ BitVec 1))
(declare-const U3_state_ROB4_op_type (Int))
(declare-const U3_state_ROB4_destination (Int))
(declare-const U3_state_ROB4_result (Int))
(declare-const U3_state_ROB4_exception (_ BitVec 1))
(declare-const U3_state_ROB4_done (_ BitVec 1))

(declare-const U3_state_ROB5_busy (_ BitVec 1))
(declare-const U3_state_ROB5_op_type (Int))
(declare-const U3_state_ROB5_destination (Int))
(declare-const U3_state_ROB5_result (Int))
(declare-const U3_state_ROB5_exception (_ BitVec 1))
(declare-const U3_state_ROB5_done (_ BitVec 1))

(declare-const U3_state_ROB6_busy (_ BitVec 1))
(declare-const U3_state_ROB6_op_type (Int))
(declare-const U3_state_ROB6_destination (Int))
(declare-const U3_state_ROB6_result (Int))
(declare-const U3_state_ROB6_exception (_ BitVec 1))
(declare-const U3_state_ROB6_done (_ BitVec 1))

(declare-const U3_state_ROB7_busy (_ BitVec 1))
(declare-const U3_state_ROB7_op_type (Int))
(declare-const U3_state_ROB7_destination (Int))
(declare-const U3_state_ROB7_result (Int))
(declare-const U3_state_ROB7_exception (_ BitVec 1))
(declare-const U3_state_ROB7_done (_ BitVec 1))

(declare-const U3_state_RS0_op_type (Int))
(declare-const U3_state_RS0_op (Int))
(declare-const U3_state_RS0_ROB_dst (_ BitVec 6))
(declare-const U3_state_RS0_vj (Int))
(declare-const U3_state_RS0_vk (Int))
(declare-const U3_state_RS0_qj (_ BitVec 6))
(declare-const U3_state_RS0_qk (_ BitVec 6))
(declare-const U3_state_RS0_imm (Int))
(declare-const U3_state_RS0_dis (_ BitVec 1))
(declare-const U3_state_RS0_busy (_ BitVec 1))
(declare-const U3_state_RS0_Ltag (_ BitVec 6))

(declare-const U3_state_RS1_op_type (Int))
(declare-const U3_state_RS1_op (Int))
(declare-const U3_state_RS1_ROB_dst (_ BitVec 6))
(declare-const U3_state_RS1_vj (Int))
(declare-const U3_state_RS1_vk (Int))
(declare-const U3_state_RS1_qj (_ BitVec 6))
(declare-const U3_state_RS1_qk (_ BitVec 6))
(declare-const U3_state_RS1_imm (Int))
(declare-const U3_state_RS1_dis (_ BitVec 1))
(declare-const U3_state_RS1_busy (_ BitVec 1))
(declare-const U3_state_RS1_Ltag (_ BitVec 6))

(declare-const U3_state_RS2_op_type (Int))
(declare-const U3_state_RS2_op (Int))
(declare-const U3_state_RS2_ROB_dst (_ BitVec 6))
(declare-const U3_state_RS2_vj (Int))
(declare-const U3_state_RS2_vk (Int))
(declare-const U3_state_RS2_qj (_ BitVec 6))
(declare-const U3_state_RS2_qk (_ BitVec 6))
(declare-const U3_state_RS2_imm (Int))
(declare-const U3_state_RS2_dis (_ BitVec 1))
(declare-const U3_state_RS2_busy (_ BitVec 1))
(declare-const U3_state_RS2_Ltag (_ BitVec 6))

(declare-const U3_state_RS3_op_type (Int))
(declare-const U3_state_RS3_op (Int))
(declare-const U3_state_RS3_ROB_dst (_ BitVec 6))
(declare-const U3_state_RS3_vj (Int))
(declare-const U3_state_RS3_vk (Int))
(declare-const U3_state_RS3_qj (_ BitVec 6))
(declare-const U3_state_RS3_qk (_ BitVec 6))
(declare-const U3_state_RS3_imm (Int))
(declare-const U3_state_RS3_dis (_ BitVec 1))
(declare-const U3_state_RS3_busy (_ BitVec 1))
(declare-const U3_state_RS3_Ltag (_ BitVec 6))

(declare-const U3_state_RS4_op_type (Int))
(declare-const U3_state_RS4_op (Int))
(declare-const U3_state_RS4_ROB_dst (_ BitVec 6))
(declare-const U3_state_RS4_vj (Int))
(declare-const U3_state_RS4_vk (Int))
(declare-const U3_state_RS4_qj (_ BitVec 6))
(declare-const U3_state_RS4_qk (_ BitVec 6))
(declare-const U3_state_RS4_imm (Int))
(declare-const U3_state_RS4_dis (_ BitVec 1))
(declare-const U3_state_RS4_busy (_ BitVec 1))
(declare-const U3_state_RS4_Ltag (_ BitVec 6))

(declare-const U3_state_RS5_op_type (Int))
(declare-const U3_state_RS5_op (Int))
(declare-const U3_state_RS5_ROB_dst (_ BitVec 6))
(declare-const U3_state_RS5_vj (Int))
(declare-const U3_state_RS5_vk (Int))
(declare-const U3_state_RS5_qj (_ BitVec 6))
(declare-const U3_state_RS5_qk (_ BitVec 6))
(declare-const U3_state_RS5_imm (Int))
(declare-const U3_state_RS5_dis (_ BitVec 1))
(declare-const U3_state_RS5_busy (_ BitVec 1))
(declare-const U3_state_RS5_Ltag (_ BitVec 6))

(declare-const U3_state_RS6_op_type (Int))
(declare-const U3_state_RS6_op (Int))
(declare-const U3_state_RS6_ROB_dst (_ BitVec 6))
(declare-const U3_state_RS6_vj (Int))
(declare-const U3_state_RS6_vk (Int))
(declare-const U3_state_RS6_qj (_ BitVec 6))
(declare-const U3_state_RS6_qk (_ BitVec 6))
(declare-const U3_state_RS6_imm (Int))
(declare-const U3_state_RS6_dis (_ BitVec 1))
(declare-const U3_state_RS6_busy (_ BitVec 1))
(declare-const U3_state_RS6_Ltag (_ BitVec 6))

(declare-const U3_state_RS7_op_type (Int))
(declare-const U3_state_RS7_op (Int))
(declare-const U3_state_RS7_ROB_dst (_ BitVec 6))
(declare-const U3_state_RS7_vj (Int))
(declare-const U3_state_RS7_vk (Int))
(declare-const U3_state_RS7_qj (_ BitVec 6))
(declare-const U3_state_RS7_qk (_ BitVec 6))
(declare-const U3_state_RS7_imm (Int))
(declare-const U3_state_RS7_dis (_ BitVec 1))
(declare-const U3_state_RS7_busy (_ BitVec 1))
(declare-const U3_state_RS7_Ltag (_ BitVec 6))

(declare-const U3_state_LSQ0_op_type (Int))
(declare-const U3_state_LSQ0_op (Int))
(declare-const U3_state_LSQ0_ROB_dst (_ BitVec 6))
(declare-const U3_state_LSQ0_vj (Int))
(declare-const U3_state_LSQ0_vk (Int))
(declare-const U3_state_LSQ0_qj (_ BitVec 6))
(declare-const U3_state_LSQ0_qk (_ BitVec 6))
(declare-const U3_state_LSQ0_imm (Int))
(declare-const U3_state_LSQ0_dis (_ BitVec 1))
(declare-const U3_state_LSQ0_busy (_ BitVec 1))
(declare-const U3_state_LSQ0_Ltag (_ BitVec 6))

(declare-const U3_state_LSQ1_op_type (Int))
(declare-const U3_state_LSQ1_op (Int))
(declare-const U3_state_LSQ1_ROB_dst (_ BitVec 6))
(declare-const U3_state_LSQ1_vj (Int))
(declare-const U3_state_LSQ1_vk (Int))
(declare-const U3_state_LSQ1_qj (_ BitVec 6))
(declare-const U3_state_LSQ1_qk (_ BitVec 6))
(declare-const U3_state_LSQ1_imm (Int))
(declare-const U3_state_LSQ1_dis (_ BitVec 1))
(declare-const U3_state_LSQ1_busy (_ BitVec 1))
(declare-const U3_state_LSQ1_Ltag (_ BitVec 6))

(declare-const U3_state_LSQ2_op_type (Int))
(declare-const U3_state_LSQ2_op (Int))
(declare-const U3_state_LSQ2_ROB_dst (_ BitVec 6))
(declare-const U3_state_LSQ2_vj (Int))
(declare-const U3_state_LSQ2_vk (Int))
(declare-const U3_state_LSQ2_qj (_ BitVec 6))
(declare-const U3_state_LSQ2_qk (_ BitVec 6))
(declare-const U3_state_LSQ2_imm (Int))
(declare-const U3_state_LSQ2_dis (_ BitVec 1))
(declare-const U3_state_LSQ2_busy (_ BitVec 1))
(declare-const U3_state_LSQ2_Ltag (_ BitVec 6))

(declare-const U3_state_LSQ3_op_type (Int))
(declare-const U3_state_LSQ3_op (Int))
(declare-const U3_state_LSQ3_ROB_dst (_ BitVec 6))
(declare-const U3_state_LSQ3_vj (Int))
(declare-const U3_state_LSQ3_vk (Int))
(declare-const U3_state_LSQ3_qj (_ BitVec 6))
(declare-const U3_state_LSQ3_qk (_ BitVec 6))
(declare-const U3_state_LSQ3_imm (Int))
(declare-const U3_state_LSQ3_dis (_ BitVec 1))
(declare-const U3_state_LSQ3_busy (_ BitVec 1))
(declare-const U3_state_LSQ3_Ltag (_ BitVec 6))

(declare-const U3_state_LSQ4_op_type (Int))
(declare-const U3_state_LSQ4_op (Int))
(declare-const U3_state_LSQ4_ROB_dst (_ BitVec 6))
(declare-const U3_state_LSQ4_vj (Int))
(declare-const U3_state_LSQ4_vk (Int))
(declare-const U3_state_LSQ4_qj (_ BitVec 6))
(declare-const U3_state_LSQ4_qk (_ BitVec 6))
(declare-const U3_state_LSQ4_imm (Int))
(declare-const U3_state_LSQ4_dis (_ BitVec 1))
(declare-const U3_state_LSQ4_busy (_ BitVec 1))
(declare-const U3_state_LSQ4_Ltag (_ BitVec 6))

(declare-const U3_state_LSQ5_op_type (Int))
(declare-const U3_state_LSQ5_op (Int))
(declare-const U3_state_LSQ5_ROB_dst (_ BitVec 6))
(declare-const U3_state_LSQ5_vj (Int))
(declare-const U3_state_LSQ5_vk (Int))
(declare-const U3_state_LSQ5_qj (_ BitVec 6))
(declare-const U3_state_LSQ5_qk (_ BitVec 6))
(declare-const U3_state_LSQ5_imm (Int))
(declare-const U3_state_LSQ5_dis (_ BitVec 1))
(declare-const U3_state_LSQ5_busy (_ BitVec 1))
(declare-const U3_state_LSQ5_Ltag (_ BitVec 6))

(declare-const U3_state_LSQ6_op_type (Int))
(declare-const U3_state_LSQ6_op (Int))
(declare-const U3_state_LSQ6_ROB_dst (_ BitVec 6))
(declare-const U3_state_LSQ6_vj (Int))
(declare-const U3_state_LSQ6_vk (Int))
(declare-const U3_state_LSQ6_qj (_ BitVec 6))
(declare-const U3_state_LSQ6_qk (_ BitVec 6))
(declare-const U3_state_LSQ6_imm (Int))
(declare-const U3_state_LSQ6_dis (_ BitVec 1))
(declare-const U3_state_LSQ6_busy (_ BitVec 1))
(declare-const U3_state_LSQ6_Ltag (_ BitVec 6))

(declare-const U3_state_LSQ7_op_type (Int))
(declare-const U3_state_LSQ7_op (Int))
(declare-const U3_state_LSQ7_ROB_dst (_ BitVec 6))
(declare-const U3_state_LSQ7_vj (Int))
(declare-const U3_state_LSQ7_vk (Int))
(declare-const U3_state_LSQ7_qj (_ BitVec 6))
(declare-const U3_state_LSQ7_qk (_ BitVec 6))
(declare-const U3_state_LSQ7_imm (Int))
(declare-const U3_state_LSQ7_dis (_ BitVec 1))
(declare-const U3_state_LSQ7_busy (_ BitVec 1))
(declare-const U3_state_LSQ7_Ltag (_ BitVec 6))


(declare-const U4_state_Cache0_Tag (Int))
(declare-const U4_state_Cache1_Tag (Int))
(declare-const U4_state_Cache2_Tag (Int))
(declare-const U4_state_Cache3_Tag (Int))
(declare-const U4_state_Cache0_Data (Int))
(declare-const U4_state_Cache1_Data (Int))
(declare-const U4_state_Cache2_Data (Int))
(declare-const U4_state_Cache3_Data (Int))
(declare-const U4_state_Cache0_Valid (_ BitVec 1))
(declare-const U4_state_Cache1_Valid (_ BitVec 1))
(declare-const U4_state_Cache2_Valid (_ BitVec 1))
(declare-const U4_state_Cache3_Valid (_ BitVec 1))

(declare-const U4_state_IP (_ BitVec 6))
(declare-const U4_state_CP (_ BitVec 6))
(declare-const U4_state_Main_Ltag (_ BitVec 6))
(declare-const U4_state_PC (Int))

(declare-const U4_state_ROB0_busy (_ BitVec 1))
(declare-const U4_state_ROB0_op_type (Int))
(declare-const U4_state_ROB0_destination (Int))
(declare-const U4_state_ROB0_result (Int))
(declare-const U4_state_ROB0_exception (_ BitVec 1))
(declare-const U4_state_ROB0_done (_ BitVec 1))

(declare-const U4_state_ROB1_busy (_ BitVec 1))
(declare-const U4_state_ROB1_op_type (Int))
(declare-const U4_state_ROB1_destination (Int))
(declare-const U4_state_ROB1_result (Int))
(declare-const U4_state_ROB1_exception (_ BitVec 1))
(declare-const U4_state_ROB1_done (_ BitVec 1))

(declare-const U4_state_ROB2_busy (_ BitVec 1))
(declare-const U4_state_ROB2_op_type (Int))
(declare-const U4_state_ROB2_destination (Int))
(declare-const U4_state_ROB2_result (Int))
(declare-const U4_state_ROB2_exception (_ BitVec 1))
(declare-const U4_state_ROB2_done (_ BitVec 1))

(declare-const U4_state_ROB3_busy (_ BitVec 1))
(declare-const U4_state_ROB3_op_type (Int))
(declare-const U4_state_ROB3_destination (Int))
(declare-const U4_state_ROB3_result (Int))
(declare-const U4_state_ROB3_exception (_ BitVec 1))
(declare-const U4_state_ROB3_done (_ BitVec 1))

(declare-const U4_state_ROB4_busy (_ BitVec 1))
(declare-const U4_state_ROB4_op_type (Int))
(declare-const U4_state_ROB4_destination (Int))
(declare-const U4_state_ROB4_result (Int))
(declare-const U4_state_ROB4_exception (_ BitVec 1))
(declare-const U4_state_ROB4_done (_ BitVec 1))

(declare-const U4_state_ROB5_busy (_ BitVec 1))
(declare-const U4_state_ROB5_op_type (Int))
(declare-const U4_state_ROB5_destination (Int))
(declare-const U4_state_ROB5_result (Int))
(declare-const U4_state_ROB5_exception (_ BitVec 1))
(declare-const U4_state_ROB5_done (_ BitVec 1))

(declare-const U4_state_ROB6_busy (_ BitVec 1))
(declare-const U4_state_ROB6_op_type (Int))
(declare-const U4_state_ROB6_destination (Int))
(declare-const U4_state_ROB6_result (Int))
(declare-const U4_state_ROB6_exception (_ BitVec 1))
(declare-const U4_state_ROB6_done (_ BitVec 1))

(declare-const U4_state_ROB7_busy (_ BitVec 1))
(declare-const U4_state_ROB7_op_type (Int))
(declare-const U4_state_ROB7_destination (Int))
(declare-const U4_state_ROB7_result (Int))
(declare-const U4_state_ROB7_exception (_ BitVec 1))
(declare-const U4_state_ROB7_done (_ BitVec 1))

(declare-const U4_state_RS0_op_type (Int))
(declare-const U4_state_RS0_op (Int))
(declare-const U4_state_RS0_ROB_dst (_ BitVec 6))
(declare-const U4_state_RS0_vj (Int))
(declare-const U4_state_RS0_vk (Int))
(declare-const U4_state_RS0_qj (_ BitVec 6))
(declare-const U4_state_RS0_qk (_ BitVec 6))
(declare-const U4_state_RS0_imm (Int))
(declare-const U4_state_RS0_dis (_ BitVec 1))
(declare-const U4_state_RS0_busy (_ BitVec 1))
(declare-const U4_state_RS0_Ltag (_ BitVec 6))

(declare-const U4_state_RS1_op_type (Int))
(declare-const U4_state_RS1_op (Int))
(declare-const U4_state_RS1_ROB_dst (_ BitVec 6))
(declare-const U4_state_RS1_vj (Int))
(declare-const U4_state_RS1_vk (Int))
(declare-const U4_state_RS1_qj (_ BitVec 6))
(declare-const U4_state_RS1_qk (_ BitVec 6))
(declare-const U4_state_RS1_imm (Int))
(declare-const U4_state_RS1_dis (_ BitVec 1))
(declare-const U4_state_RS1_busy (_ BitVec 1))
(declare-const U4_state_RS1_Ltag (_ BitVec 6))

(declare-const U4_state_RS2_op_type (Int))
(declare-const U4_state_RS2_op (Int))
(declare-const U4_state_RS2_ROB_dst (_ BitVec 6))
(declare-const U4_state_RS2_vj (Int))
(declare-const U4_state_RS2_vk (Int))
(declare-const U4_state_RS2_qj (_ BitVec 6))
(declare-const U4_state_RS2_qk (_ BitVec 6))
(declare-const U4_state_RS2_imm (Int))
(declare-const U4_state_RS2_dis (_ BitVec 1))
(declare-const U4_state_RS2_busy (_ BitVec 1))
(declare-const U4_state_RS2_Ltag (_ BitVec 6))

(declare-const U4_state_RS3_op_type (Int))
(declare-const U4_state_RS3_op (Int))
(declare-const U4_state_RS3_ROB_dst (_ BitVec 6))
(declare-const U4_state_RS3_vj (Int))
(declare-const U4_state_RS3_vk (Int))
(declare-const U4_state_RS3_qj (_ BitVec 6))
(declare-const U4_state_RS3_qk (_ BitVec 6))
(declare-const U4_state_RS3_imm (Int))
(declare-const U4_state_RS3_dis (_ BitVec 1))
(declare-const U4_state_RS3_busy (_ BitVec 1))
(declare-const U4_state_RS3_Ltag (_ BitVec 6))

(declare-const U4_state_RS4_op_type (Int))
(declare-const U4_state_RS4_op (Int))
(declare-const U4_state_RS4_ROB_dst (_ BitVec 6))
(declare-const U4_state_RS4_vj (Int))
(declare-const U4_state_RS4_vk (Int))
(declare-const U4_state_RS4_qj (_ BitVec 6))
(declare-const U4_state_RS4_qk (_ BitVec 6))
(declare-const U4_state_RS4_imm (Int))
(declare-const U4_state_RS4_dis (_ BitVec 1))
(declare-const U4_state_RS4_busy (_ BitVec 1))
(declare-const U4_state_RS4_Ltag (_ BitVec 6))

(declare-const U4_state_RS5_op_type (Int))
(declare-const U4_state_RS5_op (Int))
(declare-const U4_state_RS5_ROB_dst (_ BitVec 6))
(declare-const U4_state_RS5_vj (Int))
(declare-const U4_state_RS5_vk (Int))
(declare-const U4_state_RS5_qj (_ BitVec 6))
(declare-const U4_state_RS5_qk (_ BitVec 6))
(declare-const U4_state_RS5_imm (Int))
(declare-const U4_state_RS5_dis (_ BitVec 1))
(declare-const U4_state_RS5_busy (_ BitVec 1))
(declare-const U4_state_RS5_Ltag (_ BitVec 6))

(declare-const U4_state_RS6_op_type (Int))
(declare-const U4_state_RS6_op (Int))
(declare-const U4_state_RS6_ROB_dst (_ BitVec 6))
(declare-const U4_state_RS6_vj (Int))
(declare-const U4_state_RS6_vk (Int))
(declare-const U4_state_RS6_qj (_ BitVec 6))
(declare-const U4_state_RS6_qk (_ BitVec 6))
(declare-const U4_state_RS6_imm (Int))
(declare-const U4_state_RS6_dis (_ BitVec 1))
(declare-const U4_state_RS6_busy (_ BitVec 1))
(declare-const U4_state_RS6_Ltag (_ BitVec 6))

(declare-const U4_state_RS7_op_type (Int))
(declare-const U4_state_RS7_op (Int))
(declare-const U4_state_RS7_ROB_dst (_ BitVec 6))
(declare-const U4_state_RS7_vj (Int))
(declare-const U4_state_RS7_vk (Int))
(declare-const U4_state_RS7_qj (_ BitVec 6))
(declare-const U4_state_RS7_qk (_ BitVec 6))
(declare-const U4_state_RS7_imm (Int))
(declare-const U4_state_RS7_dis (_ BitVec 1))
(declare-const U4_state_RS7_busy (_ BitVec 1))
(declare-const U4_state_RS7_Ltag (_ BitVec 6))

(declare-const U4_state_LSQ0_op_type (Int))
(declare-const U4_state_LSQ0_op (Int))
(declare-const U4_state_LSQ0_ROB_dst (_ BitVec 6))
(declare-const U4_state_LSQ0_vj (Int))
(declare-const U4_state_LSQ0_vk (Int))
(declare-const U4_state_LSQ0_qj (_ BitVec 6))
(declare-const U4_state_LSQ0_qk (_ BitVec 6))
(declare-const U4_state_LSQ0_imm (Int))
(declare-const U4_state_LSQ0_dis (_ BitVec 1))
(declare-const U4_state_LSQ0_busy (_ BitVec 1))
(declare-const U4_state_LSQ0_Ltag (_ BitVec 6))

(declare-const U4_state_LSQ1_op_type (Int))
(declare-const U4_state_LSQ1_op (Int))
(declare-const U4_state_LSQ1_ROB_dst (_ BitVec 6))
(declare-const U4_state_LSQ1_vj (Int))
(declare-const U4_state_LSQ1_vk (Int))
(declare-const U4_state_LSQ1_qj (_ BitVec 6))
(declare-const U4_state_LSQ1_qk (_ BitVec 6))
(declare-const U4_state_LSQ1_imm (Int))
(declare-const U4_state_LSQ1_dis (_ BitVec 1))
(declare-const U4_state_LSQ1_busy (_ BitVec 1))
(declare-const U4_state_LSQ1_Ltag (_ BitVec 6))

(declare-const U4_state_LSQ2_op_type (Int))
(declare-const U4_state_LSQ2_op (Int))
(declare-const U4_state_LSQ2_ROB_dst (_ BitVec 6))
(declare-const U4_state_LSQ2_vj (Int))
(declare-const U4_state_LSQ2_vk (Int))
(declare-const U4_state_LSQ2_qj (_ BitVec 6))
(declare-const U4_state_LSQ2_qk (_ BitVec 6))
(declare-const U4_state_LSQ2_imm (Int))
(declare-const U4_state_LSQ2_dis (_ BitVec 1))
(declare-const U4_state_LSQ2_busy (_ BitVec 1))
(declare-const U4_state_LSQ2_Ltag (_ BitVec 6))

(declare-const U4_state_LSQ3_op_type (Int))
(declare-const U4_state_LSQ3_op (Int))
(declare-const U4_state_LSQ3_ROB_dst (_ BitVec 6))
(declare-const U4_state_LSQ3_vj (Int))
(declare-const U4_state_LSQ3_vk (Int))
(declare-const U4_state_LSQ3_qj (_ BitVec 6))
(declare-const U4_state_LSQ3_qk (_ BitVec 6))
(declare-const U4_state_LSQ3_imm (Int))
(declare-const U4_state_LSQ3_dis (_ BitVec 1))
(declare-const U4_state_LSQ3_busy (_ BitVec 1))
(declare-const U4_state_LSQ3_Ltag (_ BitVec 6))

(declare-const U4_state_LSQ4_op_type (Int))
(declare-const U4_state_LSQ4_op (Int))
(declare-const U4_state_LSQ4_ROB_dst (_ BitVec 6))
(declare-const U4_state_LSQ4_vj (Int))
(declare-const U4_state_LSQ4_vk (Int))
(declare-const U4_state_LSQ4_qj (_ BitVec 6))
(declare-const U4_state_LSQ4_qk (_ BitVec 6))
(declare-const U4_state_LSQ4_imm (Int))
(declare-const U4_state_LSQ4_dis (_ BitVec 1))
(declare-const U4_state_LSQ4_busy (_ BitVec 1))
(declare-const U4_state_LSQ4_Ltag (_ BitVec 6))

(declare-const U4_state_LSQ5_op_type (Int))
(declare-const U4_state_LSQ5_op (Int))
(declare-const U4_state_LSQ5_ROB_dst (_ BitVec 6))
(declare-const U4_state_LSQ5_vj (Int))
(declare-const U4_state_LSQ5_vk (Int))
(declare-const U4_state_LSQ5_qj (_ BitVec 6))
(declare-const U4_state_LSQ5_qk (_ BitVec 6))
(declare-const U4_state_LSQ5_imm (Int))
(declare-const U4_state_LSQ5_dis (_ BitVec 1))
(declare-const U4_state_LSQ5_busy (_ BitVec 1))
(declare-const U4_state_LSQ5_Ltag (_ BitVec 6))

(declare-const U4_state_LSQ6_op_type (Int))
(declare-const U4_state_LSQ6_op (Int))
(declare-const U4_state_LSQ6_ROB_dst (_ BitVec 6))
(declare-const U4_state_LSQ6_vj (Int))
(declare-const U4_state_LSQ6_vk (Int))
(declare-const U4_state_LSQ6_qj (_ BitVec 6))
(declare-const U4_state_LSQ6_qk (_ BitVec 6))
(declare-const U4_state_LSQ6_imm (Int))
(declare-const U4_state_LSQ6_dis (_ BitVec 1))
(declare-const U4_state_LSQ6_busy (_ BitVec 1))
(declare-const U4_state_LSQ6_Ltag (_ BitVec 6))

(declare-const U4_state_LSQ7_op_type (Int))
(declare-const U4_state_LSQ7_op (Int))
(declare-const U4_state_LSQ7_ROB_dst (_ BitVec 6))
(declare-const U4_state_LSQ7_vj (Int))
(declare-const U4_state_LSQ7_vk (Int))
(declare-const U4_state_LSQ7_qj (_ BitVec 6))
(declare-const U4_state_LSQ7_qk (_ BitVec 6))
(declare-const U4_state_LSQ7_imm (Int))
(declare-const U4_state_LSQ7_dis (_ BitVec 1))
(declare-const U4_state_LSQ7_busy (_ BitVec 1))
(declare-const U4_state_LSQ7_Ltag (_ BitVec 6))

;)


(assert
	(not
;---------------------------Issue--------------------------------------------------------------		
		(let
			(
				(Instruction (select T_IM T_PC))
			)
		(let
			(
				(op (Inst_op Instruction))
				(op_type (Inst_op_type Instruction))
				(rs (Inst_rs Instruction))
				(rt (Inst_rt Instruction))
				(rd (Inst_rd Instruction))
				(imm (Inst_imm Instruction))
				(PC_plus_one (+ T_PC 4))
				
				(ROB1_busy (select T_ROB_busy (_ bv1 6)))
				(ROB2_busy (select T_ROB_busy (_ bv2 6)))
				(ROB3_busy (select T_ROB_busy (_ bv3 6)))
				(ROB4_busy (select T_ROB_busy (_ bv4 6)))
				(ROB5_busy (select T_ROB_busy (_ bv5 6)))
				(ROB6_busy (select T_ROB_busy (_ bv6 6)))
				(ROB7_busy (select T_ROB_busy (_ bv7 6)))
				(ROB8_busy (select T_ROB_busy (_ bv8 6)))
				(ROB9_busy (select T_ROB_busy (_ bv9 6)))
				(ROB10_busy (select T_ROB_busy (_ bv10 6)))
				(ROB11_busy (select T_ROB_busy (_ bv11 6)))
				(ROB12_busy (select T_ROB_busy (_ bv12 6)))
				(ROB13_busy (select T_ROB_busy (_ bv13 6)))
				(ROB14_busy (select T_ROB_busy (_ bv14 6)))
				(ROB15_busy (select T_ROB_busy (_ bv15 6)))
				(ROB16_busy (select T_ROB_busy (_ bv16 6)))
				(ROB17_busy (select T_ROB_busy (_ bv17 6)))
				(ROB18_busy (select T_ROB_busy (_ bv18 6)))
				(ROB19_busy (select T_ROB_busy (_ bv19 6)))
				(ROB20_busy (select T_ROB_busy (_ bv20 6)))
				(ROB21_busy (select T_ROB_busy (_ bv21 6)))
				(ROB22_busy (select T_ROB_busy (_ bv22 6)))
				(ROB23_busy (select T_ROB_busy (_ bv23 6)))
				(ROB24_busy (select T_ROB_busy (_ bv24 6)))
				(ROB25_busy (select T_ROB_busy (_ bv25 6)))
				(ROB26_busy (select T_ROB_busy (_ bv26 6)))
				(ROB27_busy (select T_ROB_busy (_ bv27 6)))
				(ROB28_busy (select T_ROB_busy (_ bv28 6)))
				(ROB29_busy (select T_ROB_busy (_ bv29 6)))
				(ROB30_busy (select T_ROB_busy (_ bv30 6)))
				(ROB31_busy (select T_ROB_busy (_ bv31 6)))
				(ROB32_busy (select T_ROB_busy (_ bv32 6)))
				(ROB33_busy (select T_ROB_busy (_ bv33 6)))
				(ROB34_busy (select T_ROB_busy (_ bv34 6)))
				(ROB35_busy (select T_ROB_busy (_ bv35 6)))
				(ROB36_busy (select T_ROB_busy (_ bv36 6)))
				(ROB37_busy (select T_ROB_busy (_ bv37 6)))
				(ROB38_busy (select T_ROB_busy (_ bv38 6)))
				(ROB39_busy (select T_ROB_busy (_ bv39 6)))
				(ROB40_busy (select T_ROB_busy (_ bv40 6)))
				(ROB41_busy (select T_ROB_busy (_ bv41 6)))
				(ROB42_busy (select T_ROB_busy (_ bv42 6)))
				(ROB43_busy (select T_ROB_busy (_ bv43 6)))
				(ROB44_busy (select T_ROB_busy (_ bv44 6)))
				(ROB45_busy (select T_ROB_busy (_ bv45 6)))
				(ROB46_busy (select T_ROB_busy (_ bv46 6)))
				(ROB47_busy (select T_ROB_busy (_ bv47 6)))
				(ROB48_busy (select T_ROB_busy (_ bv48 6)))
				(ROB49_busy (select T_ROB_busy (_ bv49 6)))
				(ROB50_busy (select T_ROB_busy (_ bv50 6)))
				(ROB51_busy (select T_ROB_busy (_ bv51 6)))
				(ROB52_busy (select T_ROB_busy (_ bv52 6)))
				(ROB53_busy (select T_ROB_busy (_ bv53 6)))
				(ROB54_busy (select T_ROB_busy (_ bv54 6)))
				(ROB55_busy (select T_ROB_busy (_ bv55 6)))
				(ROB56_busy (select T_ROB_busy (_ bv56 6)))
				(ROB57_busy (select T_ROB_busy (_ bv57 6)))
				(ROB58_busy (select T_ROB_busy (_ bv58 6)))
				(ROB59_busy (select T_ROB_busy (_ bv59 6)))
				(ROB60_busy (select T_ROB_busy (_ bv60 6)))
				(ROB61_busy (select T_ROB_busy (_ bv61 6)))
				(ROB62_busy (select T_ROB_busy (_ bv62 6)))
				(ROB63_busy (select T_ROB_busy (_ bv63 6)))

				
				(RS0_busy (select T_RS_busy (_ bv0 3)))
				(RS1_busy (select T_RS_busy (_ bv1 3)))
				(RS2_busy (select T_RS_busy (_ bv2 3)))
				(RS3_busy (select T_RS_busy (_ bv3 3)))
				(RS4_busy (select T_RS_busy (_ bv4 3)))
				(RS5_busy (select T_RS_busy (_ bv5 3)))
				(RS6_busy (select T_RS_busy (_ bv6 3)))
				(RS7_busy (select T_RS_busy (_ bv7 3)))
				
				(LSQ0_busy (select T_LSQ_busy (_ bv0 3)))
				(LSQ1_busy (select T_LSQ_busy (_ bv1 3)))
				(LSQ2_busy (select T_LSQ_busy (_ bv2 3)))
				(LSQ3_busy (select T_LSQ_busy (_ bv3 3)))
				(LSQ4_busy (select T_LSQ_busy (_ bv4 3)))
				(LSQ5_busy (select T_LSQ_busy (_ bv5 3)))
				(LSQ6_busy (select T_LSQ_busy (_ bv6 3)))
				(LSQ7_busy (select T_LSQ_busy (_ bv7 3)))
				
			)
		(let
			(
				(RF_rs (select T_RF rs))
				(RF_rt (select T_RF rt))
			)
		(let((IP_m1 (subtract T_IP)))
		(let((IP_m2 (subtract IP_m1)))
		(let((IP_m3 (subtract IP_m2)))
		(let((IP_m4 (subtract IP_m3)))
		(let((IP_m5 (subtract IP_m4)))
		(let((IP_m6 (subtract IP_m5)))
		(let((IP_m7 (subtract IP_m6)))
		(let((IP_m8 (subtract IP_m7)))
		(let((IP_m9 (subtract IP_m8)))
		(let((IP_m10 (subtract IP_m9)))
		(let((IP_m11 (subtract IP_m10)))
		(let((IP_m12 (subtract IP_m11)))
		(let((IP_m13 (subtract IP_m12)))
		(let((IP_m14 (subtract IP_m13)))
		(let((IP_m15 (subtract IP_m14)))
		(let((IP_m16 (subtract IP_m15)))
		(let((IP_m17 (subtract IP_m16)))
		(let((IP_m18 (subtract IP_m17)))
		(let((IP_m19 (subtract IP_m18)))
		(let((IP_m20 (subtract IP_m19)))
		(let((IP_m21 (subtract IP_m20)))
		(let((IP_m22 (subtract IP_m21)))
		(let((IP_m23 (subtract IP_m22)))
		(let((IP_m24 (subtract IP_m23)))
		(let((IP_m25 (subtract IP_m24)))
		(let((IP_m26 (subtract IP_m25)))
		(let((IP_m27 (subtract IP_m26)))
		(let((IP_m28 (subtract IP_m27)))
		(let((IP_m29 (subtract IP_m28)))
		(let((IP_m30 (subtract IP_m29)))
		(let((IP_m31 (subtract IP_m30)))
		(let((IP_m32 (subtract IP_m31)))
		(let((IP_m33 (subtract IP_m32)))
		(let((IP_m34 (subtract IP_m33)))
		(let((IP_m35 (subtract IP_m34)))
		(let((IP_m36 (subtract IP_m35)))
		(let((IP_m37 (subtract IP_m36)))
		(let((IP_m38 (subtract IP_m37)))
		(let((IP_m39 (subtract IP_m38)))
		(let((IP_m40 (subtract IP_m39)))
		(let((IP_m41 (subtract IP_m40)))
		(let((IP_m42 (subtract IP_m41)))
		(let((IP_m43 (subtract IP_m42)))
		(let((IP_m44 (subtract IP_m43)))
		(let((IP_m45 (subtract IP_m44)))
		(let((IP_m46 (subtract IP_m45)))
		(let((IP_m47 (subtract IP_m46)))
		(let((IP_m48 (subtract IP_m47)))
		(let((IP_m49 (subtract IP_m48)))
		(let((IP_m50 (subtract IP_m49)))
		(let((IP_m51 (subtract IP_m50)))
		(let((IP_m52 (subtract IP_m51)))
		(let((IP_m53 (subtract IP_m52)))
		(let((IP_m54 (subtract IP_m53)))
		(let((IP_m55 (subtract IP_m54)))
		(let((IP_m56 (subtract IP_m55)))
		(let((IP_m57 (subtract IP_m56)))
		(let((IP_m58 (subtract IP_m57)))
		(let((IP_m59 (subtract IP_m58)))
		(let((IP_m60 (subtract IP_m59)))
		(let((IP_m61 (subtract IP_m60)))
		(let((IP_m62 (subtract IP_m61)))
		(let((IP_m63 (subtract IP_m62)))

		(let
			(	
				(RAT_rs
					(ite (and (= #b1 (select T_ROB_busy IP_m1)) (or (= Mul_div (select T_ROB_op_type IP_m1)) (= Rtype (select T_ROB_op_type IP_m1)) (= Load (select T_ROB_op_type IP_m1))) (= rs (select T_ROB_destination IP_m1))) IP_m1
					(ite (and (= #b1 (select T_ROB_busy IP_m2)) (or (= Mul_div (select T_ROB_op_type IP_m2)) (= Rtype (select T_ROB_op_type IP_m2)) (= Load (select T_ROB_op_type IP_m2))) (= rs (select T_ROB_destination IP_m2))) IP_m2
					(ite (and (= #b1 (select T_ROB_busy IP_m3)) (or (= Mul_div (select T_ROB_op_type IP_m3)) (= Rtype (select T_ROB_op_type IP_m3)) (= Load (select T_ROB_op_type IP_m3))) (= rs (select T_ROB_destination IP_m3))) IP_m3
					(ite (and (= #b1 (select T_ROB_busy IP_m4)) (or (= Mul_div (select T_ROB_op_type IP_m4)) (= Rtype (select T_ROB_op_type IP_m4)) (= Load (select T_ROB_op_type IP_m4))) (= rs (select T_ROB_destination IP_m4))) IP_m4
					(ite (and (= #b1 (select T_ROB_busy IP_m5)) (or (= Mul_div (select T_ROB_op_type IP_m5)) (= Rtype (select T_ROB_op_type IP_m5)) (= Load (select T_ROB_op_type IP_m5))) (= rs (select T_ROB_destination IP_m5))) IP_m5
					(ite (and (= #b1 (select T_ROB_busy IP_m6)) (or (= Mul_div (select T_ROB_op_type IP_m6)) (= Rtype (select T_ROB_op_type IP_m6)) (= Load (select T_ROB_op_type IP_m6))) (= rs (select T_ROB_destination IP_m6))) IP_m6
					(ite (and (= #b1 (select T_ROB_busy IP_m7)) (or (= Mul_div (select T_ROB_op_type IP_m7)) (= Rtype (select T_ROB_op_type IP_m7)) (= Load (select T_ROB_op_type IP_m7))) (= rs (select T_ROB_destination IP_m7))) IP_m7
					(ite (and (= #b1 (select T_ROB_busy IP_m8)) (or (= Mul_div (select T_ROB_op_type IP_m8)) (= Rtype (select T_ROB_op_type IP_m8)) (= Load (select T_ROB_op_type IP_m8))) (= rs (select T_ROB_destination IP_m8))) IP_m8
					(ite (and (= #b1 (select T_ROB_busy IP_m9)) (or (= Mul_div (select T_ROB_op_type IP_m9)) (= Rtype (select T_ROB_op_type IP_m9)) (= Load (select T_ROB_op_type IP_m9))) (= rs (select T_ROB_destination IP_m9))) IP_m9
					(ite (and (= #b1 (select T_ROB_busy IP_m10)) (or (= Mul_div (select T_ROB_op_type IP_m10)) (= Rtype (select T_ROB_op_type IP_m10)) (= Load (select T_ROB_op_type IP_m10))) (= rs (select T_ROB_destination IP_m10))) IP_m10
					(ite (and (= #b1 (select T_ROB_busy IP_m11)) (or (= Mul_div (select T_ROB_op_type IP_m11)) (= Rtype (select T_ROB_op_type IP_m11)) (= Load (select T_ROB_op_type IP_m11))) (= rs (select T_ROB_destination IP_m11))) IP_m11
					(ite (and (= #b1 (select T_ROB_busy IP_m12)) (or (= Mul_div (select T_ROB_op_type IP_m12)) (= Rtype (select T_ROB_op_type IP_m12)) (= Load (select T_ROB_op_type IP_m12))) (= rs (select T_ROB_destination IP_m12))) IP_m12
					(ite (and (= #b1 (select T_ROB_busy IP_m13)) (or (= Mul_div (select T_ROB_op_type IP_m13)) (= Rtype (select T_ROB_op_type IP_m13)) (= Load (select T_ROB_op_type IP_m13))) (= rs (select T_ROB_destination IP_m13))) IP_m13
					(ite (and (= #b1 (select T_ROB_busy IP_m14)) (or (= Mul_div (select T_ROB_op_type IP_m14)) (= Rtype (select T_ROB_op_type IP_m14)) (= Load (select T_ROB_op_type IP_m14))) (= rs (select T_ROB_destination IP_m14))) IP_m14
					(ite (and (= #b1 (select T_ROB_busy IP_m15)) (or (= Mul_div (select T_ROB_op_type IP_m15)) (= Rtype (select T_ROB_op_type IP_m15)) (= Load (select T_ROB_op_type IP_m15))) (= rs (select T_ROB_destination IP_m15))) IP_m15
					(ite (and (= #b1 (select T_ROB_busy IP_m16)) (or (= Mul_div (select T_ROB_op_type IP_m16)) (= Rtype (select T_ROB_op_type IP_m16)) (= Load (select T_ROB_op_type IP_m16))) (= rs (select T_ROB_destination IP_m16))) IP_m16
					(ite (and (= #b1 (select T_ROB_busy IP_m17)) (or (= Mul_div (select T_ROB_op_type IP_m17)) (= Rtype (select T_ROB_op_type IP_m17)) (= Load (select T_ROB_op_type IP_m17))) (= rs (select T_ROB_destination IP_m17))) IP_m17
					(ite (and (= #b1 (select T_ROB_busy IP_m18)) (or (= Mul_div (select T_ROB_op_type IP_m18)) (= Rtype (select T_ROB_op_type IP_m18)) (= Load (select T_ROB_op_type IP_m18))) (= rs (select T_ROB_destination IP_m18))) IP_m18
					(ite (and (= #b1 (select T_ROB_busy IP_m19)) (or (= Mul_div (select T_ROB_op_type IP_m19)) (= Rtype (select T_ROB_op_type IP_m19)) (= Load (select T_ROB_op_type IP_m19))) (= rs (select T_ROB_destination IP_m19))) IP_m19
					(ite (and (= #b1 (select T_ROB_busy IP_m20)) (or (= Mul_div (select T_ROB_op_type IP_m20)) (= Rtype (select T_ROB_op_type IP_m20)) (= Load (select T_ROB_op_type IP_m20))) (= rs (select T_ROB_destination IP_m20))) IP_m20
					(ite (and (= #b1 (select T_ROB_busy IP_m21)) (or (= Mul_div (select T_ROB_op_type IP_m21)) (= Rtype (select T_ROB_op_type IP_m21)) (= Load (select T_ROB_op_type IP_m21))) (= rs (select T_ROB_destination IP_m21))) IP_m21
					(ite (and (= #b1 (select T_ROB_busy IP_m22)) (or (= Mul_div (select T_ROB_op_type IP_m22)) (= Rtype (select T_ROB_op_type IP_m22)) (= Load (select T_ROB_op_type IP_m22))) (= rs (select T_ROB_destination IP_m22))) IP_m22
					(ite (and (= #b1 (select T_ROB_busy IP_m23)) (or (= Mul_div (select T_ROB_op_type IP_m23)) (= Rtype (select T_ROB_op_type IP_m23)) (= Load (select T_ROB_op_type IP_m23))) (= rs (select T_ROB_destination IP_m23))) IP_m23
					(ite (and (= #b1 (select T_ROB_busy IP_m24)) (or (= Mul_div (select T_ROB_op_type IP_m24)) (= Rtype (select T_ROB_op_type IP_m24)) (= Load (select T_ROB_op_type IP_m24))) (= rs (select T_ROB_destination IP_m24))) IP_m24
					(ite (and (= #b1 (select T_ROB_busy IP_m25)) (or (= Mul_div (select T_ROB_op_type IP_m25)) (= Rtype (select T_ROB_op_type IP_m25)) (= Load (select T_ROB_op_type IP_m25))) (= rs (select T_ROB_destination IP_m25))) IP_m25
					(ite (and (= #b1 (select T_ROB_busy IP_m26)) (or (= Mul_div (select T_ROB_op_type IP_m26)) (= Rtype (select T_ROB_op_type IP_m26)) (= Load (select T_ROB_op_type IP_m26))) (= rs (select T_ROB_destination IP_m26))) IP_m26
					(ite (and (= #b1 (select T_ROB_busy IP_m27)) (or (= Mul_div (select T_ROB_op_type IP_m27)) (= Rtype (select T_ROB_op_type IP_m27)) (= Load (select T_ROB_op_type IP_m27))) (= rs (select T_ROB_destination IP_m27))) IP_m27
					(ite (and (= #b1 (select T_ROB_busy IP_m28)) (or (= Mul_div (select T_ROB_op_type IP_m28)) (= Rtype (select T_ROB_op_type IP_m28)) (= Load (select T_ROB_op_type IP_m28))) (= rs (select T_ROB_destination IP_m28))) IP_m28
					(ite (and (= #b1 (select T_ROB_busy IP_m29)) (or (= Mul_div (select T_ROB_op_type IP_m29)) (= Rtype (select T_ROB_op_type IP_m29)) (= Load (select T_ROB_op_type IP_m29))) (= rs (select T_ROB_destination IP_m29))) IP_m29
					(ite (and (= #b1 (select T_ROB_busy IP_m30)) (or (= Mul_div (select T_ROB_op_type IP_m30)) (= Rtype (select T_ROB_op_type IP_m30)) (= Load (select T_ROB_op_type IP_m30))) (= rs (select T_ROB_destination IP_m30))) IP_m30
					(ite (and (= #b1 (select T_ROB_busy IP_m31)) (or (= Mul_div (select T_ROB_op_type IP_m31)) (= Rtype (select T_ROB_op_type IP_m31)) (= Load (select T_ROB_op_type IP_m31))) (= rs (select T_ROB_destination IP_m31))) IP_m31
					(ite (and (= #b1 (select T_ROB_busy IP_m32)) (or (= Mul_div (select T_ROB_op_type IP_m32)) (= Rtype (select T_ROB_op_type IP_m32)) (= Load (select T_ROB_op_type IP_m32))) (= rs (select T_ROB_destination IP_m32))) IP_m32
					(ite (and (= #b1 (select T_ROB_busy IP_m33)) (or (= Mul_div (select T_ROB_op_type IP_m33)) (= Rtype (select T_ROB_op_type IP_m33)) (= Load (select T_ROB_op_type IP_m33))) (= rs (select T_ROB_destination IP_m33))) IP_m33
					(ite (and (= #b1 (select T_ROB_busy IP_m34)) (or (= Mul_div (select T_ROB_op_type IP_m34)) (= Rtype (select T_ROB_op_type IP_m34)) (= Load (select T_ROB_op_type IP_m34))) (= rs (select T_ROB_destination IP_m34))) IP_m34
					(ite (and (= #b1 (select T_ROB_busy IP_m35)) (or (= Mul_div (select T_ROB_op_type IP_m35)) (= Rtype (select T_ROB_op_type IP_m35)) (= Load (select T_ROB_op_type IP_m35))) (= rs (select T_ROB_destination IP_m35))) IP_m35
					(ite (and (= #b1 (select T_ROB_busy IP_m36)) (or (= Mul_div (select T_ROB_op_type IP_m36)) (= Rtype (select T_ROB_op_type IP_m36)) (= Load (select T_ROB_op_type IP_m36))) (= rs (select T_ROB_destination IP_m36))) IP_m36
					(ite (and (= #b1 (select T_ROB_busy IP_m37)) (or (= Mul_div (select T_ROB_op_type IP_m37)) (= Rtype (select T_ROB_op_type IP_m37)) (= Load (select T_ROB_op_type IP_m37))) (= rs (select T_ROB_destination IP_m37))) IP_m37
					(ite (and (= #b1 (select T_ROB_busy IP_m38)) (or (= Mul_div (select T_ROB_op_type IP_m38)) (= Rtype (select T_ROB_op_type IP_m38)) (= Load (select T_ROB_op_type IP_m38))) (= rs (select T_ROB_destination IP_m38))) IP_m38
					(ite (and (= #b1 (select T_ROB_busy IP_m39)) (or (= Mul_div (select T_ROB_op_type IP_m39)) (= Rtype (select T_ROB_op_type IP_m39)) (= Load (select T_ROB_op_type IP_m39))) (= rs (select T_ROB_destination IP_m39))) IP_m39
					(ite (and (= #b1 (select T_ROB_busy IP_m40)) (or (= Mul_div (select T_ROB_op_type IP_m40)) (= Rtype (select T_ROB_op_type IP_m40)) (= Load (select T_ROB_op_type IP_m40))) (= rs (select T_ROB_destination IP_m40))) IP_m40
					(ite (and (= #b1 (select T_ROB_busy IP_m41)) (or (= Mul_div (select T_ROB_op_type IP_m41)) (= Rtype (select T_ROB_op_type IP_m41)) (= Load (select T_ROB_op_type IP_m41))) (= rs (select T_ROB_destination IP_m41))) IP_m41
					(ite (and (= #b1 (select T_ROB_busy IP_m42)) (or (= Mul_div (select T_ROB_op_type IP_m42)) (= Rtype (select T_ROB_op_type IP_m42)) (= Load (select T_ROB_op_type IP_m42))) (= rs (select T_ROB_destination IP_m42))) IP_m42
					(ite (and (= #b1 (select T_ROB_busy IP_m43)) (or (= Mul_div (select T_ROB_op_type IP_m43)) (= Rtype (select T_ROB_op_type IP_m43)) (= Load (select T_ROB_op_type IP_m43))) (= rs (select T_ROB_destination IP_m43))) IP_m43
					(ite (and (= #b1 (select T_ROB_busy IP_m44)) (or (= Mul_div (select T_ROB_op_type IP_m44)) (= Rtype (select T_ROB_op_type IP_m44)) (= Load (select T_ROB_op_type IP_m44))) (= rs (select T_ROB_destination IP_m44))) IP_m44
					(ite (and (= #b1 (select T_ROB_busy IP_m45)) (or (= Mul_div (select T_ROB_op_type IP_m45)) (= Rtype (select T_ROB_op_type IP_m45)) (= Load (select T_ROB_op_type IP_m45))) (= rs (select T_ROB_destination IP_m45))) IP_m45
					(ite (and (= #b1 (select T_ROB_busy IP_m46)) (or (= Mul_div (select T_ROB_op_type IP_m46)) (= Rtype (select T_ROB_op_type IP_m46)) (= Load (select T_ROB_op_type IP_m46))) (= rs (select T_ROB_destination IP_m46))) IP_m46
					(ite (and (= #b1 (select T_ROB_busy IP_m47)) (or (= Mul_div (select T_ROB_op_type IP_m47)) (= Rtype (select T_ROB_op_type IP_m47)) (= Load (select T_ROB_op_type IP_m47))) (= rs (select T_ROB_destination IP_m47))) IP_m47
					(ite (and (= #b1 (select T_ROB_busy IP_m48)) (or (= Mul_div (select T_ROB_op_type IP_m48)) (= Rtype (select T_ROB_op_type IP_m48)) (= Load (select T_ROB_op_type IP_m48))) (= rs (select T_ROB_destination IP_m48))) IP_m48
					(ite (and (= #b1 (select T_ROB_busy IP_m49)) (or (= Mul_div (select T_ROB_op_type IP_m49)) (= Rtype (select T_ROB_op_type IP_m49)) (= Load (select T_ROB_op_type IP_m49))) (= rs (select T_ROB_destination IP_m49))) IP_m49
					(ite (and (= #b1 (select T_ROB_busy IP_m50)) (or (= Mul_div (select T_ROB_op_type IP_m50)) (= Rtype (select T_ROB_op_type IP_m50)) (= Load (select T_ROB_op_type IP_m50))) (= rs (select T_ROB_destination IP_m50))) IP_m50
					(ite (and (= #b1 (select T_ROB_busy IP_m51)) (or (= Mul_div (select T_ROB_op_type IP_m51)) (= Rtype (select T_ROB_op_type IP_m51)) (= Load (select T_ROB_op_type IP_m51))) (= rs (select T_ROB_destination IP_m51))) IP_m51
					(ite (and (= #b1 (select T_ROB_busy IP_m52)) (or (= Mul_div (select T_ROB_op_type IP_m52)) (= Rtype (select T_ROB_op_type IP_m52)) (= Load (select T_ROB_op_type IP_m52))) (= rs (select T_ROB_destination IP_m52))) IP_m52
					(ite (and (= #b1 (select T_ROB_busy IP_m53)) (or (= Mul_div (select T_ROB_op_type IP_m53)) (= Rtype (select T_ROB_op_type IP_m53)) (= Load (select T_ROB_op_type IP_m53))) (= rs (select T_ROB_destination IP_m53))) IP_m53
					(ite (and (= #b1 (select T_ROB_busy IP_m54)) (or (= Mul_div (select T_ROB_op_type IP_m54)) (= Rtype (select T_ROB_op_type IP_m54)) (= Load (select T_ROB_op_type IP_m54))) (= rs (select T_ROB_destination IP_m54))) IP_m54
					(ite (and (= #b1 (select T_ROB_busy IP_m55)) (or (= Mul_div (select T_ROB_op_type IP_m55)) (= Rtype (select T_ROB_op_type IP_m55)) (= Load (select T_ROB_op_type IP_m55))) (= rs (select T_ROB_destination IP_m55))) IP_m55
					(ite (and (= #b1 (select T_ROB_busy IP_m56)) (or (= Mul_div (select T_ROB_op_type IP_m56)) (= Rtype (select T_ROB_op_type IP_m56)) (= Load (select T_ROB_op_type IP_m56))) (= rs (select T_ROB_destination IP_m56))) IP_m56
					(ite (and (= #b1 (select T_ROB_busy IP_m57)) (or (= Mul_div (select T_ROB_op_type IP_m57)) (= Rtype (select T_ROB_op_type IP_m57)) (= Load (select T_ROB_op_type IP_m57))) (= rs (select T_ROB_destination IP_m57))) IP_m57
					(ite (and (= #b1 (select T_ROB_busy IP_m58)) (or (= Mul_div (select T_ROB_op_type IP_m58)) (= Rtype (select T_ROB_op_type IP_m58)) (= Load (select T_ROB_op_type IP_m58))) (= rs (select T_ROB_destination IP_m58))) IP_m58
					(ite (and (= #b1 (select T_ROB_busy IP_m59)) (or (= Mul_div (select T_ROB_op_type IP_m59)) (= Rtype (select T_ROB_op_type IP_m59)) (= Load (select T_ROB_op_type IP_m59))) (= rs (select T_ROB_destination IP_m59))) IP_m59
					(ite (and (= #b1 (select T_ROB_busy IP_m60)) (or (= Mul_div (select T_ROB_op_type IP_m60)) (= Rtype (select T_ROB_op_type IP_m60)) (= Load (select T_ROB_op_type IP_m60))) (= rs (select T_ROB_destination IP_m60))) IP_m60
					(ite (and (= #b1 (select T_ROB_busy IP_m61)) (or (= Mul_div (select T_ROB_op_type IP_m61)) (= Rtype (select T_ROB_op_type IP_m61)) (= Load (select T_ROB_op_type IP_m61))) (= rs (select T_ROB_destination IP_m61))) IP_m61
					(ite (and (= #b1 (select T_ROB_busy IP_m62)) (or (= Mul_div (select T_ROB_op_type IP_m62)) (= Rtype (select T_ROB_op_type IP_m62)) (= Load (select T_ROB_op_type IP_m62))) (= rs (select T_ROB_destination IP_m62))) IP_m62
					(_ bv0 6)
					))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
				)
				(RAT_rt
					(ite (and (= #b1 (select T_ROB_busy IP_m1)) (or (= Mul_div (select T_ROB_op_type IP_m1)) (= Rtype (select T_ROB_op_type IP_m1)) (= Load (select T_ROB_op_type IP_m1))) (= rt (select T_ROB_destination IP_m1))) IP_m1
					(ite (and (= #b1 (select T_ROB_busy IP_m2)) (or (= Mul_div (select T_ROB_op_type IP_m2)) (= Rtype (select T_ROB_op_type IP_m2)) (= Load (select T_ROB_op_type IP_m2))) (= rt (select T_ROB_destination IP_m2))) IP_m2
					(ite (and (= #b1 (select T_ROB_busy IP_m3)) (or (= Mul_div (select T_ROB_op_type IP_m3)) (= Rtype (select T_ROB_op_type IP_m3)) (= Load (select T_ROB_op_type IP_m3))) (= rt (select T_ROB_destination IP_m3))) IP_m3
					(ite (and (= #b1 (select T_ROB_busy IP_m4)) (or (= Mul_div (select T_ROB_op_type IP_m4)) (= Rtype (select T_ROB_op_type IP_m4)) (= Load (select T_ROB_op_type IP_m4))) (= rt (select T_ROB_destination IP_m4))) IP_m4
					(ite (and (= #b1 (select T_ROB_busy IP_m5)) (or (= Mul_div (select T_ROB_op_type IP_m5)) (= Rtype (select T_ROB_op_type IP_m5)) (= Load (select T_ROB_op_type IP_m5))) (= rt (select T_ROB_destination IP_m5))) IP_m5
					(ite (and (= #b1 (select T_ROB_busy IP_m6)) (or (= Mul_div (select T_ROB_op_type IP_m6)) (= Rtype (select T_ROB_op_type IP_m6)) (= Load (select T_ROB_op_type IP_m6))) (= rt (select T_ROB_destination IP_m6))) IP_m6
					(ite (and (= #b1 (select T_ROB_busy IP_m7)) (or (= Mul_div (select T_ROB_op_type IP_m7)) (= Rtype (select T_ROB_op_type IP_m7)) (= Load (select T_ROB_op_type IP_m7))) (= rt (select T_ROB_destination IP_m7))) IP_m7
					(ite (and (= #b1 (select T_ROB_busy IP_m8)) (or (= Mul_div (select T_ROB_op_type IP_m8)) (= Rtype (select T_ROB_op_type IP_m8)) (= Load (select T_ROB_op_type IP_m8))) (= rt (select T_ROB_destination IP_m8))) IP_m8
					(ite (and (= #b1 (select T_ROB_busy IP_m9)) (or (= Mul_div (select T_ROB_op_type IP_m9)) (= Rtype (select T_ROB_op_type IP_m9)) (= Load (select T_ROB_op_type IP_m9))) (= rt (select T_ROB_destination IP_m9))) IP_m9
					(ite (and (= #b1 (select T_ROB_busy IP_m10)) (or (= Mul_div (select T_ROB_op_type IP_m10)) (= Rtype (select T_ROB_op_type IP_m10)) (= Load (select T_ROB_op_type IP_m10))) (= rt (select T_ROB_destination IP_m10))) IP_m10
					(ite (and (= #b1 (select T_ROB_busy IP_m11)) (or (= Mul_div (select T_ROB_op_type IP_m11)) (= Rtype (select T_ROB_op_type IP_m11)) (= Load (select T_ROB_op_type IP_m11))) (= rt (select T_ROB_destination IP_m11))) IP_m11
					(ite (and (= #b1 (select T_ROB_busy IP_m12)) (or (= Mul_div (select T_ROB_op_type IP_m12)) (= Rtype (select T_ROB_op_type IP_m12)) (= Load (select T_ROB_op_type IP_m12))) (= rt (select T_ROB_destination IP_m12))) IP_m12
					(ite (and (= #b1 (select T_ROB_busy IP_m13)) (or (= Mul_div (select T_ROB_op_type IP_m13)) (= Rtype (select T_ROB_op_type IP_m13)) (= Load (select T_ROB_op_type IP_m13))) (= rt (select T_ROB_destination IP_m13))) IP_m13
					(ite (and (= #b1 (select T_ROB_busy IP_m14)) (or (= Mul_div (select T_ROB_op_type IP_m14)) (= Rtype (select T_ROB_op_type IP_m14)) (= Load (select T_ROB_op_type IP_m14))) (= rt (select T_ROB_destination IP_m14))) IP_m14
					(ite (and (= #b1 (select T_ROB_busy IP_m15)) (or (= Mul_div (select T_ROB_op_type IP_m15)) (= Rtype (select T_ROB_op_type IP_m15)) (= Load (select T_ROB_op_type IP_m15))) (= rt (select T_ROB_destination IP_m15))) IP_m15
					(ite (and (= #b1 (select T_ROB_busy IP_m16)) (or (= Mul_div (select T_ROB_op_type IP_m16)) (= Rtype (select T_ROB_op_type IP_m16)) (= Load (select T_ROB_op_type IP_m16))) (= rt (select T_ROB_destination IP_m16))) IP_m16
					(ite (and (= #b1 (select T_ROB_busy IP_m17)) (or (= Mul_div (select T_ROB_op_type IP_m17)) (= Rtype (select T_ROB_op_type IP_m17)) (= Load (select T_ROB_op_type IP_m17))) (= rt (select T_ROB_destination IP_m17))) IP_m17
					(ite (and (= #b1 (select T_ROB_busy IP_m18)) (or (= Mul_div (select T_ROB_op_type IP_m18)) (= Rtype (select T_ROB_op_type IP_m18)) (= Load (select T_ROB_op_type IP_m18))) (= rt (select T_ROB_destination IP_m18))) IP_m18
					(ite (and (= #b1 (select T_ROB_busy IP_m19)) (or (= Mul_div (select T_ROB_op_type IP_m19)) (= Rtype (select T_ROB_op_type IP_m19)) (= Load (select T_ROB_op_type IP_m19))) (= rt (select T_ROB_destination IP_m19))) IP_m19
					(ite (and (= #b1 (select T_ROB_busy IP_m20)) (or (= Mul_div (select T_ROB_op_type IP_m20)) (= Rtype (select T_ROB_op_type IP_m20)) (= Load (select T_ROB_op_type IP_m20))) (= rt (select T_ROB_destination IP_m20))) IP_m20
					(ite (and (= #b1 (select T_ROB_busy IP_m21)) (or (= Mul_div (select T_ROB_op_type IP_m21)) (= Rtype (select T_ROB_op_type IP_m21)) (= Load (select T_ROB_op_type IP_m21))) (= rt (select T_ROB_destination IP_m21))) IP_m21
					(ite (and (= #b1 (select T_ROB_busy IP_m22)) (or (= Mul_div (select T_ROB_op_type IP_m22)) (= Rtype (select T_ROB_op_type IP_m22)) (= Load (select T_ROB_op_type IP_m22))) (= rt (select T_ROB_destination IP_m22))) IP_m22
					(ite (and (= #b1 (select T_ROB_busy IP_m23)) (or (= Mul_div (select T_ROB_op_type IP_m23)) (= Rtype (select T_ROB_op_type IP_m23)) (= Load (select T_ROB_op_type IP_m23))) (= rt (select T_ROB_destination IP_m23))) IP_m23
					(ite (and (= #b1 (select T_ROB_busy IP_m24)) (or (= Mul_div (select T_ROB_op_type IP_m24)) (= Rtype (select T_ROB_op_type IP_m24)) (= Load (select T_ROB_op_type IP_m24))) (= rt (select T_ROB_destination IP_m24))) IP_m24
					(ite (and (= #b1 (select T_ROB_busy IP_m25)) (or (= Mul_div (select T_ROB_op_type IP_m25)) (= Rtype (select T_ROB_op_type IP_m25)) (= Load (select T_ROB_op_type IP_m25))) (= rt (select T_ROB_destination IP_m25))) IP_m25
					(ite (and (= #b1 (select T_ROB_busy IP_m26)) (or (= Mul_div (select T_ROB_op_type IP_m26)) (= Rtype (select T_ROB_op_type IP_m26)) (= Load (select T_ROB_op_type IP_m26))) (= rt (select T_ROB_destination IP_m26))) IP_m26
					(ite (and (= #b1 (select T_ROB_busy IP_m27)) (or (= Mul_div (select T_ROB_op_type IP_m27)) (= Rtype (select T_ROB_op_type IP_m27)) (= Load (select T_ROB_op_type IP_m27))) (= rt (select T_ROB_destination IP_m27))) IP_m27
					(ite (and (= #b1 (select T_ROB_busy IP_m28)) (or (= Mul_div (select T_ROB_op_type IP_m28)) (= Rtype (select T_ROB_op_type IP_m28)) (= Load (select T_ROB_op_type IP_m28))) (= rt (select T_ROB_destination IP_m28))) IP_m28
					(ite (and (= #b1 (select T_ROB_busy IP_m29)) (or (= Mul_div (select T_ROB_op_type IP_m29)) (= Rtype (select T_ROB_op_type IP_m29)) (= Load (select T_ROB_op_type IP_m29))) (= rt (select T_ROB_destination IP_m29))) IP_m29
					(ite (and (= #b1 (select T_ROB_busy IP_m30)) (or (= Mul_div (select T_ROB_op_type IP_m30)) (= Rtype (select T_ROB_op_type IP_m30)) (= Load (select T_ROB_op_type IP_m30))) (= rt (select T_ROB_destination IP_m30))) IP_m30
					(ite (and (= #b1 (select T_ROB_busy IP_m31)) (or (= Mul_div (select T_ROB_op_type IP_m31)) (= Rtype (select T_ROB_op_type IP_m31)) (= Load (select T_ROB_op_type IP_m31))) (= rt (select T_ROB_destination IP_m31))) IP_m31
					(ite (and (= #b1 (select T_ROB_busy IP_m32)) (or (= Mul_div (select T_ROB_op_type IP_m32)) (= Rtype (select T_ROB_op_type IP_m32)) (= Load (select T_ROB_op_type IP_m32))) (= rt (select T_ROB_destination IP_m32))) IP_m32
					(ite (and (= #b1 (select T_ROB_busy IP_m33)) (or (= Mul_div (select T_ROB_op_type IP_m33)) (= Rtype (select T_ROB_op_type IP_m33)) (= Load (select T_ROB_op_type IP_m33))) (= rt (select T_ROB_destination IP_m33))) IP_m33
					(ite (and (= #b1 (select T_ROB_busy IP_m34)) (or (= Mul_div (select T_ROB_op_type IP_m34)) (= Rtype (select T_ROB_op_type IP_m34)) (= Load (select T_ROB_op_type IP_m34))) (= rt (select T_ROB_destination IP_m34))) IP_m34
					(ite (and (= #b1 (select T_ROB_busy IP_m35)) (or (= Mul_div (select T_ROB_op_type IP_m35)) (= Rtype (select T_ROB_op_type IP_m35)) (= Load (select T_ROB_op_type IP_m35))) (= rt (select T_ROB_destination IP_m35))) IP_m35
					(ite (and (= #b1 (select T_ROB_busy IP_m36)) (or (= Mul_div (select T_ROB_op_type IP_m36)) (= Rtype (select T_ROB_op_type IP_m36)) (= Load (select T_ROB_op_type IP_m36))) (= rt (select T_ROB_destination IP_m36))) IP_m36
					(ite (and (= #b1 (select T_ROB_busy IP_m37)) (or (= Mul_div (select T_ROB_op_type IP_m37)) (= Rtype (select T_ROB_op_type IP_m37)) (= Load (select T_ROB_op_type IP_m37))) (= rt (select T_ROB_destination IP_m37))) IP_m37
					(ite (and (= #b1 (select T_ROB_busy IP_m38)) (or (= Mul_div (select T_ROB_op_type IP_m38)) (= Rtype (select T_ROB_op_type IP_m38)) (= Load (select T_ROB_op_type IP_m38))) (= rt (select T_ROB_destination IP_m38))) IP_m38
					(ite (and (= #b1 (select T_ROB_busy IP_m39)) (or (= Mul_div (select T_ROB_op_type IP_m39)) (= Rtype (select T_ROB_op_type IP_m39)) (= Load (select T_ROB_op_type IP_m39))) (= rt (select T_ROB_destination IP_m39))) IP_m39
					(ite (and (= #b1 (select T_ROB_busy IP_m40)) (or (= Mul_div (select T_ROB_op_type IP_m40)) (= Rtype (select T_ROB_op_type IP_m40)) (= Load (select T_ROB_op_type IP_m40))) (= rt (select T_ROB_destination IP_m40))) IP_m40
					(ite (and (= #b1 (select T_ROB_busy IP_m41)) (or (= Mul_div (select T_ROB_op_type IP_m41)) (= Rtype (select T_ROB_op_type IP_m41)) (= Load (select T_ROB_op_type IP_m41))) (= rt (select T_ROB_destination IP_m41))) IP_m41
					(ite (and (= #b1 (select T_ROB_busy IP_m42)) (or (= Mul_div (select T_ROB_op_type IP_m42)) (= Rtype (select T_ROB_op_type IP_m42)) (= Load (select T_ROB_op_type IP_m42))) (= rt (select T_ROB_destination IP_m42))) IP_m42
					(ite (and (= #b1 (select T_ROB_busy IP_m43)) (or (= Mul_div (select T_ROB_op_type IP_m43)) (= Rtype (select T_ROB_op_type IP_m43)) (= Load (select T_ROB_op_type IP_m43))) (= rt (select T_ROB_destination IP_m43))) IP_m43
					(ite (and (= #b1 (select T_ROB_busy IP_m44)) (or (= Mul_div (select T_ROB_op_type IP_m44)) (= Rtype (select T_ROB_op_type IP_m44)) (= Load (select T_ROB_op_type IP_m44))) (= rt (select T_ROB_destination IP_m44))) IP_m44
					(ite (and (= #b1 (select T_ROB_busy IP_m45)) (or (= Mul_div (select T_ROB_op_type IP_m45)) (= Rtype (select T_ROB_op_type IP_m45)) (= Load (select T_ROB_op_type IP_m45))) (= rt (select T_ROB_destination IP_m45))) IP_m45
					(ite (and (= #b1 (select T_ROB_busy IP_m46)) (or (= Mul_div (select T_ROB_op_type IP_m46)) (= Rtype (select T_ROB_op_type IP_m46)) (= Load (select T_ROB_op_type IP_m46))) (= rt (select T_ROB_destination IP_m46))) IP_m46
					(ite (and (= #b1 (select T_ROB_busy IP_m47)) (or (= Mul_div (select T_ROB_op_type IP_m47)) (= Rtype (select T_ROB_op_type IP_m47)) (= Load (select T_ROB_op_type IP_m47))) (= rt (select T_ROB_destination IP_m47))) IP_m47
					(ite (and (= #b1 (select T_ROB_busy IP_m48)) (or (= Mul_div (select T_ROB_op_type IP_m48)) (= Rtype (select T_ROB_op_type IP_m48)) (= Load (select T_ROB_op_type IP_m48))) (= rt (select T_ROB_destination IP_m48))) IP_m48
					(ite (and (= #b1 (select T_ROB_busy IP_m49)) (or (= Mul_div (select T_ROB_op_type IP_m49)) (= Rtype (select T_ROB_op_type IP_m49)) (= Load (select T_ROB_op_type IP_m49))) (= rt (select T_ROB_destination IP_m49))) IP_m49
					(ite (and (= #b1 (select T_ROB_busy IP_m50)) (or (= Mul_div (select T_ROB_op_type IP_m50)) (= Rtype (select T_ROB_op_type IP_m50)) (= Load (select T_ROB_op_type IP_m50))) (= rt (select T_ROB_destination IP_m50))) IP_m50
					(ite (and (= #b1 (select T_ROB_busy IP_m51)) (or (= Mul_div (select T_ROB_op_type IP_m51)) (= Rtype (select T_ROB_op_type IP_m51)) (= Load (select T_ROB_op_type IP_m51))) (= rt (select T_ROB_destination IP_m51))) IP_m51
					(ite (and (= #b1 (select T_ROB_busy IP_m52)) (or (= Mul_div (select T_ROB_op_type IP_m52)) (= Rtype (select T_ROB_op_type IP_m52)) (= Load (select T_ROB_op_type IP_m52))) (= rt (select T_ROB_destination IP_m52))) IP_m52
					(ite (and (= #b1 (select T_ROB_busy IP_m53)) (or (= Mul_div (select T_ROB_op_type IP_m53)) (= Rtype (select T_ROB_op_type IP_m53)) (= Load (select T_ROB_op_type IP_m53))) (= rt (select T_ROB_destination IP_m53))) IP_m53
					(ite (and (= #b1 (select T_ROB_busy IP_m54)) (or (= Mul_div (select T_ROB_op_type IP_m54)) (= Rtype (select T_ROB_op_type IP_m54)) (= Load (select T_ROB_op_type IP_m54))) (= rt (select T_ROB_destination IP_m54))) IP_m54
					(ite (and (= #b1 (select T_ROB_busy IP_m55)) (or (= Mul_div (select T_ROB_op_type IP_m55)) (= Rtype (select T_ROB_op_type IP_m55)) (= Load (select T_ROB_op_type IP_m55))) (= rt (select T_ROB_destination IP_m55))) IP_m55
					(ite (and (= #b1 (select T_ROB_busy IP_m56)) (or (= Mul_div (select T_ROB_op_type IP_m56)) (= Rtype (select T_ROB_op_type IP_m56)) (= Load (select T_ROB_op_type IP_m56))) (= rt (select T_ROB_destination IP_m56))) IP_m56
					(ite (and (= #b1 (select T_ROB_busy IP_m57)) (or (= Mul_div (select T_ROB_op_type IP_m57)) (= Rtype (select T_ROB_op_type IP_m57)) (= Load (select T_ROB_op_type IP_m57))) (= rt (select T_ROB_destination IP_m57))) IP_m57
					(ite (and (= #b1 (select T_ROB_busy IP_m58)) (or (= Mul_div (select T_ROB_op_type IP_m58)) (= Rtype (select T_ROB_op_type IP_m58)) (= Load (select T_ROB_op_type IP_m58))) (= rt (select T_ROB_destination IP_m58))) IP_m58
					(ite (and (= #b1 (select T_ROB_busy IP_m59)) (or (= Mul_div (select T_ROB_op_type IP_m59)) (= Rtype (select T_ROB_op_type IP_m59)) (= Load (select T_ROB_op_type IP_m59))) (= rt (select T_ROB_destination IP_m59))) IP_m59
					(ite (and (= #b1 (select T_ROB_busy IP_m60)) (or (= Mul_div (select T_ROB_op_type IP_m60)) (= Rtype (select T_ROB_op_type IP_m60)) (= Load (select T_ROB_op_type IP_m60))) (= rt (select T_ROB_destination IP_m60))) IP_m60
					(ite (and (= #b1 (select T_ROB_busy IP_m61)) (or (= Mul_div (select T_ROB_op_type IP_m61)) (= Rtype (select T_ROB_op_type IP_m61)) (= Load (select T_ROB_op_type IP_m61))) (= rt (select T_ROB_destination IP_m61))) IP_m61
					(ite (and (= #b1 (select T_ROB_busy IP_m62)) (or (= Mul_div (select T_ROB_op_type IP_m62)) (= Rtype (select T_ROB_op_type IP_m62)) (= Load (select T_ROB_op_type IP_m62))) (= rt (select T_ROB_destination IP_m62))) IP_m62
					(_ bv0 6)
					))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
				)
				(T_Main_Ltag
					(ite (and (= #b1 (select T_ROB_busy IP_m1)) (= Lfence (select T_ROB_op_type IP_m1))) IP_m1
					(ite (and (= #b1 (select T_ROB_busy IP_m2)) (= Lfence (select T_ROB_op_type IP_m2))) IP_m2
					(ite (and (= #b1 (select T_ROB_busy IP_m3)) (= Lfence (select T_ROB_op_type IP_m3))) IP_m3
					(ite (and (= #b1 (select T_ROB_busy IP_m4)) (= Lfence (select T_ROB_op_type IP_m4))) IP_m4
					(ite (and (= #b1 (select T_ROB_busy IP_m5)) (= Lfence (select T_ROB_op_type IP_m5))) IP_m5
					(ite (and (= #b1 (select T_ROB_busy IP_m6)) (= Lfence (select T_ROB_op_type IP_m6))) IP_m6
					(ite (and (= #b1 (select T_ROB_busy IP_m7)) (= Lfence (select T_ROB_op_type IP_m7))) IP_m7
					(ite (and (= #b1 (select T_ROB_busy IP_m8)) (= Lfence (select T_ROB_op_type IP_m8))) IP_m8
					(ite (and (= #b1 (select T_ROB_busy IP_m9)) (= Lfence (select T_ROB_op_type IP_m9))) IP_m9
					(ite (and (= #b1 (select T_ROB_busy IP_m10)) (= Lfence (select T_ROB_op_type IP_m10))) IP_m10
					(ite (and (= #b1 (select T_ROB_busy IP_m11)) (= Lfence (select T_ROB_op_type IP_m11))) IP_m11
					(ite (and (= #b1 (select T_ROB_busy IP_m12)) (= Lfence (select T_ROB_op_type IP_m12))) IP_m12
					(ite (and (= #b1 (select T_ROB_busy IP_m13)) (= Lfence (select T_ROB_op_type IP_m13))) IP_m13
					(ite (and (= #b1 (select T_ROB_busy IP_m14)) (= Lfence (select T_ROB_op_type IP_m14))) IP_m14
					(ite (and (= #b1 (select T_ROB_busy IP_m15)) (= Lfence (select T_ROB_op_type IP_m15))) IP_m15
					(ite (and (= #b1 (select T_ROB_busy IP_m16)) (= Lfence (select T_ROB_op_type IP_m16))) IP_m16
					(ite (and (= #b1 (select T_ROB_busy IP_m17)) (= Lfence (select T_ROB_op_type IP_m17))) IP_m17
					(ite (and (= #b1 (select T_ROB_busy IP_m18)) (= Lfence (select T_ROB_op_type IP_m18))) IP_m18
					(ite (and (= #b1 (select T_ROB_busy IP_m19)) (= Lfence (select T_ROB_op_type IP_m19))) IP_m19
					(ite (and (= #b1 (select T_ROB_busy IP_m20)) (= Lfence (select T_ROB_op_type IP_m20))) IP_m20
					(ite (and (= #b1 (select T_ROB_busy IP_m21)) (= Lfence (select T_ROB_op_type IP_m21))) IP_m21
					(ite (and (= #b1 (select T_ROB_busy IP_m22)) (= Lfence (select T_ROB_op_type IP_m22))) IP_m22
					(ite (and (= #b1 (select T_ROB_busy IP_m23)) (= Lfence (select T_ROB_op_type IP_m23))) IP_m23
					(ite (and (= #b1 (select T_ROB_busy IP_m24)) (= Lfence (select T_ROB_op_type IP_m24))) IP_m24
					(ite (and (= #b1 (select T_ROB_busy IP_m25)) (= Lfence (select T_ROB_op_type IP_m25))) IP_m25
					(ite (and (= #b1 (select T_ROB_busy IP_m26)) (= Lfence (select T_ROB_op_type IP_m26))) IP_m26
					(ite (and (= #b1 (select T_ROB_busy IP_m27)) (= Lfence (select T_ROB_op_type IP_m27))) IP_m27
					(ite (and (= #b1 (select T_ROB_busy IP_m28)) (= Lfence (select T_ROB_op_type IP_m28))) IP_m28
					(ite (and (= #b1 (select T_ROB_busy IP_m29)) (= Lfence (select T_ROB_op_type IP_m29))) IP_m29
					(ite (and (= #b1 (select T_ROB_busy IP_m30)) (= Lfence (select T_ROB_op_type IP_m30))) IP_m30
					(ite (and (= #b1 (select T_ROB_busy IP_m31)) (= Lfence (select T_ROB_op_type IP_m31))) IP_m31
					(ite (and (= #b1 (select T_ROB_busy IP_m32)) (= Lfence (select T_ROB_op_type IP_m32))) IP_m32
					(ite (and (= #b1 (select T_ROB_busy IP_m33)) (= Lfence (select T_ROB_op_type IP_m33))) IP_m33
					(ite (and (= #b1 (select T_ROB_busy IP_m34)) (= Lfence (select T_ROB_op_type IP_m34))) IP_m34
					(ite (and (= #b1 (select T_ROB_busy IP_m35)) (= Lfence (select T_ROB_op_type IP_m35))) IP_m35
					(ite (and (= #b1 (select T_ROB_busy IP_m36)) (= Lfence (select T_ROB_op_type IP_m36))) IP_m36
					(ite (and (= #b1 (select T_ROB_busy IP_m37)) (= Lfence (select T_ROB_op_type IP_m37))) IP_m37
					(ite (and (= #b1 (select T_ROB_busy IP_m38)) (= Lfence (select T_ROB_op_type IP_m38))) IP_m38
					(ite (and (= #b1 (select T_ROB_busy IP_m39)) (= Lfence (select T_ROB_op_type IP_m39))) IP_m39
					(ite (and (= #b1 (select T_ROB_busy IP_m40)) (= Lfence (select T_ROB_op_type IP_m40))) IP_m40
					(ite (and (= #b1 (select T_ROB_busy IP_m41)) (= Lfence (select T_ROB_op_type IP_m41))) IP_m41
					(ite (and (= #b1 (select T_ROB_busy IP_m42)) (= Lfence (select T_ROB_op_type IP_m42))) IP_m42
					(ite (and (= #b1 (select T_ROB_busy IP_m43)) (= Lfence (select T_ROB_op_type IP_m43))) IP_m43
					(ite (and (= #b1 (select T_ROB_busy IP_m44)) (= Lfence (select T_ROB_op_type IP_m44))) IP_m44
					(ite (and (= #b1 (select T_ROB_busy IP_m45)) (= Lfence (select T_ROB_op_type IP_m45))) IP_m45
					(ite (and (= #b1 (select T_ROB_busy IP_m46)) (= Lfence (select T_ROB_op_type IP_m46))) IP_m46
					(ite (and (= #b1 (select T_ROB_busy IP_m47)) (= Lfence (select T_ROB_op_type IP_m47))) IP_m47
					(ite (and (= #b1 (select T_ROB_busy IP_m48)) (= Lfence (select T_ROB_op_type IP_m48))) IP_m48
					(ite (and (= #b1 (select T_ROB_busy IP_m49)) (= Lfence (select T_ROB_op_type IP_m49))) IP_m49
					(ite (and (= #b1 (select T_ROB_busy IP_m50)) (= Lfence (select T_ROB_op_type IP_m50))) IP_m50
					(ite (and (= #b1 (select T_ROB_busy IP_m51)) (= Lfence (select T_ROB_op_type IP_m51))) IP_m51
					(ite (and (= #b1 (select T_ROB_busy IP_m52)) (= Lfence (select T_ROB_op_type IP_m52))) IP_m52
					(ite (and (= #b1 (select T_ROB_busy IP_m53)) (= Lfence (select T_ROB_op_type IP_m53))) IP_m53
					(ite (and (= #b1 (select T_ROB_busy IP_m54)) (= Lfence (select T_ROB_op_type IP_m54))) IP_m54
					(ite (and (= #b1 (select T_ROB_busy IP_m55)) (= Lfence (select T_ROB_op_type IP_m55))) IP_m55
					(ite (and (= #b1 (select T_ROB_busy IP_m56)) (= Lfence (select T_ROB_op_type IP_m56))) IP_m56
					(ite (and (= #b1 (select T_ROB_busy IP_m57)) (= Lfence (select T_ROB_op_type IP_m57))) IP_m57
					(ite (and (= #b1 (select T_ROB_busy IP_m58)) (= Lfence (select T_ROB_op_type IP_m58))) IP_m58
					(ite (and (= #b1 (select T_ROB_busy IP_m59)) (= Lfence (select T_ROB_op_type IP_m59))) IP_m59
					(ite (and (= #b1 (select T_ROB_busy IP_m60)) (= Lfence (select T_ROB_op_type IP_m60))) IP_m60
					(ite (and (= #b1 (select T_ROB_busy IP_m61)) (= Lfence (select T_ROB_op_type IP_m61))) IP_m61
					(ite (and (= #b1 (select T_ROB_busy IP_m62)) (= Lfence (select T_ROB_op_type IP_m62))) IP_m62
					(_ bv0 6)
					))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
				)
			)
		(let
			(
				(stall
					(ite (= #b1 U_path_stall) (_ bv1 1)
					(ite (= #b1 (select T_ROB_busy T_IP)) (_ bv1 1)
					(ite (and (= Lfence op_type) (not (= #b000000 T_Main_Ltag)) (= #b1 (bvor ROB1_busy ROB2_busy ROB3_busy ROB4_busy ROB5_busy ROB6_busy ROB7_busy ROB8_busy ROB9_busy ROB10_busy ROB11_busy ROB12_busy ROB13_busy ROB14_busy ROB15_busy ROB16_busy ROB17_busy ROB18_busy ROB19_busy ROB20_busy ROB21_busy ROB22_busy ROB23_busy ROB24_busy ROB25_busy ROB26_busy ROB27_busy ROB28_busy ROB29_busy ROB30_busy ROB31_busy ROB32_busy ROB33_busy ROB34_busy ROB35_busy ROB36_busy ROB37_busy ROB38_busy ROB39_busy ROB40_busy ROB41_busy ROB42_busy ROB43_busy ROB44_busy ROB45_busy ROB46_busy ROB47_busy ROB48_busy ROB49_busy ROB50_busy ROB51_busy ROB52_busy ROB53_busy ROB54_busy ROB55_busy ROB56_busy ROB57_busy ROB58_busy ROB59_busy ROB60_busy ROB61_busy ROB62_busy ROB63_busy))) (_ bv1 1)
					(ite (= #b1 (bvand ROB1_busy ROB2_busy ROB3_busy ROB4_busy ROB5_busy ROB6_busy ROB7_busy ROB8_busy ROB9_busy ROB10_busy ROB11_busy ROB12_busy ROB13_busy ROB14_busy ROB15_busy ROB16_busy ROB17_busy ROB18_busy ROB19_busy ROB20_busy ROB21_busy ROB22_busy ROB23_busy ROB24_busy ROB25_busy ROB26_busy ROB27_busy ROB28_busy ROB29_busy ROB30_busy ROB31_busy ROB32_busy ROB33_busy ROB34_busy ROB35_busy ROB36_busy ROB37_busy ROB38_busy ROB39_busy ROB40_busy ROB41_busy ROB42_busy ROB43_busy ROB44_busy ROB45_busy ROB46_busy ROB47_busy ROB48_busy ROB49_busy ROB50_busy ROB51_busy ROB52_busy ROB53_busy ROB54_busy ROB55_busy ROB56_busy ROB57_busy ROB58_busy ROB59_busy ROB60_busy ROB61_busy ROB62_busy ROB63_busy )) (_ bv1 1)
					(_ bv0 1)
					))))
				)
				(RF_destination 
					(ite (= op_type Load) rt
					(ite (= op_type Rtype) rd
					(ite (= op_type Branch) imm
					0
					)))
				)
				(IP_update (bvadd T_IP (_ bv1 6)))
				
				(T_Main_Ltag (bvadd (_ bv0 6) (_ bv0 6)))
			
			)
		(let
			(
				(issue_to_rs0 (ite (and (= RS0_busy #b0) (or (= op_type Lfence) (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq7 (ite (and (= LSQ7_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs1 (ite (and (= issue_to_rs0 #b0) (= RS1_busy #b0) (or (= op_type Lfence) (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq6 (ite (and (= issue_to_lsq7 #b0) (= LSQ6_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
				
			)
		(let
			(
				(issue_to_rs2 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= RS2_busy #b0) (or (= op_type Lfence) (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq5 (ite (and (= issue_to_lsq6 #b0) (= issue_to_lsq7 #b0) (= LSQ5_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
				
			)
		(let
			(
				(issue_to_rs3 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= issue_to_rs2 #b0) (= RS3_busy #b0) (or (= op_type Lfence) (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq4 (ite (and (= issue_to_lsq5 #b0) (= issue_to_lsq6 #b0) (= issue_to_lsq7 #b0) (= LSQ4_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
				
			)
		(let
			(
				(issue_to_rs4 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= issue_to_rs2 #b0) (= issue_to_rs3 #b0) (= RS4_busy #b0) (or (= op_type Lfence) (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq3 (ite (and (= issue_to_lsq4 #b0) (= issue_to_lsq5 #b0) (= issue_to_lsq6 #b0) (= issue_to_lsq7 #b0) (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs5 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= issue_to_rs2 #b0) (= issue_to_rs3 #b0) (= issue_to_rs4 #b0) (= RS5_busy #b0) (or (= op_type Lfence) (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq2 (ite (and (= issue_to_lsq3 #b0) (= issue_to_lsq4 #b0) (= issue_to_lsq5 #b0) (= issue_to_lsq6 #b0) (= issue_to_lsq7 #b0) (= LSQ2_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs6 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= issue_to_rs2 #b0) (= issue_to_rs3 #b0) (= issue_to_rs4 #b0) (= issue_to_rs5 #b0) (= RS6_busy #b0) (or (= op_type Lfence) (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq1 (ite (and (= issue_to_lsq2 #b0) (= issue_to_lsq3 #b0) (= issue_to_lsq4 #b0) (= issue_to_lsq5 #b0) (= issue_to_lsq6 #b0) (= issue_to_lsq7 #b0) (= LSQ1_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs7 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= issue_to_rs2 #b0) (= issue_to_rs3 #b0) (= issue_to_rs4 #b0) (= issue_to_rs5 #b0) (= issue_to_rs6 #b0) (= RS7_busy #b0) (or (= op_type Lfence) (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq0 (ite (and (= issue_to_lsq1 #b0) (= issue_to_lsq2 #b0) (= issue_to_lsq3 #b0) (= issue_to_lsq4 #b0) (= issue_to_lsq5 #b0) (= issue_to_lsq6 #b0) (= issue_to_lsq7 #b0) (= LSQ0_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(RS_Issue_index 
					(ite (= issue_to_rs0 #b1) (_ bv0 3)
					(ite (= issue_to_rs1 #b1) (_ bv1 3)
					(ite (= issue_to_rs2 #b1) (_ bv2 3)
					(ite (= issue_to_rs3 #b1) (_ bv3 3)
					(ite (= issue_to_rs4 #b1) (_ bv4 3) 
					(ite (= issue_to_rs5 #b1) (_ bv5 3) 
					(ite (= issue_to_rs6 #b1) (_ bv6 3) 
					(ite (= issue_to_rs7 #b1) (_ bv7 3)  
					(_ bv0 3)))))))))
				)
				(LSQ_Issue_index 
					(ite (= issue_to_lsq7 #b1) (_ bv7 3)
					(ite (= issue_to_lsq6 #b1) (_ bv6 3)
					(ite (= issue_to_lsq5 #b1) (_ bv5 3)
					(ite (= issue_to_lsq4 #b1) (_ bv4 3)
					(ite (= issue_to_lsq3 #b1) (_ bv3 3)
					(ite (= issue_to_lsq2 #b1) (_ bv2 3)
					(ite (= issue_to_lsq1 #b1) (_ bv1 3)
					(ite (= issue_to_lsq0 #b1) (_ bv0 3) 
					(_ bv0 3)))))))))
				)
				(RS_issued (bvor issue_to_rs0 issue_to_rs1 issue_to_rs2 issue_to_rs3 issue_to_rs4 issue_to_rs5 issue_to_rs6 issue_to_rs7))
				(LSQ_issued (bvor issue_to_lsq7 issue_to_lsq6 issue_to_lsq5 issue_to_lsq4 issue_to_lsq3 issue_to_lsq2 issue_to_lsq1 issue_to_lsq0))
			)
		(let
			(
				(ROB_busy_update (store T_ROB_busy T_IP (_ bv1 1)))
				(ROB_op_type_update (store T_ROB_op_type T_IP op_type))
				(ROB_destination_update (store T_ROB_destination T_IP RF_destination))
				(ROB_result_update (store T_ROB_result T_IP 0))
				(ROB_exception_update (store T_ROB_exception T_IP (_ bv0 1)))
				(ROB_done_update (store T_ROB_done T_IP (_ bv0 1)))
				
				(IP_update (ite (= IP_update #b000000) (_ bv1 6) IP_update))	;if IP+1= rob0 then Loop back to 1
				
				(RS_op_type_update (store T_RS_op_type RS_Issue_index op_type))
				(RS_op_update (store T_RS_op RS_Issue_index op))
				(RS_ROB_dst_update (store T_RS_ROB_dst RS_Issue_index T_IP))
				(RS_vj_update (store T_RS_vj RS_Issue_index RF_rs))
				(RS_vk_update (store T_RS_vk RS_Issue_index RF_rt))
				(RS_qj_update (store T_RS_qj RS_Issue_index RAT_rs))
				(RS_qk_update (store T_RS_qk RS_Issue_index RAT_rt))
				(RS_imm_update (store T_RS_imm RS_Issue_index imm))
				(RS_dis_update (store T_RS_dis RS_Issue_index (_ bv0 1)))
				(RS_busy_update (store T_RS_busy RS_Issue_index (_ bv1 1)))
				(RS_Ltag_update (store T_RS_Ltag RS_Issue_index T_Main_Ltag))
				
				(LSQ_op_type_update (store T_LSQ_op_type LSQ_Issue_index op_type))
				(LSQ_op_update (store T_LSQ_op LSQ_Issue_index op))
				(LSQ_ROB_dst_update (store T_LSQ_ROB_dst LSQ_Issue_index T_IP))
				(LSQ_vj_update (store T_LSQ_vj LSQ_Issue_index RF_rs))
				(LSQ_vk_update (store T_LSQ_vk LSQ_Issue_index RF_rt))
				(LSQ_qj_update (store T_LSQ_qj LSQ_Issue_index RAT_rs))
				(LSQ_qk_update (store T_LSQ_qk LSQ_Issue_index RAT_rt))
				(LSQ_imm_update (store T_LSQ_imm LSQ_Issue_index imm))
				(LSQ_dis_update (store T_LSQ_dis LSQ_Issue_index (_ bv0 1)))
				(LSQ_busy_update (store T_LSQ_busy LSQ_Issue_index (_ bv1 1)))
				(LSQ_Ltag_update (store T_LSQ_Ltag LSQ_Issue_index T_Main_Ltag))
				
				(T_Main_Ltag_update (ite (= op_type Lfence) T_IP T_Main_Ltag))
			)
		(let
			(
				
				(U1_RF (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_RF T_RF))
				(U1_DM (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_DM T_DM))
				
				(U1_Cache_Tag (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Tag T_Cache_Tag))
				(U1_Cache_Data (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Data T_Cache_Data))
				(U1_Cache_Valid (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Valid T_Cache_Valid))
				
				(U1_PC
					(ite (= op_type Jump) imm
					(ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) PC_plus_one 
					T_PC))
				)
				
				(U1_IP (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) IP_update T_IP))
				(U1_CP (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_CP T_CP))
				
				(U1_ROB_busy (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_busy_update T_ROB_busy))
				(U1_ROB_op_type (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_op_type_update T_ROB_op_type))
				(U1_ROB_destination (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_destination_update T_ROB_destination))
				(U1_ROB_result (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_result_update T_ROB_result))
				(U1_ROB_exception (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_exception_update T_ROB_exception))
				(U1_ROB_done (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_done_update T_ROB_done))
				
				(U1_RS_op_type (ite (and (= stall #b0) (= RS_issued #b1)) RS_op_type_update T_RS_op_type))
				(U1_RS_op (ite (and (= stall #b0) (= RS_issued #b1)) RS_op_update T_RS_op))
				(U1_RS_ROB_dst (ite (and (= stall #b0) (= RS_issued #b1)) RS_ROB_dst_update T_RS_ROB_dst))
				(U1_RS_vj (ite (and (= stall #b0) (= RS_issued #b1)) RS_vj_update T_RS_vj))
				(U1_RS_vk (ite (and (= stall #b0) (= RS_issued #b1)) RS_vk_update T_RS_vk))
				(U1_RS_qj (ite (and (= stall #b0) (= RS_issued #b1)) RS_qj_update T_RS_qj))
				(U1_RS_qk (ite (and (= stall #b0) (= RS_issued #b1)) RS_qk_update T_RS_qk))
				(U1_RS_imm (ite (and (= stall #b0) (= RS_issued #b1)) RS_imm_update T_RS_imm))
				(U1_RS_dis (ite (and (= stall #b0) (= RS_issued #b1)) RS_dis_update T_RS_dis))
				(U1_RS_busy (ite (and (= stall #b0) (= RS_issued #b1)) RS_busy_update T_RS_busy))
				(U1_RS_Ltag (ite (and (= stall #b0) (= RS_issued #b1)) RS_Ltag_update T_RS_Ltag))
				
				(U1_LSQ_op_type (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_op_type_update T_LSQ_op_type))
				(U1_LSQ_op (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_op_update T_LSQ_op))
				(U1_LSQ_ROB_dst (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_ROB_dst_update T_LSQ_ROB_dst))
				(U1_LSQ_vj (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_vj_update T_LSQ_vj))
				(U1_LSQ_vk (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_vk_update T_LSQ_vk))
				(U1_LSQ_qj (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_qj_update T_LSQ_qj))
				(U1_LSQ_qk (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_qk_update T_LSQ_qk))
				(U1_LSQ_imm (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_imm_update T_LSQ_imm))
				(U1_LSQ_dis (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_dis_update T_LSQ_dis))
				(U1_LSQ_busy (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_busy_update T_LSQ_busy))
				(U1_LSQ_Ltag (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_Ltag_update T_LSQ_Ltag))
				
				
				(U1_Main_Ltag (ite (and (= stall #b0) (= RS_issued #b1)) T_Main_Ltag_update T_Main_Ltag))
			
			)
;---------------------------Update--------------------------------------------------------------	
		(let
			(
				(U1_RS0_busy (select U1_RS_busy (_ bv0 3)))
				(U1_RS0_qj (select U1_RS_qj (_ bv0 3)))
				(U1_RS0_qk (select U1_RS_qk (_ bv0 3)))
				(U1_RS1_busy (select U1_RS_busy (_ bv1 3)))
				(U1_RS1_qj (select U1_RS_qj (_ bv1 3)))
				(U1_RS1_qk (select U1_RS_qk (_ bv1 3)))
				(U1_RS2_busy (select U1_RS_busy (_ bv2 3)))
				(U1_RS2_qj (select U1_RS_qj (_ bv2 3)))
				(U1_RS2_qk (select U1_RS_qk (_ bv2 3)))
				(U1_RS3_busy (select U1_RS_busy (_ bv3 3)))
				(U1_RS3_qj (select U1_RS_qj (_ bv3 3)))
				(U1_RS3_qk (select U1_RS_qk (_ bv3 3)))
				(U1_RS4_busy (select U1_RS_busy (_ bv4 3)))
				(U1_RS4_qj (select U1_RS_qj (_ bv4 3)))
				(U1_RS4_qk (select U1_RS_qk (_ bv4 3)))
				(U1_RS5_busy (select U1_RS_busy (_ bv5 3)))
				(U1_RS5_qj (select U1_RS_qj (_ bv5 3)))
				(U1_RS5_qk (select U1_RS_qk (_ bv5 3)))
				(U1_RS6_busy (select U1_RS_busy (_ bv6 3)))
				(U1_RS6_qj (select U1_RS_qj (_ bv6 3)))
				(U1_RS6_qk (select U1_RS_qk (_ bv6 3)))
				(U1_RS7_busy (select U1_RS_busy (_ bv7 3)))
				(U1_RS7_qj (select U1_RS_qj (_ bv7 3)))
				(U1_RS7_qk (select U1_RS_qk (_ bv7 3)))
				
				(U1_LSQ0_busy (select U1_LSQ_busy (_ bv0 3)))
				(U1_LSQ0_qj (select U1_LSQ_qj (_ bv0 3)))
				(U1_LSQ0_qk (select U1_LSQ_qk (_ bv0 3)))
				(U1_LSQ1_busy (select U1_LSQ_busy (_ bv1 3)))
				(U1_LSQ1_qj (select U1_LSQ_qj (_ bv1 3)))
				(U1_LSQ1_qk (select U1_LSQ_qk (_ bv1 3)))
				(U1_LSQ2_busy (select U1_LSQ_busy (_ bv2 3)))
				(U1_LSQ2_qj (select U1_LSQ_qj (_ bv2 3)))
				(U1_LSQ2_qk (select U1_LSQ_qk (_ bv2 3)))
				(U1_LSQ3_busy (select U1_LSQ_busy (_ bv3 3)))
				(U1_LSQ3_qj (select U1_LSQ_qj (_ bv3 3)))
				(U1_LSQ3_qk (select U1_LSQ_qk (_ bv3 3)))
				(U1_LSQ4_busy (select U1_LSQ_busy (_ bv4 3)))
				(U1_LSQ4_qj (select U1_LSQ_qj (_ bv4 3)))
				(U1_LSQ4_qk (select U1_LSQ_qk (_ bv4 3)))
				(U1_LSQ5_busy (select U1_LSQ_busy (_ bv5 3)))
				(U1_LSQ5_qj (select U1_LSQ_qj (_ bv5 3)))
				(U1_LSQ5_qk (select U1_LSQ_qk (_ bv5 3)))
				(U1_LSQ6_busy (select U1_LSQ_busy (_ bv6 3)))
				(U1_LSQ6_qj (select U1_LSQ_qj (_ bv6 3)))
				(U1_LSQ6_qk (select U1_LSQ_qk (_ bv6 3)))
				(U1_LSQ7_busy (select U1_LSQ_busy (_ bv7 3)))
				(U1_LSQ7_qj (select U1_LSQ_qj (_ bv7 3)))
				(U1_LSQ7_qk (select U1_LSQ_qk (_ bv7 3)))
			)
		(let
			(
				(U1_RS0_qj_ROB_done (select U1_ROB_done U1_RS0_qj))
				(U1_RS0_qj_ROB_result (select U1_ROB_result U1_RS0_qj))
				(U1_RS0_qk_ROB_done (select U1_ROB_done U1_RS0_qk))
				(U1_RS0_qk_ROB_result (select U1_ROB_result U1_RS0_qk))
				(U1_RS1_qj_ROB_done (select U1_ROB_done U1_RS1_qj))
				(U1_RS1_qj_ROB_result (select U1_ROB_result U1_RS1_qj))
				(U1_RS1_qk_ROB_done (select U1_ROB_done U1_RS1_qk))
				(U1_RS1_qk_ROB_result (select U1_ROB_result U1_RS1_qk))
				(U1_RS2_qj_ROB_done (select U1_ROB_done U1_RS2_qj))
				(U1_RS2_qj_ROB_result (select U1_ROB_result U1_RS2_qj))
				(U1_RS2_qk_ROB_done (select U1_ROB_done U1_RS2_qk))
				(U1_RS2_qk_ROB_result (select U1_ROB_result U1_RS2_qk))
				(U1_RS3_qj_ROB_done (select U1_ROB_done U1_RS3_qj))
				(U1_RS3_qj_ROB_result (select U1_ROB_result U1_RS3_qj))
				(U1_RS3_qk_ROB_done (select U1_ROB_done U1_RS3_qk))
				(U1_RS3_qk_ROB_result (select U1_ROB_result U1_RS3_qk))
				(U1_RS4_qj_ROB_done (select U1_ROB_done U1_RS4_qj))
				(U1_RS4_qj_ROB_result (select U1_ROB_result U1_RS4_qj))
				(U1_RS4_qk_ROB_done (select U1_ROB_done U1_RS4_qk))
				(U1_RS4_qk_ROB_result (select U1_ROB_result U1_RS4_qk))
				(U1_RS5_qj_ROB_done (select U1_ROB_done U1_RS5_qj))
				(U1_RS5_qj_ROB_result (select U1_ROB_result U1_RS5_qj))
				(U1_RS5_qk_ROB_done (select U1_ROB_done U1_RS5_qk))
				(U1_RS5_qk_ROB_result (select U1_ROB_result U1_RS5_qk))
				(U1_RS6_qj_ROB_done (select U1_ROB_done U1_RS6_qj))
				(U1_RS6_qj_ROB_result (select U1_ROB_result U1_RS6_qj))
				(U1_RS6_qk_ROB_done (select U1_ROB_done U1_RS6_qk))
				(U1_RS6_qk_ROB_result (select U1_ROB_result U1_RS6_qk))
				(U1_RS7_qj_ROB_done (select U1_ROB_done U1_RS7_qj))
				(U1_RS7_qj_ROB_result (select U1_ROB_result U1_RS7_qj))
				(U1_RS7_qk_ROB_done (select U1_ROB_done U1_RS7_qk))
				(U1_RS7_qk_ROB_result (select U1_ROB_result U1_RS7_qk))
				
				(U1_LSQ0_qj_ROB_done (select U1_ROB_done U1_LSQ0_qj))
				(U1_LSQ0_qj_ROB_result (select U1_ROB_result U1_LSQ0_qj))
				(U1_LSQ0_qk_ROB_done (select U1_ROB_done U1_LSQ0_qk))
				(U1_LSQ0_qk_ROB_result (select U1_ROB_result U1_LSQ0_qk))
				(U1_LSQ1_qj_ROB_done (select U1_ROB_done U1_LSQ1_qj))
				(U1_LSQ1_qj_ROB_result (select U1_ROB_result U1_LSQ1_qj))
				(U1_LSQ1_qk_ROB_done (select U1_ROB_done U1_LSQ1_qk))
				(U1_LSQ1_qk_ROB_result (select U1_ROB_result U1_LSQ1_qk))
				(U1_LSQ2_qj_ROB_done (select U1_ROB_done U1_LSQ2_qj))
				(U1_LSQ2_qj_ROB_result (select U1_ROB_result U1_LSQ2_qj))
				(U1_LSQ2_qk_ROB_done (select U1_ROB_done U1_LSQ2_qk))
				(U1_LSQ2_qk_ROB_result (select U1_ROB_result U1_LSQ2_qk))
				(U1_LSQ3_qj_ROB_done (select U1_ROB_done U1_LSQ3_qj))
				(U1_LSQ3_qj_ROB_result (select U1_ROB_result U1_LSQ3_qj))
				(U1_LSQ3_qk_ROB_done (select U1_ROB_done U1_LSQ3_qk))
				(U1_LSQ3_qk_ROB_result (select U1_ROB_result U1_LSQ3_qk))
				(U1_LSQ4_qj_ROB_done (select U1_ROB_done U1_LSQ4_qj))
				(U1_LSQ4_qj_ROB_result (select U1_ROB_result U1_LSQ4_qj))
				(U1_LSQ4_qk_ROB_done (select U1_ROB_done U1_LSQ4_qk))
				(U1_LSQ4_qk_ROB_result (select U1_ROB_result U1_LSQ4_qk))
				(U1_LSQ5_qj_ROB_done (select U1_ROB_done U1_LSQ5_qj))
				(U1_LSQ5_qj_ROB_result (select U1_ROB_result U1_LSQ5_qj))
				(U1_LSQ5_qk_ROB_done (select U1_ROB_done U1_LSQ5_qk))
				(U1_LSQ5_qk_ROB_result (select U1_ROB_result U1_LSQ5_qk))
				(U1_LSQ6_qj_ROB_done (select U1_ROB_done U1_LSQ6_qj))
				(U1_LSQ6_qj_ROB_result (select U1_ROB_result U1_LSQ6_qj))
				(U1_LSQ6_qk_ROB_done (select U1_ROB_done U1_LSQ6_qk))
				(U1_LSQ6_qk_ROB_result (select U1_ROB_result U1_LSQ6_qk))
				(U1_LSQ7_qj_ROB_done (select U1_ROB_done U1_LSQ7_qj))
				(U1_LSQ7_qj_ROB_result (select U1_ROB_result U1_LSQ7_qj))
				(U1_LSQ7_qk_ROB_done (select U1_ROB_done U1_LSQ7_qk))
				(U1_LSQ7_qk_ROB_result (select U1_ROB_result U1_LSQ7_qk))
			)
		(let
			(
				(U1_RS0_vj_update (store U1_RS_vj (_ bv0 3) U1_RS0_qj_ROB_result))
				(U1_RS0_vk_update (store U1_RS_vk (_ bv0 3) U1_RS0_qk_ROB_result))					
				(U1_RS0_qj_update (store U1_RS_qj (_ bv0 3) (_ bv0 6)))	
				(U1_RS0_qk_update (store U1_RS_qk (_ bv0 3) (_ bv0 6)))	
				(U1_LSQ0_vj_update (store U1_LSQ_vj (_ bv0 3) U1_LSQ0_qj_ROB_result))	
				(U1_LSQ0_vk_update (store U1_LSQ_vk (_ bv0 3) U1_LSQ0_qk_ROB_result))	
				(U1_LSQ0_qj_update (store U1_LSQ_qj (_ bv0 3) (_ bv0 6)))	
				(U1_LSQ0_qk_update (store U1_LSQ_qk (_ bv0 3) (_ bv0 6)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS0_busy) (not (= #b000000 U1_RS0_qj)) (= #b1 U1_RS0_qj_ROB_done)) U1_RS0_vj_update U1_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS0_busy) (not (= #b000000 U1_RS0_qk)) (= #b1 U1_RS0_qk_ROB_done)) U1_RS0_vk_update U1_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS0_busy) (not (= #b000000 U1_RS0_qj)) (= #b1 U1_RS0_qj_ROB_done)) U1_RS0_qj_update U1_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS0_busy) (not (= #b000000 U1_RS0_qk)) (= #b1 U1_RS0_qk_ROB_done)) U1_RS0_qk_update U1_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ0_busy) (not (= #b000000 U1_LSQ0_qj)) (= #b1 U1_LSQ0_qj_ROB_done)) U1_LSQ0_vj_update U1_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ0_busy) (not (= #b000000 U1_LSQ0_qk)) (= #b1 U1_LSQ0_qk_ROB_done)) U1_LSQ0_vk_update U1_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ0_busy) (not (= #b000000 U1_LSQ0_qj)) (= #b1 U1_LSQ0_qj_ROB_done)) U1_LSQ0_qj_update U1_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ0_busy) (not (= #b000000 U1_LSQ0_qk)) (= #b1 U1_LSQ0_qk_ROB_done)) U1_LSQ0_qk_update U1_LSQ_qk))
			)
		(let
			(
				(U1_RS1_vj_update (store U2_RS_vj (_ bv1 3) U1_RS1_qj_ROB_result))	
				(U1_RS1_vk_update (store U2_RS_vk (_ bv1 3) U1_RS1_qk_ROB_result))	
				(U1_RS1_qj_update (store U2_RS_qj (_ bv1 3) (_ bv0 6)))	
				(U1_RS1_qk_update (store U2_RS_qk (_ bv1 3) (_ bv0 6)))	
				(U1_LSQ1_vj_update (store U2_LSQ_vj (_ bv1 3) U1_LSQ1_qj_ROB_result))	
				(U1_LSQ1_vk_update (store U2_LSQ_vk (_ bv1 3) U1_LSQ1_qk_ROB_result))	
				(U1_LSQ1_qj_update (store U2_LSQ_qj (_ bv1 3) (_ bv0 6)))	
				(U1_LSQ1_qk_update (store U2_LSQ_qk (_ bv1 3) (_ bv0 6)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS1_busy) (not (= #b000000 U1_RS1_qj)) (= #b1 U1_RS1_qj_ROB_done)) U1_RS1_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS1_busy) (not (= #b000000 U1_RS1_qk)) (= #b1 U1_RS1_qk_ROB_done)) U1_RS1_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS1_busy) (not (= #b000000 U1_RS1_qj)) (= #b1 U1_RS1_qj_ROB_done)) U1_RS1_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS1_busy) (not (= #b000000 U1_RS1_qk)) (= #b1 U1_RS1_qk_ROB_done)) U1_RS1_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ1_busy) (not (= #b000000 U1_LSQ1_qj)) (= #b1 U1_LSQ1_qj_ROB_done)) U1_LSQ1_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ1_busy) (not (= #b000000 U1_LSQ1_qk)) (= #b1 U1_LSQ1_qk_ROB_done)) U1_LSQ1_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ1_busy) (not (= #b000000 U1_LSQ1_qj)) (= #b1 U1_LSQ1_qj_ROB_done)) U1_LSQ1_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ1_busy) (not (= #b000000 U1_LSQ1_qk)) (= #b1 U1_LSQ1_qk_ROB_done)) U1_LSQ1_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U1_RS2_vj_update (store U2_RS_vj (_ bv2 3) U1_RS2_qj_ROB_result))	
				(U1_RS2_vk_update (store U2_RS_vk (_ bv2 3) U1_RS2_qk_ROB_result))	
				(U1_RS2_qj_update (store U2_RS_qj (_ bv2 3) (_ bv0 6)))	
				(U1_RS2_qk_update (store U2_RS_qk (_ bv2 3) (_ bv0 6)))	
				(U1_LSQ2_vj_update (store U2_LSQ_vj (_ bv2 3) U1_LSQ2_qj_ROB_result))	
				(U1_LSQ2_vk_update (store U2_LSQ_vk (_ bv2 3) U1_LSQ2_qk_ROB_result))	
				(U1_LSQ2_qj_update (store U2_LSQ_qj (_ bv2 3) (_ bv0 6)))	
				(U1_LSQ2_qk_update (store U2_LSQ_qk (_ bv2 3) (_ bv0 6)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS2_busy) (not (= #b000000 U1_RS2_qj)) (= #b1 U1_RS2_qj_ROB_done)) U1_RS2_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS2_busy) (not (= #b000000 U1_RS2_qk)) (= #b1 U1_RS2_qk_ROB_done)) U1_RS2_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS2_busy) (not (= #b000000 U1_RS2_qj)) (= #b1 U1_RS2_qj_ROB_done)) U1_RS2_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS2_busy) (not (= #b000000 U1_RS2_qk)) (= #b1 U1_RS2_qk_ROB_done)) U1_RS2_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ2_busy) (not (= #b000000 U1_LSQ2_qj)) (= #b1 U1_LSQ2_qj_ROB_done)) U1_LSQ2_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ2_busy) (not (= #b000000 U1_LSQ2_qk)) (= #b1 U1_LSQ2_qk_ROB_done)) U1_LSQ2_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ2_busy) (not (= #b000000 U1_LSQ2_qj)) (= #b1 U1_LSQ2_qj_ROB_done)) U1_LSQ2_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ2_busy) (not (= #b000000 U1_LSQ2_qk)) (= #b1 U1_LSQ2_qk_ROB_done)) U1_LSQ2_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U1_RS3_vj_update (store U2_RS_vj (_ bv3 3) U1_RS3_qj_ROB_result))	
				(U1_RS3_vk_update (store U2_RS_vk (_ bv3 3) U1_RS3_qk_ROB_result))	
				(U1_RS3_qj_update (store U2_RS_qj (_ bv3 3) (_ bv0 6)))	
				(U1_RS3_qk_update (store U2_RS_qk (_ bv3 3) (_ bv0 6)))	
				(U1_LSQ3_vj_update (store U2_LSQ_vj (_ bv3 3) U1_LSQ3_qj_ROB_result))	
				(U1_LSQ3_vk_update (store U2_LSQ_vk (_ bv3 3) U1_LSQ3_qk_ROB_result))	
				(U1_LSQ3_qj_update (store U2_LSQ_qj (_ bv3 3) (_ bv0 6)))	
				(U1_LSQ3_qk_update (store U2_LSQ_qk (_ bv3 3) (_ bv0 6)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS3_busy) (not (= #b000000 U1_RS3_qj)) (= #b1 U1_RS3_qj_ROB_done)) U1_RS3_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS3_busy) (not (= #b000000 U1_RS3_qk)) (= #b1 U1_RS3_qk_ROB_done)) U1_RS3_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS3_busy) (not (= #b000000 U1_RS3_qj)) (= #b1 U1_RS3_qj_ROB_done)) U1_RS3_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS3_busy) (not (= #b000000 U1_RS3_qk)) (= #b1 U1_RS3_qk_ROB_done)) U1_RS3_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ3_busy) (not (= #b000000 U1_LSQ3_qj)) (= #b1 U1_LSQ3_qj_ROB_done)) U1_LSQ3_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ3_busy) (not (= #b000000 U1_LSQ3_qk)) (= #b1 U1_LSQ3_qk_ROB_done)) U1_LSQ3_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ3_busy) (not (= #b000000 U1_LSQ3_qj)) (= #b1 U1_LSQ3_qj_ROB_done)) U1_LSQ3_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ3_busy) (not (= #b000000 U1_LSQ3_qk)) (= #b1 U1_LSQ3_qk_ROB_done)) U1_LSQ3_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U1_RS4_vj_update (store U2_RS_vj (_ bv4 3) U1_RS4_qj_ROB_result))	
				(U1_RS4_vk_update (store U2_RS_vk (_ bv4 3) U1_RS4_qk_ROB_result))	
				(U1_RS4_qj_update (store U2_RS_qj (_ bv4 3) (_ bv0 6)))	
				(U1_RS4_qk_update (store U2_RS_qk (_ bv4 3) (_ bv0 6)))	
				(U1_LSQ4_vj_update (store U2_LSQ_vj (_ bv4 3) U1_LSQ4_qj_ROB_result))	
				(U1_LSQ4_vk_update (store U2_LSQ_vk (_ bv4 3) U1_LSQ4_qk_ROB_result))	
				(U1_LSQ4_qj_update (store U2_LSQ_qj (_ bv4 3) (_ bv0 6)))	
				(U1_LSQ4_qk_update (store U2_LSQ_qk (_ bv4 3) (_ bv0 6)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS4_busy) (not (= #b000000 U1_RS4_qj)) (= #b1 U1_RS4_qj_ROB_done)) U1_RS4_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS4_busy) (not (= #b000000 U1_RS4_qk)) (= #b1 U1_RS4_qk_ROB_done)) U1_RS4_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS4_busy) (not (= #b000000 U1_RS4_qj)) (= #b1 U1_RS4_qj_ROB_done)) U1_RS4_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS4_busy) (not (= #b000000 U1_RS4_qk)) (= #b1 U1_RS4_qk_ROB_done)) U1_RS4_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ4_busy) (not (= #b000000 U1_LSQ4_qj)) (= #b1 U1_LSQ4_qj_ROB_done)) U1_LSQ4_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ4_busy) (not (= #b000000 U1_LSQ4_qk)) (= #b1 U1_LSQ4_qk_ROB_done)) U1_LSQ4_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ4_busy) (not (= #b000000 U1_LSQ4_qj)) (= #b1 U1_LSQ4_qj_ROB_done)) U1_LSQ4_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ4_busy) (not (= #b000000 U1_LSQ4_qk)) (= #b1 U1_LSQ4_qk_ROB_done)) U1_LSQ4_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U1_RS5_vj_update (store U2_RS_vj (_ bv5 3) U1_RS5_qj_ROB_result))	
				(U1_RS5_vk_update (store U2_RS_vk (_ bv5 3) U1_RS5_qk_ROB_result))	
				(U1_RS5_qj_update (store U2_RS_qj (_ bv5 3) (_ bv0 6)))	
				(U1_RS5_qk_update (store U2_RS_qk (_ bv5 3) (_ bv0 6)))	
				(U1_LSQ5_vj_update (store U2_LSQ_vj (_ bv5 3) U1_LSQ5_qj_ROB_result))	
				(U1_LSQ5_vk_update (store U2_LSQ_vk (_ bv5 3) U1_LSQ5_qk_ROB_result))	
				(U1_LSQ5_qj_update (store U2_LSQ_qj (_ bv5 3) (_ bv0 6)))	
				(U1_LSQ5_qk_update (store U2_LSQ_qk (_ bv5 3) (_ bv0 6)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS5_busy) (not (= #b000000 U1_RS5_qj)) (= #b1 U1_RS5_qj_ROB_done)) U1_RS5_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS5_busy) (not (= #b000000 U1_RS5_qk)) (= #b1 U1_RS5_qk_ROB_done)) U1_RS5_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS5_busy) (not (= #b000000 U1_RS5_qj)) (= #b1 U1_RS5_qj_ROB_done)) U1_RS5_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS5_busy) (not (= #b000000 U1_RS5_qk)) (= #b1 U1_RS5_qk_ROB_done)) U1_RS5_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ5_busy) (not (= #b000000 U1_LSQ5_qj)) (= #b1 U1_LSQ5_qj_ROB_done)) U1_LSQ5_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ5_busy) (not (= #b000000 U1_LSQ5_qk)) (= #b1 U1_LSQ5_qk_ROB_done)) U1_LSQ5_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ5_busy) (not (= #b000000 U1_LSQ5_qj)) (= #b1 U1_LSQ5_qj_ROB_done)) U1_LSQ5_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ5_busy) (not (= #b000000 U1_LSQ5_qk)) (= #b1 U1_LSQ5_qk_ROB_done)) U1_LSQ5_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U1_RS6_vj_update (store U2_RS_vj (_ bv6 3) U1_RS6_qj_ROB_result))	
				(U1_RS6_vk_update (store U2_RS_vk (_ bv6 3) U1_RS6_qk_ROB_result))	
				(U1_RS6_qj_update (store U2_RS_qj (_ bv6 3) (_ bv0 6)))	
				(U1_RS6_qk_update (store U2_RS_qk (_ bv6 3) (_ bv0 6)))	
				(U1_LSQ6_vj_update (store U2_LSQ_vj (_ bv6 3) U1_LSQ6_qj_ROB_result))	
				(U1_LSQ6_vk_update (store U2_LSQ_vk (_ bv6 3) U1_LSQ6_qk_ROB_result))	
				(U1_LSQ6_qj_update (store U2_LSQ_qj (_ bv6 3) (_ bv0 6)))	
				(U1_LSQ6_qk_update (store U2_LSQ_qk (_ bv6 3) (_ bv0 6)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS6_busy) (not (= #b000000 U1_RS6_qj)) (= #b1 U1_RS6_qj_ROB_done)) U1_RS6_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS6_busy) (not (= #b000000 U1_RS6_qk)) (= #b1 U1_RS6_qk_ROB_done)) U1_RS6_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS6_busy) (not (= #b000000 U1_RS6_qj)) (= #b1 U1_RS6_qj_ROB_done)) U1_RS6_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS6_busy) (not (= #b000000 U1_RS6_qk)) (= #b1 U1_RS6_qk_ROB_done)) U1_RS6_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ6_busy) (not (= #b000000 U1_LSQ6_qj)) (= #b1 U1_LSQ6_qj_ROB_done)) U1_LSQ6_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ6_busy) (not (= #b000000 U1_LSQ6_qk)) (= #b1 U1_LSQ6_qk_ROB_done)) U1_LSQ6_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ6_busy) (not (= #b000000 U1_LSQ6_qj)) (= #b1 U1_LSQ6_qj_ROB_done)) U1_LSQ6_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ6_busy) (not (= #b000000 U1_LSQ6_qk)) (= #b1 U1_LSQ6_qk_ROB_done)) U1_LSQ6_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U1_RS7_vj_update (store U2_RS_vj (_ bv7 3) U1_RS7_qj_ROB_result))	
				(U1_RS7_vk_update (store U2_RS_vk (_ bv7 3) U1_RS7_qk_ROB_result))	
				(U1_RS7_qj_update (store U2_RS_qj (_ bv7 3) (_ bv0 6)))	
				(U1_RS7_qk_update (store U2_RS_qk (_ bv7 3) (_ bv0 6)))	
				(U1_LSQ7_vj_update (store U2_LSQ_vj (_ bv7 3) U1_LSQ7_qj_ROB_result))	
				(U1_LSQ7_vk_update (store U2_LSQ_vk (_ bv7 3) U1_LSQ7_qk_ROB_result))	
				(U1_LSQ7_qj_update (store U2_LSQ_qj (_ bv7 3) (_ bv0 6)))	
				(U1_LSQ7_qk_update (store U2_LSQ_qk (_ bv7 3) (_ bv0 6)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS7_busy) (not (= #b000000 U1_RS7_qj)) (= #b1 U1_RS7_qj_ROB_done)) U1_RS7_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS7_busy) (not (= #b000000 U1_RS7_qk)) (= #b1 U1_RS7_qk_ROB_done)) U1_RS7_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS7_busy) (not (= #b000000 U1_RS7_qj)) (= #b1 U1_RS7_qj_ROB_done)) U1_RS7_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS7_busy) (not (= #b000000 U1_RS7_qk)) (= #b1 U1_RS7_qk_ROB_done)) U1_RS7_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ7_busy) (not (= #b000000 U1_LSQ7_qj)) (= #b1 U1_LSQ7_qj_ROB_done)) U1_LSQ7_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ7_busy) (not (= #b000000 U1_LSQ7_qk)) (= #b1 U1_LSQ7_qk_ROB_done)) U1_LSQ7_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ7_busy) (not (= #b000000 U1_LSQ7_qj)) (= #b1 U1_LSQ7_qj_ROB_done)) U1_LSQ7_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ7_busy) (not (= #b000000 U1_LSQ7_qk)) (= #b1 U1_LSQ7_qk_ROB_done)) U1_LSQ7_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U2_RS0_busy (select U1_RS_busy (_ bv0 3)))
				(U2_RS0_qj (select U2_RS_qj (_ bv0 3)))
				(U2_RS0_qk (select U2_RS_qk (_ bv0 3)))
				(U2_RS1_busy (select U1_RS_busy (_ bv1 3)))
				(U2_RS1_qj (select U2_RS_qj (_ bv1 3)))
				(U2_RS1_qk (select U2_RS_qk (_ bv1 3)))
				(U2_RS2_busy (select U1_RS_busy (_ bv2 3)))
				(U2_RS2_qj (select U2_RS_qj (_ bv2 3)))
				(U2_RS2_qk (select U2_RS_qk (_ bv2 3)))
				(U2_RS3_busy (select U1_RS_busy (_ bv3 3)))
				(U2_RS3_qj (select U2_RS_qj (_ bv3 3)))
				(U2_RS3_qk (select U2_RS_qk (_ bv3 3)))
				(U2_RS4_busy (select U1_RS_busy (_ bv4 3)))
				(U2_RS4_qj (select U2_RS_qj (_ bv4 3)))
				(U2_RS4_qk (select U2_RS_qk (_ bv4 3)))
				(U2_RS5_busy (select U1_RS_busy (_ bv5 3)))
				(U2_RS5_qj (select U2_RS_qj (_ bv5 3)))
				(U2_RS5_qk (select U2_RS_qk (_ bv5 3)))
				(U2_RS6_busy (select U1_RS_busy (_ bv6 3)))
				(U2_RS6_qj (select U2_RS_qj (_ bv6 3)))
				(U2_RS6_qk (select U2_RS_qk (_ bv6 3)))
				(U2_RS7_busy (select U1_RS_busy (_ bv7 3)))
				(U2_RS7_qj (select U2_RS_qj (_ bv7 3)))
				(U2_RS7_qk (select U2_RS_qk (_ bv7 3)))
				(U2_LSQ0_busy (select U1_LSQ_busy (_ bv0 3)))
				(U2_LSQ0_qj (select U2_LSQ_qj (_ bv0 3)))
				(U2_LSQ0_qk (select U2_LSQ_qk (_ bv0 3)))
				(U2_LSQ1_busy (select U1_LSQ_busy (_ bv1 3)))
				(U2_LSQ1_qj (select U2_LSQ_qj (_ bv1 3)))
				(U2_LSQ1_qk (select U2_LSQ_qk (_ bv1 3)))
				(U2_LSQ2_busy (select U1_LSQ_busy (_ bv2 3)))
				(U2_LSQ2_qj (select U2_LSQ_qj (_ bv2 3)))
				(U2_LSQ2_qk (select U2_LSQ_qk (_ bv2 3)))
				(U2_LSQ3_busy (select U1_LSQ_busy (_ bv3 3)))
				(U2_LSQ3_qj (select U2_LSQ_qj (_ bv3 3)))
				(U2_LSQ3_qk (select U2_LSQ_qk (_ bv3 3)))
				(U2_LSQ4_busy (select U1_LSQ_busy (_ bv4 3)))
				(U2_LSQ4_qj (select U2_LSQ_qj (_ bv4 3)))
				(U2_LSQ4_qk (select U2_LSQ_qk (_ bv4 3)))
				(U2_LSQ5_busy (select U1_LSQ_busy (_ bv5 3)))
				(U2_LSQ5_qj (select U2_LSQ_qj (_ bv5 3)))
				(U2_LSQ5_qk (select U2_LSQ_qk (_ bv5 3)))
				(U2_LSQ6_busy (select U1_LSQ_busy (_ bv6 3)))
				(U2_LSQ6_qj (select U2_LSQ_qj (_ bv6 3)))
				(U2_LSQ6_qk (select U2_LSQ_qk (_ bv6 3)))
				(U2_LSQ7_busy (select U1_LSQ_busy (_ bv7 3)))
				(U2_LSQ7_qj (select U2_LSQ_qj (_ bv7 3)))
				(U2_LSQ7_qk (select U2_LSQ_qk (_ bv7 3)))
				(U2_LSQ0_Ltag (select U1_LSQ_Ltag (_ bv0 3)))
				(U2_LSQ1_Ltag (select U1_LSQ_Ltag (_ bv1 3)))
				(U2_LSQ2_Ltag (select U1_LSQ_Ltag (_ bv2 3)))
				(U2_LSQ3_Ltag (select U1_LSQ_Ltag (_ bv3 3)))
				(U2_LSQ4_Ltag (select U1_LSQ_Ltag (_ bv4 3)))
				(U2_LSQ5_Ltag (select U1_LSQ_Ltag (_ bv5 3)))
				(U2_LSQ6_Ltag (select U1_LSQ_Ltag (_ bv6 3)))
				(U2_LSQ7_Ltag (select U1_LSQ_Ltag (_ bv7 3)))
				
				(U2_RS0_Ltag (select U1_RS_Ltag (_ bv0 3)))
				(U2_RS1_Ltag (select U1_RS_Ltag (_ bv1 3)))
				(U2_RS2_Ltag (select U1_RS_Ltag (_ bv2 3)))
				(U2_RS3_Ltag (select U1_RS_Ltag (_ bv3 3)))
				(U2_RS4_Ltag (select U1_RS_Ltag (_ bv4 3)))
				(U2_RS5_Ltag (select U1_RS_Ltag (_ bv5 3)))
				(U2_RS6_Ltag (select U1_RS_Ltag (_ bv6 3)))
				(U2_RS7_Ltag (select U1_RS_Ltag (_ bv7 3)))
			)
		(let
			(
				(U2_RS0_dis (ite (and (= #b000000 U2_RS0_Ltag) (= #b1 U2_RS0_busy) (= #b000000 U2_RS0_qj) (= #b000000 U2_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_RS1_dis (ite (and (= #b000000 U2_RS1_Ltag) (= #b1 U2_RS1_busy) (= #b000000 U2_RS1_qj) (= #b000000 U2_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_RS2_dis (ite (and (= #b000000 U2_RS2_Ltag) (= #b1 U2_RS2_busy) (= #b000000 U2_RS2_qj) (= #b000000 U2_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_RS3_dis (ite (and (= #b000000 U2_RS3_Ltag) (= #b1 U2_RS3_busy) (= #b000000 U2_RS3_qj) (= #b000000 U2_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(U2_RS4_dis (ite (and (= #b000000 U2_RS4_Ltag) (= #b1 U2_RS4_busy) (= #b000000 U2_RS4_qj) (= #b000000 U2_RS4_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_RS5_dis (ite (and (= #b000000 U2_RS5_Ltag) (= #b1 U2_RS5_busy) (= #b000000 U2_RS5_qj) (= #b000000 U2_RS5_qk)) (_ bv1 1) (_ bv0 1)))	
				(U2_RS6_dis (ite (and (= #b000000 U2_RS6_Ltag) (= #b1 U2_RS6_busy) (= #b000000 U2_RS6_qj) (= #b000000 U2_RS6_qk)) (_ bv1 1) (_ bv0 1)))	
				(U2_RS7_dis (ite (and (= #b000000 U2_RS7_Ltag) (= #b1 U2_RS7_busy) (= #b000000 U2_RS7_qj) (= #b000000 U2_RS7_qk)) (_ bv1 1) (_ bv0 1)))		
				(U2_LSQ0_dis (ite (and (= #b000000 U2_LSQ0_Ltag) (= #b1 U2_LSQ0_busy) (= #b000000 U2_LSQ0_qj) (= #b000000 U2_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ1_dis (ite (and (= #b000000 U2_LSQ1_Ltag) (= #b1 U2_LSQ1_busy) (= #b000000 U2_LSQ1_qj) (= #b000000 U2_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ2_dis (ite (and (= #b000000 U2_LSQ2_Ltag) (= #b1 U2_LSQ2_busy) (= #b000000 U2_LSQ2_qj) (= #b000000 U2_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ3_dis (ite (and (= #b000000 U2_LSQ3_Ltag) (= #b1 U2_LSQ3_busy) (= #b000000 U2_LSQ3_qj) (= #b000000 U2_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ4_dis (ite (and (= #b000000 U2_LSQ4_Ltag) (= #b1 U2_LSQ4_busy) (= #b000000 U2_LSQ4_qj) (= #b000000 U2_LSQ4_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ5_dis (ite (and (= #b000000 U2_LSQ5_Ltag) (= #b1 U2_LSQ5_busy) (= #b000000 U2_LSQ5_qj) (= #b000000 U2_LSQ5_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ6_dis (ite (and (= #b000000 U2_LSQ6_Ltag) (= #b1 U2_LSQ6_busy) (= #b000000 U2_LSQ6_qj) (= #b000000 U2_LSQ6_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ7_dis (ite (and (= #b000000 U2_LSQ7_Ltag) (= #b1 U2_LSQ7_busy) (= #b000000 U2_LSQ7_qj) (= #b000000 U2_LSQ7_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(U2_RS_dis (store U1_RS_dis (_ bv0 3) U2_RS0_dis))
				(U2_LSQ_dis (store U1_LSQ_dis (_ bv0 3) U2_LSQ0_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv1 3) U2_RS1_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv1 3) U2_LSQ1_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv2 3) U2_RS2_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv2 3) U2_LSQ2_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv3 3) U2_RS3_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv3 3) U2_LSQ3_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv4 3) U2_RS4_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv4 3) U2_LSQ4_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv5 3) U2_RS5_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv5 3) U2_LSQ5_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv6 3) U2_RS6_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv6 3) U2_LSQ6_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv7 3) U2_RS7_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv7 3) U2_LSQ7_dis))
			)
		(let
			(
				(U2_RF (ite (= 0 0) U1_RF U1_RF))
				(U2_DM (ite (= 0 0) U1_DM U1_DM))
				
				(U2_Cache_Tag (ite (= 0 0) U1_Cache_Tag U1_Cache_Tag))
				(U2_Cache_Data (ite (= 0 0) U1_Cache_Data U1_Cache_Data))
				(U2_Cache_Valid (ite (= 0 0) U1_Cache_Valid U1_Cache_Valid))
				
				(U2_PC (ite (= 0 0) U1_PC U1_PC))
				
				(U2_IP (ite (= 0 0) U1_IP U1_IP))
				(U2_CP (ite (= 0 0) U1_CP U1_CP))
				
				(U2_ROB_busy (ite (= 0 0) U1_ROB_busy U1_ROB_busy))
				(U2_ROB_op_type (ite (= 0 0) U1_ROB_op_type U1_ROB_op_type))
				(U2_ROB_destination (ite (= 0 0) U1_ROB_destination U1_ROB_destination))
				(U2_ROB_result (ite (= 0 0) U1_ROB_result U1_ROB_result))
				(U2_ROB_exception (ite (= 0 0) U1_ROB_exception U1_ROB_exception))
				(U2_ROB_done (ite (= 0 0) U1_ROB_done U1_ROB_done))
				
				(U2_RS_op_type (ite (= 0 0) U1_RS_op_type U1_RS_op_type))
				(U2_RS_op (ite (= 0 0) U1_RS_op U1_RS_op))
				(U2_RS_ROB_dst (ite (= 0 0) U1_RS_ROB_dst U1_RS_ROB_dst))
				(U2_RS_vj (ite (= 0 0) U2_RS_vj U2_RS_vj))
				(U2_RS_vk (ite (= 0 0) U2_RS_vk U2_RS_vk))
				(U2_RS_qj (ite (= 0 0) U2_RS_qj U2_RS_qj))
				(U2_RS_qk (ite (= 0 0) U2_RS_qk U2_RS_qk))
				(U2_RS_imm (ite (= 0 0) U1_RS_imm U1_RS_imm))
				(U2_RS_dis (ite (= 0 0) U2_RS_dis U2_RS_dis))
				(U2_RS_busy (ite (= 0 0) U1_RS_busy U1_RS_busy))
				(U2_RS_Ltag (ite (= 0 0) U1_RS_Ltag U1_RS_Ltag))
				
				(U2_LSQ_op_type (ite (= 0 0) U1_LSQ_op_type U1_LSQ_op_type))
				(U2_LSQ_op (ite (= 0 0) U1_LSQ_op U1_LSQ_op))
				(U2_LSQ_ROB_dst (ite (= 0 0) U1_LSQ_ROB_dst U1_LSQ_ROB_dst))
				(U2_LSQ_vj (ite (= 0 0) U2_LSQ_vj U2_LSQ_vj))
				(U2_LSQ_vk (ite (= 0 0) U2_LSQ_vk U2_LSQ_vk))
				(U2_LSQ_qj (ite (= 0 0) U2_LSQ_qj U2_LSQ_qj))
				(U2_LSQ_qk (ite (= 0 0) U2_LSQ_qk U2_LSQ_qk))
				(U2_LSQ_imm (ite (= 0 0) U1_LSQ_imm U1_LSQ_imm))
				(U2_LSQ_dis (ite (= 0 0) U2_LSQ_dis U2_LSQ_dis))
				(U2_LSQ_busy (ite (= 0 0) U1_LSQ_busy U1_LSQ_busy))
				(U2_LSQ_Ltag (ite (= 0 0) U1_LSQ_Ltag U1_LSQ_Ltag))
				
				(U2_Main_Ltag (ite (= 0 0) U1_Main_Ltag U1_Main_Ltag))
				
			)
			
;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(U2_RS0_dis (select U2_RS_dis (_ bv0 3)))
				(U2_RS1_dis (select U2_RS_dis (_ bv1 3)))
				(U2_RS2_dis (select U2_RS_dis (_ bv2 3)))
				(U2_RS3_dis (select U2_RS_dis (_ bv3 3)))
				(U2_RS4_dis (select U2_RS_dis (_ bv4 3)))
				(U2_RS5_dis (select U2_RS_dis (_ bv5 3)))
				(U2_RS6_dis (select U2_RS_dis (_ bv6 3)))
				(U2_RS7_dis (select U2_RS_dis (_ bv7 3)))
				
				(U2_RS0_Ltag (select U2_RS_Ltag (_ bv0 3)))
				(U2_RS1_Ltag (select U2_RS_Ltag (_ bv1 3)))
				(U2_RS2_Ltag (select U2_RS_Ltag (_ bv2 3)))
				(U2_RS3_Ltag (select U2_RS_Ltag (_ bv3 3)))
				(U2_RS4_Ltag (select U2_RS_Ltag (_ bv4 3)))
				(U2_RS5_Ltag (select U2_RS_Ltag (_ bv5 3)))
				(U2_RS6_Ltag (select U2_RS_Ltag (_ bv6 3)))
				(U2_RS7_Ltag (select U2_RS_Ltag (_ bv7 3)))
				
			)
		(let
			(
				(U2_RS_dis_index
					(ite (and (= U2_RS0_dis #b1)) (_ bv0 3)
					(ite (and (= U2_RS1_Ltag #b000000) (= U2_RS1_dis #b1)) (_ bv1 3)
					(ite (and (= U2_RS2_Ltag #b000000) (= U2_RS2_dis #b1)) (_ bv2 3)
					(ite (and (= U2_RS3_Ltag #b000000) (= U2_RS3_dis #b1)) (_ bv3 3) 
					(ite (and (= U2_RS4_Ltag #b000000) (= U2_RS4_dis #b1)) (_ bv4 3) 
					(ite (and (= U2_RS5_Ltag #b000000) (= U2_RS5_dis #b1)) (_ bv5 3) 
					(ite (and (= U2_RS6_Ltag #b000000) (= U2_RS6_dis #b1)) (_ bv6 3) 
					(ite (and (= U2_RS7_Ltag #b000000) (= U2_RS7_dis #b1)) (_ bv7 3) 
					(_ bv0 3)
					))))))))
				)
				(U2_RS_entry_dispatched
					(ite (and (= U2_RS0_dis #b1)) (_ bv1 1)
					(ite (and (= U2_RS1_Ltag #b000000) (= U2_RS1_dis #b1)) (_ bv1 1)
					(ite (and (= U2_RS2_Ltag #b000000) (= U2_RS2_dis #b1)) (_ bv1 1)
					(ite (and (= U2_RS3_Ltag #b000000) (= U2_RS3_dis #b1)) (_ bv1 1) 
					(ite (and (= U2_RS4_Ltag #b000000) (= U2_RS4_dis #b1)) (_ bv1 1) 
					(ite (and (= U2_RS5_Ltag #b000000) (= U2_RS5_dis #b1)) (_ bv1 1) 
					(ite (and (= U2_RS6_Ltag #b000000) (= U2_RS6_dis #b1)) (_ bv1 1) 
					(ite (and (= U2_RS7_Ltag #b000000) (= U2_RS7_dis #b1)) (_ bv1 1) 
					(_ bv0 1)
					))))))))
				)
			)	
		(let
			(
				(U2_RS_dis_vj (select U2_RS_vj U2_RS_dis_index))
				(U2_RS_dis_vk (select U2_RS_vk U2_RS_dis_index))
				(U2_RS_dis_qj (select U2_RS_qj U2_RS_dis_index))
				(U2_RS_dis_qk (select U2_RS_qk U2_RS_dis_index))
				(U2_RS_dis_op (select U2_RS_op U2_RS_dis_index))
				(U2_RS_dis_op_type (select U2_RS_op_type U2_RS_dis_index))
				(U2_RS_dis_imm (select U2_RS_imm U2_RS_dis_index))
				(U2_RS_dis_ROB_dst (select U2_RS_ROB_dst U2_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR U2_RS_dis_vj U2_RS_dis_vk U2_RS_dis_imm U2_RS_dis_op))
				(ALU1_result (ALU1 U2_RS_dis_vj U2_RS_dis_vk U2_RS_dis_imm U2_RS_dis_op))
				(MUL_DIV_result (MUL_DIV U2_RS_dis_vj U2_RS_dis_vk U2_RS_dis_imm U2_RS_dis_op))
			)
		(let
			(
				(U2_RS_result
					(ite (= U2_RS_dis_op_type Rtype) ALU1_result
					(ite (= U2_RS_dis_op_type Branch) Branch_result
					(ite (= U2_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(U2_ROB_result_update (store U2_ROB_result U2_RS_dis_ROB_dst U2_RS_result))
				(U2_ROB_done_update (store U2_ROB_done U2_RS_dis_ROB_dst (_ bv1 1)))
				(U2_ROB_exception_update (store U2_ROB_exception U2_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(U3_ROB_result (ite (= U2_RS_entry_dispatched #b1) U2_ROB_result_update U2_ROB_result))
				(U3_ROB_done (ite (= U2_RS_entry_dispatched #b1) U2_ROB_done_update U2_ROB_done))
				(U3_ROB_exception (ite (and (= U2_RS_dis_op_type Branch) (= U2_RS_result 1) (= U2_RS_entry_dispatched #b1)) U2_ROB_exception_update U2_ROB_exception))
			)
		(let
			(
				(U2_RS_op_type_update (store U2_RS_op_type U2_RS_dis_index 0))
				(U2_RS_op_update (store U2_RS_op U2_RS_dis_index 0))
				(U2_RS_ROB_dst_update (store U2_RS_ROB_dst U2_RS_dis_index (_ bv0 6)))
				(U2_RS_vj_update (store U2_RS_vj U2_RS_dis_index 0))
				(U2_RS_vk_update (store U2_RS_vk U2_RS_dis_index 0))
				(U2_RS_qj_update (store U2_RS_qj U2_RS_dis_index (_ bv0 6)))
				(U2_RS_qk_update (store U2_RS_qk U2_RS_dis_index (_ bv0 6)))
				(U2_RS_imm_update (store U2_RS_imm U2_RS_dis_index 0))
				(U2_RS_dis_update (store U2_RS_dis U2_RS_dis_index (_ bv0 1)))
				(U2_RS_busy_update (store U2_RS_busy U2_RS_dis_index (_ bv0 1)))
				(U2_RS_Ltag_update (store U2_RS_Ltag U2_RS_dis_index (_ bv0 6)))
			)
		(let
			(
				(U3_RS_op_type (ite (= U2_RS_entry_dispatched #b1) U2_RS_op_type_update U2_RS_op_type))
				(U3_RS_op (ite (= U2_RS_entry_dispatched #b1) U2_RS_op_update U2_RS_op))
				(U3_RS_ROB_dst (ite (= U2_RS_entry_dispatched #b1) U2_RS_ROB_dst_update U2_RS_ROB_dst))
				(U3_RS_vj (ite (= U2_RS_entry_dispatched #b1) U2_RS_vj_update U2_RS_vj))
				(U3_RS_vk (ite (= U2_RS_entry_dispatched #b1) U2_RS_vk_update U2_RS_vk))
				(U3_RS_qj (ite (= U2_RS_entry_dispatched #b1) U2_RS_qj_update U2_RS_qj))
				(U3_RS_qk (ite (= U2_RS_entry_dispatched #b1) U2_RS_qk_update U2_RS_qk))
				(U3_RS_imm (ite (= U2_RS_entry_dispatched #b1) U2_RS_imm_update U2_RS_imm))
				(U3_RS_dis (ite (= U2_RS_entry_dispatched #b1) U2_RS_dis_update U2_RS_dis))
				(U3_RS_busy (ite (= U2_RS_entry_dispatched #b1) U2_RS_busy_update U2_RS_busy))
				(U3_RS_Ltag (ite (= U2_RS_entry_dispatched #b1) U2_RS_Ltag_update U2_RS_Ltag))
			)
;=============================================================================================================
		(let
			(
				(U2_LSQ0_dis (select U2_LSQ_dis (_ bv0 3)))
				(U2_LSQ1_dis (select U2_LSQ_dis (_ bv1 3)))
				(U2_LSQ2_dis (select U2_LSQ_dis (_ bv2 3)))
				(U2_LSQ3_dis (select U2_LSQ_dis (_ bv3 3)))
				(U2_LSQ4_dis (select U2_LSQ_dis (_ bv4 3)))
				(U2_LSQ5_dis (select U2_LSQ_dis (_ bv5 3)))
				(U2_LSQ6_dis (select U2_LSQ_dis (_ bv6 3)))
				(U2_LSQ7_dis (select U2_LSQ_dis (_ bv7 3)))
				
				(U2_LSQ0_Ltag (select U2_LSQ_Ltag (_ bv0 3)))
				(U2_LSQ1_Ltag (select U2_LSQ_Ltag (_ bv1 3)))
				(U2_LSQ2_Ltag (select U2_LSQ_Ltag (_ bv2 3)))
				(U2_LSQ3_Ltag (select U2_LSQ_Ltag (_ bv3 3)))
				(U2_LSQ4_Ltag (select U2_LSQ_Ltag (_ bv4 3)))
				(U2_LSQ5_Ltag (select U2_LSQ_Ltag (_ bv5 3)))
				(U2_LSQ6_Ltag (select U2_LSQ_Ltag (_ bv6 3)))
				(U2_LSQ7_Ltag (select U2_LSQ_Ltag (_ bv7 3)))
			)
		(let
			(
				(U2_LSQ_dis_index
					(ite (and (= U2_LSQ0_Ltag #b000000) (= U2_LSQ0_dis #b1)) (_ bv0 3)
					(ite (and (= U2_LSQ1_Ltag #b000000) (= U2_LSQ1_dis #b1)) (_ bv1 3)
					(ite (and (= U2_LSQ2_Ltag #b000000) (= U2_LSQ2_dis #b1)) (_ bv2 3)
					(ite (and (= U2_LSQ3_Ltag #b000000) (= U2_LSQ3_dis #b1)) (_ bv3 3) 
					(ite (and (= U2_LSQ4_Ltag #b000000) (= U2_LSQ4_dis #b1)) (_ bv4 3) 
					(ite (and (= U2_LSQ5_Ltag #b000000) (= U2_LSQ5_dis #b1)) (_ bv5 3) 
					(ite (and (= U2_LSQ6_Ltag #b000000) (= U2_LSQ6_dis #b1)) (_ bv6 3) 
					(ite (and (= U2_LSQ7_Ltag #b000000) (= U2_LSQ7_dis #b1)) (_ bv7 3) 
					(_ bv0 3)
					))))))))
				)
				(U2_LSQ_entry_dispatched
					(ite (and (= U2_LSQ0_Ltag #b000000) (= U2_LSQ0_dis #b1)) (_ bv1 1)
					(ite (and (= U2_LSQ1_Ltag #b000000) (= U2_LSQ1_dis #b1)) (_ bv1 1)
					(ite (and (= U2_LSQ2_Ltag #b000000) (= U2_LSQ2_dis #b1)) (_ bv1 1)
					(ite (and (= U2_LSQ3_Ltag #b000000) (= U2_LSQ3_dis #b1)) (_ bv1 1) 
					(ite (and (= U2_LSQ4_Ltag #b000000) (= U2_LSQ4_dis #b1)) (_ bv1 1) 
					(ite (and (= U2_LSQ5_Ltag #b000000) (= U2_LSQ5_dis #b1)) (_ bv1 1) 
					(ite (and (= U2_LSQ6_Ltag #b000000) (= U2_LSQ6_dis #b1)) (_ bv1 1) 
					(ite (and (= U2_LSQ7_Ltag #b000000) (= U2_LSQ7_dis #b1)) (_ bv1 1) 
					(_ bv0 1)
					))))))))
				)
			)	
		(let
			(
				(U2_LSQ_dis_vj (select U2_LSQ_vj U2_LSQ_dis_index))
				(U2_LSQ_dis_vk (select U2_LSQ_vk U2_LSQ_dis_index))
				(U2_LSQ_dis_qj (select U2_LSQ_qj U2_LSQ_dis_index))
				(U2_LSQ_dis_qk (select U2_LSQ_qk U2_LSQ_dis_index))
				(U2_LSQ_dis_op (select U2_LSQ_op U2_LSQ_dis_index))
				(U2_LSQ_dis_op_type (select U2_LSQ_op_type U2_LSQ_dis_index))
				(U2_LSQ_dis_imm (select U2_LSQ_imm U2_LSQ_dis_index))
				(U2_LSQ_dis_ROB_dst (select U2_LSQ_ROB_dst U2_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit U2_LSQ_dis_vj U2_LSQ_dis_imm U2_LSQ_dis_op))
				(Store_address (STORE_Unit U2_LSQ_dis_vj U2_LSQ_dis_imm U2_LSQ_dis_op))
			)
		(let
			(
				(U2_Cache0_Tag (select U2_Cache_Tag (_ bv0 2)))
				(U2_Cache0_Data (select U2_Cache_Data (_ bv0 2)))
				(U2_Cache0_Valid (select U2_Cache_Valid (_ bv0 2)))
				(U2_Cache1_Tag (select U2_Cache_Tag (_ bv1 2)))
				(U2_Cache1_Data (select U2_Cache_Data (_ bv1 2)))
				(U2_Cache1_Valid (select U2_Cache_Valid (_ bv1 2)))
				(U2_Cache2_Tag (select U2_Cache_Tag (_ bv2 2)))
				(U2_Cache2_Data (select U2_Cache_Data (_ bv2 2)))
				(U2_Cache2_Valid (select U2_Cache_Valid (_ bv2 2)))
				(U2_Cache3_Tag (select U2_Cache_Tag (_ bv3 2)))
				(U2_Cache3_Data (select U2_Cache_Data (_ bv3 2)))
				(U2_Cache3_Valid (select U2_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select U2_DM LOAD_addr))
				(U2_Cache0_Hit_Load (ite (and (= U2_Cache0_Valid #b1) (= U2_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U2_Cache1_Hit_Load (ite (and (= U2_Cache1_Valid #b1) (= U2_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U2_Cache2_Hit_Load (ite (and (= U2_Cache2_Valid #b1) (= U2_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U2_Cache3_Hit_Load (ite (and (= U2_Cache3_Valid #b1) (= U2_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_U2_Cache_Line 
					(ite (= U2_Cache0_Valid #b0) (_ bv0 2)	;check if U2_Cache line 0 is free
					(ite (= U2_Cache1_Valid #b0) (_ bv1 2)	;check if U2_Cache line 1 is free
					(ite (= U2_Cache2_Valid #b0) (_ bv2 2)	;check if U2_Cache line 2 is free
					(ite (= U2_Cache3_Valid #b0) (_ bv3 2)	;check if U2_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U2_Cache line 0 
					))))
				)
			)
		(let
			(
				(U2_Cache_Hit_load (bvor U2_Cache0_Hit_Load U2_Cache1_Hit_Load U2_Cache2_Hit_Load U2_Cache3_Hit_Load))
			)
		(let
			(
				(U2_LSQ_result
					(ite (= U2_LSQ_dis_op_type Load) LOAD_Value
					(ite (= U2_LSQ_dis_op_type Store) U2_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(U2_ROB_destination_update (store U2_ROB_destination U2_LSQ_dis_ROB_dst Store_address))
				(U2_ROB_result_load (store U3_ROB_result U2_LSQ_dis_ROB_dst LOAD_Value))
				(U2_ROB_result_store (store U3_ROB_result U2_LSQ_dis_ROB_dst U2_LSQ_dis_vk))
				(U2_ROB_done_update (store U3_ROB_done U2_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(U2_Cache_tag_Update_Load (store U2_Cache_Tag Available_U2_Cache_Line LOAD_addr))
				
				(U2_Cache_data_Update_Load (store U2_Cache_Data Available_U2_Cache_Line LOAD_Value))
				
				(U2_Cache_valid_Update_Load (store U2_Cache_Valid Available_U2_Cache_Line (_ bv1 1)))
				
				
			)
		(let
			(
				(U3_ROB_destination (ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_LSQ_dis_op_type Store)) U2_ROB_destination_update U2_ROB_destination))
				(U3_ROB_result
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_LSQ_dis_op_type Load)) U2_ROB_result_load
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_LSQ_dis_op_type Store)) U2_ROB_result_store
					U3_ROB_result
					))
				)
				(U3_ROB_done (ite (= U2_LSQ_entry_dispatched #b1) U2_ROB_done_update U3_ROB_done))
				
				(U3_Cache_Tag
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load)) U2_Cache_tag_Update_Load			;If load and U2_Cache miss, update the U2_Cache
					U2_Cache_Tag
					)
				)
				(U3_Cache_Data
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load)) U2_Cache_data_Update_Load			;If load and U2_Cache miss, update the U2_Cache
					U2_Cache_Data
					)
				)
				(U3_Cache_Valid
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load)) U2_Cache_valid_Update_Load			;If load and U2_Cache miss, update the U2_Cache
					U2_Cache_Valid
					)
				)
			)
		(let
			(
				(U2_LSQ_op_type_update (store U2_LSQ_op_type U2_LSQ_dis_index 0))
				(U2_LSQ_op_update (store U2_LSQ_op U2_LSQ_dis_index 0))
				(U2_LSQ_ROB_dst_update (store U2_LSQ_ROB_dst U2_LSQ_dis_index (_ bv0 6)))
				(U2_LSQ_vj_update (store U2_LSQ_vj U2_LSQ_dis_index 0))
				(U2_LSQ_vk_update (store U2_LSQ_vk U2_LSQ_dis_index 0))
				(U2_LSQ_qj_update (store U2_LSQ_qj U2_LSQ_dis_index (_ bv0 6)))
				(U2_LSQ_qk_update (store U2_LSQ_qk U2_LSQ_dis_index (_ bv0 6)))
				(U2_LSQ_imm_update (store U2_LSQ_imm U2_LSQ_dis_index 0))
				(U2_LSQ_dis_update (store U2_LSQ_dis U2_LSQ_dis_index (_ bv0 1)))
				(U2_LSQ_busy_update (store U2_LSQ_busy U2_LSQ_dis_index (_ bv0 1)))
				(U2_LSQ_Ltag_update (store U2_LSQ_Ltag U2_LSQ_dis_index (_ bv0 6)))
			)
		(let
			(
				(U3_LSQ_op_type (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_op_type_update U2_LSQ_op_type))
				(U3_LSQ_op (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_op_update U2_LSQ_op))
				(U3_LSQ_ROB_dst (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_ROB_dst_update U2_LSQ_ROB_dst))
				(U3_LSQ_vj (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_vj_update U2_LSQ_vj))
				(U3_LSQ_vk (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_vk_update U2_LSQ_vk))
				(U3_LSQ_qj (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_qj_update U2_LSQ_qj))
				(U3_LSQ_qk (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_qk_update U2_LSQ_qk))
				(U3_LSQ_imm (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_imm_update U2_LSQ_imm))
				(U3_LSQ_dis (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_dis_update U2_LSQ_dis))
				(U3_LSQ_busy (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_busy_update U2_LSQ_busy))
				(U3_LSQ_Ltag (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_Ltag_update U2_LSQ_Ltag))
				
				(U3_Main_Ltag (ite (= 0 0) U2_Main_Ltag U2_Main_Ltag))
			)
;==================================update======================================================================
		(let
			(
				(U3_RS0_busy (select U3_RS_busy (_ bv0 3)))
				(U3_RS0_qj (select U3_RS_qj (_ bv0 3)))
				(U3_RS0_qk (select U3_RS_qk (_ bv0 3)))
				(U3_RS1_busy (select U3_RS_busy (_ bv1 3)))
				(U3_RS1_qj (select U3_RS_qj (_ bv1 3)))
				(U3_RS1_qk (select U3_RS_qk (_ bv1 3)))
				(U3_RS2_busy (select U3_RS_busy (_ bv2 3)))
				(U3_RS2_qj (select U3_RS_qj (_ bv2 3)))
				(U3_RS2_qk (select U3_RS_qk (_ bv2 3)))
				(U3_RS3_busy (select U3_RS_busy (_ bv3 3)))
				(U3_RS3_qj (select U3_RS_qj (_ bv3 3)))
				(U3_RS3_qk (select U3_RS_qk (_ bv3 3)))
				(U3_RS4_busy (select U3_RS_busy (_ bv4 3)))
				(U3_RS4_qj (select U3_RS_qj (_ bv4 3)))
				(U3_RS4_qk (select U3_RS_qk (_ bv4 3)))
				(U3_RS5_busy (select U3_RS_busy (_ bv5 3)))
				(U3_RS5_qj (select U3_RS_qj (_ bv5 3)))
				(U3_RS5_qk (select U3_RS_qk (_ bv5 3)))
				(U3_RS6_busy (select U3_RS_busy (_ bv6 3)))
				(U3_RS6_qj (select U3_RS_qj (_ bv6 3)))
				(U3_RS6_qk (select U3_RS_qk (_ bv6 3)))
				(U3_RS7_busy (select U3_RS_busy (_ bv7 3)))
				(U3_RS7_qj (select U3_RS_qj (_ bv7 3)))
				(U3_RS7_qk (select U3_RS_qk (_ bv7 3)))
				
				(U3_LSQ0_busy (select U3_LSQ_busy (_ bv0 3)))
				(U3_LSQ0_qj (select U3_LSQ_qj (_ bv0 3)))
				(U3_LSQ0_qk (select U3_LSQ_qk (_ bv0 3)))
				(U3_LSQ1_busy (select U3_LSQ_busy (_ bv1 3)))
				(U3_LSQ1_qj (select U3_LSQ_qj (_ bv1 3)))
				(U3_LSQ1_qk (select U3_LSQ_qk (_ bv1 3)))
				(U3_LSQ2_busy (select U3_LSQ_busy (_ bv2 3)))
				(U3_LSQ2_qj (select U3_LSQ_qj (_ bv2 3)))
				(U3_LSQ2_qk (select U3_LSQ_qk (_ bv2 3)))
				(U3_LSQ3_busy (select U3_LSQ_busy (_ bv3 3)))
				(U3_LSQ3_qj (select U3_LSQ_qj (_ bv3 3)))
				(U3_LSQ3_qk (select U3_LSQ_qk (_ bv3 3)))
				(U3_LSQ4_busy (select U3_LSQ_busy (_ bv4 3)))
				(U3_LSQ4_qj (select U3_LSQ_qj (_ bv4 3)))
				(U3_LSQ4_qk (select U3_LSQ_qk (_ bv4 3)))
				(U3_LSQ5_busy (select U3_LSQ_busy (_ bv5 3)))
				(U3_LSQ5_qj (select U3_LSQ_qj (_ bv5 3)))
				(U3_LSQ5_qk (select U3_LSQ_qk (_ bv5 3)))
				(U3_LSQ6_busy (select U3_LSQ_busy (_ bv6 3)))
				(U3_LSQ6_qj (select U3_LSQ_qj (_ bv6 3)))
				(U3_LSQ6_qk (select U3_LSQ_qk (_ bv6 3)))
				(U3_LSQ7_busy (select U3_LSQ_busy (_ bv7 3)))
				(U3_LSQ7_qj (select U3_LSQ_qj (_ bv7 3)))
				(U3_LSQ7_qk (select U3_LSQ_qk (_ bv7 3)))
			)
		(let
			(
				(U3_RS0_qj_ROB_done (select U3_ROB_done U3_RS0_qj))
				(U3_RS0_qj_ROB_result (select U3_ROB_result U3_RS0_qj))
				(U3_RS0_qk_ROB_done (select U3_ROB_done U3_RS0_qk))
				(U3_RS0_qk_ROB_result (select U3_ROB_result U3_RS0_qk))
				(U3_RS1_qj_ROB_done (select U3_ROB_done U3_RS1_qj))
				(U3_RS1_qj_ROB_result (select U3_ROB_result U3_RS1_qj))
				(U3_RS1_qk_ROB_done (select U3_ROB_done U3_RS1_qk))
				(U3_RS1_qk_ROB_result (select U3_ROB_result U3_RS1_qk))
				(U3_RS2_qj_ROB_done (select U3_ROB_done U3_RS2_qj))
				(U3_RS2_qj_ROB_result (select U3_ROB_result U3_RS2_qj))
				(U3_RS2_qk_ROB_done (select U3_ROB_done U3_RS2_qk))
				(U3_RS2_qk_ROB_result (select U3_ROB_result U3_RS2_qk))
				(U3_RS3_qj_ROB_done (select U3_ROB_done U3_RS3_qj))
				(U3_RS3_qj_ROB_result (select U3_ROB_result U3_RS3_qj))
				(U3_RS3_qk_ROB_done (select U3_ROB_done U3_RS3_qk))
				(U3_RS3_qk_ROB_result (select U3_ROB_result U3_RS3_qk))
				(U3_RS4_qj_ROB_done (select U3_ROB_done U3_RS4_qj))
				(U3_RS4_qj_ROB_result (select U3_ROB_result U3_RS4_qj))
				(U3_RS4_qk_ROB_done (select U3_ROB_done U3_RS4_qk))
				(U3_RS4_qk_ROB_result (select U3_ROB_result U3_RS4_qk))
				(U3_RS5_qj_ROB_done (select U3_ROB_done U3_RS5_qj))
				(U3_RS5_qj_ROB_result (select U3_ROB_result U3_RS5_qj))
				(U3_RS5_qk_ROB_done (select U3_ROB_done U3_RS5_qk))
				(U3_RS5_qk_ROB_result (select U3_ROB_result U3_RS5_qk))
				(U3_RS6_qj_ROB_done (select U3_ROB_done U3_RS6_qj))
				(U3_RS6_qj_ROB_result (select U3_ROB_result U3_RS6_qj))
				(U3_RS6_qk_ROB_done (select U3_ROB_done U3_RS6_qk))
				(U3_RS6_qk_ROB_result (select U3_ROB_result U3_RS6_qk))
				(U3_RS7_qj_ROB_done (select U3_ROB_done U3_RS7_qj))
				(U3_RS7_qj_ROB_result (select U3_ROB_result U3_RS7_qj))
				(U3_RS7_qk_ROB_done (select U3_ROB_done U3_RS7_qk))
				(U3_RS7_qk_ROB_result (select U3_ROB_result U3_RS7_qk))
				
				(U3_LSQ0_qj_ROB_done (select U3_ROB_done U3_LSQ0_qj))
				(U3_LSQ0_qj_ROB_result (select U3_ROB_result U3_LSQ0_qj))
				(U3_LSQ0_qk_ROB_done (select U3_ROB_done U3_LSQ0_qk))
				(U3_LSQ0_qk_ROB_result (select U3_ROB_result U3_LSQ0_qk))
				(U3_LSQ1_qj_ROB_done (select U3_ROB_done U3_LSQ1_qj))
				(U3_LSQ1_qj_ROB_result (select U3_ROB_result U3_LSQ1_qj))
				(U3_LSQ1_qk_ROB_done (select U3_ROB_done U3_LSQ1_qk))
				(U3_LSQ1_qk_ROB_result (select U3_ROB_result U3_LSQ1_qk))
				(U3_LSQ2_qj_ROB_done (select U3_ROB_done U3_LSQ2_qj))
				(U3_LSQ2_qj_ROB_result (select U3_ROB_result U3_LSQ2_qj))
				(U3_LSQ2_qk_ROB_done (select U3_ROB_done U3_LSQ2_qk))
				(U3_LSQ2_qk_ROB_result (select U3_ROB_result U3_LSQ2_qk))
				(U3_LSQ3_qj_ROB_done (select U3_ROB_done U3_LSQ3_qj))
				(U3_LSQ3_qj_ROB_result (select U3_ROB_result U3_LSQ3_qj))
				(U3_LSQ3_qk_ROB_done (select U3_ROB_done U3_LSQ3_qk))
				(U3_LSQ3_qk_ROB_result (select U3_ROB_result U3_LSQ3_qk))
				(U3_LSQ4_qj_ROB_done (select U3_ROB_done U3_LSQ4_qj))
				(U3_LSQ4_qj_ROB_result (select U3_ROB_result U3_LSQ4_qj))
				(U3_LSQ4_qk_ROB_done (select U3_ROB_done U3_LSQ4_qk))
				(U3_LSQ4_qk_ROB_result (select U3_ROB_result U3_LSQ4_qk))
				(U3_LSQ5_qj_ROB_done (select U3_ROB_done U3_LSQ5_qj))
				(U3_LSQ5_qj_ROB_result (select U3_ROB_result U3_LSQ5_qj))
				(U3_LSQ5_qk_ROB_done (select U3_ROB_done U3_LSQ5_qk))
				(U3_LSQ5_qk_ROB_result (select U3_ROB_result U3_LSQ5_qk))
				(U3_LSQ6_qj_ROB_done (select U3_ROB_done U3_LSQ6_qj))
				(U3_LSQ6_qj_ROB_result (select U3_ROB_result U3_LSQ6_qj))
				(U3_LSQ6_qk_ROB_done (select U3_ROB_done U3_LSQ6_qk))
				(U3_LSQ6_qk_ROB_result (select U3_ROB_result U3_LSQ6_qk))
				(U3_LSQ7_qj_ROB_done (select U3_ROB_done U3_LSQ7_qj))
				(U3_LSQ7_qj_ROB_result (select U3_ROB_result U3_LSQ7_qj))
				(U3_LSQ7_qk_ROB_done (select U3_ROB_done U3_LSQ7_qk))
				(U3_LSQ7_qk_ROB_result (select U3_ROB_result U3_LSQ7_qk))
			)
		(let
			(
				(U3_RS0_vj_update (store U3_RS_vj (_ bv0 3) U3_RS0_qj_ROB_result))
				(U3_RS0_vk_update (store U3_RS_vk (_ bv0 3) U3_RS0_qk_ROB_result))					
				(U3_RS0_qj_update (store U3_RS_qj (_ bv0 3) (_ bv0 6)))	
				(U3_RS0_qk_update (store U3_RS_qk (_ bv0 3) (_ bv0 6)))	
				(U3_LSQ0_vj_update (store U3_LSQ_vj (_ bv0 3) U3_LSQ0_qj_ROB_result))	
				(U3_LSQ0_vk_update (store U3_LSQ_vk (_ bv0 3) U3_LSQ0_qk_ROB_result))	
				(U3_LSQ0_qj_update (store U3_LSQ_qj (_ bv0 3) (_ bv0 6)))	
				(U3_LSQ0_qk_update (store U3_LSQ_qk (_ bv0 3) (_ bv0 6)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS0_busy) (not (= #b000000 U3_RS0_qj)) (= #b1 U3_RS0_qj_ROB_done)) U3_RS0_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS0_busy) (not (= #b000000 U3_RS0_qk)) (= #b1 U3_RS0_qk_ROB_done)) U3_RS0_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS0_busy) (not (= #b000000 U3_RS0_qj)) (= #b1 U3_RS0_qj_ROB_done)) U3_RS0_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS0_busy) (not (= #b000000 U3_RS0_qk)) (= #b1 U3_RS0_qk_ROB_done)) U3_RS0_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ0_busy) (not (= #b000000 U3_LSQ0_qj)) (= #b1 U3_LSQ0_qj_ROB_done)) U3_LSQ0_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ0_busy) (not (= #b000000 U3_LSQ0_qk)) (= #b1 U3_LSQ0_qk_ROB_done)) U3_LSQ0_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ0_busy) (not (= #b000000 U3_LSQ0_qj)) (= #b1 U3_LSQ0_qj_ROB_done)) U3_LSQ0_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ0_busy) (not (= #b000000 U3_LSQ0_qk)) (= #b1 U3_LSQ0_qk_ROB_done)) U3_LSQ0_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS1_vj_update (store U3_RS_vj (_ bv1 3) U3_RS1_qj_ROB_result))	
				(U3_RS1_vk_update (store U3_RS_vk (_ bv1 3) U3_RS1_qk_ROB_result))	
				(U3_RS1_qj_update (store U3_RS_qj (_ bv1 3) (_ bv0 6)))	
				(U3_RS1_qk_update (store U3_RS_qk (_ bv1 3) (_ bv0 6)))	
				(U3_LSQ1_vj_update (store U3_LSQ_vj (_ bv1 3) U3_LSQ1_qj_ROB_result))	
				(U3_LSQ1_vk_update (store U3_LSQ_vk (_ bv1 3) U3_LSQ1_qk_ROB_result))	
				(U3_LSQ1_qj_update (store U3_LSQ_qj (_ bv1 3) (_ bv0 6)))	
				(U3_LSQ1_qk_update (store U3_LSQ_qk (_ bv1 3) (_ bv0 6)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS1_busy) (not (= #b000000 U3_RS1_qj)) (= #b1 U3_RS1_qj_ROB_done)) U3_RS1_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS1_busy) (not (= #b000000 U3_RS1_qk)) (= #b1 U3_RS1_qk_ROB_done)) U3_RS1_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS1_busy) (not (= #b000000 U3_RS1_qj)) (= #b1 U3_RS1_qj_ROB_done)) U3_RS1_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS1_busy) (not (= #b000000 U3_RS1_qk)) (= #b1 U3_RS1_qk_ROB_done)) U3_RS1_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ1_busy) (not (= #b000000 U3_LSQ1_qj)) (= #b1 U3_LSQ1_qj_ROB_done)) U3_LSQ1_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ1_busy) (not (= #b000000 U3_LSQ1_qk)) (= #b1 U3_LSQ1_qk_ROB_done)) U3_LSQ1_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ1_busy) (not (= #b000000 U3_LSQ1_qj)) (= #b1 U3_LSQ1_qj_ROB_done)) U3_LSQ1_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ1_busy) (not (= #b000000 U3_LSQ1_qk)) (= #b1 U3_LSQ1_qk_ROB_done)) U3_LSQ1_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS2_vj_update (store U3_RS_vj (_ bv2 3) U3_RS2_qj_ROB_result))	
				(U3_RS2_vk_update (store U3_RS_vk (_ bv2 3) U3_RS2_qk_ROB_result))	
				(U3_RS2_qj_update (store U3_RS_qj (_ bv2 3) (_ bv0 6)))	
				(U3_RS2_qk_update (store U3_RS_qk (_ bv2 3) (_ bv0 6)))	
				(U3_LSQ2_vj_update (store U3_LSQ_vj (_ bv2 3) U3_LSQ2_qj_ROB_result))	
				(U3_LSQ2_vk_update (store U3_LSQ_vk (_ bv2 3) U3_LSQ2_qk_ROB_result))	
				(U3_LSQ2_qj_update (store U3_LSQ_qj (_ bv2 3) (_ bv0 6)))	
				(U3_LSQ2_qk_update (store U3_LSQ_qk (_ bv2 3) (_ bv0 6)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS2_busy) (not (= #b000000 U3_RS2_qj)) (= #b1 U3_RS2_qj_ROB_done)) U3_RS2_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS2_busy) (not (= #b000000 U3_RS2_qk)) (= #b1 U3_RS2_qk_ROB_done)) U3_RS2_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS2_busy) (not (= #b000000 U3_RS2_qj)) (= #b1 U3_RS2_qj_ROB_done)) U3_RS2_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS2_busy) (not (= #b000000 U3_RS2_qk)) (= #b1 U3_RS2_qk_ROB_done)) U3_RS2_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ2_busy) (not (= #b000000 U3_LSQ2_qj)) (= #b1 U3_LSQ2_qj_ROB_done)) U3_LSQ2_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ2_busy) (not (= #b000000 U3_LSQ2_qk)) (= #b1 U3_LSQ2_qk_ROB_done)) U3_LSQ2_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ2_busy) (not (= #b000000 U3_LSQ2_qj)) (= #b1 U3_LSQ2_qj_ROB_done)) U3_LSQ2_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ2_busy) (not (= #b000000 U3_LSQ2_qk)) (= #b1 U3_LSQ2_qk_ROB_done)) U3_LSQ2_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS3_vj_update (store U3_RS_vj (_ bv3 3) U3_RS3_qj_ROB_result))	
				(U3_RS3_vk_update (store U3_RS_vk (_ bv3 3) U3_RS3_qk_ROB_result))	
				(U3_RS3_qj_update (store U3_RS_qj (_ bv3 3) (_ bv0 6)))	
				(U3_RS3_qk_update (store U3_RS_qk (_ bv3 3) (_ bv0 6)))	
				(U3_LSQ3_vj_update (store U3_LSQ_vj (_ bv3 3) U3_LSQ3_qj_ROB_result))	
				(U3_LSQ3_vk_update (store U3_LSQ_vk (_ bv3 3) U3_LSQ3_qk_ROB_result))	
				(U3_LSQ3_qj_update (store U3_LSQ_qj (_ bv3 3) (_ bv0 6)))	
				(U3_LSQ3_qk_update (store U3_LSQ_qk (_ bv3 3) (_ bv0 6)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS3_busy) (not (= #b000000 U3_RS3_qj)) (= #b1 U3_RS3_qj_ROB_done)) U3_RS3_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS3_busy) (not (= #b000000 U3_RS3_qk)) (= #b1 U3_RS3_qk_ROB_done)) U3_RS3_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS3_busy) (not (= #b000000 U3_RS3_qj)) (= #b1 U3_RS3_qj_ROB_done)) U3_RS3_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS3_busy) (not (= #b000000 U3_RS3_qk)) (= #b1 U3_RS3_qk_ROB_done)) U3_RS3_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ3_busy) (not (= #b000000 U3_LSQ3_qj)) (= #b1 U3_LSQ3_qj_ROB_done)) U3_LSQ3_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ3_busy) (not (= #b000000 U3_LSQ3_qk)) (= #b1 U3_LSQ3_qk_ROB_done)) U3_LSQ3_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ3_busy) (not (= #b000000 U3_LSQ3_qj)) (= #b1 U3_LSQ3_qj_ROB_done)) U3_LSQ3_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ3_busy) (not (= #b000000 U3_LSQ3_qk)) (= #b1 U3_LSQ3_qk_ROB_done)) U3_LSQ3_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS4_vj_update (store U3_RS_vj (_ bv4 3) U3_RS4_qj_ROB_result))	
				(U3_RS4_vk_update (store U3_RS_vk (_ bv4 3) U3_RS4_qk_ROB_result))	
				(U3_RS4_qj_update (store U3_RS_qj (_ bv4 3) (_ bv0 6)))	
				(U3_RS4_qk_update (store U3_RS_qk (_ bv4 3) (_ bv0 6)))	
				(U3_LSQ4_vj_update (store U3_LSQ_vj (_ bv4 3) U3_LSQ4_qj_ROB_result))	
				(U3_LSQ4_vk_update (store U3_LSQ_vk (_ bv4 3) U3_LSQ4_qk_ROB_result))	
				(U3_LSQ4_qj_update (store U3_LSQ_qj (_ bv4 3) (_ bv0 6)))	
				(U3_LSQ4_qk_update (store U3_LSQ_qk (_ bv4 3) (_ bv0 6)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS4_busy) (not (= #b000000 U3_RS4_qj)) (= #b1 U3_RS4_qj_ROB_done)) U3_RS4_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS4_busy) (not (= #b000000 U3_RS4_qk)) (= #b1 U3_RS4_qk_ROB_done)) U3_RS4_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS4_busy) (not (= #b000000 U3_RS4_qj)) (= #b1 U3_RS4_qj_ROB_done)) U3_RS4_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS4_busy) (not (= #b000000 U3_RS4_qk)) (= #b1 U3_RS4_qk_ROB_done)) U3_RS4_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ4_busy) (not (= #b000000 U3_LSQ4_qj)) (= #b1 U3_LSQ4_qj_ROB_done)) U3_LSQ4_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ4_busy) (not (= #b000000 U3_LSQ4_qk)) (= #b1 U3_LSQ4_qk_ROB_done)) U3_LSQ4_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ4_busy) (not (= #b000000 U3_LSQ4_qj)) (= #b1 U3_LSQ4_qj_ROB_done)) U3_LSQ4_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ4_busy) (not (= #b000000 U3_LSQ4_qk)) (= #b1 U3_LSQ4_qk_ROB_done)) U3_LSQ4_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS5_vj_update (store U3_RS_vj (_ bv5 3) U3_RS5_qj_ROB_result))	
				(U3_RS5_vk_update (store U3_RS_vk (_ bv5 3) U3_RS5_qk_ROB_result))	
				(U3_RS5_qj_update (store U3_RS_qj (_ bv5 3) (_ bv0 6)))	
				(U3_RS5_qk_update (store U3_RS_qk (_ bv5 3) (_ bv0 6)))	
				(U3_LSQ5_vj_update (store U3_LSQ_vj (_ bv5 3) U3_LSQ5_qj_ROB_result))	
				(U3_LSQ5_vk_update (store U3_LSQ_vk (_ bv5 3) U3_LSQ5_qk_ROB_result))	
				(U3_LSQ5_qj_update (store U3_LSQ_qj (_ bv5 3) (_ bv0 6)))	
				(U3_LSQ5_qk_update (store U3_LSQ_qk (_ bv5 3) (_ bv0 6)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS5_busy) (not (= #b000000 U3_RS5_qj)) (= #b1 U3_RS5_qj_ROB_done)) U3_RS5_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS5_busy) (not (= #b000000 U3_RS5_qk)) (= #b1 U3_RS5_qk_ROB_done)) U3_RS5_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS5_busy) (not (= #b000000 U3_RS5_qj)) (= #b1 U3_RS5_qj_ROB_done)) U3_RS5_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS5_busy) (not (= #b000000 U3_RS5_qk)) (= #b1 U3_RS5_qk_ROB_done)) U3_RS5_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ5_busy) (not (= #b000000 U3_LSQ5_qj)) (= #b1 U3_LSQ5_qj_ROB_done)) U3_LSQ5_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ5_busy) (not (= #b000000 U3_LSQ5_qk)) (= #b1 U3_LSQ5_qk_ROB_done)) U3_LSQ5_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ5_busy) (not (= #b000000 U3_LSQ5_qj)) (= #b1 U3_LSQ5_qj_ROB_done)) U3_LSQ5_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ5_busy) (not (= #b000000 U3_LSQ5_qk)) (= #b1 U3_LSQ5_qk_ROB_done)) U3_LSQ5_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS6_vj_update (store U3_RS_vj (_ bv6 3) U3_RS6_qj_ROB_result))	
				(U3_RS6_vk_update (store U3_RS_vk (_ bv6 3) U3_RS6_qk_ROB_result))	
				(U3_RS6_qj_update (store U3_RS_qj (_ bv6 3) (_ bv0 6)))	
				(U3_RS6_qk_update (store U3_RS_qk (_ bv6 3) (_ bv0 6)))	
				(U3_LSQ6_vj_update (store U3_LSQ_vj (_ bv6 3) U3_LSQ6_qj_ROB_result))	
				(U3_LSQ6_vk_update (store U3_LSQ_vk (_ bv6 3) U3_LSQ6_qk_ROB_result))	
				(U3_LSQ6_qj_update (store U3_LSQ_qj (_ bv6 3) (_ bv0 6)))	
				(U3_LSQ6_qk_update (store U3_LSQ_qk (_ bv6 3) (_ bv0 6)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS6_busy) (not (= #b000000 U3_RS6_qj)) (= #b1 U3_RS6_qj_ROB_done)) U3_RS6_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS6_busy) (not (= #b000000 U3_RS6_qk)) (= #b1 U3_RS6_qk_ROB_done)) U3_RS6_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS6_busy) (not (= #b000000 U3_RS6_qj)) (= #b1 U3_RS6_qj_ROB_done)) U3_RS6_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS6_busy) (not (= #b000000 U3_RS6_qk)) (= #b1 U3_RS6_qk_ROB_done)) U3_RS6_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ6_busy) (not (= #b000000 U3_LSQ6_qj)) (= #b1 U3_LSQ6_qj_ROB_done)) U3_LSQ6_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ6_busy) (not (= #b000000 U3_LSQ6_qk)) (= #b1 U3_LSQ6_qk_ROB_done)) U3_LSQ6_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ6_busy) (not (= #b000000 U3_LSQ6_qj)) (= #b1 U3_LSQ6_qj_ROB_done)) U3_LSQ6_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ6_busy) (not (= #b000000 U3_LSQ6_qk)) (= #b1 U3_LSQ6_qk_ROB_done)) U3_LSQ6_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS7_vj_update (store U3_RS_vj (_ bv7 3) U3_RS7_qj_ROB_result))	
				(U3_RS7_vk_update (store U3_RS_vk (_ bv7 3) U3_RS7_qk_ROB_result))	
				(U3_RS7_qj_update (store U3_RS_qj (_ bv7 3) (_ bv0 6)))	
				(U3_RS7_qk_update (store U3_RS_qk (_ bv7 3) (_ bv0 6)))	
				(U3_LSQ7_vj_update (store U3_LSQ_vj (_ bv7 3) U3_LSQ7_qj_ROB_result))	
				(U3_LSQ7_vk_update (store U3_LSQ_vk (_ bv7 3) U3_LSQ7_qk_ROB_result))	
				(U3_LSQ7_qj_update (store U3_LSQ_qj (_ bv7 3) (_ bv0 6)))	
				(U3_LSQ7_qk_update (store U3_LSQ_qk (_ bv7 3) (_ bv0 6)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS7_busy) (not (= #b000000 U3_RS7_qj)) (= #b1 U3_RS7_qj_ROB_done)) U3_RS7_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS7_busy) (not (= #b000000 U3_RS7_qk)) (= #b1 U3_RS7_qk_ROB_done)) U3_RS7_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS7_busy) (not (= #b000000 U3_RS7_qj)) (= #b1 U3_RS7_qj_ROB_done)) U3_RS7_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS7_busy) (not (= #b000000 U3_RS7_qk)) (= #b1 U3_RS7_qk_ROB_done)) U3_RS7_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ7_busy) (not (= #b000000 U3_LSQ7_qj)) (= #b1 U3_LSQ7_qj_ROB_done)) U3_LSQ7_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ7_busy) (not (= #b000000 U3_LSQ7_qk)) (= #b1 U3_LSQ7_qk_ROB_done)) U3_LSQ7_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ7_busy) (not (= #b000000 U3_LSQ7_qj)) (= #b1 U3_LSQ7_qj_ROB_done)) U3_LSQ7_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ7_busy) (not (= #b000000 U3_LSQ7_qk)) (= #b1 U3_LSQ7_qk_ROB_done)) U3_LSQ7_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS0_busy (select U3_RS_busy (_ bv0 3)))
				(U3_RS0_qj (select U3_RS_qj (_ bv0 3)))
				(U3_RS0_qk (select U3_RS_qk (_ bv0 3)))
				(U3_RS1_busy (select U3_RS_busy (_ bv1 3)))
				(U3_RS1_qj (select U3_RS_qj (_ bv1 3)))
				(U3_RS1_qk (select U3_RS_qk (_ bv1 3)))
				(U3_RS2_busy (select U3_RS_busy (_ bv2 3)))
				(U3_RS2_qj (select U3_RS_qj (_ bv2 3)))
				(U3_RS2_qk (select U3_RS_qk (_ bv2 3)))
				(U3_RS3_busy (select U3_RS_busy (_ bv3 3)))
				(U3_RS3_qj (select U3_RS_qj (_ bv3 3)))
				(U3_RS3_qk (select U3_RS_qk (_ bv3 3)))
				(U3_RS4_busy (select U3_RS_busy (_ bv4 3)))
				(U3_RS4_qj (select U3_RS_qj (_ bv4 3)))
				(U3_RS4_qk (select U3_RS_qk (_ bv4 3)))
				(U3_RS5_busy (select U3_RS_busy (_ bv5 3)))
				(U3_RS5_qj (select U3_RS_qj (_ bv5 3)))
				(U3_RS5_qk (select U3_RS_qk (_ bv5 3)))
				(U3_RS6_busy (select U3_RS_busy (_ bv6 3)))
				(U3_RS6_qj (select U3_RS_qj (_ bv6 3)))
				(U3_RS6_qk (select U3_RS_qk (_ bv6 3)))
				(U3_RS7_busy (select U3_RS_busy (_ bv7 3)))
				(U3_RS7_qj (select U3_RS_qj (_ bv7 3)))
				(U3_RS7_qk (select U3_RS_qk (_ bv7 3)))
				(U3_LSQ0_busy (select U3_LSQ_busy (_ bv0 3)))
				(U3_LSQ0_qj (select U3_LSQ_qj (_ bv0 3)))
				(U3_LSQ0_qk (select U3_LSQ_qk (_ bv0 3)))
				(U3_LSQ1_busy (select U3_LSQ_busy (_ bv1 3)))
				(U3_LSQ1_qj (select U3_LSQ_qj (_ bv1 3)))
				(U3_LSQ1_qk (select U3_LSQ_qk (_ bv1 3)))
				(U3_LSQ2_busy (select U3_LSQ_busy (_ bv2 3)))
				(U3_LSQ2_qj (select U3_LSQ_qj (_ bv2 3)))
				(U3_LSQ2_qk (select U3_LSQ_qk (_ bv2 3)))
				(U3_LSQ3_busy (select U3_LSQ_busy (_ bv3 3)))
				(U3_LSQ3_qj (select U3_LSQ_qj (_ bv3 3)))
				(U3_LSQ3_qk (select U3_LSQ_qk (_ bv3 3)))
				(U3_LSQ4_busy (select U3_LSQ_busy (_ bv4 3)))
				(U3_LSQ4_qj (select U3_LSQ_qj (_ bv4 3)))
				(U3_LSQ4_qk (select U3_LSQ_qk (_ bv4 3)))
				(U3_LSQ5_busy (select U3_LSQ_busy (_ bv5 3)))
				(U3_LSQ5_qj (select U3_LSQ_qj (_ bv5 3)))
				(U3_LSQ5_qk (select U3_LSQ_qk (_ bv5 3)))
				(U3_LSQ6_busy (select U3_LSQ_busy (_ bv6 3)))
				(U3_LSQ6_qj (select U3_LSQ_qj (_ bv6 3)))
				(U3_LSQ6_qk (select U3_LSQ_qk (_ bv6 3)))
				(U3_LSQ7_busy (select U3_LSQ_busy (_ bv7 3)))
				(U3_LSQ7_qj (select U3_LSQ_qj (_ bv7 3)))
				(U3_LSQ7_qk (select U3_LSQ_qk (_ bv7 3)))
				(U3_LSQ0_Ltag (select U3_LSQ_Ltag (_ bv0 3)))
				(U3_LSQ1_Ltag (select U3_LSQ_Ltag (_ bv1 3)))
				(U3_LSQ2_Ltag (select U3_LSQ_Ltag (_ bv2 3)))
				(U3_LSQ3_Ltag (select U3_LSQ_Ltag (_ bv3 3)))
				(U3_LSQ4_Ltag (select U3_LSQ_Ltag (_ bv4 3)))
				(U3_LSQ5_Ltag (select U3_LSQ_Ltag (_ bv5 3)))
				(U3_LSQ6_Ltag (select U3_LSQ_Ltag (_ bv6 3)))
				(U3_LSQ7_Ltag (select U3_LSQ_Ltag (_ bv7 3)))
				
				(U3_RS0_Ltag (select U3_RS_Ltag (_ bv0 3)))
				(U3_RS1_Ltag (select U3_RS_Ltag (_ bv1 3)))
				(U3_RS2_Ltag (select U3_RS_Ltag (_ bv2 3)))
				(U3_RS3_Ltag (select U3_RS_Ltag (_ bv3 3)))
				(U3_RS4_Ltag (select U3_RS_Ltag (_ bv4 3)))
				(U3_RS5_Ltag (select U3_RS_Ltag (_ bv5 3)))
				(U3_RS6_Ltag (select U3_RS_Ltag (_ bv6 3)))
				(U3_RS7_Ltag (select U3_RS_Ltag (_ bv7 3)))
			)
		(let
			(
				(U3_RS0_dis (ite (and (= #b000000 U3_RS0_Ltag) (= #b1 U3_RS0_busy) (= #b000000 U3_RS0_qj) (= #b000000 U3_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_RS1_dis (ite (and (= #b000000 U3_RS1_Ltag) (= #b1 U3_RS1_busy) (= #b000000 U3_RS1_qj) (= #b000000 U3_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_RS2_dis (ite (and (= #b000000 U3_RS2_Ltag) (= #b1 U3_RS2_busy) (= #b000000 U3_RS2_qj) (= #b000000 U3_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_RS3_dis (ite (and (= #b000000 U3_RS3_Ltag) (= #b1 U3_RS3_busy) (= #b000000 U3_RS3_qj) (= #b000000 U3_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(U3_RS4_dis (ite (and (= #b000000 U3_RS4_Ltag) (= #b1 U3_RS4_busy) (= #b000000 U3_RS4_qj) (= #b000000 U3_RS4_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_RS5_dis (ite (and (= #b000000 U3_RS5_Ltag) (= #b1 U3_RS5_busy) (= #b000000 U3_RS5_qj) (= #b000000 U3_RS5_qk)) (_ bv1 1) (_ bv0 1)))	
				(U3_RS6_dis (ite (and (= #b000000 U3_RS6_Ltag) (= #b1 U3_RS6_busy) (= #b000000 U3_RS6_qj) (= #b000000 U3_RS6_qk)) (_ bv1 1) (_ bv0 1)))	
				(U3_RS7_dis (ite (and (= #b000000 U3_RS7_Ltag) (= #b1 U3_RS7_busy) (= #b000000 U3_RS7_qj) (= #b000000 U3_RS7_qk)) (_ bv1 1) (_ bv0 1)))		
				(U3_LSQ0_dis (ite (and (= #b000000 U3_LSQ0_Ltag) (= #b1 U3_LSQ0_busy) (= #b000000 U3_LSQ0_qj) (= #b000000 U3_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ1_dis (ite (and (= #b000000 U3_LSQ1_Ltag) (= #b1 U3_LSQ1_busy) (= #b000000 U3_LSQ1_qj) (= #b000000 U3_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ2_dis (ite (and (= #b000000 U3_LSQ2_Ltag) (= #b1 U3_LSQ2_busy) (= #b000000 U3_LSQ2_qj) (= #b000000 U3_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ3_dis (ite (and (= #b000000 U3_LSQ3_Ltag) (= #b1 U3_LSQ3_busy) (= #b000000 U3_LSQ3_qj) (= #b000000 U3_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ4_dis (ite (and (= #b000000 U3_LSQ4_Ltag) (= #b1 U3_LSQ4_busy) (= #b000000 U3_LSQ4_qj) (= #b000000 U3_LSQ4_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ5_dis (ite (and (= #b000000 U3_LSQ5_Ltag) (= #b1 U3_LSQ5_busy) (= #b000000 U3_LSQ5_qj) (= #b000000 U3_LSQ5_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ6_dis (ite (and (= #b000000 U3_LSQ6_Ltag) (= #b1 U3_LSQ6_busy) (= #b000000 U3_LSQ6_qj) (= #b000000 U3_LSQ6_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ7_dis (ite (and (= #b000000 U3_LSQ7_Ltag) (= #b1 U3_LSQ7_busy) (= #b000000 U3_LSQ7_qj) (= #b000000 U3_LSQ7_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv0 3) U3_RS0_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv0 3) U3_LSQ0_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv1 3) U3_RS1_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv1 3) U3_LSQ1_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv2 3) U3_RS2_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv2 3) U3_LSQ2_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv3 3) U3_RS3_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv3 3) U3_LSQ3_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv4 3) U3_RS4_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv4 3) U3_LSQ4_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv5 3) U3_RS5_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv5 3) U3_LSQ5_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv6 3) U3_RS6_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv6 3) U3_LSQ6_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv7 3) U3_RS7_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv7 3) U3_LSQ7_dis))
			)
		(let
			(
				(U3_RF (ite (= 0 0) U2_RF U2_RF))
				(U3_DM (ite (= 0 0) U2_DM U2_DM))
				
				(U3_Cache_Tag (ite (= 0 0) U3_Cache_Tag U3_Cache_Tag))
				(U3_Cache_Data (ite (= 0 0) U3_Cache_Data U3_Cache_Data))
				(U3_Cache_Valid (ite (= 0 0) U3_Cache_Valid U3_Cache_Valid))
				
				(U3_PC (ite (= 0 0) U2_PC U2_PC))
				
				(U3_IP (ite (= 0 0) U2_IP U2_IP))
				(U3_CP (ite (= 0 0) U2_CP U2_CP))
				
				(U3_ROB_busy (ite (= 0 0) U2_ROB_busy U2_ROB_busy))
				(U3_ROB_op_type (ite (= 0 0) U2_ROB_op_type U2_ROB_op_type))
				(U3_ROB_destination (ite (= 0 0) U3_ROB_destination U3_ROB_destination))
				(U3_ROB_result (ite (= 0 0) U3_ROB_result U3_ROB_result))
				(U3_ROB_exception (ite (= 0 0) U3_ROB_exception U3_ROB_exception))
				(U3_ROB_done (ite (= 0 0) U3_ROB_done U3_ROB_done))
				
				(U3_RS_op_type (ite (= 0 0) U3_RS_op_type U3_RS_op_type))
				(U3_RS_op (ite (= 0 0) U3_RS_op U3_RS_op))
				(U3_RS_ROB_dst (ite (= 0 0) U3_RS_ROB_dst U3_RS_ROB_dst))
				(U3_RS_vj (ite (= 0 0) U3_RS_vj U3_RS_vj))
				(U3_RS_vk (ite (= 0 0) U3_RS_vk U3_RS_vk))
				(U3_RS_qj (ite (= 0 0) U3_RS_qj U3_RS_qj))
				(U3_RS_qk (ite (= 0 0) U3_RS_qk U3_RS_qk))
				(U3_RS_imm (ite (= 0 0) U3_RS_imm U3_RS_imm))
				(U3_RS_dis (ite (= 0 0) U3_RS_dis U3_RS_dis))
				(U3_RS_busy (ite (= 0 0) U3_RS_busy U3_RS_busy))
				(U3_RS_Ltag (ite (= 0 0) U3_RS_Ltag U3_RS_Ltag))
				
				(U3_LSQ_op_type (ite (= 0 0) U3_LSQ_op_type U3_LSQ_op_type))
				(U3_LSQ_op (ite (= 0 0) U3_LSQ_op U3_LSQ_op))
				(U3_LSQ_ROB_dst (ite (= 0 0) U3_LSQ_ROB_dst U3_LSQ_ROB_dst))
				(U3_LSQ_vj (ite (= 0 0) U3_LSQ_vj U3_LSQ_vj))
				(U3_LSQ_vk (ite (= 0 0) U3_LSQ_vk U3_LSQ_vk))
				(U3_LSQ_qj (ite (= 0 0) U3_LSQ_qj U3_LSQ_qj))
				(U3_LSQ_qk (ite (= 0 0) U3_LSQ_qk U3_LSQ_qk))
				(U3_LSQ_imm (ite (= 0 0) U3_LSQ_imm U3_LSQ_imm))
				(U3_LSQ_dis (ite (= 0 0) U3_LSQ_dis U3_LSQ_dis))
				(U3_LSQ_busy (ite (= 0 0) U3_LSQ_busy U3_LSQ_busy))
				(U3_LSQ_Ltag (ite (= 0 0) U3_LSQ_Ltag U3_LSQ_Ltag))
				
				(U3_Main_Ltag (ite (= 0 0) U3_Main_Ltag U3_Main_Ltag))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_U3_ROB_busy (select U3_ROB_busy U3_CP))
				(CP_U3_ROB_op_type (select U3_ROB_op_type U3_CP))
				(CP_U3_ROB_destination (select U3_ROB_destination U3_CP))
				(CP_U3_ROB_result (select U3_ROB_result U3_CP))
				(CP_U3_ROB_exception (select U3_ROB_exception U3_CP))
				(CP_U3_ROB_done (select U3_ROB_done U3_CP))
			)
		(let
			(
				(CP_update (bvadd U3_CP (_ bv1 6)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b000000) (_ bv1 6) CP_update))
				(RF_update (store U3_RF CP_U3_ROB_destination CP_U3_ROB_result))
				(DM_update (store U3_DM CP_U3_ROB_destination CP_U3_ROB_result))
				
				(U3_ROB_busy_update (store U3_ROB_busy U3_CP (_ bv0 1)))
				(U3_ROB_op_type_update (store U3_ROB_op_type U3_CP 0))
				(U3_ROB_destination_update (store U3_ROB_destination U3_CP 0))
				(U3_ROB_resulU3_update (store U3_ROB_result U3_CP 0))
				(U3_ROB_exception_update (store U3_ROB_exception U3_CP (_ bv0 1)))
				(U3_ROB_done_update (store U3_ROB_done U3_CP (_ bv0 1)))
			)
		(let
			(
				(U3_Cache0_Tag (select U3_Cache_Tag (_ bv0 2)))
				(U3_Cache0_Data (select U3_Cache_Data (_ bv0 2)))
				(U3_Cache0_Valid (select U3_Cache_Valid (_ bv0 2)))
				(U3_Cache1_Tag (select U3_Cache_Tag (_ bv1 2)))
				(U3_Cache1_Data (select U3_Cache_Data (_ bv1 2)))
				(U3_Cache1_Valid (select U3_Cache_Valid (_ bv1 2)))
				(U3_Cache2_Tag (select U3_Cache_Tag (_ bv2 2)))
				(U3_Cache2_Data (select U3_Cache_Data (_ bv2 2)))
				(U3_Cache2_Valid (select U3_Cache_Valid (_ bv2 2)))
				(U3_Cache3_Tag (select U3_Cache_Tag (_ bv3 2)))
				(U3_Cache3_Data (select U3_Cache_Data (_ bv3 2)))
				(U3_Cache3_Valid (select U3_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(U3_Cache0_Hit_Store (ite (and (= U3_Cache0_Valid #b1) (= U3_Cache0_Tag CP_U3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U3_Cache1_Hit_Store (ite (and (= U3_Cache1_Valid #b1) (= U3_Cache1_Tag CP_U3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U3_Cache2_Hit_Store (ite (and (= U3_Cache2_Valid #b1) (= U3_Cache2_Tag CP_U3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U3_Cache3_Hit_Store (ite (and (= U3_Cache3_Valid #b1) (= U3_Cache3_Tag CP_U3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_U3_Cache_Line 
					(ite (= U3_Cache0_Valid #b0) (_ bv0 2)	;check if U3_Cache line 0 is free
					(ite (= U3_Cache1_Valid #b0) (_ bv1 2)	;check if U3_Cache line 1 is free
					(ite (= U3_Cache2_Valid #b0) (_ bv2 2)	;check if U3_Cache line 2 is free
					(ite (= U3_Cache3_Valid #b0) (_ bv3 2)	;check if U3_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U3_Cache line 0 
					))))
				)
				(U3_Cache_Store_Hit_Index
					(ite (= U3_Cache0_Hit_Store #b1) (_ bv0 2)		;If U3_Cache has a hit for store, then whats the line index
					(ite (= U3_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= U3_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= U3_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(U3_Cache_Hit_Store (bvor U3_Cache0_Hit_Store U3_Cache1_Hit_Store U3_Cache2_Hit_Store U3_Cache3_Hit_Store))
			)
		(let
			(
				(U3_Cache_tag_Update_Store_Hit (store U3_Cache_Tag U3_Cache_Store_Hit_Index CP_U3_ROB_destination))	;if U3_Cache is a hit, update the line with new data
				(U3_Cache_tag_Update_Store_Miss (store U3_Cache_Tag Available_U3_Cache_Line CP_U3_ROB_destination))	
				
				(U3_Cache_data_Update_Store_Hit (store U3_Cache_Data U3_Cache_Store_Hit_Index CP_U3_ROB_result))	;if U3_Cache is a hit, update the line with new data
				(U3_Cache_data_Update_Store_Miss (store U3_Cache_Data Available_U3_Cache_Line CP_U3_ROB_result))	;if U3_Cache is a miss, update the available entry with data
				
				(U3_Cache_valid_Update_Store_Hit (store U3_Cache_Valid U3_Cache_Store_Hit_Index (_ bv1 1)))	;if U3_Cache is a hit, update the line with new data
				(U3_Cache_valid_Update_Store_Miss (store U3_Cache_Valid Available_U3_Cache_Line (_ bv1 1)))	;if U3_Cache is a miss, update the available entry with data
				
				(CP_U3_ROB_exception (ite (and (= CP_U3_ROB_op_type Branch) (= 1 CP_U3_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
			)
		(let
			(
				(U3_LSQ0_Ltag (select U3_LSQ_Ltag (_ bv0 3)))
				(U3_LSQ1_Ltag (select U3_LSQ_Ltag (_ bv1 3)))
				(U3_LSQ2_Ltag (select U3_LSQ_Ltag (_ bv2 3)))
				(U3_LSQ3_Ltag (select U3_LSQ_Ltag (_ bv3 3)))
				(U3_LSQ4_Ltag (select U3_LSQ_Ltag (_ bv4 3)))
				(U3_LSQ5_Ltag (select U3_LSQ_Ltag (_ bv5 3)))
				(U3_LSQ6_Ltag (select U3_LSQ_Ltag (_ bv6 3)))
				(U3_LSQ7_Ltag (select U3_LSQ_Ltag (_ bv7 3)))
				
				(U3_RS0_Ltag (select U3_RS_Ltag (_ bv0 3)))
				(U3_RS1_Ltag (select U3_RS_Ltag (_ bv1 3)))
				(U3_RS2_Ltag (select U3_RS_Ltag (_ bv2 3)))
				(U3_RS3_Ltag (select U3_RS_Ltag (_ bv3 3)))
				(U3_RS4_Ltag (select U3_RS_Ltag (_ bv4 3)))
				(U3_RS5_Ltag (select U3_RS_Ltag (_ bv5 3)))
				(U3_RS6_Ltag (select U3_RS_Ltag (_ bv6 3)))
				(U3_RS7_Ltag (select U3_RS_Ltag (_ bv7 3)))
			)
		(let
			(
				(U3_LSQ0_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_LSQ0_Ltag U3_CP)) (_ bv0 6) U3_LSQ0_Ltag))
				(U3_LSQ1_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_LSQ1_Ltag U3_CP)) (_ bv0 6) U3_LSQ1_Ltag))
				(U3_LSQ2_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_LSQ2_Ltag U3_CP)) (_ bv0 6) U3_LSQ2_Ltag))
				(U3_LSQ3_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_LSQ3_Ltag U3_CP)) (_ bv0 6) U3_LSQ3_Ltag))
				(U3_LSQ4_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_LSQ4_Ltag U3_CP)) (_ bv0 6) U3_LSQ4_Ltag))
				(U3_LSQ5_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_LSQ5_Ltag U3_CP)) (_ bv0 6) U3_LSQ5_Ltag))
				(U3_LSQ6_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_LSQ6_Ltag U3_CP)) (_ bv0 6) U3_LSQ6_Ltag))
				(U3_LSQ7_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_LSQ7_Ltag U3_CP)) (_ bv0 6) U3_LSQ7_Ltag))
				
				(U3_RS0_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_RS0_Ltag U3_CP)) (_ bv0 6) U3_RS0_Ltag))
				(U3_RS1_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_RS1_Ltag U3_CP)) (_ bv0 6) U3_RS1_Ltag))
				(U3_RS2_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_RS2_Ltag U3_CP)) (_ bv0 6) U3_RS2_Ltag))
				(U3_RS3_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_RS3_Ltag U3_CP)) (_ bv0 6) U3_RS3_Ltag))
				(U3_RS4_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_RS4_Ltag U3_CP)) (_ bv0 6) U3_RS4_Ltag))
				(U3_RS5_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_RS5_Ltag U3_CP)) (_ bv0 6) U3_RS5_Ltag))
				(U3_RS6_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_RS6_Ltag U3_CP)) (_ bv0 6) U3_RS6_Ltag))
				(U3_RS7_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_RS7_Ltag U3_CP)) (_ bv0 6) U3_RS7_Ltag))
			)
		(let
			(
				(U3_LSQ_Ltag (store U3_LSQ_Ltag (_ bv0 3) U3_LSQ0_Ltag))
				(U3_RS_Ltag (store U3_RS_Ltag (_ bv0 3) U3_RS0_Ltag))
			)
		(let
			(
				(U3_LSQ_Ltag (store U3_LSQ_Ltag (_ bv1 3) U3_LSQ1_Ltag))
				(U3_RS_Ltag (store U3_RS_Ltag (_ bv1 3) U3_RS1_Ltag))
			)
		(let
			(
				(U3_LSQ_Ltag (store U3_LSQ_Ltag (_ bv2 3) U3_LSQ2_Ltag))
				(U3_RS_Ltag (store U3_RS_Ltag (_ bv2 3) U3_RS2_Ltag))
			)
		(let
			(
				(U3_LSQ_Ltag (store U3_LSQ_Ltag (_ bv3 3) U3_LSQ3_Ltag))
				(U3_RS_Ltag (store U3_RS_Ltag (_ bv3 3) U3_RS3_Ltag))
			)
		(let
			(
				(U3_LSQ_Ltag (store U3_LSQ_Ltag (_ bv4 3) U3_LSQ4_Ltag))
				(U3_RS_Ltag (store U3_RS_Ltag (_ bv4 3) U3_RS4_Ltag))
			)
		(let
			(
				(U3_LSQ_Ltag (store U3_LSQ_Ltag (_ bv5 3) U3_LSQ5_Ltag))
				(U3_RS_Ltag (store U3_RS_Ltag (_ bv5 3) U3_RS5_Ltag))
			)
		(let
			(
				(U3_LSQ_Ltag (store U3_LSQ_Ltag (_ bv6 3) U3_LSQ6_Ltag))
				(U3_RS_Ltag (store U3_RS_Ltag (_ bv6 3) U3_RS6_Ltag))
			)
		(let
			(
				(U3_LSQ_Ltag (store U3_LSQ_Ltag (_ bv7 3) U3_LSQ7_Ltag))
				(U3_RS_Ltag (store U3_RS_Ltag (_ bv7 3) U3_RS7_Ltag))
			)
		(let
			(
				(U4_RF (ite (and (= CP_U3_ROB_done #b1) (or (= CP_U3_ROB_op_type Rtype) (= CP_U3_ROB_op_type Mul_div) (= CP_U3_ROB_op_type Load))) RF_update U3_RF))
				(U4_DM (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Store)) DM_update U3_DM))
				
				(U4_PC (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) CP_U3_ROB_destination U3_PC))
				(U4_IP (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) (_ bv1 6) U3_IP))
				(U4_CP 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) (_ bv1 6) 
					(ite (= CP_U3_ROB_done #b1) CP_update
					U3_CP))
				)
				(U4_ROB_busy 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U3_ROB_done #b1) U3_ROB_busy_update
					U3_ROB_busy))
				)
				(U4_ROB_op_type 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U3_ROB_done #b1) U3_ROB_op_type_update
					U3_ROB_op_type))
				)
				(U4_ROB_destination 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U3_ROB_done #b1) U3_ROB_destination_update
					U3_ROB_destination))
				)
				(U4_ROB_result 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U3_ROB_done #b1) U3_ROB_resulU3_update
					U3_ROB_result))
				)
				(U4_ROB_exception 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U3_ROB_done #b1) U3_ROB_exception_update
					U3_ROB_exception))
				)
				(U4_ROB_done 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U3_ROB_done #b1) U3_ROB_done_update
					U3_ROB_done))
				)
				
				(U4_RS_op_type (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_op_type))
				(U4_RS_op (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_op))
				(U4_RS_ROB_dst (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_RS_ROB_dst))
				(U4_RS_vj (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_vj))
				(U4_RS_vk (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_vk))
				(U4_RS_qj (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_RS_qj))
				(U4_RS_qk (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_RS_qk))
				(U4_RS_imm (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_imm))
				(U4_RS_dis (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_1bit U3_RS_dis))
				(U4_RS_busy (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_1bit U3_RS_busy))
				(U4_RS_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_RS_Ltag))	
				
				(U4_LSQ_op_type (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_op_type))
				(U4_LSQ_op (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_op))
				(U4_LSQ_ROB_dst (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_vj))
				(U4_LSQ_vk (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_vk))
				(U4_LSQ_qj (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_LSQ_qj))
				(U4_LSQ_qk (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_LSQ_qk))
				(U4_LSQ_imm (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_imm))
				(U4_LSQ_dis (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_1bit U3_LSQ_dis))
				(U4_LSQ_busy (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_1bit U3_LSQ_busy))
				(U4_LSQ_Ltag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_LSQ_Ltag))	
				
				
				(U4_Main_Ltag 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) (_ bv0 6) 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Lfence) (= U3_CP U3_Main_Ltag)) (_ bv0 6) 
						U3_Main_Ltag))
				)


				
				(U4_Cache_Tag
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b0) (= CP_U3_ROB_op_type Store)) U3_Cache_tag_Update_Store_Miss	;If Store and U3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b1) (= CP_U3_ROB_op_type Store)) U3_Cache_tag_Update_Store_Hit		;If Store and U3_Cache hit, update the line with new data
					U3_Cache_Tag
					))
				)
				(U4_Cache_Data
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b0) (= CP_U3_ROB_op_type Store)) U3_Cache_data_Update_Store_Miss	;If Store and U3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b1) (= CP_U3_ROB_op_type Store)) U3_Cache_data_Update_Store_Hit		;If Store and U3_Cache hit, update the line with new data
					U3_Cache_Data
					))
				)
				(U4_Cache_Valid
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b0) (= CP_U3_ROB_op_type Store)) U3_Cache_valid_Update_Store_Miss	;If Store and U3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b1) (= CP_U3_ROB_op_type Store)) U3_Cache_valid_Update_Store_Hit		;If Store and U3_Cache hit, update the line with new data
					U3_Cache_Valid
					))
				)
			)

;-----------------------------Calculations--------------------------------------------------------------		
		(let ((T_IP_m1 (subtract T_IP)))
		(let ((T_IP_m2 (subtract T_IP_m1)))
		(let ((T_IP_m3 (subtract T_IP_m2)))
		(let ((T_IP_m4 (subtract T_IP_m3)))
		(let ((T_IP_m5 (subtract T_IP_m4)))
		(let ((T_IP_m6 (subtract T_IP_m5)))
		(let ((T_IP_m7 (subtract T_IP_m6)))
		(let ((T_IP_m8 (subtract T_IP_m7)))
		(let ((T_IP_m9 (subtract T_IP_m8)))
		(let ((T_IP_m10 (subtract T_IP_m9)))
		(let ((T_IP_m11 (subtract T_IP_m10)))
		(let ((T_IP_m12 (subtract T_IP_m11)))
		(let ((T_IP_m13 (subtract T_IP_m12)))
		(let ((T_IP_m14 (subtract T_IP_m13)))
		(let ((T_IP_m15 (subtract T_IP_m14)))
		(let ((T_IP_m16 (subtract T_IP_m15)))
		(let ((T_IP_m17 (subtract T_IP_m16)))
		(let ((T_IP_m18 (subtract T_IP_m17)))
		(let ((T_IP_m19 (subtract T_IP_m18)))
		(let ((T_IP_m20 (subtract T_IP_m19)))
		(let ((T_IP_m21 (subtract T_IP_m20)))
		(let ((T_IP_m22 (subtract T_IP_m21)))
		(let ((T_IP_m23 (subtract T_IP_m22)))
		(let ((T_IP_m24 (subtract T_IP_m23)))
		(let ((T_IP_m25 (subtract T_IP_m24)))
		(let ((T_IP_m26 (subtract T_IP_m25)))
		(let ((T_IP_m27 (subtract T_IP_m26)))
		(let ((T_IP_m28 (subtract T_IP_m27)))
		(let ((T_IP_m29 (subtract T_IP_m28)))
		(let ((T_IP_m30 (subtract T_IP_m29)))
		(let ((T_IP_m31 (subtract T_IP_m30)))
		(let ((T_IP_m32 (subtract T_IP_m31)))
		(let ((T_IP_m33 (subtract T_IP_m32)))
		(let ((T_IP_m34 (subtract T_IP_m33)))
		(let ((T_IP_m35 (subtract T_IP_m34)))
		(let ((T_IP_m36 (subtract T_IP_m35)))
		(let ((T_IP_m37 (subtract T_IP_m36)))
		(let ((T_IP_m38 (subtract T_IP_m37)))
		(let ((T_IP_m39 (subtract T_IP_m38)))
		(let ((T_IP_m40 (subtract T_IP_m39)))
		(let ((T_IP_m41 (subtract T_IP_m40)))
		(let ((T_IP_m42 (subtract T_IP_m41)))
		(let ((T_IP_m43 (subtract T_IP_m42)))
		(let ((T_IP_m44 (subtract T_IP_m43)))
		(let ((T_IP_m45 (subtract T_IP_m44)))
		(let ((T_IP_m46 (subtract T_IP_m45)))
		(let ((T_IP_m47 (subtract T_IP_m46)))
		(let ((T_IP_m48 (subtract T_IP_m47)))
		(let ((T_IP_m49 (subtract T_IP_m48)))
		(let ((T_IP_m50 (subtract T_IP_m49)))
		(let ((T_IP_m51 (subtract T_IP_m50)))
		(let ((T_IP_m52 (subtract T_IP_m51)))
		(let ((T_IP_m53 (subtract T_IP_m52)))
		(let ((T_IP_m54 (subtract T_IP_m53)))
		(let ((T_IP_m55 (subtract T_IP_m54)))
		(let ((T_IP_m56 (subtract T_IP_m55)))
		(let ((T_IP_m57 (subtract T_IP_m56)))
		(let ((T_IP_m58 (subtract T_IP_m57)))
		(let ((T_IP_m59 (subtract T_IP_m58)))
		(let ((T_IP_m60 (subtract T_IP_m59)))
		(let ((T_IP_m61 (subtract T_IP_m60)))
		(let ((T_IP_m62 (subtract T_IP_m61)))
		(let ((T_IP_m63 (subtract T_IP_m62)))


		(let ((T_CP_a1 (addition T_CP)))
		(let ((T_CP_a2 (addition T_CP_a1)))
		(let ((T_CP_a3 (addition T_CP_a2)))
		(let ((T_CP_a4 (addition T_CP_a3)))
		
		(let ((U4_CP_a1 (addition U4_CP)))
		(let ((U4_CP_a2 (addition U4_CP_a1)))
		(let ((U4_CP_a3 (addition U4_CP_a2)))
		(let ((U4_CP_a4 (addition U4_CP_a3)))
		
		(let ((T_any_rob_a1 (addition any_rob)))
		(let ((T_any_rob_a2 (addition T_any_rob_a1)))
		(let ((T_any_rob_a3 (addition T_any_rob_a2)))
		(let ((T_any_rob_a4 (addition T_any_rob_a3)))
		(let ((T_any_rob_a5 (addition T_any_rob_a4)))
		(let ((T_any_rob_a6 (addition T_any_rob_a5)))
		(let ((T_any_rob_a7 (addition T_any_rob_a6)))
		(let ((T_any_rob_a8 (addition T_any_rob_a7)))
		(let ((T_any_rob_a9 (addition T_any_rob_a8)))
		(let ((T_any_rob_a10 (addition T_any_rob_a9)))
		(let ((T_any_rob_a11 (addition T_any_rob_a10)))
		(let ((T_any_rob_a12 (addition T_any_rob_a11)))
		(let ((T_any_rob_a13 (addition T_any_rob_a12)))
		(let ((T_any_rob_a14 (addition T_any_rob_a13)))
		(let ((T_any_rob_a15 (addition T_any_rob_a14)))
		(let ((T_any_rob_a16 (addition T_any_rob_a15)))
		(let ((T_any_rob_a17 (addition T_any_rob_a16)))
		(let ((T_any_rob_a18 (addition T_any_rob_a17)))
		(let ((T_any_rob_a19 (addition T_any_rob_a18)))
		(let ((T_any_rob_a20 (addition T_any_rob_a19)))
		(let ((T_any_rob_a21 (addition T_any_rob_a20)))
		(let ((T_any_rob_a22 (addition T_any_rob_a21)))
		(let ((T_any_rob_a23 (addition T_any_rob_a22)))
		(let ((T_any_rob_a24 (addition T_any_rob_a23)))
		(let ((T_any_rob_a25 (addition T_any_rob_a24)))
		(let ((T_any_rob_a26 (addition T_any_rob_a25)))
		(let ((T_any_rob_a27 (addition T_any_rob_a26)))
		(let ((T_any_rob_a28 (addition T_any_rob_a27)))
		(let ((T_any_rob_a29 (addition T_any_rob_a28)))
		(let ((T_any_rob_a30 (addition T_any_rob_a29)))
		(let ((T_any_rob_a31 (addition T_any_rob_a30)))
		(let ((T_any_rob_a32 (addition T_any_rob_a31)))
		(let ((T_any_rob_a33 (addition T_any_rob_a32)))
		(let ((T_any_rob_a34 (addition T_any_rob_a33)))
		(let ((T_any_rob_a35 (addition T_any_rob_a34)))
		(let ((T_any_rob_a36 (addition T_any_rob_a35)))
		(let ((T_any_rob_a37 (addition T_any_rob_a36)))
		(let ((T_any_rob_a38 (addition T_any_rob_a37)))
		(let ((T_any_rob_a39 (addition T_any_rob_a38)))
		(let ((T_any_rob_a40 (addition T_any_rob_a39)))
		(let ((T_any_rob_a41 (addition T_any_rob_a40)))
		(let ((T_any_rob_a42 (addition T_any_rob_a41)))
		(let ((T_any_rob_a43 (addition T_any_rob_a42)))
		(let ((T_any_rob_a44 (addition T_any_rob_a43)))
		(let ((T_any_rob_a45 (addition T_any_rob_a44)))
		(let ((T_any_rob_a46 (addition T_any_rob_a45)))
		(let ((T_any_rob_a47 (addition T_any_rob_a46)))
		(let ((T_any_rob_a48 (addition T_any_rob_a47)))
		(let ((T_any_rob_a49 (addition T_any_rob_a48)))
		(let ((T_any_rob_a50 (addition T_any_rob_a49)))
		(let ((T_any_rob_a51 (addition T_any_rob_a50)))
		(let ((T_any_rob_a52 (addition T_any_rob_a51)))
		(let ((T_any_rob_a53 (addition T_any_rob_a52)))
		(let ((T_any_rob_a54 (addition T_any_rob_a53)))
		(let ((T_any_rob_a55 (addition T_any_rob_a54)))
		(let ((T_any_rob_a56 (addition T_any_rob_a55)))
		(let ((T_any_rob_a57 (addition T_any_rob_a56)))
		(let ((T_any_rob_a58 (addition T_any_rob_a57)))
		(let ((T_any_rob_a59 (addition T_any_rob_a58)))
		(let ((T_any_rob_a60 (addition T_any_rob_a59)))
		(let ((T_any_rob_a61 (addition T_any_rob_a60)))
		(let ((T_any_rob_a62 (addition T_any_rob_a61)))
		(let ((T_any_rob_a63 (addition T_any_rob_a62)))

		(let ((T_LSQ7_ROBdst_m1 (subtract (select T_LSQ_ROB_dst (_ bv7 3)))))
		(let ((T_LSQ7_ROBdst_m2 (subtract T_LSQ7_ROBdst_m1)))
		(let ((T_LSQ7_ROBdst_m3 (subtract T_LSQ7_ROBdst_m2)))
		(let ((T_LSQ7_ROBdst_m4 (subtract T_LSQ7_ROBdst_m3)))
		(let ((T_LSQ7_ROBdst_m5 (subtract T_LSQ7_ROBdst_m4)))
		(let ((T_LSQ7_ROBdst_m6 (subtract T_LSQ7_ROBdst_m5)))
		(let ((T_LSQ7_ROBdst_m7 (subtract T_LSQ7_ROBdst_m6)))
		(let ((T_LSQ7_ROBdst_m8 (subtract T_LSQ7_ROBdst_m7)))
		(let ((T_LSQ7_ROBdst_m9 (subtract T_LSQ7_ROBdst_m8)))
		(let ((T_LSQ7_ROBdst_m10 (subtract T_LSQ7_ROBdst_m9)))
		(let ((T_LSQ7_ROBdst_m11 (subtract T_LSQ7_ROBdst_m10)))
		(let ((T_LSQ7_ROBdst_m12 (subtract T_LSQ7_ROBdst_m11)))
		(let ((T_LSQ7_ROBdst_m13 (subtract T_LSQ7_ROBdst_m12)))
		(let ((T_LSQ7_ROBdst_m14 (subtract T_LSQ7_ROBdst_m13)))
		(let ((T_LSQ7_ROBdst_m15 (subtract T_LSQ7_ROBdst_m14)))
		(let ((T_LSQ7_ROBdst_m16 (subtract T_LSQ7_ROBdst_m15)))
		(let ((T_LSQ7_ROBdst_m17 (subtract T_LSQ7_ROBdst_m16)))
		(let ((T_LSQ7_ROBdst_m18 (subtract T_LSQ7_ROBdst_m17)))
		(let ((T_LSQ7_ROBdst_m19 (subtract T_LSQ7_ROBdst_m18)))
		(let ((T_LSQ7_ROBdst_m20 (subtract T_LSQ7_ROBdst_m19)))
		(let ((T_LSQ7_ROBdst_m21 (subtract T_LSQ7_ROBdst_m20)))
		(let ((T_LSQ7_ROBdst_m22 (subtract T_LSQ7_ROBdst_m21)))
		(let ((T_LSQ7_ROBdst_m23 (subtract T_LSQ7_ROBdst_m22)))
		(let ((T_LSQ7_ROBdst_m24 (subtract T_LSQ7_ROBdst_m23)))
		(let ((T_LSQ7_ROBdst_m25 (subtract T_LSQ7_ROBdst_m24)))
		(let ((T_LSQ7_ROBdst_m26 (subtract T_LSQ7_ROBdst_m25)))
		(let ((T_LSQ7_ROBdst_m27 (subtract T_LSQ7_ROBdst_m26)))
		(let ((T_LSQ7_ROBdst_m28 (subtract T_LSQ7_ROBdst_m27)))
		(let ((T_LSQ7_ROBdst_m29 (subtract T_LSQ7_ROBdst_m28)))
		(let ((T_LSQ7_ROBdst_m30 (subtract T_LSQ7_ROBdst_m29)))
		(let ((T_LSQ7_ROBdst_m31 (subtract T_LSQ7_ROBdst_m30)))
		(let ((T_LSQ7_ROBdst_m32 (subtract T_LSQ7_ROBdst_m31)))
		(let ((T_LSQ7_ROBdst_m33 (subtract T_LSQ7_ROBdst_m32)))
		(let ((T_LSQ7_ROBdst_m34 (subtract T_LSQ7_ROBdst_m33)))
		(let ((T_LSQ7_ROBdst_m35 (subtract T_LSQ7_ROBdst_m34)))
		(let ((T_LSQ7_ROBdst_m36 (subtract T_LSQ7_ROBdst_m35)))
		(let ((T_LSQ7_ROBdst_m37 (subtract T_LSQ7_ROBdst_m36)))
		(let ((T_LSQ7_ROBdst_m38 (subtract T_LSQ7_ROBdst_m37)))
		(let ((T_LSQ7_ROBdst_m39 (subtract T_LSQ7_ROBdst_m38)))
		(let ((T_LSQ7_ROBdst_m40 (subtract T_LSQ7_ROBdst_m39)))
		(let ((T_LSQ7_ROBdst_m41 (subtract T_LSQ7_ROBdst_m40)))
		(let ((T_LSQ7_ROBdst_m42 (subtract T_LSQ7_ROBdst_m41)))
		(let ((T_LSQ7_ROBdst_m43 (subtract T_LSQ7_ROBdst_m42)))
		(let ((T_LSQ7_ROBdst_m44 (subtract T_LSQ7_ROBdst_m43)))
		(let ((T_LSQ7_ROBdst_m45 (subtract T_LSQ7_ROBdst_m44)))
		(let ((T_LSQ7_ROBdst_m46 (subtract T_LSQ7_ROBdst_m45)))
		(let ((T_LSQ7_ROBdst_m47 (subtract T_LSQ7_ROBdst_m46)))
		(let ((T_LSQ7_ROBdst_m48 (subtract T_LSQ7_ROBdst_m47)))
		(let ((T_LSQ7_ROBdst_m49 (subtract T_LSQ7_ROBdst_m48)))
		(let ((T_LSQ7_ROBdst_m50 (subtract T_LSQ7_ROBdst_m49)))
		(let ((T_LSQ7_ROBdst_m51 (subtract T_LSQ7_ROBdst_m50)))
		(let ((T_LSQ7_ROBdst_m52 (subtract T_LSQ7_ROBdst_m51)))
		(let ((T_LSQ7_ROBdst_m53 (subtract T_LSQ7_ROBdst_m52)))
		(let ((T_LSQ7_ROBdst_m54 (subtract T_LSQ7_ROBdst_m53)))
		(let ((T_LSQ7_ROBdst_m55 (subtract T_LSQ7_ROBdst_m54)))
		(let ((T_LSQ7_ROBdst_m56 (subtract T_LSQ7_ROBdst_m55)))
		(let ((T_LSQ7_ROBdst_m57 (subtract T_LSQ7_ROBdst_m56)))
		(let ((T_LSQ7_ROBdst_m58 (subtract T_LSQ7_ROBdst_m57)))
		(let ((T_LSQ7_ROBdst_m59 (subtract T_LSQ7_ROBdst_m58)))
		(let ((T_LSQ7_ROBdst_m60 (subtract T_LSQ7_ROBdst_m59)))
		(let ((T_LSQ7_ROBdst_m61 (subtract T_LSQ7_ROBdst_m60)))
		(let ((T_LSQ7_ROBdst_m62 (subtract T_LSQ7_ROBdst_m61)))
		(let ((T_LSQ7_ROBdst_m63 (subtract T_LSQ7_ROBdst_m62)))

		(let ((T_LSQ6_ROBdst_m1 (subtract (select T_LSQ_ROB_dst (_ bv6 3)))))
		(let ((T_LSQ6_ROBdst_m2 (subtract T_LSQ6_ROBdst_m1)))
		(let ((T_LSQ6_ROBdst_m3 (subtract T_LSQ6_ROBdst_m2)))
		(let ((T_LSQ6_ROBdst_m4 (subtract T_LSQ6_ROBdst_m3)))
		(let ((T_LSQ6_ROBdst_m5 (subtract T_LSQ6_ROBdst_m4)))
		(let ((T_LSQ6_ROBdst_m6 (subtract T_LSQ6_ROBdst_m5)))
		(let ((T_LSQ6_ROBdst_m7 (subtract T_LSQ6_ROBdst_m6)))
		(let ((T_LSQ6_ROBdst_m8 (subtract T_LSQ6_ROBdst_m7)))
		(let ((T_LSQ6_ROBdst_m9 (subtract T_LSQ6_ROBdst_m8)))
		(let ((T_LSQ6_ROBdst_m10 (subtract T_LSQ6_ROBdst_m9)))
		(let ((T_LSQ6_ROBdst_m11 (subtract T_LSQ6_ROBdst_m10)))
		(let ((T_LSQ6_ROBdst_m12 (subtract T_LSQ6_ROBdst_m11)))
		(let ((T_LSQ6_ROBdst_m13 (subtract T_LSQ6_ROBdst_m12)))
		(let ((T_LSQ6_ROBdst_m14 (subtract T_LSQ6_ROBdst_m13)))
		(let ((T_LSQ6_ROBdst_m15 (subtract T_LSQ6_ROBdst_m14)))
		(let ((T_LSQ6_ROBdst_m16 (subtract T_LSQ6_ROBdst_m15)))
		(let ((T_LSQ6_ROBdst_m17 (subtract T_LSQ6_ROBdst_m16)))
		(let ((T_LSQ6_ROBdst_m18 (subtract T_LSQ6_ROBdst_m17)))
		(let ((T_LSQ6_ROBdst_m19 (subtract T_LSQ6_ROBdst_m18)))
		(let ((T_LSQ6_ROBdst_m20 (subtract T_LSQ6_ROBdst_m19)))
		(let ((T_LSQ6_ROBdst_m21 (subtract T_LSQ6_ROBdst_m20)))
		(let ((T_LSQ6_ROBdst_m22 (subtract T_LSQ6_ROBdst_m21)))
		(let ((T_LSQ6_ROBdst_m23 (subtract T_LSQ6_ROBdst_m22)))
		(let ((T_LSQ6_ROBdst_m24 (subtract T_LSQ6_ROBdst_m23)))
		(let ((T_LSQ6_ROBdst_m25 (subtract T_LSQ6_ROBdst_m24)))
		(let ((T_LSQ6_ROBdst_m26 (subtract T_LSQ6_ROBdst_m25)))
		(let ((T_LSQ6_ROBdst_m27 (subtract T_LSQ6_ROBdst_m26)))
		(let ((T_LSQ6_ROBdst_m28 (subtract T_LSQ6_ROBdst_m27)))
		(let ((T_LSQ6_ROBdst_m29 (subtract T_LSQ6_ROBdst_m28)))
		(let ((T_LSQ6_ROBdst_m30 (subtract T_LSQ6_ROBdst_m29)))
		(let ((T_LSQ6_ROBdst_m31 (subtract T_LSQ6_ROBdst_m30)))
		(let ((T_LSQ6_ROBdst_m32 (subtract T_LSQ6_ROBdst_m31)))
		(let ((T_LSQ6_ROBdst_m33 (subtract T_LSQ6_ROBdst_m32)))
		(let ((T_LSQ6_ROBdst_m34 (subtract T_LSQ6_ROBdst_m33)))
		(let ((T_LSQ6_ROBdst_m35 (subtract T_LSQ6_ROBdst_m34)))
		(let ((T_LSQ6_ROBdst_m36 (subtract T_LSQ6_ROBdst_m35)))
		(let ((T_LSQ6_ROBdst_m37 (subtract T_LSQ6_ROBdst_m36)))
		(let ((T_LSQ6_ROBdst_m38 (subtract T_LSQ6_ROBdst_m37)))
		(let ((T_LSQ6_ROBdst_m39 (subtract T_LSQ6_ROBdst_m38)))
		(let ((T_LSQ6_ROBdst_m40 (subtract T_LSQ6_ROBdst_m39)))
		(let ((T_LSQ6_ROBdst_m41 (subtract T_LSQ6_ROBdst_m40)))
		(let ((T_LSQ6_ROBdst_m42 (subtract T_LSQ6_ROBdst_m41)))
		(let ((T_LSQ6_ROBdst_m43 (subtract T_LSQ6_ROBdst_m42)))
		(let ((T_LSQ6_ROBdst_m44 (subtract T_LSQ6_ROBdst_m43)))
		(let ((T_LSQ6_ROBdst_m45 (subtract T_LSQ6_ROBdst_m44)))
		(let ((T_LSQ6_ROBdst_m46 (subtract T_LSQ6_ROBdst_m45)))
		(let ((T_LSQ6_ROBdst_m47 (subtract T_LSQ6_ROBdst_m46)))
		(let ((T_LSQ6_ROBdst_m48 (subtract T_LSQ6_ROBdst_m47)))
		(let ((T_LSQ6_ROBdst_m49 (subtract T_LSQ6_ROBdst_m48)))
		(let ((T_LSQ6_ROBdst_m50 (subtract T_LSQ6_ROBdst_m49)))
		(let ((T_LSQ6_ROBdst_m51 (subtract T_LSQ6_ROBdst_m50)))
		(let ((T_LSQ6_ROBdst_m52 (subtract T_LSQ6_ROBdst_m51)))
		(let ((T_LSQ6_ROBdst_m53 (subtract T_LSQ6_ROBdst_m52)))
		(let ((T_LSQ6_ROBdst_m54 (subtract T_LSQ6_ROBdst_m53)))
		(let ((T_LSQ6_ROBdst_m55 (subtract T_LSQ6_ROBdst_m54)))
		(let ((T_LSQ6_ROBdst_m56 (subtract T_LSQ6_ROBdst_m55)))
		(let ((T_LSQ6_ROBdst_m57 (subtract T_LSQ6_ROBdst_m56)))
		(let ((T_LSQ6_ROBdst_m58 (subtract T_LSQ6_ROBdst_m57)))
		(let ((T_LSQ6_ROBdst_m59 (subtract T_LSQ6_ROBdst_m58)))
		(let ((T_LSQ6_ROBdst_m60 (subtract T_LSQ6_ROBdst_m59)))
		(let ((T_LSQ6_ROBdst_m61 (subtract T_LSQ6_ROBdst_m60)))
		(let ((T_LSQ6_ROBdst_m62 (subtract T_LSQ6_ROBdst_m61)))
		(let ((T_LSQ6_ROBdst_m63 (subtract T_LSQ6_ROBdst_m62)))

		(let ((T_LSQ5_ROBdst_m1 (subtract (select T_LSQ_ROB_dst (_ bv5 3)))))
		(let ((T_LSQ5_ROBdst_m2 (subtract T_LSQ5_ROBdst_m1)))
		(let ((T_LSQ5_ROBdst_m3 (subtract T_LSQ5_ROBdst_m2)))
		(let ((T_LSQ5_ROBdst_m4 (subtract T_LSQ5_ROBdst_m3)))
		(let ((T_LSQ5_ROBdst_m5 (subtract T_LSQ5_ROBdst_m4)))
		(let ((T_LSQ5_ROBdst_m6 (subtract T_LSQ5_ROBdst_m5)))
		(let ((T_LSQ5_ROBdst_m7 (subtract T_LSQ5_ROBdst_m6)))
		(let ((T_LSQ5_ROBdst_m8 (subtract T_LSQ5_ROBdst_m7)))
		(let ((T_LSQ5_ROBdst_m9 (subtract T_LSQ5_ROBdst_m8)))
		(let ((T_LSQ5_ROBdst_m10 (subtract T_LSQ5_ROBdst_m9)))
		(let ((T_LSQ5_ROBdst_m11 (subtract T_LSQ5_ROBdst_m10)))
		(let ((T_LSQ5_ROBdst_m12 (subtract T_LSQ5_ROBdst_m11)))
		(let ((T_LSQ5_ROBdst_m13 (subtract T_LSQ5_ROBdst_m12)))
		(let ((T_LSQ5_ROBdst_m14 (subtract T_LSQ5_ROBdst_m13)))
		(let ((T_LSQ5_ROBdst_m15 (subtract T_LSQ5_ROBdst_m14)))
		(let ((T_LSQ5_ROBdst_m16 (subtract T_LSQ5_ROBdst_m15)))
		(let ((T_LSQ5_ROBdst_m17 (subtract T_LSQ5_ROBdst_m16)))
		(let ((T_LSQ5_ROBdst_m18 (subtract T_LSQ5_ROBdst_m17)))
		(let ((T_LSQ5_ROBdst_m19 (subtract T_LSQ5_ROBdst_m18)))
		(let ((T_LSQ5_ROBdst_m20 (subtract T_LSQ5_ROBdst_m19)))
		(let ((T_LSQ5_ROBdst_m21 (subtract T_LSQ5_ROBdst_m20)))
		(let ((T_LSQ5_ROBdst_m22 (subtract T_LSQ5_ROBdst_m21)))
		(let ((T_LSQ5_ROBdst_m23 (subtract T_LSQ5_ROBdst_m22)))
		(let ((T_LSQ5_ROBdst_m24 (subtract T_LSQ5_ROBdst_m23)))
		(let ((T_LSQ5_ROBdst_m25 (subtract T_LSQ5_ROBdst_m24)))
		(let ((T_LSQ5_ROBdst_m26 (subtract T_LSQ5_ROBdst_m25)))
		(let ((T_LSQ5_ROBdst_m27 (subtract T_LSQ5_ROBdst_m26)))
		(let ((T_LSQ5_ROBdst_m28 (subtract T_LSQ5_ROBdst_m27)))
		(let ((T_LSQ5_ROBdst_m29 (subtract T_LSQ5_ROBdst_m28)))
		(let ((T_LSQ5_ROBdst_m30 (subtract T_LSQ5_ROBdst_m29)))
		(let ((T_LSQ5_ROBdst_m31 (subtract T_LSQ5_ROBdst_m30)))
		(let ((T_LSQ5_ROBdst_m32 (subtract T_LSQ5_ROBdst_m31)))
		(let ((T_LSQ5_ROBdst_m33 (subtract T_LSQ5_ROBdst_m32)))
		(let ((T_LSQ5_ROBdst_m34 (subtract T_LSQ5_ROBdst_m33)))
		(let ((T_LSQ5_ROBdst_m35 (subtract T_LSQ5_ROBdst_m34)))
		(let ((T_LSQ5_ROBdst_m36 (subtract T_LSQ5_ROBdst_m35)))
		(let ((T_LSQ5_ROBdst_m37 (subtract T_LSQ5_ROBdst_m36)))
		(let ((T_LSQ5_ROBdst_m38 (subtract T_LSQ5_ROBdst_m37)))
		(let ((T_LSQ5_ROBdst_m39 (subtract T_LSQ5_ROBdst_m38)))
		(let ((T_LSQ5_ROBdst_m40 (subtract T_LSQ5_ROBdst_m39)))
		(let ((T_LSQ5_ROBdst_m41 (subtract T_LSQ5_ROBdst_m40)))
		(let ((T_LSQ5_ROBdst_m42 (subtract T_LSQ5_ROBdst_m41)))
		(let ((T_LSQ5_ROBdst_m43 (subtract T_LSQ5_ROBdst_m42)))
		(let ((T_LSQ5_ROBdst_m44 (subtract T_LSQ5_ROBdst_m43)))
		(let ((T_LSQ5_ROBdst_m45 (subtract T_LSQ5_ROBdst_m44)))
		(let ((T_LSQ5_ROBdst_m46 (subtract T_LSQ5_ROBdst_m45)))
		(let ((T_LSQ5_ROBdst_m47 (subtract T_LSQ5_ROBdst_m46)))
		(let ((T_LSQ5_ROBdst_m48 (subtract T_LSQ5_ROBdst_m47)))
		(let ((T_LSQ5_ROBdst_m49 (subtract T_LSQ5_ROBdst_m48)))
		(let ((T_LSQ5_ROBdst_m50 (subtract T_LSQ5_ROBdst_m49)))
		(let ((T_LSQ5_ROBdst_m51 (subtract T_LSQ5_ROBdst_m50)))
		(let ((T_LSQ5_ROBdst_m52 (subtract T_LSQ5_ROBdst_m51)))
		(let ((T_LSQ5_ROBdst_m53 (subtract T_LSQ5_ROBdst_m52)))
		(let ((T_LSQ5_ROBdst_m54 (subtract T_LSQ5_ROBdst_m53)))
		(let ((T_LSQ5_ROBdst_m55 (subtract T_LSQ5_ROBdst_m54)))
		(let ((T_LSQ5_ROBdst_m56 (subtract T_LSQ5_ROBdst_m55)))
		(let ((T_LSQ5_ROBdst_m57 (subtract T_LSQ5_ROBdst_m56)))
		(let ((T_LSQ5_ROBdst_m58 (subtract T_LSQ5_ROBdst_m57)))
		(let ((T_LSQ5_ROBdst_m59 (subtract T_LSQ5_ROBdst_m58)))
		(let ((T_LSQ5_ROBdst_m60 (subtract T_LSQ5_ROBdst_m59)))
		(let ((T_LSQ5_ROBdst_m61 (subtract T_LSQ5_ROBdst_m60)))
		(let ((T_LSQ5_ROBdst_m62 (subtract T_LSQ5_ROBdst_m61)))
		(let ((T_LSQ5_ROBdst_m63 (subtract T_LSQ5_ROBdst_m62)))


		(let ((T_LSQ4_ROBdst_m1 (subtract (select T_LSQ_ROB_dst (_ bv4 3)))))
		(let ((T_LSQ4_ROBdst_m2 (subtract T_LSQ4_ROBdst_m1)))
		(let ((T_LSQ4_ROBdst_m3 (subtract T_LSQ4_ROBdst_m2)))
		(let ((T_LSQ4_ROBdst_m4 (subtract T_LSQ4_ROBdst_m3)))
		(let ((T_LSQ4_ROBdst_m5 (subtract T_LSQ4_ROBdst_m4)))
		(let ((T_LSQ4_ROBdst_m6 (subtract T_LSQ4_ROBdst_m5)))
		(let ((T_LSQ4_ROBdst_m7 (subtract T_LSQ4_ROBdst_m6)))
		(let ((T_LSQ4_ROBdst_m8 (subtract T_LSQ4_ROBdst_m7)))
		(let ((T_LSQ4_ROBdst_m9 (subtract T_LSQ4_ROBdst_m8)))
		(let ((T_LSQ4_ROBdst_m10 (subtract T_LSQ4_ROBdst_m9)))
		(let ((T_LSQ4_ROBdst_m11 (subtract T_LSQ4_ROBdst_m10)))
		(let ((T_LSQ4_ROBdst_m12 (subtract T_LSQ4_ROBdst_m11)))
		(let ((T_LSQ4_ROBdst_m13 (subtract T_LSQ4_ROBdst_m12)))
		(let ((T_LSQ4_ROBdst_m14 (subtract T_LSQ4_ROBdst_m13)))
		(let ((T_LSQ4_ROBdst_m15 (subtract T_LSQ4_ROBdst_m14)))
		(let ((T_LSQ4_ROBdst_m16 (subtract T_LSQ4_ROBdst_m15)))
		(let ((T_LSQ4_ROBdst_m17 (subtract T_LSQ4_ROBdst_m16)))
		(let ((T_LSQ4_ROBdst_m18 (subtract T_LSQ4_ROBdst_m17)))
		(let ((T_LSQ4_ROBdst_m19 (subtract T_LSQ4_ROBdst_m18)))
		(let ((T_LSQ4_ROBdst_m20 (subtract T_LSQ4_ROBdst_m19)))
		(let ((T_LSQ4_ROBdst_m21 (subtract T_LSQ4_ROBdst_m20)))
		(let ((T_LSQ4_ROBdst_m22 (subtract T_LSQ4_ROBdst_m21)))
		(let ((T_LSQ4_ROBdst_m23 (subtract T_LSQ4_ROBdst_m22)))
		(let ((T_LSQ4_ROBdst_m24 (subtract T_LSQ4_ROBdst_m23)))
		(let ((T_LSQ4_ROBdst_m25 (subtract T_LSQ4_ROBdst_m24)))
		(let ((T_LSQ4_ROBdst_m26 (subtract T_LSQ4_ROBdst_m25)))
		(let ((T_LSQ4_ROBdst_m27 (subtract T_LSQ4_ROBdst_m26)))
		(let ((T_LSQ4_ROBdst_m28 (subtract T_LSQ4_ROBdst_m27)))
		(let ((T_LSQ4_ROBdst_m29 (subtract T_LSQ4_ROBdst_m28)))
		(let ((T_LSQ4_ROBdst_m30 (subtract T_LSQ4_ROBdst_m29)))
		(let ((T_LSQ4_ROBdst_m31 (subtract T_LSQ4_ROBdst_m30)))
		(let ((T_LSQ4_ROBdst_m32 (subtract T_LSQ4_ROBdst_m31)))
		(let ((T_LSQ4_ROBdst_m33 (subtract T_LSQ4_ROBdst_m32)))
		(let ((T_LSQ4_ROBdst_m34 (subtract T_LSQ4_ROBdst_m33)))
		(let ((T_LSQ4_ROBdst_m35 (subtract T_LSQ4_ROBdst_m34)))
		(let ((T_LSQ4_ROBdst_m36 (subtract T_LSQ4_ROBdst_m35)))
		(let ((T_LSQ4_ROBdst_m37 (subtract T_LSQ4_ROBdst_m36)))
		(let ((T_LSQ4_ROBdst_m38 (subtract T_LSQ4_ROBdst_m37)))
		(let ((T_LSQ4_ROBdst_m39 (subtract T_LSQ4_ROBdst_m38)))
		(let ((T_LSQ4_ROBdst_m40 (subtract T_LSQ4_ROBdst_m39)))
		(let ((T_LSQ4_ROBdst_m41 (subtract T_LSQ4_ROBdst_m40)))
		(let ((T_LSQ4_ROBdst_m42 (subtract T_LSQ4_ROBdst_m41)))
		(let ((T_LSQ4_ROBdst_m43 (subtract T_LSQ4_ROBdst_m42)))
		(let ((T_LSQ4_ROBdst_m44 (subtract T_LSQ4_ROBdst_m43)))
		(let ((T_LSQ4_ROBdst_m45 (subtract T_LSQ4_ROBdst_m44)))
		(let ((T_LSQ4_ROBdst_m46 (subtract T_LSQ4_ROBdst_m45)))
		(let ((T_LSQ4_ROBdst_m47 (subtract T_LSQ4_ROBdst_m46)))
		(let ((T_LSQ4_ROBdst_m48 (subtract T_LSQ4_ROBdst_m47)))
		(let ((T_LSQ4_ROBdst_m49 (subtract T_LSQ4_ROBdst_m48)))
		(let ((T_LSQ4_ROBdst_m50 (subtract T_LSQ4_ROBdst_m49)))
		(let ((T_LSQ4_ROBdst_m51 (subtract T_LSQ4_ROBdst_m50)))
		(let ((T_LSQ4_ROBdst_m52 (subtract T_LSQ4_ROBdst_m51)))
		(let ((T_LSQ4_ROBdst_m53 (subtract T_LSQ4_ROBdst_m52)))
		(let ((T_LSQ4_ROBdst_m54 (subtract T_LSQ4_ROBdst_m53)))
		(let ((T_LSQ4_ROBdst_m55 (subtract T_LSQ4_ROBdst_m54)))
		(let ((T_LSQ4_ROBdst_m56 (subtract T_LSQ4_ROBdst_m55)))
		(let ((T_LSQ4_ROBdst_m57 (subtract T_LSQ4_ROBdst_m56)))
		(let ((T_LSQ4_ROBdst_m58 (subtract T_LSQ4_ROBdst_m57)))
		(let ((T_LSQ4_ROBdst_m59 (subtract T_LSQ4_ROBdst_m58)))
		(let ((T_LSQ4_ROBdst_m60 (subtract T_LSQ4_ROBdst_m59)))
		(let ((T_LSQ4_ROBdst_m61 (subtract T_LSQ4_ROBdst_m60)))
		(let ((T_LSQ4_ROBdst_m62 (subtract T_LSQ4_ROBdst_m61)))
		(let ((T_LSQ4_ROBdst_m63 (subtract T_LSQ4_ROBdst_m62)))		
		
		(let ((T_LSQ3_ROBdst_m1 (subtract (select T_LSQ_ROB_dst (_ bv3 3)))))
		(let ((T_LSQ3_ROBdst_m2 (subtract T_LSQ3_ROBdst_m1)))
		(let ((T_LSQ3_ROBdst_m3 (subtract T_LSQ3_ROBdst_m2)))
		(let ((T_LSQ3_ROBdst_m4 (subtract T_LSQ3_ROBdst_m3)))
		(let ((T_LSQ3_ROBdst_m5 (subtract T_LSQ3_ROBdst_m4)))
		(let ((T_LSQ3_ROBdst_m6 (subtract T_LSQ3_ROBdst_m5)))
		(let ((T_LSQ3_ROBdst_m7 (subtract T_LSQ3_ROBdst_m6)))
		(let ((T_LSQ3_ROBdst_m8 (subtract T_LSQ3_ROBdst_m7)))
		(let ((T_LSQ3_ROBdst_m9 (subtract T_LSQ3_ROBdst_m8)))
		(let ((T_LSQ3_ROBdst_m10 (subtract T_LSQ3_ROBdst_m9)))
		(let ((T_LSQ3_ROBdst_m11 (subtract T_LSQ3_ROBdst_m10)))
		(let ((T_LSQ3_ROBdst_m12 (subtract T_LSQ3_ROBdst_m11)))
		(let ((T_LSQ3_ROBdst_m13 (subtract T_LSQ3_ROBdst_m12)))
		(let ((T_LSQ3_ROBdst_m14 (subtract T_LSQ3_ROBdst_m13)))
		(let ((T_LSQ3_ROBdst_m15 (subtract T_LSQ3_ROBdst_m14)))
		(let ((T_LSQ3_ROBdst_m16 (subtract T_LSQ3_ROBdst_m15)))
		(let ((T_LSQ3_ROBdst_m17 (subtract T_LSQ3_ROBdst_m16)))
		(let ((T_LSQ3_ROBdst_m18 (subtract T_LSQ3_ROBdst_m17)))
		(let ((T_LSQ3_ROBdst_m19 (subtract T_LSQ3_ROBdst_m18)))
		(let ((T_LSQ3_ROBdst_m20 (subtract T_LSQ3_ROBdst_m19)))
		(let ((T_LSQ3_ROBdst_m21 (subtract T_LSQ3_ROBdst_m20)))
		(let ((T_LSQ3_ROBdst_m22 (subtract T_LSQ3_ROBdst_m21)))
		(let ((T_LSQ3_ROBdst_m23 (subtract T_LSQ3_ROBdst_m22)))
		(let ((T_LSQ3_ROBdst_m24 (subtract T_LSQ3_ROBdst_m23)))
		(let ((T_LSQ3_ROBdst_m25 (subtract T_LSQ3_ROBdst_m24)))
		(let ((T_LSQ3_ROBdst_m26 (subtract T_LSQ3_ROBdst_m25)))
		(let ((T_LSQ3_ROBdst_m27 (subtract T_LSQ3_ROBdst_m26)))
		(let ((T_LSQ3_ROBdst_m28 (subtract T_LSQ3_ROBdst_m27)))
		(let ((T_LSQ3_ROBdst_m29 (subtract T_LSQ3_ROBdst_m28)))
		(let ((T_LSQ3_ROBdst_m30 (subtract T_LSQ3_ROBdst_m29)))
		(let ((T_LSQ3_ROBdst_m31 (subtract T_LSQ3_ROBdst_m30)))
		(let ((T_LSQ3_ROBdst_m32 (subtract T_LSQ3_ROBdst_m31)))
		(let ((T_LSQ3_ROBdst_m33 (subtract T_LSQ3_ROBdst_m32)))
		(let ((T_LSQ3_ROBdst_m34 (subtract T_LSQ3_ROBdst_m33)))
		(let ((T_LSQ3_ROBdst_m35 (subtract T_LSQ3_ROBdst_m34)))
		(let ((T_LSQ3_ROBdst_m36 (subtract T_LSQ3_ROBdst_m35)))
		(let ((T_LSQ3_ROBdst_m37 (subtract T_LSQ3_ROBdst_m36)))
		(let ((T_LSQ3_ROBdst_m38 (subtract T_LSQ3_ROBdst_m37)))
		(let ((T_LSQ3_ROBdst_m39 (subtract T_LSQ3_ROBdst_m38)))
		(let ((T_LSQ3_ROBdst_m40 (subtract T_LSQ3_ROBdst_m39)))
		(let ((T_LSQ3_ROBdst_m41 (subtract T_LSQ3_ROBdst_m40)))
		(let ((T_LSQ3_ROBdst_m42 (subtract T_LSQ3_ROBdst_m41)))
		(let ((T_LSQ3_ROBdst_m43 (subtract T_LSQ3_ROBdst_m42)))
		(let ((T_LSQ3_ROBdst_m44 (subtract T_LSQ3_ROBdst_m43)))
		(let ((T_LSQ3_ROBdst_m45 (subtract T_LSQ3_ROBdst_m44)))
		(let ((T_LSQ3_ROBdst_m46 (subtract T_LSQ3_ROBdst_m45)))
		(let ((T_LSQ3_ROBdst_m47 (subtract T_LSQ3_ROBdst_m46)))
		(let ((T_LSQ3_ROBdst_m48 (subtract T_LSQ3_ROBdst_m47)))
		(let ((T_LSQ3_ROBdst_m49 (subtract T_LSQ3_ROBdst_m48)))
		(let ((T_LSQ3_ROBdst_m50 (subtract T_LSQ3_ROBdst_m49)))
		(let ((T_LSQ3_ROBdst_m51 (subtract T_LSQ3_ROBdst_m50)))
		(let ((T_LSQ3_ROBdst_m52 (subtract T_LSQ3_ROBdst_m51)))
		(let ((T_LSQ3_ROBdst_m53 (subtract T_LSQ3_ROBdst_m52)))
		(let ((T_LSQ3_ROBdst_m54 (subtract T_LSQ3_ROBdst_m53)))
		(let ((T_LSQ3_ROBdst_m55 (subtract T_LSQ3_ROBdst_m54)))
		(let ((T_LSQ3_ROBdst_m56 (subtract T_LSQ3_ROBdst_m55)))
		(let ((T_LSQ3_ROBdst_m57 (subtract T_LSQ3_ROBdst_m56)))
		(let ((T_LSQ3_ROBdst_m58 (subtract T_LSQ3_ROBdst_m57)))
		(let ((T_LSQ3_ROBdst_m59 (subtract T_LSQ3_ROBdst_m58)))
		(let ((T_LSQ3_ROBdst_m60 (subtract T_LSQ3_ROBdst_m59)))
		(let ((T_LSQ3_ROBdst_m61 (subtract T_LSQ3_ROBdst_m60)))
		(let ((T_LSQ3_ROBdst_m62 (subtract T_LSQ3_ROBdst_m61)))
		(let ((T_LSQ3_ROBdst_m63 (subtract T_LSQ3_ROBdst_m62)))

		
		(let ((T_LSQ2_ROBdst_m1 (subtract (select T_LSQ_ROB_dst (_ bv2 3)))))
		(let ((T_LSQ2_ROBdst_m2 (subtract T_LSQ2_ROBdst_m1)))
		(let ((T_LSQ2_ROBdst_m3 (subtract T_LSQ2_ROBdst_m2)))
		(let ((T_LSQ2_ROBdst_m4 (subtract T_LSQ2_ROBdst_m3)))
		(let ((T_LSQ2_ROBdst_m5 (subtract T_LSQ2_ROBdst_m4)))
		(let ((T_LSQ2_ROBdst_m6 (subtract T_LSQ2_ROBdst_m5)))
		(let ((T_LSQ2_ROBdst_m7 (subtract T_LSQ2_ROBdst_m6)))
		(let ((T_LSQ2_ROBdst_m8 (subtract T_LSQ2_ROBdst_m7)))
		(let ((T_LSQ2_ROBdst_m9 (subtract T_LSQ2_ROBdst_m8)))
		(let ((T_LSQ2_ROBdst_m10 (subtract T_LSQ2_ROBdst_m9)))
		(let ((T_LSQ2_ROBdst_m11 (subtract T_LSQ2_ROBdst_m10)))
		(let ((T_LSQ2_ROBdst_m12 (subtract T_LSQ2_ROBdst_m11)))
		(let ((T_LSQ2_ROBdst_m13 (subtract T_LSQ2_ROBdst_m12)))
		(let ((T_LSQ2_ROBdst_m14 (subtract T_LSQ2_ROBdst_m13)))
		(let ((T_LSQ2_ROBdst_m15 (subtract T_LSQ2_ROBdst_m14)))
		(let ((T_LSQ2_ROBdst_m16 (subtract T_LSQ2_ROBdst_m15)))
		(let ((T_LSQ2_ROBdst_m17 (subtract T_LSQ2_ROBdst_m16)))
		(let ((T_LSQ2_ROBdst_m18 (subtract T_LSQ2_ROBdst_m17)))
		(let ((T_LSQ2_ROBdst_m19 (subtract T_LSQ2_ROBdst_m18)))
		(let ((T_LSQ2_ROBdst_m20 (subtract T_LSQ2_ROBdst_m19)))
		(let ((T_LSQ2_ROBdst_m21 (subtract T_LSQ2_ROBdst_m20)))
		(let ((T_LSQ2_ROBdst_m22 (subtract T_LSQ2_ROBdst_m21)))
		(let ((T_LSQ2_ROBdst_m23 (subtract T_LSQ2_ROBdst_m22)))
		(let ((T_LSQ2_ROBdst_m24 (subtract T_LSQ2_ROBdst_m23)))
		(let ((T_LSQ2_ROBdst_m25 (subtract T_LSQ2_ROBdst_m24)))
		(let ((T_LSQ2_ROBdst_m26 (subtract T_LSQ2_ROBdst_m25)))
		(let ((T_LSQ2_ROBdst_m27 (subtract T_LSQ2_ROBdst_m26)))
		(let ((T_LSQ2_ROBdst_m28 (subtract T_LSQ2_ROBdst_m27)))
		(let ((T_LSQ2_ROBdst_m29 (subtract T_LSQ2_ROBdst_m28)))
		(let ((T_LSQ2_ROBdst_m30 (subtract T_LSQ2_ROBdst_m29)))
		(let ((T_LSQ2_ROBdst_m31 (subtract T_LSQ2_ROBdst_m30)))
		(let ((T_LSQ2_ROBdst_m32 (subtract T_LSQ2_ROBdst_m31)))
		(let ((T_LSQ2_ROBdst_m33 (subtract T_LSQ2_ROBdst_m32)))
		(let ((T_LSQ2_ROBdst_m34 (subtract T_LSQ2_ROBdst_m33)))
		(let ((T_LSQ2_ROBdst_m35 (subtract T_LSQ2_ROBdst_m34)))
		(let ((T_LSQ2_ROBdst_m36 (subtract T_LSQ2_ROBdst_m35)))
		(let ((T_LSQ2_ROBdst_m37 (subtract T_LSQ2_ROBdst_m36)))
		(let ((T_LSQ2_ROBdst_m38 (subtract T_LSQ2_ROBdst_m37)))
		(let ((T_LSQ2_ROBdst_m39 (subtract T_LSQ2_ROBdst_m38)))
		(let ((T_LSQ2_ROBdst_m40 (subtract T_LSQ2_ROBdst_m39)))
		(let ((T_LSQ2_ROBdst_m41 (subtract T_LSQ2_ROBdst_m40)))
		(let ((T_LSQ2_ROBdst_m42 (subtract T_LSQ2_ROBdst_m41)))
		(let ((T_LSQ2_ROBdst_m43 (subtract T_LSQ2_ROBdst_m42)))
		(let ((T_LSQ2_ROBdst_m44 (subtract T_LSQ2_ROBdst_m43)))
		(let ((T_LSQ2_ROBdst_m45 (subtract T_LSQ2_ROBdst_m44)))
		(let ((T_LSQ2_ROBdst_m46 (subtract T_LSQ2_ROBdst_m45)))
		(let ((T_LSQ2_ROBdst_m47 (subtract T_LSQ2_ROBdst_m46)))
		(let ((T_LSQ2_ROBdst_m48 (subtract T_LSQ2_ROBdst_m47)))
		(let ((T_LSQ2_ROBdst_m49 (subtract T_LSQ2_ROBdst_m48)))
		(let ((T_LSQ2_ROBdst_m50 (subtract T_LSQ2_ROBdst_m49)))
		(let ((T_LSQ2_ROBdst_m51 (subtract T_LSQ2_ROBdst_m50)))
		(let ((T_LSQ2_ROBdst_m52 (subtract T_LSQ2_ROBdst_m51)))
		(let ((T_LSQ2_ROBdst_m53 (subtract T_LSQ2_ROBdst_m52)))
		(let ((T_LSQ2_ROBdst_m54 (subtract T_LSQ2_ROBdst_m53)))
		(let ((T_LSQ2_ROBdst_m55 (subtract T_LSQ2_ROBdst_m54)))
		(let ((T_LSQ2_ROBdst_m56 (subtract T_LSQ2_ROBdst_m55)))
		(let ((T_LSQ2_ROBdst_m57 (subtract T_LSQ2_ROBdst_m56)))
		(let ((T_LSQ2_ROBdst_m58 (subtract T_LSQ2_ROBdst_m57)))
		(let ((T_LSQ2_ROBdst_m59 (subtract T_LSQ2_ROBdst_m58)))
		(let ((T_LSQ2_ROBdst_m60 (subtract T_LSQ2_ROBdst_m59)))
		(let ((T_LSQ2_ROBdst_m61 (subtract T_LSQ2_ROBdst_m60)))
		(let ((T_LSQ2_ROBdst_m62 (subtract T_LSQ2_ROBdst_m61)))
		(let ((T_LSQ2_ROBdst_m63 (subtract T_LSQ2_ROBdst_m62)))
		
		(let ((T_LSQ1_ROBdst_m1 (subtract (select T_LSQ_ROB_dst (_ bv1 3)))))
		(let ((T_LSQ1_ROBdst_m2 (subtract T_LSQ1_ROBdst_m1)))
		(let ((T_LSQ1_ROBdst_m3 (subtract T_LSQ1_ROBdst_m2)))
		(let ((T_LSQ1_ROBdst_m4 (subtract T_LSQ1_ROBdst_m3)))
		(let ((T_LSQ1_ROBdst_m5 (subtract T_LSQ1_ROBdst_m4)))
		(let ((T_LSQ1_ROBdst_m6 (subtract T_LSQ1_ROBdst_m5)))
		(let ((T_LSQ1_ROBdst_m7 (subtract T_LSQ1_ROBdst_m6)))
		(let ((T_LSQ1_ROBdst_m8 (subtract T_LSQ1_ROBdst_m7)))
		(let ((T_LSQ1_ROBdst_m9 (subtract T_LSQ1_ROBdst_m8)))
		(let ((T_LSQ1_ROBdst_m10 (subtract T_LSQ1_ROBdst_m9)))
		(let ((T_LSQ1_ROBdst_m11 (subtract T_LSQ1_ROBdst_m10)))
		(let ((T_LSQ1_ROBdst_m12 (subtract T_LSQ1_ROBdst_m11)))
		(let ((T_LSQ1_ROBdst_m13 (subtract T_LSQ1_ROBdst_m12)))
		(let ((T_LSQ1_ROBdst_m14 (subtract T_LSQ1_ROBdst_m13)))
		(let ((T_LSQ1_ROBdst_m15 (subtract T_LSQ1_ROBdst_m14)))
		(let ((T_LSQ1_ROBdst_m16 (subtract T_LSQ1_ROBdst_m15)))
		(let ((T_LSQ1_ROBdst_m17 (subtract T_LSQ1_ROBdst_m16)))
		(let ((T_LSQ1_ROBdst_m18 (subtract T_LSQ1_ROBdst_m17)))
		(let ((T_LSQ1_ROBdst_m19 (subtract T_LSQ1_ROBdst_m18)))
		(let ((T_LSQ1_ROBdst_m20 (subtract T_LSQ1_ROBdst_m19)))
		(let ((T_LSQ1_ROBdst_m21 (subtract T_LSQ1_ROBdst_m20)))
		(let ((T_LSQ1_ROBdst_m22 (subtract T_LSQ1_ROBdst_m21)))
		(let ((T_LSQ1_ROBdst_m23 (subtract T_LSQ1_ROBdst_m22)))
		(let ((T_LSQ1_ROBdst_m24 (subtract T_LSQ1_ROBdst_m23)))
		(let ((T_LSQ1_ROBdst_m25 (subtract T_LSQ1_ROBdst_m24)))
		(let ((T_LSQ1_ROBdst_m26 (subtract T_LSQ1_ROBdst_m25)))
		(let ((T_LSQ1_ROBdst_m27 (subtract T_LSQ1_ROBdst_m26)))
		(let ((T_LSQ1_ROBdst_m28 (subtract T_LSQ1_ROBdst_m27)))
		(let ((T_LSQ1_ROBdst_m29 (subtract T_LSQ1_ROBdst_m28)))
		(let ((T_LSQ1_ROBdst_m30 (subtract T_LSQ1_ROBdst_m29)))
		(let ((T_LSQ1_ROBdst_m31 (subtract T_LSQ1_ROBdst_m30)))
		(let ((T_LSQ1_ROBdst_m32 (subtract T_LSQ1_ROBdst_m31)))
		(let ((T_LSQ1_ROBdst_m33 (subtract T_LSQ1_ROBdst_m32)))
		(let ((T_LSQ1_ROBdst_m34 (subtract T_LSQ1_ROBdst_m33)))
		(let ((T_LSQ1_ROBdst_m35 (subtract T_LSQ1_ROBdst_m34)))
		(let ((T_LSQ1_ROBdst_m36 (subtract T_LSQ1_ROBdst_m35)))
		(let ((T_LSQ1_ROBdst_m37 (subtract T_LSQ1_ROBdst_m36)))
		(let ((T_LSQ1_ROBdst_m38 (subtract T_LSQ1_ROBdst_m37)))
		(let ((T_LSQ1_ROBdst_m39 (subtract T_LSQ1_ROBdst_m38)))
		(let ((T_LSQ1_ROBdst_m40 (subtract T_LSQ1_ROBdst_m39)))
		(let ((T_LSQ1_ROBdst_m41 (subtract T_LSQ1_ROBdst_m40)))
		(let ((T_LSQ1_ROBdst_m42 (subtract T_LSQ1_ROBdst_m41)))
		(let ((T_LSQ1_ROBdst_m43 (subtract T_LSQ1_ROBdst_m42)))
		(let ((T_LSQ1_ROBdst_m44 (subtract T_LSQ1_ROBdst_m43)))
		(let ((T_LSQ1_ROBdst_m45 (subtract T_LSQ1_ROBdst_m44)))
		(let ((T_LSQ1_ROBdst_m46 (subtract T_LSQ1_ROBdst_m45)))
		(let ((T_LSQ1_ROBdst_m47 (subtract T_LSQ1_ROBdst_m46)))
		(let ((T_LSQ1_ROBdst_m48 (subtract T_LSQ1_ROBdst_m47)))
		(let ((T_LSQ1_ROBdst_m49 (subtract T_LSQ1_ROBdst_m48)))
		(let ((T_LSQ1_ROBdst_m50 (subtract T_LSQ1_ROBdst_m49)))
		(let ((T_LSQ1_ROBdst_m51 (subtract T_LSQ1_ROBdst_m50)))
		(let ((T_LSQ1_ROBdst_m52 (subtract T_LSQ1_ROBdst_m51)))
		(let ((T_LSQ1_ROBdst_m53 (subtract T_LSQ1_ROBdst_m52)))
		(let ((T_LSQ1_ROBdst_m54 (subtract T_LSQ1_ROBdst_m53)))
		(let ((T_LSQ1_ROBdst_m55 (subtract T_LSQ1_ROBdst_m54)))
		(let ((T_LSQ1_ROBdst_m56 (subtract T_LSQ1_ROBdst_m55)))
		(let ((T_LSQ1_ROBdst_m57 (subtract T_LSQ1_ROBdst_m56)))
		(let ((T_LSQ1_ROBdst_m58 (subtract T_LSQ1_ROBdst_m57)))
		(let ((T_LSQ1_ROBdst_m59 (subtract T_LSQ1_ROBdst_m58)))
		(let ((T_LSQ1_ROBdst_m60 (subtract T_LSQ1_ROBdst_m59)))
		(let ((T_LSQ1_ROBdst_m61 (subtract T_LSQ1_ROBdst_m60)))
		(let ((T_LSQ1_ROBdst_m62 (subtract T_LSQ1_ROBdst_m61)))
		(let ((T_LSQ1_ROBdst_m63 (subtract T_LSQ1_ROBdst_m62)))
		
		(let ((T_LSQ0_ROBdst_m1 (subtract (select T_LSQ_ROB_dst (_ bv0 3)))))
		(let ((T_LSQ0_ROBdst_m2 (subtract T_LSQ0_ROBdst_m1)))
		(let ((T_LSQ0_ROBdst_m3 (subtract T_LSQ0_ROBdst_m2)))
		(let ((T_LSQ0_ROBdst_m4 (subtract T_LSQ0_ROBdst_m3)))
		(let ((T_LSQ0_ROBdst_m5 (subtract T_LSQ0_ROBdst_m4)))
		(let ((T_LSQ0_ROBdst_m6 (subtract T_LSQ0_ROBdst_m5)))
		(let ((T_LSQ0_ROBdst_m7 (subtract T_LSQ0_ROBdst_m6)))
		(let ((T_LSQ0_ROBdst_m8 (subtract T_LSQ0_ROBdst_m7)))
		(let ((T_LSQ0_ROBdst_m9 (subtract T_LSQ0_ROBdst_m8)))
		(let ((T_LSQ0_ROBdst_m10 (subtract T_LSQ0_ROBdst_m9)))
		(let ((T_LSQ0_ROBdst_m11 (subtract T_LSQ0_ROBdst_m10)))
		(let ((T_LSQ0_ROBdst_m12 (subtract T_LSQ0_ROBdst_m11)))
		(let ((T_LSQ0_ROBdst_m13 (subtract T_LSQ0_ROBdst_m12)))
		(let ((T_LSQ0_ROBdst_m14 (subtract T_LSQ0_ROBdst_m13)))
		(let ((T_LSQ0_ROBdst_m15 (subtract T_LSQ0_ROBdst_m14)))
		(let ((T_LSQ0_ROBdst_m16 (subtract T_LSQ0_ROBdst_m15)))
		(let ((T_LSQ0_ROBdst_m17 (subtract T_LSQ0_ROBdst_m16)))
		(let ((T_LSQ0_ROBdst_m18 (subtract T_LSQ0_ROBdst_m17)))
		(let ((T_LSQ0_ROBdst_m19 (subtract T_LSQ0_ROBdst_m18)))
		(let ((T_LSQ0_ROBdst_m20 (subtract T_LSQ0_ROBdst_m19)))
		(let ((T_LSQ0_ROBdst_m21 (subtract T_LSQ0_ROBdst_m20)))
		(let ((T_LSQ0_ROBdst_m22 (subtract T_LSQ0_ROBdst_m21)))
		(let ((T_LSQ0_ROBdst_m23 (subtract T_LSQ0_ROBdst_m22)))
		(let ((T_LSQ0_ROBdst_m24 (subtract T_LSQ0_ROBdst_m23)))
		(let ((T_LSQ0_ROBdst_m25 (subtract T_LSQ0_ROBdst_m24)))
		(let ((T_LSQ0_ROBdst_m26 (subtract T_LSQ0_ROBdst_m25)))
		(let ((T_LSQ0_ROBdst_m27 (subtract T_LSQ0_ROBdst_m26)))
		(let ((T_LSQ0_ROBdst_m28 (subtract T_LSQ0_ROBdst_m27)))
		(let ((T_LSQ0_ROBdst_m29 (subtract T_LSQ0_ROBdst_m28)))
		(let ((T_LSQ0_ROBdst_m30 (subtract T_LSQ0_ROBdst_m29)))
		(let ((T_LSQ0_ROBdst_m31 (subtract T_LSQ0_ROBdst_m30)))
		(let ((T_LSQ0_ROBdst_m32 (subtract T_LSQ0_ROBdst_m31)))
		(let ((T_LSQ0_ROBdst_m33 (subtract T_LSQ0_ROBdst_m32)))
		(let ((T_LSQ0_ROBdst_m34 (subtract T_LSQ0_ROBdst_m33)))
		(let ((T_LSQ0_ROBdst_m35 (subtract T_LSQ0_ROBdst_m34)))
		(let ((T_LSQ0_ROBdst_m36 (subtract T_LSQ0_ROBdst_m35)))
		(let ((T_LSQ0_ROBdst_m37 (subtract T_LSQ0_ROBdst_m36)))
		(let ((T_LSQ0_ROBdst_m38 (subtract T_LSQ0_ROBdst_m37)))
		(let ((T_LSQ0_ROBdst_m39 (subtract T_LSQ0_ROBdst_m38)))
		(let ((T_LSQ0_ROBdst_m40 (subtract T_LSQ0_ROBdst_m39)))
		(let ((T_LSQ0_ROBdst_m41 (subtract T_LSQ0_ROBdst_m40)))
		(let ((T_LSQ0_ROBdst_m42 (subtract T_LSQ0_ROBdst_m41)))
		(let ((T_LSQ0_ROBdst_m43 (subtract T_LSQ0_ROBdst_m42)))
		(let ((T_LSQ0_ROBdst_m44 (subtract T_LSQ0_ROBdst_m43)))
		(let ((T_LSQ0_ROBdst_m45 (subtract T_LSQ0_ROBdst_m44)))
		(let ((T_LSQ0_ROBdst_m46 (subtract T_LSQ0_ROBdst_m45)))
		(let ((T_LSQ0_ROBdst_m47 (subtract T_LSQ0_ROBdst_m46)))
		(let ((T_LSQ0_ROBdst_m48 (subtract T_LSQ0_ROBdst_m47)))
		(let ((T_LSQ0_ROBdst_m49 (subtract T_LSQ0_ROBdst_m48)))
		(let ((T_LSQ0_ROBdst_m50 (subtract T_LSQ0_ROBdst_m49)))
		(let ((T_LSQ0_ROBdst_m51 (subtract T_LSQ0_ROBdst_m50)))
		(let ((T_LSQ0_ROBdst_m52 (subtract T_LSQ0_ROBdst_m51)))
		(let ((T_LSQ0_ROBdst_m53 (subtract T_LSQ0_ROBdst_m52)))
		(let ((T_LSQ0_ROBdst_m54 (subtract T_LSQ0_ROBdst_m53)))
		(let ((T_LSQ0_ROBdst_m55 (subtract T_LSQ0_ROBdst_m54)))
		(let ((T_LSQ0_ROBdst_m56 (subtract T_LSQ0_ROBdst_m55)))
		(let ((T_LSQ0_ROBdst_m57 (subtract T_LSQ0_ROBdst_m56)))
		(let ((T_LSQ0_ROBdst_m58 (subtract T_LSQ0_ROBdst_m57)))
		(let ((T_LSQ0_ROBdst_m59 (subtract T_LSQ0_ROBdst_m58)))
		(let ((T_LSQ0_ROBdst_m60 (subtract T_LSQ0_ROBdst_m59)))
		(let ((T_LSQ0_ROBdst_m61 (subtract T_LSQ0_ROBdst_m60)))
		(let ((T_LSQ0_ROBdst_m62 (subtract T_LSQ0_ROBdst_m61)))
		(let ((T_LSQ0_ROBdst_m63 (subtract T_LSQ0_ROBdst_m62)))

		(let ((T_RS7_ROBdst_m1 (subtract (select T_RS_ROB_dst (_ bv7 3)))))
		(let ((T_RS7_ROBdst_m2 (subtract T_RS7_ROBdst_m1)))
		(let ((T_RS7_ROBdst_m3 (subtract T_RS7_ROBdst_m2)))
		(let ((T_RS7_ROBdst_m4 (subtract T_RS7_ROBdst_m3)))
		(let ((T_RS7_ROBdst_m5 (subtract T_RS7_ROBdst_m4)))
		(let ((T_RS7_ROBdst_m6 (subtract T_RS7_ROBdst_m5)))
		(let ((T_RS7_ROBdst_m7 (subtract T_RS7_ROBdst_m6)))
		(let ((T_RS7_ROBdst_m8 (subtract T_RS7_ROBdst_m7)))
		(let ((T_RS7_ROBdst_m9 (subtract T_RS7_ROBdst_m8)))
		(let ((T_RS7_ROBdst_m10 (subtract T_RS7_ROBdst_m9)))
		(let ((T_RS7_ROBdst_m11 (subtract T_RS7_ROBdst_m10)))
		(let ((T_RS7_ROBdst_m12 (subtract T_RS7_ROBdst_m11)))
		(let ((T_RS7_ROBdst_m13 (subtract T_RS7_ROBdst_m12)))
		(let ((T_RS7_ROBdst_m14 (subtract T_RS7_ROBdst_m13)))
		(let ((T_RS7_ROBdst_m15 (subtract T_RS7_ROBdst_m14)))
		(let ((T_RS7_ROBdst_m16 (subtract T_RS7_ROBdst_m15)))
		(let ((T_RS7_ROBdst_m17 (subtract T_RS7_ROBdst_m16)))
		(let ((T_RS7_ROBdst_m18 (subtract T_RS7_ROBdst_m17)))
		(let ((T_RS7_ROBdst_m19 (subtract T_RS7_ROBdst_m18)))
		(let ((T_RS7_ROBdst_m20 (subtract T_RS7_ROBdst_m19)))
		(let ((T_RS7_ROBdst_m21 (subtract T_RS7_ROBdst_m20)))
		(let ((T_RS7_ROBdst_m22 (subtract T_RS7_ROBdst_m21)))
		(let ((T_RS7_ROBdst_m23 (subtract T_RS7_ROBdst_m22)))
		(let ((T_RS7_ROBdst_m24 (subtract T_RS7_ROBdst_m23)))
		(let ((T_RS7_ROBdst_m25 (subtract T_RS7_ROBdst_m24)))
		(let ((T_RS7_ROBdst_m26 (subtract T_RS7_ROBdst_m25)))
		(let ((T_RS7_ROBdst_m27 (subtract T_RS7_ROBdst_m26)))
		(let ((T_RS7_ROBdst_m28 (subtract T_RS7_ROBdst_m27)))
		(let ((T_RS7_ROBdst_m29 (subtract T_RS7_ROBdst_m28)))
		(let ((T_RS7_ROBdst_m30 (subtract T_RS7_ROBdst_m29)))
		(let ((T_RS7_ROBdst_m31 (subtract T_RS7_ROBdst_m30)))
		(let ((T_RS7_ROBdst_m32 (subtract T_RS7_ROBdst_m31)))
		(let ((T_RS7_ROBdst_m33 (subtract T_RS7_ROBdst_m32)))
		(let ((T_RS7_ROBdst_m34 (subtract T_RS7_ROBdst_m33)))
		(let ((T_RS7_ROBdst_m35 (subtract T_RS7_ROBdst_m34)))
		(let ((T_RS7_ROBdst_m36 (subtract T_RS7_ROBdst_m35)))
		(let ((T_RS7_ROBdst_m37 (subtract T_RS7_ROBdst_m36)))
		(let ((T_RS7_ROBdst_m38 (subtract T_RS7_ROBdst_m37)))
		(let ((T_RS7_ROBdst_m39 (subtract T_RS7_ROBdst_m38)))
		(let ((T_RS7_ROBdst_m40 (subtract T_RS7_ROBdst_m39)))
		(let ((T_RS7_ROBdst_m41 (subtract T_RS7_ROBdst_m40)))
		(let ((T_RS7_ROBdst_m42 (subtract T_RS7_ROBdst_m41)))
		(let ((T_RS7_ROBdst_m43 (subtract T_RS7_ROBdst_m42)))
		(let ((T_RS7_ROBdst_m44 (subtract T_RS7_ROBdst_m43)))
		(let ((T_RS7_ROBdst_m45 (subtract T_RS7_ROBdst_m44)))
		(let ((T_RS7_ROBdst_m46 (subtract T_RS7_ROBdst_m45)))
		(let ((T_RS7_ROBdst_m47 (subtract T_RS7_ROBdst_m46)))
		(let ((T_RS7_ROBdst_m48 (subtract T_RS7_ROBdst_m47)))
		(let ((T_RS7_ROBdst_m49 (subtract T_RS7_ROBdst_m48)))
		(let ((T_RS7_ROBdst_m50 (subtract T_RS7_ROBdst_m49)))
		(let ((T_RS7_ROBdst_m51 (subtract T_RS7_ROBdst_m50)))
		(let ((T_RS7_ROBdst_m52 (subtract T_RS7_ROBdst_m51)))
		(let ((T_RS7_ROBdst_m53 (subtract T_RS7_ROBdst_m52)))
		(let ((T_RS7_ROBdst_m54 (subtract T_RS7_ROBdst_m53)))
		(let ((T_RS7_ROBdst_m55 (subtract T_RS7_ROBdst_m54)))
		(let ((T_RS7_ROBdst_m56 (subtract T_RS7_ROBdst_m55)))
		(let ((T_RS7_ROBdst_m57 (subtract T_RS7_ROBdst_m56)))
		(let ((T_RS7_ROBdst_m58 (subtract T_RS7_ROBdst_m57)))
		(let ((T_RS7_ROBdst_m59 (subtract T_RS7_ROBdst_m58)))
		(let ((T_RS7_ROBdst_m60 (subtract T_RS7_ROBdst_m59)))
		(let ((T_RS7_ROBdst_m61 (subtract T_RS7_ROBdst_m60)))
		(let ((T_RS7_ROBdst_m62 (subtract T_RS7_ROBdst_m61)))
		(let ((T_RS7_ROBdst_m63 (subtract T_RS7_ROBdst_m62)))

		
		(let ((T_RS6_ROBdst_m1 (subtract (select T_RS_ROB_dst (_ bv6 3)))))
		(let ((T_RS6_ROBdst_m2 (subtract T_RS6_ROBdst_m1)))
		(let ((T_RS6_ROBdst_m3 (subtract T_RS6_ROBdst_m2)))
		(let ((T_RS6_ROBdst_m4 (subtract T_RS6_ROBdst_m3)))
		(let ((T_RS6_ROBdst_m5 (subtract T_RS6_ROBdst_m4)))
		(let ((T_RS6_ROBdst_m6 (subtract T_RS6_ROBdst_m5)))
		(let ((T_RS6_ROBdst_m7 (subtract T_RS6_ROBdst_m6)))
		(let ((T_RS6_ROBdst_m8 (subtract T_RS6_ROBdst_m7)))
		(let ((T_RS6_ROBdst_m9 (subtract T_RS6_ROBdst_m8)))
		(let ((T_RS6_ROBdst_m10 (subtract T_RS6_ROBdst_m9)))
		(let ((T_RS6_ROBdst_m11 (subtract T_RS6_ROBdst_m10)))
		(let ((T_RS6_ROBdst_m12 (subtract T_RS6_ROBdst_m11)))
		(let ((T_RS6_ROBdst_m13 (subtract T_RS6_ROBdst_m12)))
		(let ((T_RS6_ROBdst_m14 (subtract T_RS6_ROBdst_m13)))
		(let ((T_RS6_ROBdst_m15 (subtract T_RS6_ROBdst_m14)))
		(let ((T_RS6_ROBdst_m16 (subtract T_RS6_ROBdst_m15)))
		(let ((T_RS6_ROBdst_m17 (subtract T_RS6_ROBdst_m16)))
		(let ((T_RS6_ROBdst_m18 (subtract T_RS6_ROBdst_m17)))
		(let ((T_RS6_ROBdst_m19 (subtract T_RS6_ROBdst_m18)))
		(let ((T_RS6_ROBdst_m20 (subtract T_RS6_ROBdst_m19)))
		(let ((T_RS6_ROBdst_m21 (subtract T_RS6_ROBdst_m20)))
		(let ((T_RS6_ROBdst_m22 (subtract T_RS6_ROBdst_m21)))
		(let ((T_RS6_ROBdst_m23 (subtract T_RS6_ROBdst_m22)))
		(let ((T_RS6_ROBdst_m24 (subtract T_RS6_ROBdst_m23)))
		(let ((T_RS6_ROBdst_m25 (subtract T_RS6_ROBdst_m24)))
		(let ((T_RS6_ROBdst_m26 (subtract T_RS6_ROBdst_m25)))
		(let ((T_RS6_ROBdst_m27 (subtract T_RS6_ROBdst_m26)))
		(let ((T_RS6_ROBdst_m28 (subtract T_RS6_ROBdst_m27)))
		(let ((T_RS6_ROBdst_m29 (subtract T_RS6_ROBdst_m28)))
		(let ((T_RS6_ROBdst_m30 (subtract T_RS6_ROBdst_m29)))
		(let ((T_RS6_ROBdst_m31 (subtract T_RS6_ROBdst_m30)))
		(let ((T_RS6_ROBdst_m32 (subtract T_RS6_ROBdst_m31)))
		(let ((T_RS6_ROBdst_m33 (subtract T_RS6_ROBdst_m32)))
		(let ((T_RS6_ROBdst_m34 (subtract T_RS6_ROBdst_m33)))
		(let ((T_RS6_ROBdst_m35 (subtract T_RS6_ROBdst_m34)))
		(let ((T_RS6_ROBdst_m36 (subtract T_RS6_ROBdst_m35)))
		(let ((T_RS6_ROBdst_m37 (subtract T_RS6_ROBdst_m36)))
		(let ((T_RS6_ROBdst_m38 (subtract T_RS6_ROBdst_m37)))
		(let ((T_RS6_ROBdst_m39 (subtract T_RS6_ROBdst_m38)))
		(let ((T_RS6_ROBdst_m40 (subtract T_RS6_ROBdst_m39)))
		(let ((T_RS6_ROBdst_m41 (subtract T_RS6_ROBdst_m40)))
		(let ((T_RS6_ROBdst_m42 (subtract T_RS6_ROBdst_m41)))
		(let ((T_RS6_ROBdst_m43 (subtract T_RS6_ROBdst_m42)))
		(let ((T_RS6_ROBdst_m44 (subtract T_RS6_ROBdst_m43)))
		(let ((T_RS6_ROBdst_m45 (subtract T_RS6_ROBdst_m44)))
		(let ((T_RS6_ROBdst_m46 (subtract T_RS6_ROBdst_m45)))
		(let ((T_RS6_ROBdst_m47 (subtract T_RS6_ROBdst_m46)))
		(let ((T_RS6_ROBdst_m48 (subtract T_RS6_ROBdst_m47)))
		(let ((T_RS6_ROBdst_m49 (subtract T_RS6_ROBdst_m48)))
		(let ((T_RS6_ROBdst_m50 (subtract T_RS6_ROBdst_m49)))
		(let ((T_RS6_ROBdst_m51 (subtract T_RS6_ROBdst_m50)))
		(let ((T_RS6_ROBdst_m52 (subtract T_RS6_ROBdst_m51)))
		(let ((T_RS6_ROBdst_m53 (subtract T_RS6_ROBdst_m52)))
		(let ((T_RS6_ROBdst_m54 (subtract T_RS6_ROBdst_m53)))
		(let ((T_RS6_ROBdst_m55 (subtract T_RS6_ROBdst_m54)))
		(let ((T_RS6_ROBdst_m56 (subtract T_RS6_ROBdst_m55)))
		(let ((T_RS6_ROBdst_m57 (subtract T_RS6_ROBdst_m56)))
		(let ((T_RS6_ROBdst_m58 (subtract T_RS6_ROBdst_m57)))
		(let ((T_RS6_ROBdst_m59 (subtract T_RS6_ROBdst_m58)))
		(let ((T_RS6_ROBdst_m60 (subtract T_RS6_ROBdst_m59)))
		(let ((T_RS6_ROBdst_m61 (subtract T_RS6_ROBdst_m60)))
		(let ((T_RS6_ROBdst_m62 (subtract T_RS6_ROBdst_m61)))
		(let ((T_RS6_ROBdst_m63 (subtract T_RS6_ROBdst_m62)))

		
		(let ((T_RS5_ROBdst_m1 (subtract (select T_RS_ROB_dst (_ bv5 3)))))
		(let ((T_RS5_ROBdst_m2 (subtract T_RS5_ROBdst_m1)))
		(let ((T_RS5_ROBdst_m3 (subtract T_RS5_ROBdst_m2)))
		(let ((T_RS5_ROBdst_m4 (subtract T_RS5_ROBdst_m3)))
		(let ((T_RS5_ROBdst_m5 (subtract T_RS5_ROBdst_m4)))
		(let ((T_RS5_ROBdst_m6 (subtract T_RS5_ROBdst_m5)))
		(let ((T_RS5_ROBdst_m7 (subtract T_RS5_ROBdst_m6)))
		(let ((T_RS5_ROBdst_m8 (subtract T_RS5_ROBdst_m7)))
		(let ((T_RS5_ROBdst_m9 (subtract T_RS5_ROBdst_m8)))
		(let ((T_RS5_ROBdst_m10 (subtract T_RS5_ROBdst_m9)))
		(let ((T_RS5_ROBdst_m11 (subtract T_RS5_ROBdst_m10)))
		(let ((T_RS5_ROBdst_m12 (subtract T_RS5_ROBdst_m11)))
		(let ((T_RS5_ROBdst_m13 (subtract T_RS5_ROBdst_m12)))
		(let ((T_RS5_ROBdst_m14 (subtract T_RS5_ROBdst_m13)))
		(let ((T_RS5_ROBdst_m15 (subtract T_RS5_ROBdst_m14)))
		(let ((T_RS5_ROBdst_m16 (subtract T_RS5_ROBdst_m15)))
		(let ((T_RS5_ROBdst_m17 (subtract T_RS5_ROBdst_m16)))
		(let ((T_RS5_ROBdst_m18 (subtract T_RS5_ROBdst_m17)))
		(let ((T_RS5_ROBdst_m19 (subtract T_RS5_ROBdst_m18)))
		(let ((T_RS5_ROBdst_m20 (subtract T_RS5_ROBdst_m19)))
		(let ((T_RS5_ROBdst_m21 (subtract T_RS5_ROBdst_m20)))
		(let ((T_RS5_ROBdst_m22 (subtract T_RS5_ROBdst_m21)))
		(let ((T_RS5_ROBdst_m23 (subtract T_RS5_ROBdst_m22)))
		(let ((T_RS5_ROBdst_m24 (subtract T_RS5_ROBdst_m23)))
		(let ((T_RS5_ROBdst_m25 (subtract T_RS5_ROBdst_m24)))
		(let ((T_RS5_ROBdst_m26 (subtract T_RS5_ROBdst_m25)))
		(let ((T_RS5_ROBdst_m27 (subtract T_RS5_ROBdst_m26)))
		(let ((T_RS5_ROBdst_m28 (subtract T_RS5_ROBdst_m27)))
		(let ((T_RS5_ROBdst_m29 (subtract T_RS5_ROBdst_m28)))
		(let ((T_RS5_ROBdst_m30 (subtract T_RS5_ROBdst_m29)))
		(let ((T_RS5_ROBdst_m31 (subtract T_RS5_ROBdst_m30)))
		(let ((T_RS5_ROBdst_m32 (subtract T_RS5_ROBdst_m31)))
		(let ((T_RS5_ROBdst_m33 (subtract T_RS5_ROBdst_m32)))
		(let ((T_RS5_ROBdst_m34 (subtract T_RS5_ROBdst_m33)))
		(let ((T_RS5_ROBdst_m35 (subtract T_RS5_ROBdst_m34)))
		(let ((T_RS5_ROBdst_m36 (subtract T_RS5_ROBdst_m35)))
		(let ((T_RS5_ROBdst_m37 (subtract T_RS5_ROBdst_m36)))
		(let ((T_RS5_ROBdst_m38 (subtract T_RS5_ROBdst_m37)))
		(let ((T_RS5_ROBdst_m39 (subtract T_RS5_ROBdst_m38)))
		(let ((T_RS5_ROBdst_m40 (subtract T_RS5_ROBdst_m39)))
		(let ((T_RS5_ROBdst_m41 (subtract T_RS5_ROBdst_m40)))
		(let ((T_RS5_ROBdst_m42 (subtract T_RS5_ROBdst_m41)))
		(let ((T_RS5_ROBdst_m43 (subtract T_RS5_ROBdst_m42)))
		(let ((T_RS5_ROBdst_m44 (subtract T_RS5_ROBdst_m43)))
		(let ((T_RS5_ROBdst_m45 (subtract T_RS5_ROBdst_m44)))
		(let ((T_RS5_ROBdst_m46 (subtract T_RS5_ROBdst_m45)))
		(let ((T_RS5_ROBdst_m47 (subtract T_RS5_ROBdst_m46)))
		(let ((T_RS5_ROBdst_m48 (subtract T_RS5_ROBdst_m47)))
		(let ((T_RS5_ROBdst_m49 (subtract T_RS5_ROBdst_m48)))
		(let ((T_RS5_ROBdst_m50 (subtract T_RS5_ROBdst_m49)))
		(let ((T_RS5_ROBdst_m51 (subtract T_RS5_ROBdst_m50)))
		(let ((T_RS5_ROBdst_m52 (subtract T_RS5_ROBdst_m51)))
		(let ((T_RS5_ROBdst_m53 (subtract T_RS5_ROBdst_m52)))
		(let ((T_RS5_ROBdst_m54 (subtract T_RS5_ROBdst_m53)))
		(let ((T_RS5_ROBdst_m55 (subtract T_RS5_ROBdst_m54)))
		(let ((T_RS5_ROBdst_m56 (subtract T_RS5_ROBdst_m55)))
		(let ((T_RS5_ROBdst_m57 (subtract T_RS5_ROBdst_m56)))
		(let ((T_RS5_ROBdst_m58 (subtract T_RS5_ROBdst_m57)))
		(let ((T_RS5_ROBdst_m59 (subtract T_RS5_ROBdst_m58)))
		(let ((T_RS5_ROBdst_m60 (subtract T_RS5_ROBdst_m59)))
		(let ((T_RS5_ROBdst_m61 (subtract T_RS5_ROBdst_m60)))
		(let ((T_RS5_ROBdst_m62 (subtract T_RS5_ROBdst_m61)))
		(let ((T_RS5_ROBdst_m63 (subtract T_RS5_ROBdst_m62)))

		
		(let ((T_RS4_ROBdst_m1 (subtract (select T_RS_ROB_dst (_ bv4 3)))))
		(let ((T_RS4_ROBdst_m2 (subtract T_RS4_ROBdst_m1)))
		(let ((T_RS4_ROBdst_m3 (subtract T_RS4_ROBdst_m2)))
		(let ((T_RS4_ROBdst_m4 (subtract T_RS4_ROBdst_m3)))
		(let ((T_RS4_ROBdst_m5 (subtract T_RS4_ROBdst_m4)))
		(let ((T_RS4_ROBdst_m6 (subtract T_RS4_ROBdst_m5)))
		(let ((T_RS4_ROBdst_m7 (subtract T_RS4_ROBdst_m6)))
		(let ((T_RS4_ROBdst_m8 (subtract T_RS4_ROBdst_m7)))
		(let ((T_RS4_ROBdst_m9 (subtract T_RS4_ROBdst_m8)))
		(let ((T_RS4_ROBdst_m10 (subtract T_RS4_ROBdst_m9)))
		(let ((T_RS4_ROBdst_m11 (subtract T_RS4_ROBdst_m10)))
		(let ((T_RS4_ROBdst_m12 (subtract T_RS4_ROBdst_m11)))
		(let ((T_RS4_ROBdst_m13 (subtract T_RS4_ROBdst_m12)))
		(let ((T_RS4_ROBdst_m14 (subtract T_RS4_ROBdst_m13)))
		(let ((T_RS4_ROBdst_m15 (subtract T_RS4_ROBdst_m14)))
		(let ((T_RS4_ROBdst_m16 (subtract T_RS4_ROBdst_m15)))
		(let ((T_RS4_ROBdst_m17 (subtract T_RS4_ROBdst_m16)))
		(let ((T_RS4_ROBdst_m18 (subtract T_RS4_ROBdst_m17)))
		(let ((T_RS4_ROBdst_m19 (subtract T_RS4_ROBdst_m18)))
		(let ((T_RS4_ROBdst_m20 (subtract T_RS4_ROBdst_m19)))
		(let ((T_RS4_ROBdst_m21 (subtract T_RS4_ROBdst_m20)))
		(let ((T_RS4_ROBdst_m22 (subtract T_RS4_ROBdst_m21)))
		(let ((T_RS4_ROBdst_m23 (subtract T_RS4_ROBdst_m22)))
		(let ((T_RS4_ROBdst_m24 (subtract T_RS4_ROBdst_m23)))
		(let ((T_RS4_ROBdst_m25 (subtract T_RS4_ROBdst_m24)))
		(let ((T_RS4_ROBdst_m26 (subtract T_RS4_ROBdst_m25)))
		(let ((T_RS4_ROBdst_m27 (subtract T_RS4_ROBdst_m26)))
		(let ((T_RS4_ROBdst_m28 (subtract T_RS4_ROBdst_m27)))
		(let ((T_RS4_ROBdst_m29 (subtract T_RS4_ROBdst_m28)))
		(let ((T_RS4_ROBdst_m30 (subtract T_RS4_ROBdst_m29)))
		(let ((T_RS4_ROBdst_m31 (subtract T_RS4_ROBdst_m30)))
		(let ((T_RS4_ROBdst_m32 (subtract T_RS4_ROBdst_m31)))
		(let ((T_RS4_ROBdst_m33 (subtract T_RS4_ROBdst_m32)))
		(let ((T_RS4_ROBdst_m34 (subtract T_RS4_ROBdst_m33)))
		(let ((T_RS4_ROBdst_m35 (subtract T_RS4_ROBdst_m34)))
		(let ((T_RS4_ROBdst_m36 (subtract T_RS4_ROBdst_m35)))
		(let ((T_RS4_ROBdst_m37 (subtract T_RS4_ROBdst_m36)))
		(let ((T_RS4_ROBdst_m38 (subtract T_RS4_ROBdst_m37)))
		(let ((T_RS4_ROBdst_m39 (subtract T_RS4_ROBdst_m38)))
		(let ((T_RS4_ROBdst_m40 (subtract T_RS4_ROBdst_m39)))
		(let ((T_RS4_ROBdst_m41 (subtract T_RS4_ROBdst_m40)))
		(let ((T_RS4_ROBdst_m42 (subtract T_RS4_ROBdst_m41)))
		(let ((T_RS4_ROBdst_m43 (subtract T_RS4_ROBdst_m42)))
		(let ((T_RS4_ROBdst_m44 (subtract T_RS4_ROBdst_m43)))
		(let ((T_RS4_ROBdst_m45 (subtract T_RS4_ROBdst_m44)))
		(let ((T_RS4_ROBdst_m46 (subtract T_RS4_ROBdst_m45)))
		(let ((T_RS4_ROBdst_m47 (subtract T_RS4_ROBdst_m46)))
		(let ((T_RS4_ROBdst_m48 (subtract T_RS4_ROBdst_m47)))
		(let ((T_RS4_ROBdst_m49 (subtract T_RS4_ROBdst_m48)))
		(let ((T_RS4_ROBdst_m50 (subtract T_RS4_ROBdst_m49)))
		(let ((T_RS4_ROBdst_m51 (subtract T_RS4_ROBdst_m50)))
		(let ((T_RS4_ROBdst_m52 (subtract T_RS4_ROBdst_m51)))
		(let ((T_RS4_ROBdst_m53 (subtract T_RS4_ROBdst_m52)))
		(let ((T_RS4_ROBdst_m54 (subtract T_RS4_ROBdst_m53)))
		(let ((T_RS4_ROBdst_m55 (subtract T_RS4_ROBdst_m54)))
		(let ((T_RS4_ROBdst_m56 (subtract T_RS4_ROBdst_m55)))
		(let ((T_RS4_ROBdst_m57 (subtract T_RS4_ROBdst_m56)))
		(let ((T_RS4_ROBdst_m58 (subtract T_RS4_ROBdst_m57)))
		(let ((T_RS4_ROBdst_m59 (subtract T_RS4_ROBdst_m58)))
		(let ((T_RS4_ROBdst_m60 (subtract T_RS4_ROBdst_m59)))
		(let ((T_RS4_ROBdst_m61 (subtract T_RS4_ROBdst_m60)))
		(let ((T_RS4_ROBdst_m62 (subtract T_RS4_ROBdst_m61)))
		(let ((T_RS4_ROBdst_m63 (subtract T_RS4_ROBdst_m62)))

		
		(let ((T_RS3_ROBdst_m1 (subtract (select T_RS_ROB_dst (_ bv3 3)))))
		(let ((T_RS3_ROBdst_m2 (subtract T_RS3_ROBdst_m1)))
		(let ((T_RS3_ROBdst_m3 (subtract T_RS3_ROBdst_m2)))
		(let ((T_RS3_ROBdst_m4 (subtract T_RS3_ROBdst_m3)))
		(let ((T_RS3_ROBdst_m5 (subtract T_RS3_ROBdst_m4)))
		(let ((T_RS3_ROBdst_m6 (subtract T_RS3_ROBdst_m5)))
		(let ((T_RS3_ROBdst_m7 (subtract T_RS3_ROBdst_m6)))
		(let ((T_RS3_ROBdst_m8 (subtract T_RS3_ROBdst_m7)))
		(let ((T_RS3_ROBdst_m9 (subtract T_RS3_ROBdst_m8)))
		(let ((T_RS3_ROBdst_m10 (subtract T_RS3_ROBdst_m9)))
		(let ((T_RS3_ROBdst_m11 (subtract T_RS3_ROBdst_m10)))
		(let ((T_RS3_ROBdst_m12 (subtract T_RS3_ROBdst_m11)))
		(let ((T_RS3_ROBdst_m13 (subtract T_RS3_ROBdst_m12)))
		(let ((T_RS3_ROBdst_m14 (subtract T_RS3_ROBdst_m13)))
		(let ((T_RS3_ROBdst_m15 (subtract T_RS3_ROBdst_m14)))
		(let ((T_RS3_ROBdst_m16 (subtract T_RS3_ROBdst_m15)))
		(let ((T_RS3_ROBdst_m17 (subtract T_RS3_ROBdst_m16)))
		(let ((T_RS3_ROBdst_m18 (subtract T_RS3_ROBdst_m17)))
		(let ((T_RS3_ROBdst_m19 (subtract T_RS3_ROBdst_m18)))
		(let ((T_RS3_ROBdst_m20 (subtract T_RS3_ROBdst_m19)))
		(let ((T_RS3_ROBdst_m21 (subtract T_RS3_ROBdst_m20)))
		(let ((T_RS3_ROBdst_m22 (subtract T_RS3_ROBdst_m21)))
		(let ((T_RS3_ROBdst_m23 (subtract T_RS3_ROBdst_m22)))
		(let ((T_RS3_ROBdst_m24 (subtract T_RS3_ROBdst_m23)))
		(let ((T_RS3_ROBdst_m25 (subtract T_RS3_ROBdst_m24)))
		(let ((T_RS3_ROBdst_m26 (subtract T_RS3_ROBdst_m25)))
		(let ((T_RS3_ROBdst_m27 (subtract T_RS3_ROBdst_m26)))
		(let ((T_RS3_ROBdst_m28 (subtract T_RS3_ROBdst_m27)))
		(let ((T_RS3_ROBdst_m29 (subtract T_RS3_ROBdst_m28)))
		(let ((T_RS3_ROBdst_m30 (subtract T_RS3_ROBdst_m29)))
		(let ((T_RS3_ROBdst_m31 (subtract T_RS3_ROBdst_m30)))
		(let ((T_RS3_ROBdst_m32 (subtract T_RS3_ROBdst_m31)))
		(let ((T_RS3_ROBdst_m33 (subtract T_RS3_ROBdst_m32)))
		(let ((T_RS3_ROBdst_m34 (subtract T_RS3_ROBdst_m33)))
		(let ((T_RS3_ROBdst_m35 (subtract T_RS3_ROBdst_m34)))
		(let ((T_RS3_ROBdst_m36 (subtract T_RS3_ROBdst_m35)))
		(let ((T_RS3_ROBdst_m37 (subtract T_RS3_ROBdst_m36)))
		(let ((T_RS3_ROBdst_m38 (subtract T_RS3_ROBdst_m37)))
		(let ((T_RS3_ROBdst_m39 (subtract T_RS3_ROBdst_m38)))
		(let ((T_RS3_ROBdst_m40 (subtract T_RS3_ROBdst_m39)))
		(let ((T_RS3_ROBdst_m41 (subtract T_RS3_ROBdst_m40)))
		(let ((T_RS3_ROBdst_m42 (subtract T_RS3_ROBdst_m41)))
		(let ((T_RS3_ROBdst_m43 (subtract T_RS3_ROBdst_m42)))
		(let ((T_RS3_ROBdst_m44 (subtract T_RS3_ROBdst_m43)))
		(let ((T_RS3_ROBdst_m45 (subtract T_RS3_ROBdst_m44)))
		(let ((T_RS3_ROBdst_m46 (subtract T_RS3_ROBdst_m45)))
		(let ((T_RS3_ROBdst_m47 (subtract T_RS3_ROBdst_m46)))
		(let ((T_RS3_ROBdst_m48 (subtract T_RS3_ROBdst_m47)))
		(let ((T_RS3_ROBdst_m49 (subtract T_RS3_ROBdst_m48)))
		(let ((T_RS3_ROBdst_m50 (subtract T_RS3_ROBdst_m49)))
		(let ((T_RS3_ROBdst_m51 (subtract T_RS3_ROBdst_m50)))
		(let ((T_RS3_ROBdst_m52 (subtract T_RS3_ROBdst_m51)))
		(let ((T_RS3_ROBdst_m53 (subtract T_RS3_ROBdst_m52)))
		(let ((T_RS3_ROBdst_m54 (subtract T_RS3_ROBdst_m53)))
		(let ((T_RS3_ROBdst_m55 (subtract T_RS3_ROBdst_m54)))
		(let ((T_RS3_ROBdst_m56 (subtract T_RS3_ROBdst_m55)))
		(let ((T_RS3_ROBdst_m57 (subtract T_RS3_ROBdst_m56)))
		(let ((T_RS3_ROBdst_m58 (subtract T_RS3_ROBdst_m57)))
		(let ((T_RS3_ROBdst_m59 (subtract T_RS3_ROBdst_m58)))
		(let ((T_RS3_ROBdst_m60 (subtract T_RS3_ROBdst_m59)))
		(let ((T_RS3_ROBdst_m61 (subtract T_RS3_ROBdst_m60)))
		(let ((T_RS3_ROBdst_m62 (subtract T_RS3_ROBdst_m61)))
		(let ((T_RS3_ROBdst_m63 (subtract T_RS3_ROBdst_m62)))

		
		(let ((T_RS2_ROBdst_m1 (subtract (select T_RS_ROB_dst (_ bv2 3)))))
		(let ((T_RS2_ROBdst_m2 (subtract T_RS2_ROBdst_m1)))
		(let ((T_RS2_ROBdst_m3 (subtract T_RS2_ROBdst_m2)))
		(let ((T_RS2_ROBdst_m4 (subtract T_RS2_ROBdst_m3)))
		(let ((T_RS2_ROBdst_m5 (subtract T_RS2_ROBdst_m4)))
		(let ((T_RS2_ROBdst_m6 (subtract T_RS2_ROBdst_m5)))
		(let ((T_RS2_ROBdst_m7 (subtract T_RS2_ROBdst_m6)))
		(let ((T_RS2_ROBdst_m8 (subtract T_RS2_ROBdst_m7)))
		(let ((T_RS2_ROBdst_m9 (subtract T_RS2_ROBdst_m8)))
		(let ((T_RS2_ROBdst_m10 (subtract T_RS2_ROBdst_m9)))
		(let ((T_RS2_ROBdst_m11 (subtract T_RS2_ROBdst_m10)))
		(let ((T_RS2_ROBdst_m12 (subtract T_RS2_ROBdst_m11)))
		(let ((T_RS2_ROBdst_m13 (subtract T_RS2_ROBdst_m12)))
		(let ((T_RS2_ROBdst_m14 (subtract T_RS2_ROBdst_m13)))
		(let ((T_RS2_ROBdst_m15 (subtract T_RS2_ROBdst_m14)))
		(let ((T_RS2_ROBdst_m16 (subtract T_RS2_ROBdst_m15)))
		(let ((T_RS2_ROBdst_m17 (subtract T_RS2_ROBdst_m16)))
		(let ((T_RS2_ROBdst_m18 (subtract T_RS2_ROBdst_m17)))
		(let ((T_RS2_ROBdst_m19 (subtract T_RS2_ROBdst_m18)))
		(let ((T_RS2_ROBdst_m20 (subtract T_RS2_ROBdst_m19)))
		(let ((T_RS2_ROBdst_m21 (subtract T_RS2_ROBdst_m20)))
		(let ((T_RS2_ROBdst_m22 (subtract T_RS2_ROBdst_m21)))
		(let ((T_RS2_ROBdst_m23 (subtract T_RS2_ROBdst_m22)))
		(let ((T_RS2_ROBdst_m24 (subtract T_RS2_ROBdst_m23)))
		(let ((T_RS2_ROBdst_m25 (subtract T_RS2_ROBdst_m24)))
		(let ((T_RS2_ROBdst_m26 (subtract T_RS2_ROBdst_m25)))
		(let ((T_RS2_ROBdst_m27 (subtract T_RS2_ROBdst_m26)))
		(let ((T_RS2_ROBdst_m28 (subtract T_RS2_ROBdst_m27)))
		(let ((T_RS2_ROBdst_m29 (subtract T_RS2_ROBdst_m28)))
		(let ((T_RS2_ROBdst_m30 (subtract T_RS2_ROBdst_m29)))
		(let ((T_RS2_ROBdst_m31 (subtract T_RS2_ROBdst_m30)))
		(let ((T_RS2_ROBdst_m32 (subtract T_RS2_ROBdst_m31)))
		(let ((T_RS2_ROBdst_m33 (subtract T_RS2_ROBdst_m32)))
		(let ((T_RS2_ROBdst_m34 (subtract T_RS2_ROBdst_m33)))
		(let ((T_RS2_ROBdst_m35 (subtract T_RS2_ROBdst_m34)))
		(let ((T_RS2_ROBdst_m36 (subtract T_RS2_ROBdst_m35)))
		(let ((T_RS2_ROBdst_m37 (subtract T_RS2_ROBdst_m36)))
		(let ((T_RS2_ROBdst_m38 (subtract T_RS2_ROBdst_m37)))
		(let ((T_RS2_ROBdst_m39 (subtract T_RS2_ROBdst_m38)))
		(let ((T_RS2_ROBdst_m40 (subtract T_RS2_ROBdst_m39)))
		(let ((T_RS2_ROBdst_m41 (subtract T_RS2_ROBdst_m40)))
		(let ((T_RS2_ROBdst_m42 (subtract T_RS2_ROBdst_m41)))
		(let ((T_RS2_ROBdst_m43 (subtract T_RS2_ROBdst_m42)))
		(let ((T_RS2_ROBdst_m44 (subtract T_RS2_ROBdst_m43)))
		(let ((T_RS2_ROBdst_m45 (subtract T_RS2_ROBdst_m44)))
		(let ((T_RS2_ROBdst_m46 (subtract T_RS2_ROBdst_m45)))
		(let ((T_RS2_ROBdst_m47 (subtract T_RS2_ROBdst_m46)))
		(let ((T_RS2_ROBdst_m48 (subtract T_RS2_ROBdst_m47)))
		(let ((T_RS2_ROBdst_m49 (subtract T_RS2_ROBdst_m48)))
		(let ((T_RS2_ROBdst_m50 (subtract T_RS2_ROBdst_m49)))
		(let ((T_RS2_ROBdst_m51 (subtract T_RS2_ROBdst_m50)))
		(let ((T_RS2_ROBdst_m52 (subtract T_RS2_ROBdst_m51)))
		(let ((T_RS2_ROBdst_m53 (subtract T_RS2_ROBdst_m52)))
		(let ((T_RS2_ROBdst_m54 (subtract T_RS2_ROBdst_m53)))
		(let ((T_RS2_ROBdst_m55 (subtract T_RS2_ROBdst_m54)))
		(let ((T_RS2_ROBdst_m56 (subtract T_RS2_ROBdst_m55)))
		(let ((T_RS2_ROBdst_m57 (subtract T_RS2_ROBdst_m56)))
		(let ((T_RS2_ROBdst_m58 (subtract T_RS2_ROBdst_m57)))
		(let ((T_RS2_ROBdst_m59 (subtract T_RS2_ROBdst_m58)))
		(let ((T_RS2_ROBdst_m60 (subtract T_RS2_ROBdst_m59)))
		(let ((T_RS2_ROBdst_m61 (subtract T_RS2_ROBdst_m60)))
		(let ((T_RS2_ROBdst_m62 (subtract T_RS2_ROBdst_m61)))
		(let ((T_RS2_ROBdst_m63 (subtract T_RS2_ROBdst_m62)))
		
		(let ((T_RS1_ROBdst_m1 (subtract (select T_RS_ROB_dst (_ bv1 3)))))
		(let ((T_RS1_ROBdst_m2 (subtract T_RS1_ROBdst_m1)))
		(let ((T_RS1_ROBdst_m3 (subtract T_RS1_ROBdst_m2)))
		(let ((T_RS1_ROBdst_m4 (subtract T_RS1_ROBdst_m3)))
		(let ((T_RS1_ROBdst_m5 (subtract T_RS1_ROBdst_m4)))
		(let ((T_RS1_ROBdst_m6 (subtract T_RS1_ROBdst_m5)))
		(let ((T_RS1_ROBdst_m7 (subtract T_RS1_ROBdst_m6)))
		(let ((T_RS1_ROBdst_m8 (subtract T_RS1_ROBdst_m7)))
		(let ((T_RS1_ROBdst_m9 (subtract T_RS1_ROBdst_m8)))
		(let ((T_RS1_ROBdst_m10 (subtract T_RS1_ROBdst_m9)))
		(let ((T_RS1_ROBdst_m11 (subtract T_RS1_ROBdst_m10)))
		(let ((T_RS1_ROBdst_m12 (subtract T_RS1_ROBdst_m11)))
		(let ((T_RS1_ROBdst_m13 (subtract T_RS1_ROBdst_m12)))
		(let ((T_RS1_ROBdst_m14 (subtract T_RS1_ROBdst_m13)))
		(let ((T_RS1_ROBdst_m15 (subtract T_RS1_ROBdst_m14)))
		(let ((T_RS1_ROBdst_m16 (subtract T_RS1_ROBdst_m15)))
		(let ((T_RS1_ROBdst_m17 (subtract T_RS1_ROBdst_m16)))
		(let ((T_RS1_ROBdst_m18 (subtract T_RS1_ROBdst_m17)))
		(let ((T_RS1_ROBdst_m19 (subtract T_RS1_ROBdst_m18)))
		(let ((T_RS1_ROBdst_m20 (subtract T_RS1_ROBdst_m19)))
		(let ((T_RS1_ROBdst_m21 (subtract T_RS1_ROBdst_m20)))
		(let ((T_RS1_ROBdst_m22 (subtract T_RS1_ROBdst_m21)))
		(let ((T_RS1_ROBdst_m23 (subtract T_RS1_ROBdst_m22)))
		(let ((T_RS1_ROBdst_m24 (subtract T_RS1_ROBdst_m23)))
		(let ((T_RS1_ROBdst_m25 (subtract T_RS1_ROBdst_m24)))
		(let ((T_RS1_ROBdst_m26 (subtract T_RS1_ROBdst_m25)))
		(let ((T_RS1_ROBdst_m27 (subtract T_RS1_ROBdst_m26)))
		(let ((T_RS1_ROBdst_m28 (subtract T_RS1_ROBdst_m27)))
		(let ((T_RS1_ROBdst_m29 (subtract T_RS1_ROBdst_m28)))
		(let ((T_RS1_ROBdst_m30 (subtract T_RS1_ROBdst_m29)))
		(let ((T_RS1_ROBdst_m31 (subtract T_RS1_ROBdst_m30)))
		(let ((T_RS1_ROBdst_m32 (subtract T_RS1_ROBdst_m31)))
		(let ((T_RS1_ROBdst_m33 (subtract T_RS1_ROBdst_m32)))
		(let ((T_RS1_ROBdst_m34 (subtract T_RS1_ROBdst_m33)))
		(let ((T_RS1_ROBdst_m35 (subtract T_RS1_ROBdst_m34)))
		(let ((T_RS1_ROBdst_m36 (subtract T_RS1_ROBdst_m35)))
		(let ((T_RS1_ROBdst_m37 (subtract T_RS1_ROBdst_m36)))
		(let ((T_RS1_ROBdst_m38 (subtract T_RS1_ROBdst_m37)))
		(let ((T_RS1_ROBdst_m39 (subtract T_RS1_ROBdst_m38)))
		(let ((T_RS1_ROBdst_m40 (subtract T_RS1_ROBdst_m39)))
		(let ((T_RS1_ROBdst_m41 (subtract T_RS1_ROBdst_m40)))
		(let ((T_RS1_ROBdst_m42 (subtract T_RS1_ROBdst_m41)))
		(let ((T_RS1_ROBdst_m43 (subtract T_RS1_ROBdst_m42)))
		(let ((T_RS1_ROBdst_m44 (subtract T_RS1_ROBdst_m43)))
		(let ((T_RS1_ROBdst_m45 (subtract T_RS1_ROBdst_m44)))
		(let ((T_RS1_ROBdst_m46 (subtract T_RS1_ROBdst_m45)))
		(let ((T_RS1_ROBdst_m47 (subtract T_RS1_ROBdst_m46)))
		(let ((T_RS1_ROBdst_m48 (subtract T_RS1_ROBdst_m47)))
		(let ((T_RS1_ROBdst_m49 (subtract T_RS1_ROBdst_m48)))
		(let ((T_RS1_ROBdst_m50 (subtract T_RS1_ROBdst_m49)))
		(let ((T_RS1_ROBdst_m51 (subtract T_RS1_ROBdst_m50)))
		(let ((T_RS1_ROBdst_m52 (subtract T_RS1_ROBdst_m51)))
		(let ((T_RS1_ROBdst_m53 (subtract T_RS1_ROBdst_m52)))
		(let ((T_RS1_ROBdst_m54 (subtract T_RS1_ROBdst_m53)))
		(let ((T_RS1_ROBdst_m55 (subtract T_RS1_ROBdst_m54)))
		(let ((T_RS1_ROBdst_m56 (subtract T_RS1_ROBdst_m55)))
		(let ((T_RS1_ROBdst_m57 (subtract T_RS1_ROBdst_m56)))
		(let ((T_RS1_ROBdst_m58 (subtract T_RS1_ROBdst_m57)))
		(let ((T_RS1_ROBdst_m59 (subtract T_RS1_ROBdst_m58)))
		(let ((T_RS1_ROBdst_m60 (subtract T_RS1_ROBdst_m59)))
		(let ((T_RS1_ROBdst_m61 (subtract T_RS1_ROBdst_m60)))
		(let ((T_RS1_ROBdst_m62 (subtract T_RS1_ROBdst_m61)))
		(let ((T_RS1_ROBdst_m63 (subtract T_RS1_ROBdst_m62)))
		
		(let ((T_RS0_ROBdst_m1 (subtract (select T_RS_ROB_dst (_ bv0 3)))))
		(let ((T_RS0_ROBdst_m2 (subtract T_RS0_ROBdst_m1)))
		(let ((T_RS0_ROBdst_m3 (subtract T_RS0_ROBdst_m2)))
		(let ((T_RS0_ROBdst_m4 (subtract T_RS0_ROBdst_m3)))
		(let ((T_RS0_ROBdst_m5 (subtract T_RS0_ROBdst_m4)))
		(let ((T_RS0_ROBdst_m6 (subtract T_RS0_ROBdst_m5)))
		(let ((T_RS0_ROBdst_m7 (subtract T_RS0_ROBdst_m6)))
		(let ((T_RS0_ROBdst_m8 (subtract T_RS0_ROBdst_m7)))
		(let ((T_RS0_ROBdst_m9 (subtract T_RS0_ROBdst_m8)))
		(let ((T_RS0_ROBdst_m10 (subtract T_RS0_ROBdst_m9)))
		(let ((T_RS0_ROBdst_m11 (subtract T_RS0_ROBdst_m10)))
		(let ((T_RS0_ROBdst_m12 (subtract T_RS0_ROBdst_m11)))
		(let ((T_RS0_ROBdst_m13 (subtract T_RS0_ROBdst_m12)))
		(let ((T_RS0_ROBdst_m14 (subtract T_RS0_ROBdst_m13)))
		(let ((T_RS0_ROBdst_m15 (subtract T_RS0_ROBdst_m14)))
		(let ((T_RS0_ROBdst_m16 (subtract T_RS0_ROBdst_m15)))
		(let ((T_RS0_ROBdst_m17 (subtract T_RS0_ROBdst_m16)))
		(let ((T_RS0_ROBdst_m18 (subtract T_RS0_ROBdst_m17)))
		(let ((T_RS0_ROBdst_m19 (subtract T_RS0_ROBdst_m18)))
		(let ((T_RS0_ROBdst_m20 (subtract T_RS0_ROBdst_m19)))
		(let ((T_RS0_ROBdst_m21 (subtract T_RS0_ROBdst_m20)))
		(let ((T_RS0_ROBdst_m22 (subtract T_RS0_ROBdst_m21)))
		(let ((T_RS0_ROBdst_m23 (subtract T_RS0_ROBdst_m22)))
		(let ((T_RS0_ROBdst_m24 (subtract T_RS0_ROBdst_m23)))
		(let ((T_RS0_ROBdst_m25 (subtract T_RS0_ROBdst_m24)))
		(let ((T_RS0_ROBdst_m26 (subtract T_RS0_ROBdst_m25)))
		(let ((T_RS0_ROBdst_m27 (subtract T_RS0_ROBdst_m26)))
		(let ((T_RS0_ROBdst_m28 (subtract T_RS0_ROBdst_m27)))
		(let ((T_RS0_ROBdst_m29 (subtract T_RS0_ROBdst_m28)))
		(let ((T_RS0_ROBdst_m30 (subtract T_RS0_ROBdst_m29)))
		(let ((T_RS0_ROBdst_m31 (subtract T_RS0_ROBdst_m30)))
		(let ((T_RS0_ROBdst_m32 (subtract T_RS0_ROBdst_m31)))
		(let ((T_RS0_ROBdst_m33 (subtract T_RS0_ROBdst_m32)))
		(let ((T_RS0_ROBdst_m34 (subtract T_RS0_ROBdst_m33)))
		(let ((T_RS0_ROBdst_m35 (subtract T_RS0_ROBdst_m34)))
		(let ((T_RS0_ROBdst_m36 (subtract T_RS0_ROBdst_m35)))
		(let ((T_RS0_ROBdst_m37 (subtract T_RS0_ROBdst_m36)))
		(let ((T_RS0_ROBdst_m38 (subtract T_RS0_ROBdst_m37)))
		(let ((T_RS0_ROBdst_m39 (subtract T_RS0_ROBdst_m38)))
		(let ((T_RS0_ROBdst_m40 (subtract T_RS0_ROBdst_m39)))
		(let ((T_RS0_ROBdst_m41 (subtract T_RS0_ROBdst_m40)))
		(let ((T_RS0_ROBdst_m42 (subtract T_RS0_ROBdst_m41)))
		(let ((T_RS0_ROBdst_m43 (subtract T_RS0_ROBdst_m42)))
		(let ((T_RS0_ROBdst_m44 (subtract T_RS0_ROBdst_m43)))
		(let ((T_RS0_ROBdst_m45 (subtract T_RS0_ROBdst_m44)))
		(let ((T_RS0_ROBdst_m46 (subtract T_RS0_ROBdst_m45)))
		(let ((T_RS0_ROBdst_m47 (subtract T_RS0_ROBdst_m46)))
		(let ((T_RS0_ROBdst_m48 (subtract T_RS0_ROBdst_m47)))
		(let ((T_RS0_ROBdst_m49 (subtract T_RS0_ROBdst_m48)))
		(let ((T_RS0_ROBdst_m50 (subtract T_RS0_ROBdst_m49)))
		(let ((T_RS0_ROBdst_m51 (subtract T_RS0_ROBdst_m50)))
		(let ((T_RS0_ROBdst_m52 (subtract T_RS0_ROBdst_m51)))
		(let ((T_RS0_ROBdst_m53 (subtract T_RS0_ROBdst_m52)))
		(let ((T_RS0_ROBdst_m54 (subtract T_RS0_ROBdst_m53)))
		(let ((T_RS0_ROBdst_m55 (subtract T_RS0_ROBdst_m54)))
		(let ((T_RS0_ROBdst_m56 (subtract T_RS0_ROBdst_m55)))
		(let ((T_RS0_ROBdst_m57 (subtract T_RS0_ROBdst_m56)))
		(let ((T_RS0_ROBdst_m58 (subtract T_RS0_ROBdst_m57)))
		(let ((T_RS0_ROBdst_m59 (subtract T_RS0_ROBdst_m58)))
		(let ((T_RS0_ROBdst_m60 (subtract T_RS0_ROBdst_m59)))
		(let ((T_RS0_ROBdst_m61 (subtract T_RS0_ROBdst_m60)))
		(let ((T_RS0_ROBdst_m62 (subtract T_RS0_ROBdst_m61)))
		(let ((T_RS0_ROBdst_m63 (subtract T_RS0_ROBdst_m62)))
		
		(let ((U4_LSQ3_ROBdst_m1 (subtract (select U4_LSQ_ROB_dst (_ bv3 3)))))
		(let ((U4_LSQ3_ROBdst_m2 (subtract U4_LSQ3_ROBdst_m1)))
		(let ((U4_LSQ3_ROBdst_m3 (subtract U4_LSQ3_ROBdst_m2)))
		(let ((U4_LSQ3_ROBdst_m4 (subtract U4_LSQ3_ROBdst_m3)))
		(let ((U4_LSQ3_ROBdst_m5 (subtract U4_LSQ3_ROBdst_m4)))
		(let ((U4_LSQ3_ROBdst_m6 (subtract U4_LSQ3_ROBdst_m5)))
		(let ((U4_LSQ3_ROBdst_m7 (subtract U4_LSQ3_ROBdst_m6)))
		(let ((U4_LSQ3_ROBdst_m8 (subtract U4_LSQ3_ROBdst_m7)))	

		(let ((U4_LSQ2_ROBdst_m1 (subtract (select U4_LSQ_ROB_dst (_ bv2 3)))))
		(let ((U4_LSQ2_ROBdst_m2 (subtract U4_LSQ2_ROBdst_m1)))
		(let ((U4_LSQ2_ROBdst_m3 (subtract U4_LSQ2_ROBdst_m2)))
		(let ((U4_LSQ2_ROBdst_m4 (subtract U4_LSQ2_ROBdst_m3)))	
		(let ((U4_LSQ2_ROBdst_m5 (subtract U4_LSQ2_ROBdst_m4)))	
		(let ((U4_LSQ2_ROBdst_m6 (subtract U4_LSQ2_ROBdst_m5)))	
		(let ((U4_LSQ2_ROBdst_m7 (subtract U4_LSQ2_ROBdst_m6)))	
		(let ((U4_LSQ2_ROBdst_m8 (subtract U4_LSQ2_ROBdst_m7)))	

		(let ((U4_LSQ1_ROBdst_m1 (subtract (select U4_LSQ_ROB_dst (_ bv1 3)))))
		(let ((U4_LSQ1_ROBdst_m2 (subtract U4_LSQ1_ROBdst_m1)))
		(let ((U4_LSQ1_ROBdst_m3 (subtract U4_LSQ1_ROBdst_m2)))
		(let ((U4_LSQ1_ROBdst_m4 (subtract U4_LSQ1_ROBdst_m3)))
		(let ((U4_LSQ1_ROBdst_m5 (subtract U4_LSQ1_ROBdst_m4)))
		(let ((U4_LSQ1_ROBdst_m6 (subtract U4_LSQ1_ROBdst_m5)))
		(let ((U4_LSQ1_ROBdst_m7 (subtract U4_LSQ1_ROBdst_m6)))
		(let ((U4_LSQ1_ROBdst_m8 (subtract U4_LSQ1_ROBdst_m7)))	

		(let ((U4_LSQ0_ROBdst_m1 (subtract (select U4_LSQ_ROB_dst (_ bv0 3)))))
		(let ((U4_LSQ0_ROBdst_m2 (subtract U4_LSQ0_ROBdst_m1)))
		(let ((U4_LSQ0_ROBdst_m3 (subtract U4_LSQ0_ROBdst_m2)))
		(let ((U4_LSQ0_ROBdst_m4 (subtract U4_LSQ0_ROBdst_m3)))
		(let ((U4_LSQ0_ROBdst_m5 (subtract U4_LSQ0_ROBdst_m4)))
		(let ((U4_LSQ0_ROBdst_m6 (subtract U4_LSQ0_ROBdst_m5)))
		(let ((U4_LSQ0_ROBdst_m7 (subtract U4_LSQ0_ROBdst_m6)))
		(let ((U4_LSQ0_ROBdst_m8 (subtract U4_LSQ0_ROBdst_m7)))
		(let
			(
				(T_oldest_Lfense (oldest_lfence T_ROB_op_type T_CP T_IP))
				(U4_oldest_Lfense (oldest_lfence U4_ROB_op_type U4_CP U4_IP))
			)
		(let
			(
				(rob_aheadof_T_Lf (bvadd T_oldest_Lfense T_any_rob_adder))
				(rob_aheadof_U4_Lf (bvadd U4_oldest_Lfense U4_any_rob_adder))
			)
;-----------------------------Property--------------------------------------------------------------		
		(=>
			(and

				(not (= T_IP #b000000)) 
				(not (= T_CP #b000000))
				
				(= #b0 (select T_ROB_busy (_ bv0 6)))	;done
				
				(=> (= #b0 (select T_ROB_busy (_ bv0 6))) (and (= (select T_ROB_op_type (_ bv0 6)) 0) (= (select T_ROB_destination (_ bv0 6)) 0) (= (select T_ROB_result (_ bv0 6)) 0) (= (select T_ROB_exception (_ bv0 6)) #b0) (= (select T_ROB_done (_ bv0 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv1 6))) (and (= (select T_ROB_op_type (_ bv1 6)) 0) (= (select T_ROB_destination (_ bv1 6)) 0) (= (select T_ROB_result (_ bv1 6)) 0) (= (select T_ROB_exception (_ bv1 6)) #b0) (= (select T_ROB_done (_ bv1 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv2 6))) (and (= (select T_ROB_op_type (_ bv2 6)) 0) (= (select T_ROB_destination (_ bv2 6)) 0) (= (select T_ROB_result (_ bv2 6)) 0) (= (select T_ROB_exception (_ bv2 6)) #b0) (= (select T_ROB_done (_ bv2 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv3 6))) (and (= (select T_ROB_op_type (_ bv3 6)) 0) (= (select T_ROB_destination (_ bv3 6)) 0) (= (select T_ROB_result (_ bv3 6)) 0) (= (select T_ROB_exception (_ bv3 6)) #b0) (= (select T_ROB_done (_ bv3 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv4 6))) (and (= (select T_ROB_op_type (_ bv4 6)) 0) (= (select T_ROB_destination (_ bv4 6)) 0) (= (select T_ROB_result (_ bv4 6)) 0) (= (select T_ROB_exception (_ bv4 6)) #b0) (= (select T_ROB_done (_ bv4 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv5 6))) (and (= (select T_ROB_op_type (_ bv5 6)) 0) (= (select T_ROB_destination (_ bv5 6)) 0) (= (select T_ROB_result (_ bv5 6)) 0) (= (select T_ROB_exception (_ bv5 6)) #b0) (= (select T_ROB_done (_ bv5 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv6 6))) (and (= (select T_ROB_op_type (_ bv6 6)) 0) (= (select T_ROB_destination (_ bv6 6)) 0) (= (select T_ROB_result (_ bv6 6)) 0) (= (select T_ROB_exception (_ bv6 6)) #b0) (= (select T_ROB_done (_ bv6 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv7 6))) (and (= (select T_ROB_op_type (_ bv7 6)) 0) (= (select T_ROB_destination (_ bv7 6)) 0) (= (select T_ROB_result (_ bv7 6)) 0) (= (select T_ROB_exception (_ bv7 6)) #b0) (= (select T_ROB_done (_ bv7 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv8 6))) (and (= (select T_ROB_op_type (_ bv8 6)) 0) (= (select T_ROB_destination (_ bv8 6)) 0) (= (select T_ROB_result (_ bv8 6)) 0) (= (select T_ROB_exception (_ bv8 6)) #b0) (= (select T_ROB_done (_ bv8 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv9 6))) (and (= (select T_ROB_op_type (_ bv9 6)) 0) (= (select T_ROB_destination (_ bv9 6)) 0) (= (select T_ROB_result (_ bv9 6)) 0) (= (select T_ROB_exception (_ bv9 6)) #b0) (= (select T_ROB_done (_ bv9 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv10 6))) (and (= (select T_ROB_op_type (_ bv10 6)) 0) (= (select T_ROB_destination (_ bv10 6)) 0) (= (select T_ROB_result (_ bv10 6)) 0) (= (select T_ROB_exception (_ bv10 6)) #b0) (= (select T_ROB_done (_ bv10 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv11 6))) (and (= (select T_ROB_op_type (_ bv11 6)) 0) (= (select T_ROB_destination (_ bv11 6)) 0) (= (select T_ROB_result (_ bv11 6)) 0) (= (select T_ROB_exception (_ bv11 6)) #b0) (= (select T_ROB_done (_ bv11 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv12 6))) (and (= (select T_ROB_op_type (_ bv12 6)) 0) (= (select T_ROB_destination (_ bv12 6)) 0) (= (select T_ROB_result (_ bv12 6)) 0) (= (select T_ROB_exception (_ bv12 6)) #b0) (= (select T_ROB_done (_ bv12 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv13 6))) (and (= (select T_ROB_op_type (_ bv13 6)) 0) (= (select T_ROB_destination (_ bv13 6)) 0) (= (select T_ROB_result (_ bv13 6)) 0) (= (select T_ROB_exception (_ bv13 6)) #b0) (= (select T_ROB_done (_ bv13 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv14 6))) (and (= (select T_ROB_op_type (_ bv14 6)) 0) (= (select T_ROB_destination (_ bv14 6)) 0) (= (select T_ROB_result (_ bv14 6)) 0) (= (select T_ROB_exception (_ bv14 6)) #b0) (= (select T_ROB_done (_ bv14 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv15 6))) (and (= (select T_ROB_op_type (_ bv15 6)) 0) (= (select T_ROB_destination (_ bv15 6)) 0) (= (select T_ROB_result (_ bv15 6)) 0) (= (select T_ROB_exception (_ bv15 6)) #b0) (= (select T_ROB_done (_ bv15 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv16 6))) (and (= (select T_ROB_op_type (_ bv16 6)) 0) (= (select T_ROB_destination (_ bv16 6)) 0) (= (select T_ROB_result (_ bv16 6)) 0) (= (select T_ROB_exception (_ bv16 6)) #b0) (= (select T_ROB_done (_ bv16 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv17 6))) (and (= (select T_ROB_op_type (_ bv17 6)) 0) (= (select T_ROB_destination (_ bv17 6)) 0) (= (select T_ROB_result (_ bv17 6)) 0) (= (select T_ROB_exception (_ bv17 6)) #b0) (= (select T_ROB_done (_ bv17 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv18 6))) (and (= (select T_ROB_op_type (_ bv18 6)) 0) (= (select T_ROB_destination (_ bv18 6)) 0) (= (select T_ROB_result (_ bv18 6)) 0) (= (select T_ROB_exception (_ bv18 6)) #b0) (= (select T_ROB_done (_ bv18 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv19 6))) (and (= (select T_ROB_op_type (_ bv19 6)) 0) (= (select T_ROB_destination (_ bv19 6)) 0) (= (select T_ROB_result (_ bv19 6)) 0) (= (select T_ROB_exception (_ bv19 6)) #b0) (= (select T_ROB_done (_ bv19 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv20 6))) (and (= (select T_ROB_op_type (_ bv20 6)) 0) (= (select T_ROB_destination (_ bv20 6)) 0) (= (select T_ROB_result (_ bv20 6)) 0) (= (select T_ROB_exception (_ bv20 6)) #b0) (= (select T_ROB_done (_ bv20 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv21 6))) (and (= (select T_ROB_op_type (_ bv21 6)) 0) (= (select T_ROB_destination (_ bv21 6)) 0) (= (select T_ROB_result (_ bv21 6)) 0) (= (select T_ROB_exception (_ bv21 6)) #b0) (= (select T_ROB_done (_ bv21 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv22 6))) (and (= (select T_ROB_op_type (_ bv22 6)) 0) (= (select T_ROB_destination (_ bv22 6)) 0) (= (select T_ROB_result (_ bv22 6)) 0) (= (select T_ROB_exception (_ bv22 6)) #b0) (= (select T_ROB_done (_ bv22 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv23 6))) (and (= (select T_ROB_op_type (_ bv23 6)) 0) (= (select T_ROB_destination (_ bv23 6)) 0) (= (select T_ROB_result (_ bv23 6)) 0) (= (select T_ROB_exception (_ bv23 6)) #b0) (= (select T_ROB_done (_ bv23 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv24 6))) (and (= (select T_ROB_op_type (_ bv24 6)) 0) (= (select T_ROB_destination (_ bv24 6)) 0) (= (select T_ROB_result (_ bv24 6)) 0) (= (select T_ROB_exception (_ bv24 6)) #b0) (= (select T_ROB_done (_ bv24 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv25 6))) (and (= (select T_ROB_op_type (_ bv25 6)) 0) (= (select T_ROB_destination (_ bv25 6)) 0) (= (select T_ROB_result (_ bv25 6)) 0) (= (select T_ROB_exception (_ bv25 6)) #b0) (= (select T_ROB_done (_ bv25 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv26 6))) (and (= (select T_ROB_op_type (_ bv26 6)) 0) (= (select T_ROB_destination (_ bv26 6)) 0) (= (select T_ROB_result (_ bv26 6)) 0) (= (select T_ROB_exception (_ bv26 6)) #b0) (= (select T_ROB_done (_ bv26 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv27 6))) (and (= (select T_ROB_op_type (_ bv27 6)) 0) (= (select T_ROB_destination (_ bv27 6)) 0) (= (select T_ROB_result (_ bv27 6)) 0) (= (select T_ROB_exception (_ bv27 6)) #b0) (= (select T_ROB_done (_ bv27 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv28 6))) (and (= (select T_ROB_op_type (_ bv28 6)) 0) (= (select T_ROB_destination (_ bv28 6)) 0) (= (select T_ROB_result (_ bv28 6)) 0) (= (select T_ROB_exception (_ bv28 6)) #b0) (= (select T_ROB_done (_ bv28 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv29 6))) (and (= (select T_ROB_op_type (_ bv29 6)) 0) (= (select T_ROB_destination (_ bv29 6)) 0) (= (select T_ROB_result (_ bv29 6)) 0) (= (select T_ROB_exception (_ bv29 6)) #b0) (= (select T_ROB_done (_ bv29 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv30 6))) (and (= (select T_ROB_op_type (_ bv30 6)) 0) (= (select T_ROB_destination (_ bv30 6)) 0) (= (select T_ROB_result (_ bv30 6)) 0) (= (select T_ROB_exception (_ bv30 6)) #b0) (= (select T_ROB_done (_ bv30 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv31 6))) (and (= (select T_ROB_op_type (_ bv31 6)) 0) (= (select T_ROB_destination (_ bv31 6)) 0) (= (select T_ROB_result (_ bv31 6)) 0) (= (select T_ROB_exception (_ bv31 6)) #b0) (= (select T_ROB_done (_ bv31 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv32 6))) (and (= (select T_ROB_op_type (_ bv32 6)) 0) (= (select T_ROB_destination (_ bv32 6)) 0) (= (select T_ROB_result (_ bv32 6)) 0) (= (select T_ROB_exception (_ bv32 6)) #b0) (= (select T_ROB_done (_ bv32 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv33 6))) (and (= (select T_ROB_op_type (_ bv33 6)) 0) (= (select T_ROB_destination (_ bv33 6)) 0) (= (select T_ROB_result (_ bv33 6)) 0) (= (select T_ROB_exception (_ bv33 6)) #b0) (= (select T_ROB_done (_ bv33 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv34 6))) (and (= (select T_ROB_op_type (_ bv34 6)) 0) (= (select T_ROB_destination (_ bv34 6)) 0) (= (select T_ROB_result (_ bv34 6)) 0) (= (select T_ROB_exception (_ bv34 6)) #b0) (= (select T_ROB_done (_ bv34 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv35 6))) (and (= (select T_ROB_op_type (_ bv35 6)) 0) (= (select T_ROB_destination (_ bv35 6)) 0) (= (select T_ROB_result (_ bv35 6)) 0) (= (select T_ROB_exception (_ bv35 6)) #b0) (= (select T_ROB_done (_ bv35 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv36 6))) (and (= (select T_ROB_op_type (_ bv36 6)) 0) (= (select T_ROB_destination (_ bv36 6)) 0) (= (select T_ROB_result (_ bv36 6)) 0) (= (select T_ROB_exception (_ bv36 6)) #b0) (= (select T_ROB_done (_ bv36 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv37 6))) (and (= (select T_ROB_op_type (_ bv37 6)) 0) (= (select T_ROB_destination (_ bv37 6)) 0) (= (select T_ROB_result (_ bv37 6)) 0) (= (select T_ROB_exception (_ bv37 6)) #b0) (= (select T_ROB_done (_ bv37 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv38 6))) (and (= (select T_ROB_op_type (_ bv38 6)) 0) (= (select T_ROB_destination (_ bv38 6)) 0) (= (select T_ROB_result (_ bv38 6)) 0) (= (select T_ROB_exception (_ bv38 6)) #b0) (= (select T_ROB_done (_ bv38 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv39 6))) (and (= (select T_ROB_op_type (_ bv39 6)) 0) (= (select T_ROB_destination (_ bv39 6)) 0) (= (select T_ROB_result (_ bv39 6)) 0) (= (select T_ROB_exception (_ bv39 6)) #b0) (= (select T_ROB_done (_ bv39 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv40 6))) (and (= (select T_ROB_op_type (_ bv40 6)) 0) (= (select T_ROB_destination (_ bv40 6)) 0) (= (select T_ROB_result (_ bv40 6)) 0) (= (select T_ROB_exception (_ bv40 6)) #b0) (= (select T_ROB_done (_ bv40 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv41 6))) (and (= (select T_ROB_op_type (_ bv41 6)) 0) (= (select T_ROB_destination (_ bv41 6)) 0) (= (select T_ROB_result (_ bv41 6)) 0) (= (select T_ROB_exception (_ bv41 6)) #b0) (= (select T_ROB_done (_ bv41 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv42 6))) (and (= (select T_ROB_op_type (_ bv42 6)) 0) (= (select T_ROB_destination (_ bv42 6)) 0) (= (select T_ROB_result (_ bv42 6)) 0) (= (select T_ROB_exception (_ bv42 6)) #b0) (= (select T_ROB_done (_ bv42 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv43 6))) (and (= (select T_ROB_op_type (_ bv43 6)) 0) (= (select T_ROB_destination (_ bv43 6)) 0) (= (select T_ROB_result (_ bv43 6)) 0) (= (select T_ROB_exception (_ bv43 6)) #b0) (= (select T_ROB_done (_ bv43 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv44 6))) (and (= (select T_ROB_op_type (_ bv44 6)) 0) (= (select T_ROB_destination (_ bv44 6)) 0) (= (select T_ROB_result (_ bv44 6)) 0) (= (select T_ROB_exception (_ bv44 6)) #b0) (= (select T_ROB_done (_ bv44 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv45 6))) (and (= (select T_ROB_op_type (_ bv45 6)) 0) (= (select T_ROB_destination (_ bv45 6)) 0) (= (select T_ROB_result (_ bv45 6)) 0) (= (select T_ROB_exception (_ bv45 6)) #b0) (= (select T_ROB_done (_ bv45 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv46 6))) (and (= (select T_ROB_op_type (_ bv46 6)) 0) (= (select T_ROB_destination (_ bv46 6)) 0) (= (select T_ROB_result (_ bv46 6)) 0) (= (select T_ROB_exception (_ bv46 6)) #b0) (= (select T_ROB_done (_ bv46 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv47 6))) (and (= (select T_ROB_op_type (_ bv47 6)) 0) (= (select T_ROB_destination (_ bv47 6)) 0) (= (select T_ROB_result (_ bv47 6)) 0) (= (select T_ROB_exception (_ bv47 6)) #b0) (= (select T_ROB_done (_ bv47 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv48 6))) (and (= (select T_ROB_op_type (_ bv48 6)) 0) (= (select T_ROB_destination (_ bv48 6)) 0) (= (select T_ROB_result (_ bv48 6)) 0) (= (select T_ROB_exception (_ bv48 6)) #b0) (= (select T_ROB_done (_ bv48 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv49 6))) (and (= (select T_ROB_op_type (_ bv49 6)) 0) (= (select T_ROB_destination (_ bv49 6)) 0) (= (select T_ROB_result (_ bv49 6)) 0) (= (select T_ROB_exception (_ bv49 6)) #b0) (= (select T_ROB_done (_ bv49 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv50 6))) (and (= (select T_ROB_op_type (_ bv50 6)) 0) (= (select T_ROB_destination (_ bv50 6)) 0) (= (select T_ROB_result (_ bv50 6)) 0) (= (select T_ROB_exception (_ bv50 6)) #b0) (= (select T_ROB_done (_ bv50 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv51 6))) (and (= (select T_ROB_op_type (_ bv51 6)) 0) (= (select T_ROB_destination (_ bv51 6)) 0) (= (select T_ROB_result (_ bv51 6)) 0) (= (select T_ROB_exception (_ bv51 6)) #b0) (= (select T_ROB_done (_ bv51 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv52 6))) (and (= (select T_ROB_op_type (_ bv52 6)) 0) (= (select T_ROB_destination (_ bv52 6)) 0) (= (select T_ROB_result (_ bv52 6)) 0) (= (select T_ROB_exception (_ bv52 6)) #b0) (= (select T_ROB_done (_ bv52 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv53 6))) (and (= (select T_ROB_op_type (_ bv53 6)) 0) (= (select T_ROB_destination (_ bv53 6)) 0) (= (select T_ROB_result (_ bv53 6)) 0) (= (select T_ROB_exception (_ bv53 6)) #b0) (= (select T_ROB_done (_ bv53 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv54 6))) (and (= (select T_ROB_op_type (_ bv54 6)) 0) (= (select T_ROB_destination (_ bv54 6)) 0) (= (select T_ROB_result (_ bv54 6)) 0) (= (select T_ROB_exception (_ bv54 6)) #b0) (= (select T_ROB_done (_ bv54 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv55 6))) (and (= (select T_ROB_op_type (_ bv55 6)) 0) (= (select T_ROB_destination (_ bv55 6)) 0) (= (select T_ROB_result (_ bv55 6)) 0) (= (select T_ROB_exception (_ bv55 6)) #b0) (= (select T_ROB_done (_ bv55 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv56 6))) (and (= (select T_ROB_op_type (_ bv56 6)) 0) (= (select T_ROB_destination (_ bv56 6)) 0) (= (select T_ROB_result (_ bv56 6)) 0) (= (select T_ROB_exception (_ bv56 6)) #b0) (= (select T_ROB_done (_ bv56 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv57 6))) (and (= (select T_ROB_op_type (_ bv57 6)) 0) (= (select T_ROB_destination (_ bv57 6)) 0) (= (select T_ROB_result (_ bv57 6)) 0) (= (select T_ROB_exception (_ bv57 6)) #b0) (= (select T_ROB_done (_ bv57 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv58 6))) (and (= (select T_ROB_op_type (_ bv58 6)) 0) (= (select T_ROB_destination (_ bv58 6)) 0) (= (select T_ROB_result (_ bv58 6)) 0) (= (select T_ROB_exception (_ bv58 6)) #b0) (= (select T_ROB_done (_ bv58 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv59 6))) (and (= (select T_ROB_op_type (_ bv59 6)) 0) (= (select T_ROB_destination (_ bv59 6)) 0) (= (select T_ROB_result (_ bv59 6)) 0) (= (select T_ROB_exception (_ bv59 6)) #b0) (= (select T_ROB_done (_ bv59 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv60 6))) (and (= (select T_ROB_op_type (_ bv60 6)) 0) (= (select T_ROB_destination (_ bv60 6)) 0) (= (select T_ROB_result (_ bv60 6)) 0) (= (select T_ROB_exception (_ bv60 6)) #b0) (= (select T_ROB_done (_ bv60 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv61 6))) (and (= (select T_ROB_op_type (_ bv61 6)) 0) (= (select T_ROB_destination (_ bv61 6)) 0) (= (select T_ROB_result (_ bv61 6)) 0) (= (select T_ROB_exception (_ bv61 6)) #b0) (= (select T_ROB_done (_ bv61 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv62 6))) (and (= (select T_ROB_op_type (_ bv62 6)) 0) (= (select T_ROB_destination (_ bv62 6)) 0) (= (select T_ROB_result (_ bv62 6)) 0) (= (select T_ROB_exception (_ bv62 6)) #b0) (= (select T_ROB_done (_ bv62 6)) #b0) ))
				(=> (= #b0 (select T_ROB_busy (_ bv63 6))) (and (= (select T_ROB_op_type (_ bv63 6)) 0) (= (select T_ROB_destination (_ bv63 6)) 0) (= (select T_ROB_result (_ bv63 6)) 0) (= (select T_ROB_exception (_ bv63 6)) #b0) (= (select T_ROB_done (_ bv63 6)) #b0) ))

				
;----------------------------------------------------------------------------------------Invariant 6----------------------------------------------------------------------------------				
				(=> (= #b1 (select T_RS_busy (_ bv0 3))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv0 3))) (select T_RS_op_type (_ bv0 3))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv0 3)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv0 3))))))
				(=> (= #b1 (select T_RS_busy (_ bv1 3))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv1 3))) (select T_RS_op_type (_ bv1 3))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv1 3)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv1 3))))))
				(=> (= #b1 (select T_RS_busy (_ bv2 3))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv2 3))) (select T_RS_op_type (_ bv2 3))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv2 3)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv2 3))))))
				(=> (= #b1 (select T_RS_busy (_ bv3 3))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv3 3))) (select T_RS_op_type (_ bv3 3))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv3 3)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv3 3))))))
				(=> (= #b1 (select T_RS_busy (_ bv4 3))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv4 3))) (select T_RS_op_type (_ bv4 3))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv4 3)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv4 3))))))
				(=> (= #b1 (select T_RS_busy (_ bv5 3))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv5 3))) (select T_RS_op_type (_ bv5 3))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv5 3)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv5 3))))))
				(=> (= #b1 (select T_RS_busy (_ bv6 3))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv6 3))) (select T_RS_op_type (_ bv6 3))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv6 3)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv6 3))))))
				(=> (= #b1 (select T_RS_busy (_ bv7 3))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv7 3))) (select T_RS_op_type (_ bv7 3))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv7 3)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv7 3))))))

				(=> (= #b1 (select T_LSQ_busy (_ bv0 3))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv0 3))) (select T_LSQ_op_type (_ bv0 3))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv0 3)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv0 3))))))
				(=> (= #b1 (select T_LSQ_busy (_ bv1 3))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv1 3))) (select T_LSQ_op_type (_ bv1 3))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv1 3)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv1 3))))))
				(=> (= #b1 (select T_LSQ_busy (_ bv2 3))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv2 3))) (select T_LSQ_op_type (_ bv2 3))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv2 3)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv2 3))))))
				(=> (= #b1 (select T_LSQ_busy (_ bv3 3))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv3 3))) (select T_LSQ_op_type (_ bv3 3))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv3 3)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv3 3))))))
				(=> (= #b1 (select T_LSQ_busy (_ bv4 3))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv4 3))) (select T_LSQ_op_type (_ bv4 3))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv4 3)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv4 3))))))
				(=> (= #b1 (select T_LSQ_busy (_ bv5 3))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv5 3))) (select T_LSQ_op_type (_ bv5 3))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv5 3)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv5 3))))))
				(=> (= #b1 (select T_LSQ_busy (_ bv6 3))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv6 3))) (select T_LSQ_op_type (_ bv6 3))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv6 3)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv6 3))))))
				(=> (= #b1 (select T_LSQ_busy (_ bv7 3))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv7 3))) (select T_LSQ_op_type (_ bv7 3))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv7 3)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv7 3))))))

;-----------------------------------------------------------------------------------------End of Invariant 6--------------------------------------------------------------------------
		
				(=> (= #b0 (select T_RS_busy (_ bv0 3))) (and (= #b000000 (select T_RS_ROB_dst (_ bv0 3))) (= #b0 (select T_RS_dis (_ bv0 3)))))
				(=> (= #b0 (select T_RS_busy (_ bv1 3))) (and (= #b000000 (select T_RS_ROB_dst (_ bv1 3))) (= #b0 (select T_RS_dis (_ bv1 3)))))
				(=> (= #b0 (select T_RS_busy (_ bv2 3))) (and (= #b000000 (select T_RS_ROB_dst (_ bv2 3))) (= #b0 (select T_RS_dis (_ bv2 3)))))
				(=> (= #b0 (select T_RS_busy (_ bv3 3))) (and (= #b000000 (select T_RS_ROB_dst (_ bv3 3))) (= #b0 (select T_RS_dis (_ bv3 3)))))
				(=> (= #b0 (select T_RS_busy (_ bv4 3))) (and (= #b000000 (select T_RS_ROB_dst (_ bv4 3))) (= #b0 (select T_RS_dis (_ bv4 3)))))
				(=> (= #b0 (select T_RS_busy (_ bv5 3))) (and (= #b000000 (select T_RS_ROB_dst (_ bv5 3))) (= #b0 (select T_RS_dis (_ bv5 3)))))
				(=> (= #b0 (select T_RS_busy (_ bv6 3))) (and (= #b000000 (select T_RS_ROB_dst (_ bv6 3))) (= #b0 (select T_RS_dis (_ bv6 3)))))
				(=> (= #b0 (select T_RS_busy (_ bv7 3))) (and (= #b000000 (select T_RS_ROB_dst (_ bv7 3))) (= #b0 (select T_RS_dis (_ bv7 3)))))
				
				(=> (= #b1 (select T_RS_busy (_ bv0 3))) (not (= #b000000 (select T_RS_ROB_dst (_ bv0 3)))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv1 3))) (not (= #b000000 (select T_RS_ROB_dst (_ bv1 3)))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv2 3))) (not (= #b000000 (select T_RS_ROB_dst (_ bv2 3)))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv3 3))) (not (= #b000000 (select T_RS_ROB_dst (_ bv3 3)))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv4 3))) (not (= #b000000 (select T_RS_ROB_dst (_ bv4 3)))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv5 3))) (not (= #b000000 (select T_RS_ROB_dst (_ bv5 3)))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv6 3))) (not (= #b000000 (select T_RS_ROB_dst (_ bv6 3)))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv7 3))) (not (= #b000000 (select T_RS_ROB_dst (_ bv7 3)))))	;done
				
				(=> (= #b0 (select T_LSQ_busy (_ bv0 3))) (and (= #b000000 (select T_LSQ_ROB_dst (_ bv0 3))) (= #b0 (select T_LSQ_dis (_ bv0 3)))))
				(=> (= #b0 (select T_LSQ_busy (_ bv1 3))) (and (= #b000000 (select T_LSQ_ROB_dst (_ bv1 3))) (= #b0 (select T_LSQ_dis (_ bv1 3)))))
				(=> (= #b0 (select T_LSQ_busy (_ bv2 3))) (and (= #b000000 (select T_LSQ_ROB_dst (_ bv2 3))) (= #b0 (select T_LSQ_dis (_ bv2 3)))))
				(=> (= #b0 (select T_LSQ_busy (_ bv3 3))) (and (= #b000000 (select T_LSQ_ROB_dst (_ bv3 3))) (= #b0 (select T_LSQ_dis (_ bv3 3)))))
				(=> (= #b0 (select T_LSQ_busy (_ bv4 3))) (and (= #b000000 (select T_LSQ_ROB_dst (_ bv4 3))) (= #b0 (select T_LSQ_dis (_ bv4 3)))))
				(=> (= #b0 (select T_LSQ_busy (_ bv5 3))) (and (= #b000000 (select T_LSQ_ROB_dst (_ bv5 3))) (= #b0 (select T_LSQ_dis (_ bv5 3)))))
				(=> (= #b0 (select T_LSQ_busy (_ bv6 3))) (and (= #b000000 (select T_LSQ_ROB_dst (_ bv6 3))) (= #b0 (select T_LSQ_dis (_ bv6 3)))))
				(=> (= #b0 (select T_LSQ_busy (_ bv7 3))) (and (= #b000000 (select T_LSQ_ROB_dst (_ bv7 3))) (= #b0 (select T_LSQ_dis (_ bv7 3)))))
								
				(=> (= #b1 (select T_LSQ_busy (_ bv0 3))) (not (= #b000000 (select T_LSQ_ROB_dst (_ bv0 3)))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv1 3))) (not (= #b000000 (select T_LSQ_ROB_dst (_ bv1 3)))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv2 3))) (not (= #b000000 (select T_LSQ_ROB_dst (_ bv2 3)))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv3 3))) (not (= #b000000 (select T_LSQ_ROB_dst (_ bv3 3)))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv4 3))) (not (= #b000000 (select T_LSQ_ROB_dst (_ bv4 3)))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv5 3))) (not (= #b000000 (select T_LSQ_ROB_dst (_ bv5 3)))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv6 3))) (not (= #b000000 (select T_LSQ_ROB_dst (_ bv6 3)))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv7 3))) (not (= #b000000 (select T_LSQ_ROB_dst (_ bv7 3)))))	;done
				
;---------------------------------------------------Invariant 7---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------								
				(=> (= #b1 (select T_RS_busy (_ bv0 3))) (and (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv7 3)))) 					(not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_RS_busy (_ bv1 3))) (and (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv7 3))))					(not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv7 3))))   )) ;done
				(=> (= #b1 (select T_RS_busy (_ bv2 3))) (and (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv7 3))))					(not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_RS_busy (_ bv3 3))) (and (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv7 3))))					(not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_RS_busy (_ bv4 3))) (and (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv7 3))))					(not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_RS_busy (_ bv5 3))) (and (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv7 3))))					(not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_RS_busy (_ bv6 3))) (and (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv7 3))))					(not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_RS_busy (_ bv7 3))) (and (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv6 3))))					(not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_RS_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv7 3))))  )) ;done			
				
				(=> (= #b1 (select T_LSQ_busy (_ bv0 3))) (and (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_LSQ_ROB_dst (_ bv7 3)))) 				(not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv0 3)) (select T_RS_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_LSQ_busy (_ bv1 3))) (and (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_LSQ_ROB_dst (_ bv7 3))))					(not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv1 3)) (select T_RS_ROB_dst (_ bv7 3))))   )) ;done
				(=> (= #b1 (select T_LSQ_busy (_ bv2 3))) (and (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_LSQ_ROB_dst (_ bv7 3))))					(not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv2 3)) (select T_RS_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_LSQ_busy (_ bv3 3))) (and (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_LSQ_ROB_dst (_ bv7 3))))					(not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv3 3)) (select T_RS_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_LSQ_busy (_ bv4 3))) (and (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_LSQ_ROB_dst (_ bv7 3))))					(not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv4 3)) (select T_RS_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_LSQ_busy (_ bv5 3))) (and (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_LSQ_ROB_dst (_ bv7 3))))					(not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv5 3)) (select T_RS_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_LSQ_busy (_ bv6 3))) (and (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_LSQ_ROB_dst (_ bv7 3))))					(not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv6 3)) (select T_RS_ROB_dst (_ bv7 3))))  )) ;done
				(=> (= #b1 (select T_LSQ_busy (_ bv7 3))) (and (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_LSQ_ROB_dst (_ bv6 3))))					(not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv0 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv1 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv2 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv3 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv4 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv5 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv6 3)))) (not (= (select T_LSQ_ROB_dst (_ bv7 3)) (select T_RS_ROB_dst (_ bv7 3))))  )) ;done
;--------------------------------------------------------------End of Invariant 7-----------------------------------------------------------------------------

;(-----------------------------Invariant 1--------------------------------------------------------------------------------
				(= T_Main_Ltag
					(ite (and (= #b1 (select T_ROB_busy T_IP_m1)) (= Lfence (select T_ROB_op_type T_IP_m1))) T_IP_m1
					(ite (and (= #b1 (select T_ROB_busy T_IP_m2)) (= Lfence (select T_ROB_op_type T_IP_m2))) T_IP_m2
					(ite (and (= #b1 (select T_ROB_busy T_IP_m3)) (= Lfence (select T_ROB_op_type T_IP_m3))) T_IP_m3
					(ite (and (= #b1 (select T_ROB_busy T_IP_m4)) (= Lfence (select T_ROB_op_type T_IP_m4))) T_IP_m4
					(ite (and (= #b1 (select T_ROB_busy T_IP_m5)) (= Lfence (select T_ROB_op_type T_IP_m5))) T_IP_m5
					(ite (and (= #b1 (select T_ROB_busy T_IP_m6)) (= Lfence (select T_ROB_op_type T_IP_m6))) T_IP_m6
					(ite (and (= #b1 (select T_ROB_busy T_IP_m7)) (= Lfence (select T_ROB_op_type T_IP_m7))) T_IP_m7
					(ite (and (= #b1 (select T_ROB_busy T_IP_m8)) (= Lfence (select T_ROB_op_type T_IP_m8))) T_IP_m8
					(ite (and (= #b1 (select T_ROB_busy T_IP_m9)) (= Lfence (select T_ROB_op_type T_IP_m9))) T_IP_m9
					(ite (and (= #b1 (select T_ROB_busy T_IP_m10)) (= Lfence (select T_ROB_op_type T_IP_m10))) T_IP_m10
					(ite (and (= #b1 (select T_ROB_busy T_IP_m11)) (= Lfence (select T_ROB_op_type T_IP_m11))) T_IP_m11
					(ite (and (= #b1 (select T_ROB_busy T_IP_m12)) (= Lfence (select T_ROB_op_type T_IP_m12))) T_IP_m12
					(ite (and (= #b1 (select T_ROB_busy T_IP_m13)) (= Lfence (select T_ROB_op_type T_IP_m13))) T_IP_m13
					(ite (and (= #b1 (select T_ROB_busy T_IP_m14)) (= Lfence (select T_ROB_op_type T_IP_m14))) T_IP_m14
					(ite (and (= #b1 (select T_ROB_busy T_IP_m15)) (= Lfence (select T_ROB_op_type T_IP_m15))) T_IP_m15
					(ite (and (= #b1 (select T_ROB_busy T_IP_m16)) (= Lfence (select T_ROB_op_type T_IP_m16))) T_IP_m16
					(ite (and (= #b1 (select T_ROB_busy T_IP_m17)) (= Lfence (select T_ROB_op_type T_IP_m17))) T_IP_m17
					(ite (and (= #b1 (select T_ROB_busy T_IP_m18)) (= Lfence (select T_ROB_op_type T_IP_m18))) T_IP_m18
					(ite (and (= #b1 (select T_ROB_busy T_IP_m19)) (= Lfence (select T_ROB_op_type T_IP_m19))) T_IP_m19
					(ite (and (= #b1 (select T_ROB_busy T_IP_m20)) (= Lfence (select T_ROB_op_type T_IP_m20))) T_IP_m20
					(ite (and (= #b1 (select T_ROB_busy T_IP_m21)) (= Lfence (select T_ROB_op_type T_IP_m21))) T_IP_m21
					(ite (and (= #b1 (select T_ROB_busy T_IP_m22)) (= Lfence (select T_ROB_op_type T_IP_m22))) T_IP_m22
					(ite (and (= #b1 (select T_ROB_busy T_IP_m23)) (= Lfence (select T_ROB_op_type T_IP_m23))) T_IP_m23
					(ite (and (= #b1 (select T_ROB_busy T_IP_m24)) (= Lfence (select T_ROB_op_type T_IP_m24))) T_IP_m24
					(ite (and (= #b1 (select T_ROB_busy T_IP_m25)) (= Lfence (select T_ROB_op_type T_IP_m25))) T_IP_m25
					(ite (and (= #b1 (select T_ROB_busy T_IP_m26)) (= Lfence (select T_ROB_op_type T_IP_m26))) T_IP_m26
					(ite (and (= #b1 (select T_ROB_busy T_IP_m27)) (= Lfence (select T_ROB_op_type T_IP_m27))) T_IP_m27
					(ite (and (= #b1 (select T_ROB_busy T_IP_m28)) (= Lfence (select T_ROB_op_type T_IP_m28))) T_IP_m28
					(ite (and (= #b1 (select T_ROB_busy T_IP_m29)) (= Lfence (select T_ROB_op_type T_IP_m29))) T_IP_m29
					(ite (and (= #b1 (select T_ROB_busy T_IP_m30)) (= Lfence (select T_ROB_op_type T_IP_m30))) T_IP_m30
					(ite (and (= #b1 (select T_ROB_busy T_IP_m31)) (= Lfence (select T_ROB_op_type T_IP_m31))) T_IP_m31
					(ite (and (= #b1 (select T_ROB_busy T_IP_m32)) (= Lfence (select T_ROB_op_type T_IP_m32))) T_IP_m32
					(ite (and (= #b1 (select T_ROB_busy T_IP_m33)) (= Lfence (select T_ROB_op_type T_IP_m33))) T_IP_m33
					(ite (and (= #b1 (select T_ROB_busy T_IP_m34)) (= Lfence (select T_ROB_op_type T_IP_m34))) T_IP_m34
					(ite (and (= #b1 (select T_ROB_busy T_IP_m35)) (= Lfence (select T_ROB_op_type T_IP_m35))) T_IP_m35
					(ite (and (= #b1 (select T_ROB_busy T_IP_m36)) (= Lfence (select T_ROB_op_type T_IP_m36))) T_IP_m36
					(ite (and (= #b1 (select T_ROB_busy T_IP_m37)) (= Lfence (select T_ROB_op_type T_IP_m37))) T_IP_m37
					(ite (and (= #b1 (select T_ROB_busy T_IP_m38)) (= Lfence (select T_ROB_op_type T_IP_m38))) T_IP_m38
					(ite (and (= #b1 (select T_ROB_busy T_IP_m39)) (= Lfence (select T_ROB_op_type T_IP_m39))) T_IP_m39
					(ite (and (= #b1 (select T_ROB_busy T_IP_m40)) (= Lfence (select T_ROB_op_type T_IP_m40))) T_IP_m40
					(ite (and (= #b1 (select T_ROB_busy T_IP_m41)) (= Lfence (select T_ROB_op_type T_IP_m41))) T_IP_m41
					(ite (and (= #b1 (select T_ROB_busy T_IP_m42)) (= Lfence (select T_ROB_op_type T_IP_m42))) T_IP_m42
					(ite (and (= #b1 (select T_ROB_busy T_IP_m43)) (= Lfence (select T_ROB_op_type T_IP_m43))) T_IP_m43
					(ite (and (= #b1 (select T_ROB_busy T_IP_m44)) (= Lfence (select T_ROB_op_type T_IP_m44))) T_IP_m44
					(ite (and (= #b1 (select T_ROB_busy T_IP_m45)) (= Lfence (select T_ROB_op_type T_IP_m45))) T_IP_m45
					(ite (and (= #b1 (select T_ROB_busy T_IP_m46)) (= Lfence (select T_ROB_op_type T_IP_m46))) T_IP_m46
					(ite (and (= #b1 (select T_ROB_busy T_IP_m47)) (= Lfence (select T_ROB_op_type T_IP_m47))) T_IP_m47
					(ite (and (= #b1 (select T_ROB_busy T_IP_m48)) (= Lfence (select T_ROB_op_type T_IP_m48))) T_IP_m48
					(ite (and (= #b1 (select T_ROB_busy T_IP_m49)) (= Lfence (select T_ROB_op_type T_IP_m49))) T_IP_m49
					(ite (and (= #b1 (select T_ROB_busy T_IP_m50)) (= Lfence (select T_ROB_op_type T_IP_m50))) T_IP_m50
					(ite (and (= #b1 (select T_ROB_busy T_IP_m51)) (= Lfence (select T_ROB_op_type T_IP_m51))) T_IP_m51
					(ite (and (= #b1 (select T_ROB_busy T_IP_m52)) (= Lfence (select T_ROB_op_type T_IP_m52))) T_IP_m52
					(ite (and (= #b1 (select T_ROB_busy T_IP_m53)) (= Lfence (select T_ROB_op_type T_IP_m53))) T_IP_m53
					(ite (and (= #b1 (select T_ROB_busy T_IP_m54)) (= Lfence (select T_ROB_op_type T_IP_m54))) T_IP_m54
					(ite (and (= #b1 (select T_ROB_busy T_IP_m55)) (= Lfence (select T_ROB_op_type T_IP_m55))) T_IP_m55
					(ite (and (= #b1 (select T_ROB_busy T_IP_m56)) (= Lfence (select T_ROB_op_type T_IP_m56))) T_IP_m56
					(ite (and (= #b1 (select T_ROB_busy T_IP_m57)) (= Lfence (select T_ROB_op_type T_IP_m57))) T_IP_m57
					(ite (and (= #b1 (select T_ROB_busy T_IP_m58)) (= Lfence (select T_ROB_op_type T_IP_m58))) T_IP_m58
					(ite (and (= #b1 (select T_ROB_busy T_IP_m59)) (= Lfence (select T_ROB_op_type T_IP_m59))) T_IP_m59
					(ite (and (= #b1 (select T_ROB_busy T_IP_m60)) (= Lfence (select T_ROB_op_type T_IP_m60))) T_IP_m60
					(ite (and (= #b1 (select T_ROB_busy T_IP_m61)) (= Lfence (select T_ROB_op_type T_IP_m61))) T_IP_m61
					(ite (and (= #b1 (select T_ROB_busy T_IP_m62)) (= Lfence (select T_ROB_op_type T_IP_m62))) T_IP_m62
					(ite (and (= #b1 (select T_ROB_busy T_IP_m63)) (= Lfence (select T_ROB_op_type T_IP_m63))) T_IP_m63
					(_ bv0 6)
					)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
				)
				
				(=> (not (= T_Main_Ltag #b000000)) (= Lfence (select T_ROB_op_type T_Main_Ltag)))
;--------------------------------End of Invariant 1----------------------------------------------------------------------

;------------------------------Invariant 2--------------------------------------------------------------------------------
				(=> (not (= #b000000 (select T_LSQ_Ltag (_ bv0 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_LSQ_Ltag (_ bv0 3))))
						(= #b1 (select T_LSQ_busy (_ bv0 3)))
					)
				)
				(=> (not (= #b000000 (select T_LSQ_Ltag (_ bv1 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_LSQ_Ltag (_ bv1 3))))
						(= #b1 (select T_LSQ_busy (_ bv1 3)))
					)
				)
				(=> (not (= #b000000 (select T_LSQ_Ltag (_ bv2 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_LSQ_Ltag (_ bv2 3))))
						(= #b1 (select T_LSQ_busy (_ bv2 3)))
					)
				)
				(=> (not (= #b000000 (select T_LSQ_Ltag (_ bv3 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_LSQ_Ltag (_ bv3 3))))
						(= #b1 (select T_LSQ_busy (_ bv3 3)))
					)
				)
				(=> (not (= #b000000 (select T_LSQ_Ltag (_ bv4 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_LSQ_Ltag (_ bv4 3))))
						(= #b1 (select T_LSQ_busy (_ bv4 3)))
					)
				)
				(=> (not (= #b000000 (select T_LSQ_Ltag (_ bv5 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_LSQ_Ltag (_ bv5 3))))
						(= #b1 (select T_LSQ_busy (_ bv5 3)))
					)
				)
				(=> (not (= #b000000 (select T_LSQ_Ltag (_ bv6 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_LSQ_Ltag (_ bv6 3))))
						(= #b1 (select T_LSQ_busy (_ bv6 3)))
					)
				)
				(=> (not (= #b000000 (select T_LSQ_Ltag (_ bv7 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_LSQ_Ltag (_ bv7 3))))
						(= #b1 (select T_LSQ_busy (_ bv7 3)))
					)
				)
				(=> (not (= #b000000 (select T_RS_Ltag (_ bv0 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_RS_Ltag (_ bv0 3))))
						(= #b1 (select T_RS_busy (_ bv0 3)))
					)
				)
				(=> (not (= #b000000 (select T_RS_Ltag (_ bv1 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_RS_Ltag (_ bv1 3))))
						(= #b1 (select T_RS_busy (_ bv1 3)))
					)
				)
				(=> (not (= #b000000 (select T_RS_Ltag (_ bv2 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_RS_Ltag (_ bv2 3))))
						(= #b1 (select T_RS_busy (_ bv2 3)))
					)
				)
				(=> (not (= #b000000 (select T_RS_Ltag (_ bv3 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_RS_Ltag (_ bv3 3))))
						(= #b1 (select T_RS_busy (_ bv3 3)))
					)
				)
				(=> (not (= #b000000 (select T_RS_Ltag (_ bv4 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_RS_Ltag (_ bv4 3))))
						(= #b1 (select T_RS_busy (_ bv4 3)))
					)
				)
				(=> (not (= #b000000 (select T_RS_Ltag (_ bv5 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_RS_Ltag (_ bv5 3))))
						(= #b1 (select T_RS_busy (_ bv5 3)))
					)
				)
				(=> (not (= #b000000 (select T_RS_Ltag (_ bv6 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_RS_Ltag (_ bv6 3))))
						(= #b1 (select T_RS_busy (_ bv6 3)))
					)
				)
				(=> (not (= #b000000 (select T_RS_Ltag (_ bv7 3)))) 
					(and 
						(= Lfence (select T_ROB_op_type (select T_RS_Ltag (_ bv7 3))))
						(= #b1 (select T_RS_busy (_ bv7 3)))
					)
				)
;--------------------------------------End of Invariant 2-------------------------------------------------------------------------------------

;(----------------------------General Things-------------------------------------------------
				
			;	(and (bvuge any_rob #b000001) (bvult any_rob #b000111))
				(= #b0 U_path_stall)
				
				(= 0 (select empty_ROB_int (_ bv0 6)))
				(= 0 (select empty_ROB_int (_ bv1 6)))
				(= 0 (select empty_ROB_int (_ bv2 6)))
				(= 0 (select empty_ROB_int (_ bv3 6)))
				(= 0 (select empty_ROB_int (_ bv4 6)))
				(= 0 (select empty_ROB_int (_ bv5 6)))
				(= 0 (select empty_ROB_int (_ bv6 6)))
				(= 0 (select empty_ROB_int (_ bv7 6)))
				(= 0 (select empty_ROB_int (_ bv8 6)))
				(= 0 (select empty_ROB_int (_ bv9 6)))
				(= 0 (select empty_ROB_int (_ bv10 6)))
				(= 0 (select empty_ROB_int (_ bv11 6)))
				(= 0 (select empty_ROB_int (_ bv12 6)))
				(= 0 (select empty_ROB_int (_ bv13 6)))
				(= 0 (select empty_ROB_int (_ bv14 6)))
				(= 0 (select empty_ROB_int (_ bv15 6)))
				(= 0 (select empty_ROB_int (_ bv16 6)))
				(= 0 (select empty_ROB_int (_ bv17 6)))
				(= 0 (select empty_ROB_int (_ bv18 6)))
				(= 0 (select empty_ROB_int (_ bv19 6)))
				(= 0 (select empty_ROB_int (_ bv20 6)))
				(= 0 (select empty_ROB_int (_ bv21 6)))
				(= 0 (select empty_ROB_int (_ bv22 6)))
				(= 0 (select empty_ROB_int (_ bv23 6)))
				(= 0 (select empty_ROB_int (_ bv24 6)))
				(= 0 (select empty_ROB_int (_ bv25 6)))
				(= 0 (select empty_ROB_int (_ bv26 6)))
				(= 0 (select empty_ROB_int (_ bv27 6)))
				(= 0 (select empty_ROB_int (_ bv28 6)))
				(= 0 (select empty_ROB_int (_ bv29 6)))
				(= 0 (select empty_ROB_int (_ bv30 6)))
				(= 0 (select empty_ROB_int (_ bv31 6)))
				(= 0 (select empty_ROB_int (_ bv32 6)))
				(= 0 (select empty_ROB_int (_ bv33 6)))
				(= 0 (select empty_ROB_int (_ bv34 6)))
				(= 0 (select empty_ROB_int (_ bv35 6)))
				(= 0 (select empty_ROB_int (_ bv36 6)))
				(= 0 (select empty_ROB_int (_ bv37 6)))
				(= 0 (select empty_ROB_int (_ bv38 6)))
				(= 0 (select empty_ROB_int (_ bv39 6)))
				(= 0 (select empty_ROB_int (_ bv40 6)))
				(= 0 (select empty_ROB_int (_ bv41 6)))
				(= 0 (select empty_ROB_int (_ bv42 6)))
				(= 0 (select empty_ROB_int (_ bv43 6)))
				(= 0 (select empty_ROB_int (_ bv44 6)))
				(= 0 (select empty_ROB_int (_ bv45 6)))
				(= 0 (select empty_ROB_int (_ bv46 6)))
				(= 0 (select empty_ROB_int (_ bv47 6)))
				(= 0 (select empty_ROB_int (_ bv48 6)))
				(= 0 (select empty_ROB_int (_ bv49 6)))
				(= 0 (select empty_ROB_int (_ bv50 6)))
				(= 0 (select empty_ROB_int (_ bv51 6)))
				(= 0 (select empty_ROB_int (_ bv52 6)))
				(= 0 (select empty_ROB_int (_ bv53 6)))
				(= 0 (select empty_ROB_int (_ bv54 6)))
				(= 0 (select empty_ROB_int (_ bv55 6)))
				(= 0 (select empty_ROB_int (_ bv56 6)))
				(= 0 (select empty_ROB_int (_ bv57 6)))
				(= 0 (select empty_ROB_int (_ bv58 6)))
				(= 0 (select empty_ROB_int (_ bv59 6)))
				(= 0 (select empty_ROB_int (_ bv60 6)))
				(= 0 (select empty_ROB_int (_ bv61 6)))
				(= 0 (select empty_ROB_int (_ bv62 6)))
				(= 0 (select empty_ROB_int (_ bv63 6)))

				
				(= #b0 (select empty_ROB_1bit (_ bv0 6)))
				(= #b0 (select empty_ROB_1bit (_ bv1 6)))
				(= #b0 (select empty_ROB_1bit (_ bv2 6)))
				(= #b0 (select empty_ROB_1bit (_ bv3 6)))
				(= #b0 (select empty_ROB_1bit (_ bv4 6)))
				(= #b0 (select empty_ROB_1bit (_ bv5 6)))
				(= #b0 (select empty_ROB_1bit (_ bv6 6)))
				(= #b0 (select empty_ROB_1bit (_ bv7 6)))
				(= #b0 (select empty_ROB_1bit (_ bv8 6)))
				(= #b0 (select empty_ROB_1bit (_ bv9 6)))
				(= #b0 (select empty_ROB_1bit (_ bv10 6)))
				(= #b0 (select empty_ROB_1bit (_ bv11 6)))
				(= #b0 (select empty_ROB_1bit (_ bv12 6)))
				(= #b0 (select empty_ROB_1bit (_ bv13 6)))
				(= #b0 (select empty_ROB_1bit (_ bv14 6)))
				(= #b0 (select empty_ROB_1bit (_ bv15 6)))
				(= #b0 (select empty_ROB_1bit (_ bv16 6)))
				(= #b0 (select empty_ROB_1bit (_ bv17 6)))
				(= #b0 (select empty_ROB_1bit (_ bv18 6)))
				(= #b0 (select empty_ROB_1bit (_ bv19 6)))
				(= #b0 (select empty_ROB_1bit (_ bv20 6)))
				(= #b0 (select empty_ROB_1bit (_ bv21 6)))
				(= #b0 (select empty_ROB_1bit (_ bv22 6)))
				(= #b0 (select empty_ROB_1bit (_ bv23 6)))
				(= #b0 (select empty_ROB_1bit (_ bv24 6)))
				(= #b0 (select empty_ROB_1bit (_ bv25 6)))
				(= #b0 (select empty_ROB_1bit (_ bv26 6)))
				(= #b0 (select empty_ROB_1bit (_ bv27 6)))
				(= #b0 (select empty_ROB_1bit (_ bv28 6)))
				(= #b0 (select empty_ROB_1bit (_ bv29 6)))
				(= #b0 (select empty_ROB_1bit (_ bv30 6)))
				(= #b0 (select empty_ROB_1bit (_ bv31 6)))
				(= #b0 (select empty_ROB_1bit (_ bv32 6)))
				(= #b0 (select empty_ROB_1bit (_ bv33 6)))
				(= #b0 (select empty_ROB_1bit (_ bv34 6)))
				(= #b0 (select empty_ROB_1bit (_ bv35 6)))
				(= #b0 (select empty_ROB_1bit (_ bv36 6)))
				(= #b0 (select empty_ROB_1bit (_ bv37 6)))
				(= #b0 (select empty_ROB_1bit (_ bv38 6)))
				(= #b0 (select empty_ROB_1bit (_ bv39 6)))
				(= #b0 (select empty_ROB_1bit (_ bv40 6)))
				(= #b0 (select empty_ROB_1bit (_ bv41 6)))
				(= #b0 (select empty_ROB_1bit (_ bv42 6)))
				(= #b0 (select empty_ROB_1bit (_ bv43 6)))
				(= #b0 (select empty_ROB_1bit (_ bv44 6)))
				(= #b0 (select empty_ROB_1bit (_ bv45 6)))
				(= #b0 (select empty_ROB_1bit (_ bv46 6)))
				(= #b0 (select empty_ROB_1bit (_ bv47 6)))
				(= #b0 (select empty_ROB_1bit (_ bv48 6)))
				(= #b0 (select empty_ROB_1bit (_ bv49 6)))
				(= #b0 (select empty_ROB_1bit (_ bv50 6)))
				(= #b0 (select empty_ROB_1bit (_ bv51 6)))
				(= #b0 (select empty_ROB_1bit (_ bv52 6)))
				(= #b0 (select empty_ROB_1bit (_ bv53 6)))
				(= #b0 (select empty_ROB_1bit (_ bv54 6)))
				(= #b0 (select empty_ROB_1bit (_ bv55 6)))
				(= #b0 (select empty_ROB_1bit (_ bv56 6)))
				(= #b0 (select empty_ROB_1bit (_ bv57 6)))
				(= #b0 (select empty_ROB_1bit (_ bv58 6)))
				(= #b0 (select empty_ROB_1bit (_ bv59 6)))
				(= #b0 (select empty_ROB_1bit (_ bv60 6)))
				(= #b0 (select empty_ROB_1bit (_ bv61 6)))
				(= #b0 (select empty_ROB_1bit (_ bv62 6)))
				(= #b0 (select empty_ROB_1bit (_ bv63 6)))

				
				(= #b0 (select empty_RS_LSQ_1bit (_ bv0 3)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv1 3)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv2 3)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv3 3)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv4 3)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv5 3)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv6 3)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv7 3)))
				
				(= #b000000 (select empty_RS_LSQ_3bit (_ bv0 3)))
				(= #b000000 (select empty_RS_LSQ_3bit (_ bv1 3)))
				(= #b000000 (select empty_RS_LSQ_3bit (_ bv2 3)))
				(= #b000000 (select empty_RS_LSQ_3bit (_ bv3 3)))
				(= #b000000 (select empty_RS_LSQ_3bit (_ bv4 3)))
				(= #b000000 (select empty_RS_LSQ_3bit (_ bv5 3)))
				(= #b000000 (select empty_RS_LSQ_3bit (_ bv6 3)))
				(= #b000000 (select empty_RS_LSQ_3bit (_ bv7 3)))
				
				(= 0 (select empty_RS_LSQ_int (_ bv0 3)))
				(= 0 (select empty_RS_LSQ_int (_ bv1 3)))
				(= 0 (select empty_RS_LSQ_int (_ bv2 3)))
				(= 0 (select empty_RS_LSQ_int (_ bv3 3)))
				(= 0 (select empty_RS_LSQ_int (_ bv4 3)))
				(= 0 (select empty_RS_LSQ_int (_ bv5 3)))
				(= 0 (select empty_RS_LSQ_int (_ bv6 3)))
				(= 0 (select empty_RS_LSQ_int (_ bv7 3)))
				
				
				(= Rtype 0)
				(= Branch 1)
				(= Mul_div 2)
				(= Load 3)
				(= Store 4)
				(= Jump 5)
				(= Lfence 6)				
;)

;(----------------------------Visual-------------------------------------------------
				(= state_T_any_rob any_rob)
				(= state_T_any_rob_plus any_rob_plus)
				(= T_state_Cache0_Tag (select T_Cache_Tag (_ bv0 2)))
				(= T_state_Cache1_Tag (select T_Cache_Tag (_ bv1 2)))
				(= T_state_Cache2_Tag (select T_Cache_Tag (_ bv2 2)))
				(= T_state_Cache3_Tag (select T_Cache_Tag (_ bv3 2)))
				
				(= T_state_Cache0_Data (select T_Cache_Data (_ bv0 2)))
				(= T_state_Cache1_Data (select T_Cache_Data (_ bv1 2)))
				(= T_state_Cache2_Data (select T_Cache_Data (_ bv2 2)))
				(= T_state_Cache3_Data (select T_Cache_Data (_ bv3 2)))
				
				(= T_state_Cache0_Valid (select T_Cache_Valid (_ bv0 2)))
				(= T_state_Cache1_Valid (select T_Cache_Valid (_ bv1 2)))
				(= T_state_Cache2_Valid (select T_Cache_Valid (_ bv2 2)))
				(= T_state_Cache3_Valid (select T_Cache_Valid (_ bv3 2)))
				
				(= T_state_IP T_IP)
				(= T_state_CP T_CP)
				(= T_state_PC T_PC)
				(= T_state_Main_Ltag T_Main_Ltag)
				
				(= T_state_ROB0_busy (select T_ROB_busy (_ bv0 6)))
				(= T_state_ROB0_op_type (select T_ROB_op_type (_ bv0 6)))
				(= T_state_ROB0_destination (select T_ROB_destination (_ bv0 6)))
				(= T_state_ROB0_result (select T_ROB_result (_ bv0 6)))
				(= T_state_ROB0_exception (select T_ROB_exception (_ bv0 6)))
				(= T_state_ROB0_done (select T_ROB_done (_ bv0 6)))
				
				(= T_state_ROB1_busy (select T_ROB_busy (_ bv1 6)))
				(= T_state_ROB1_op_type (select T_ROB_op_type (_ bv1 6)))
				(= T_state_ROB1_destination (select T_ROB_destination (_ bv1 6)))
				(= T_state_ROB1_result (select T_ROB_result (_ bv1 6)))
				(= T_state_ROB1_exception (select T_ROB_exception (_ bv1 6)))
				(= T_state_ROB1_done (select T_ROB_done (_ bv1 6)))
				
				(= T_state_ROB2_busy (select T_ROB_busy (_ bv2 6)))
				(= T_state_ROB2_op_type (select T_ROB_op_type (_ bv2 6)))
				(= T_state_ROB2_destination (select T_ROB_destination (_ bv2 6)))
				(= T_state_ROB2_result (select T_ROB_result (_ bv2 6)))
				(= T_state_ROB2_exception (select T_ROB_exception (_ bv2 6)))
				(= T_state_ROB2_done (select T_ROB_done (_ bv2 6)))
				
				(= T_state_ROB3_busy (select T_ROB_busy (_ bv3 6)))
				(= T_state_ROB3_op_type (select T_ROB_op_type (_ bv3 6)))
				(= T_state_ROB3_destination (select T_ROB_destination (_ bv3 6)))
				(= T_state_ROB3_result (select T_ROB_result (_ bv3 6)))
				(= T_state_ROB3_exception (select T_ROB_exception (_ bv3 6)))
				(= T_state_ROB3_done (select T_ROB_done (_ bv3 6)))
				
				(= T_state_ROB4_busy (select T_ROB_busy (_ bv4 6)))
				(= T_state_ROB4_op_type (select T_ROB_op_type (_ bv4 6)))
				(= T_state_ROB4_destination (select T_ROB_destination (_ bv4 6)))
				(= T_state_ROB4_result (select T_ROB_result (_ bv4 6)))
				(= T_state_ROB4_exception (select T_ROB_exception (_ bv4 6)))
				(= T_state_ROB4_done (select T_ROB_done (_ bv4 6)))
				
				(= T_state_ROB5_busy (select T_ROB_busy (_ bv5 6)))
				(= T_state_ROB5_op_type (select T_ROB_op_type (_ bv5 6)))
				(= T_state_ROB5_destination (select T_ROB_destination (_ bv5 6)))
				(= T_state_ROB5_result (select T_ROB_result (_ bv5 6)))
				(= T_state_ROB5_exception (select T_ROB_exception (_ bv5 6)))
				(= T_state_ROB5_done (select T_ROB_done (_ bv5 6)))
				
				(= T_state_ROB6_busy (select T_ROB_busy (_ bv6 6)))
				(= T_state_ROB6_op_type (select T_ROB_op_type (_ bv6 6)))
				(= T_state_ROB6_destination (select T_ROB_destination (_ bv6 6)))
				(= T_state_ROB6_result (select T_ROB_result (_ bv6 6)))
				(= T_state_ROB6_exception (select T_ROB_exception (_ bv6 6)))
				(= T_state_ROB6_done (select T_ROB_done (_ bv6 6)))
				
				(= T_state_ROB7_busy (select T_ROB_busy (_ bv7 6)))
				(= T_state_ROB7_op_type (select T_ROB_op_type (_ bv7 6)))
				(= T_state_ROB7_destination (select T_ROB_destination (_ bv7 6)))
				(= T_state_ROB7_result (select T_ROB_result (_ bv7 6)))
				(= T_state_ROB7_exception (select T_ROB_exception (_ bv7 6)))
				(= T_state_ROB7_done (select T_ROB_done (_ bv7 6)))
				
				(= T_state_RS0_op_type (select T_RS_op_type (_ bv0 3)))
				(= T_state_RS0_op (select T_RS_op (_ bv0 3)))
				(= T_state_RS0_ROB_dst (select T_RS_ROB_dst (_ bv0 3)))
				(= T_state_RS0_vj (select T_RS_vj (_ bv0 3)))
				(= T_state_RS0_vk (select T_RS_vk (_ bv0 3)))
				(= T_state_RS0_qj (select T_RS_qj (_ bv0 3)))
				(= T_state_RS0_qk (select T_RS_qk (_ bv0 3)))
				(= T_state_RS0_imm (select T_RS_imm (_ bv0 3)))
				(= T_state_RS0_dis (select T_RS_dis (_ bv0 3)))
				(= T_state_RS0_busy (select T_RS_busy (_ bv0 3)))
				(= T_state_RS0_Ltag (select T_RS_Ltag (_ bv0 3)))
				
				(= T_state_RS1_op_type (select T_RS_op_type (_ bv1 3)))
				(= T_state_RS1_op (select T_RS_op (_ bv1 3)))
				(= T_state_RS1_ROB_dst (select T_RS_ROB_dst (_ bv1 3)))
				(= T_state_RS1_vj (select T_RS_vj (_ bv1 3)))
				(= T_state_RS1_vk (select T_RS_vk (_ bv1 3)))
				(= T_state_RS1_qj (select T_RS_qj (_ bv1 3)))
				(= T_state_RS1_qk (select T_RS_qk (_ bv1 3)))
				(= T_state_RS1_imm (select T_RS_imm (_ bv1 3)))
				(= T_state_RS1_dis (select T_RS_dis (_ bv1 3)))
				(= T_state_RS1_busy (select T_RS_busy (_ bv1 3)))
				(= T_state_RS1_Ltag (select T_RS_Ltag (_ bv1 3)))
				
				(= T_state_RS2_op_type (select T_RS_op_type (_ bv2 3)))
				(= T_state_RS2_op (select T_RS_op (_ bv2 3)))
				(= T_state_RS2_ROB_dst (select T_RS_ROB_dst (_ bv2 3)))
				(= T_state_RS2_vj (select T_RS_vj (_ bv2 3)))
				(= T_state_RS2_vk (select T_RS_vk (_ bv2 3)))
				(= T_state_RS2_qj (select T_RS_qj (_ bv2 3)))
				(= T_state_RS2_qk (select T_RS_qk (_ bv2 3)))
				(= T_state_RS2_imm (select T_RS_imm (_ bv2 3)))
				(= T_state_RS2_dis (select T_RS_dis (_ bv2 3)))
				(= T_state_RS2_busy (select T_RS_busy (_ bv2 3)))
				(= T_state_RS2_Ltag (select T_RS_Ltag (_ bv2 3)))
				
				(= T_state_RS3_op_type (select T_RS_op_type (_ bv3 3)))
				(= T_state_RS3_op (select T_RS_op (_ bv3 3)))
				(= T_state_RS3_ROB_dst (select T_RS_ROB_dst (_ bv3 3)))
				(= T_state_RS3_vj (select T_RS_vj (_ bv3 3)))
				(= T_state_RS3_vk (select T_RS_vk (_ bv3 3)))
				(= T_state_RS3_qj (select T_RS_qj (_ bv3 3)))
				(= T_state_RS3_qk (select T_RS_qk (_ bv3 3)))
				(= T_state_RS3_imm (select T_RS_imm (_ bv3 3)))
				(= T_state_RS3_dis (select T_RS_dis (_ bv3 3)))
				(= T_state_RS3_busy (select T_RS_busy (_ bv3 3)))
				(= T_state_RS3_Ltag (select T_RS_Ltag (_ bv3 3)))
				
				(= T_state_RS4_op_type (select T_RS_op_type (_ bv4 3)))
				(= T_state_RS4_op (select T_RS_op (_ bv4 3)))
				(= T_state_RS4_ROB_dst (select T_RS_ROB_dst (_ bv4 3)))
				(= T_state_RS4_vj (select T_RS_vj (_ bv4 3)))
				(= T_state_RS4_vk (select T_RS_vk (_ bv4 3)))
				(= T_state_RS4_qj (select T_RS_qj (_ bv4 3)))
				(= T_state_RS4_qk (select T_RS_qk (_ bv4 3)))
				(= T_state_RS4_imm (select T_RS_imm (_ bv4 3)))
				(= T_state_RS4_dis (select T_RS_dis (_ bv4 3)))
				(= T_state_RS4_busy (select T_RS_busy (_ bv4 3)))
				(= T_state_RS4_Ltag (select T_RS_Ltag (_ bv4 3)))
				
				(= T_state_RS5_op_type (select T_RS_op_type (_ bv5 3)))
				(= T_state_RS5_op (select T_RS_op (_ bv5 3)))
				(= T_state_RS5_ROB_dst (select T_RS_ROB_dst (_ bv5 3)))
				(= T_state_RS5_vj (select T_RS_vj (_ bv5 3)))
				(= T_state_RS5_vk (select T_RS_vk (_ bv5 3)))
				(= T_state_RS5_qj (select T_RS_qj (_ bv5 3)))
				(= T_state_RS5_qk (select T_RS_qk (_ bv5 3)))
				(= T_state_RS5_imm (select T_RS_imm (_ bv5 3)))
				(= T_state_RS5_dis (select T_RS_dis (_ bv5 3)))
				(= T_state_RS5_busy (select T_RS_busy (_ bv5 3)))
				(= T_state_RS5_Ltag (select T_RS_Ltag (_ bv5 3)))
				
				(= T_state_RS6_op_type (select T_RS_op_type (_ bv6 3)))
				(= T_state_RS6_op (select T_RS_op (_ bv6 3)))
				(= T_state_RS6_ROB_dst (select T_RS_ROB_dst (_ bv6 3)))
				(= T_state_RS6_vj (select T_RS_vj (_ bv6 3)))
				(= T_state_RS6_vk (select T_RS_vk (_ bv6 3)))
				(= T_state_RS6_qj (select T_RS_qj (_ bv6 3)))
				(= T_state_RS6_qk (select T_RS_qk (_ bv6 3)))
				(= T_state_RS6_imm (select T_RS_imm (_ bv6 3)))
				(= T_state_RS6_dis (select T_RS_dis (_ bv6 3)))
				(= T_state_RS6_busy (select T_RS_busy (_ bv6 3)))
				(= T_state_RS6_Ltag (select T_RS_Ltag (_ bv6 3)))
				
				(= T_state_RS7_op_type (select T_RS_op_type (_ bv7 3)))
				(= T_state_RS7_op (select T_RS_op (_ bv7 3)))
				(= T_state_RS7_ROB_dst (select T_RS_ROB_dst (_ bv7 3)))
				(= T_state_RS7_vj (select T_RS_vj (_ bv7 3)))
				(= T_state_RS7_vk (select T_RS_vk (_ bv7 3)))
				(= T_state_RS7_qj (select T_RS_qj (_ bv7 3)))
				(= T_state_RS7_qk (select T_RS_qk (_ bv7 3)))
				(= T_state_RS7_imm (select T_RS_imm (_ bv7 3)))
				(= T_state_RS7_dis (select T_RS_dis (_ bv7 3)))
				(= T_state_RS7_busy (select T_RS_busy (_ bv7 3)))
				(= T_state_RS7_Ltag (select T_RS_Ltag (_ bv7 3)))
				
				(= T_state_LSQ0_op_type (select T_LSQ_op_type (_ bv0 3)))
				(= T_state_LSQ0_op (select T_LSQ_op (_ bv0 3)))
				(= T_state_LSQ0_ROB_dst (select T_LSQ_ROB_dst (_ bv0 3)))
				(= T_state_LSQ0_vj (select T_LSQ_vj (_ bv0 3)))
				(= T_state_LSQ0_vk (select T_LSQ_vk (_ bv0 3)))
				(= T_state_LSQ0_qj (select T_LSQ_qj (_ bv0 3)))
				(= T_state_LSQ0_qk (select T_LSQ_qk (_ bv0 3)))
				(= T_state_LSQ0_imm (select T_LSQ_imm (_ bv0 3)))
				(= T_state_LSQ0_dis (select T_LSQ_dis (_ bv0 3)))
				(= T_state_LSQ0_busy (select T_LSQ_busy (_ bv0 3)))
				(= T_state_LSQ0_Ltag (select T_LSQ_Ltag (_ bv0 3)))
				
				(= T_state_LSQ1_op_type (select T_LSQ_op_type (_ bv1 3)))
				(= T_state_LSQ1_op (select T_LSQ_op (_ bv1 3)))
				(= T_state_LSQ1_ROB_dst (select T_LSQ_ROB_dst (_ bv1 3)))
				(= T_state_LSQ1_vj (select T_LSQ_vj (_ bv1 3)))
				(= T_state_LSQ1_vk (select T_LSQ_vk (_ bv1 3)))
				(= T_state_LSQ1_qj (select T_LSQ_qj (_ bv1 3)))
				(= T_state_LSQ1_qk (select T_LSQ_qk (_ bv1 3)))
				(= T_state_LSQ1_imm (select T_LSQ_imm (_ bv1 3)))
				(= T_state_LSQ1_dis (select T_LSQ_dis (_ bv1 3)))
				(= T_state_LSQ1_busy (select T_LSQ_busy (_ bv1 3)))
				(= T_state_LSQ1_Ltag (select T_LSQ_Ltag (_ bv1 3)))
				
				(= T_state_LSQ2_op_type (select T_LSQ_op_type (_ bv2 3)))
				(= T_state_LSQ2_op (select T_LSQ_op (_ bv2 3)))
				(= T_state_LSQ2_ROB_dst (select T_LSQ_ROB_dst (_ bv2 3)))
				(= T_state_LSQ2_vj (select T_LSQ_vj (_ bv2 3)))
				(= T_state_LSQ2_vk (select T_LSQ_vk (_ bv2 3)))
				(= T_state_LSQ2_qj (select T_LSQ_qj (_ bv2 3)))
				(= T_state_LSQ2_qk (select T_LSQ_qk (_ bv2 3)))
				(= T_state_LSQ2_imm (select T_LSQ_imm (_ bv2 3)))
				(= T_state_LSQ2_dis (select T_LSQ_dis (_ bv2 3)))
				(= T_state_LSQ2_busy (select T_LSQ_busy (_ bv2 3)))
				(= T_state_LSQ2_Ltag (select T_LSQ_Ltag (_ bv2 3)))
				
				(= T_state_LSQ3_op_type (select T_LSQ_op_type (_ bv3 3)))
				(= T_state_LSQ3_op (select T_LSQ_op (_ bv3 3)))
				(= T_state_LSQ3_ROB_dst (select T_LSQ_ROB_dst (_ bv3 3)))
				(= T_state_LSQ3_vj (select T_LSQ_vj (_ bv3 3)))
				(= T_state_LSQ3_vk (select T_LSQ_vk (_ bv3 3)))
				(= T_state_LSQ3_qj (select T_LSQ_qj (_ bv3 3)))
				(= T_state_LSQ3_qk (select T_LSQ_qk (_ bv3 3)))
				(= T_state_LSQ3_imm (select T_LSQ_imm (_ bv3 3)))
				(= T_state_LSQ3_dis (select T_LSQ_dis (_ bv3 3)))
				(= T_state_LSQ3_busy (select T_LSQ_busy (_ bv3 3)))
				(= T_state_LSQ3_Ltag (select T_LSQ_Ltag (_ bv3 3)))
				
				(= T_state_LSQ4_op_type (select T_LSQ_op_type (_ bv4 3)))
				(= T_state_LSQ4_op (select T_LSQ_op (_ bv4 3)))
				(= T_state_LSQ4_ROB_dst (select T_LSQ_ROB_dst (_ bv4 3)))
				(= T_state_LSQ4_vj (select T_LSQ_vj (_ bv4 3)))
				(= T_state_LSQ4_vk (select T_LSQ_vk (_ bv4 3)))
				(= T_state_LSQ4_qj (select T_LSQ_qj (_ bv4 3)))
				(= T_state_LSQ4_qk (select T_LSQ_qk (_ bv4 3)))
				(= T_state_LSQ4_imm (select T_LSQ_imm (_ bv4 3)))
				(= T_state_LSQ4_dis (select T_LSQ_dis (_ bv4 3)))
				(= T_state_LSQ4_busy (select T_LSQ_busy (_ bv4 3)))
				(= T_state_LSQ4_Ltag (select T_LSQ_Ltag (_ bv4 3)))
				
				(= T_state_LSQ5_op_type (select T_LSQ_op_type (_ bv5 3)))
				(= T_state_LSQ5_op (select T_LSQ_op (_ bv5 3)))
				(= T_state_LSQ5_ROB_dst (select T_LSQ_ROB_dst (_ bv5 3)))
				(= T_state_LSQ5_vj (select T_LSQ_vj (_ bv5 3)))
				(= T_state_LSQ5_vk (select T_LSQ_vk (_ bv5 3)))
				(= T_state_LSQ5_qj (select T_LSQ_qj (_ bv5 3)))
				(= T_state_LSQ5_qk (select T_LSQ_qk (_ bv5 3)))
				(= T_state_LSQ5_imm (select T_LSQ_imm (_ bv5 3)))
				(= T_state_LSQ5_dis (select T_LSQ_dis (_ bv5 3)))
				(= T_state_LSQ5_busy (select T_LSQ_busy (_ bv5 3)))
				(= T_state_LSQ5_Ltag (select T_LSQ_Ltag (_ bv5 3)))
				
				(= T_state_LSQ6_op_type (select T_LSQ_op_type (_ bv6 3)))
				(= T_state_LSQ6_op (select T_LSQ_op (_ bv6 3)))
				(= T_state_LSQ6_ROB_dst (select T_LSQ_ROB_dst (_ bv6 3)))
				(= T_state_LSQ6_vj (select T_LSQ_vj (_ bv6 3)))
				(= T_state_LSQ6_vk (select T_LSQ_vk (_ bv6 3)))
				(= T_state_LSQ6_qj (select T_LSQ_qj (_ bv6 3)))
				(= T_state_LSQ6_qk (select T_LSQ_qk (_ bv6 3)))
				(= T_state_LSQ6_imm (select T_LSQ_imm (_ bv6 3)))
				(= T_state_LSQ6_dis (select T_LSQ_dis (_ bv6 3)))
				(= T_state_LSQ6_busy (select T_LSQ_busy (_ bv6 3)))
				(= T_state_LSQ6_Ltag (select T_LSQ_Ltag (_ bv6 3)))
				
				(= T_state_LSQ7_op_type (select T_LSQ_op_type (_ bv7 3)))
				(= T_state_LSQ7_op (select T_LSQ_op (_ bv7 3)))
				(= T_state_LSQ7_ROB_dst (select T_LSQ_ROB_dst (_ bv7 3)))
				(= T_state_LSQ7_vj (select T_LSQ_vj (_ bv7 3)))
				(= T_state_LSQ7_vk (select T_LSQ_vk (_ bv7 3)))
				(= T_state_LSQ7_qj (select T_LSQ_qj (_ bv7 3)))
				(= T_state_LSQ7_qk (select T_LSQ_qk (_ bv7 3)))
				(= T_state_LSQ7_imm (select T_LSQ_imm (_ bv7 3)))
				(= T_state_LSQ7_dis (select T_LSQ_dis (_ bv7 3)))
				(= T_state_LSQ7_busy (select T_LSQ_busy (_ bv7 3)))
				(= T_state_LSQ7_Ltag (select T_LSQ_Ltag (_ bv7 3)))
				
				(= U1_state_Cache0_Tag (select U1_Cache_Tag (_ bv0 2)))
				(= U1_state_Cache1_Tag (select U1_Cache_Tag (_ bv1 2)))
				(= U1_state_Cache2_Tag (select U1_Cache_Tag (_ bv2 2)))
				(= U1_state_Cache3_Tag (select U1_Cache_Tag (_ bv3 2)))
				
				(= U1_state_Cache0_Data (select U1_Cache_Data (_ bv0 2)))
				(= U1_state_Cache1_Data (select U1_Cache_Data (_ bv1 2)))
				(= U1_state_Cache2_Data (select U1_Cache_Data (_ bv2 2)))
				(= U1_state_Cache3_Data (select U1_Cache_Data (_ bv3 2)))
				
				(= U1_state_Cache0_Valid (select U1_Cache_Valid (_ bv0 2)))
				(= U1_state_Cache1_Valid (select U1_Cache_Valid (_ bv1 2)))
				(= U1_state_Cache2_Valid (select U1_Cache_Valid (_ bv2 2)))
				(= U1_state_Cache3_Valid (select U1_Cache_Valid (_ bv3 2)))
				
				(= U1_state_IP U1_IP)
				(= U1_state_CP U1_CP)
				(= U1_state_PC U1_PC)
				(= U1_state_Main_Ltag U1_Main_Ltag)
				
				(= U1_state_ROB0_busy (select U1_ROB_busy (_ bv0 6)))
				(= U1_state_ROB0_op_type (select U1_ROB_op_type (_ bv0 6)))
				(= U1_state_ROB0_destination (select U1_ROB_destination (_ bv0 6)))
				(= U1_state_ROB0_result (select U1_ROB_result (_ bv0 6)))
				(= U1_state_ROB0_exception (select U1_ROB_exception (_ bv0 6)))
				(= U1_state_ROB0_done (select U1_ROB_done (_ bv0 6)))
				
				(= U1_state_ROB1_busy (select U1_ROB_busy (_ bv1 6)))
				(= U1_state_ROB1_op_type (select U1_ROB_op_type (_ bv1 6)))
				(= U1_state_ROB1_destination (select U1_ROB_destination (_ bv1 6)))
				(= U1_state_ROB1_result (select U1_ROB_result (_ bv1 6)))
				(= U1_state_ROB1_exception (select U1_ROB_exception (_ bv1 6)))
				(= U1_state_ROB1_done (select U1_ROB_done (_ bv1 6)))
				
				(= U1_state_ROB2_busy (select U1_ROB_busy (_ bv2 6)))
				(= U1_state_ROB2_op_type (select U1_ROB_op_type (_ bv2 6)))
				(= U1_state_ROB2_destination (select U1_ROB_destination (_ bv2 6)))
				(= U1_state_ROB2_result (select U1_ROB_result (_ bv2 6)))
				(= U1_state_ROB2_exception (select U1_ROB_exception (_ bv2 6)))
				(= U1_state_ROB2_done (select U1_ROB_done (_ bv2 6)))
				
				(= U1_state_ROB3_busy (select U1_ROB_busy (_ bv3 6)))
				(= U1_state_ROB3_op_type (select U1_ROB_op_type (_ bv3 6)))
				(= U1_state_ROB3_destination (select U1_ROB_destination (_ bv3 6)))
				(= U1_state_ROB3_result (select U1_ROB_result (_ bv3 6)))
				(= U1_state_ROB3_exception (select U1_ROB_exception (_ bv3 6)))
				(= U1_state_ROB3_done (select U1_ROB_done (_ bv3 6)))
				
				(= U1_state_ROB4_busy (select U1_ROB_busy (_ bv4 6)))
				(= U1_state_ROB4_op_type (select U1_ROB_op_type (_ bv4 6)))
				(= U1_state_ROB4_destination (select U1_ROB_destination (_ bv4 6)))
				(= U1_state_ROB4_result (select U1_ROB_result (_ bv4 6)))
				(= U1_state_ROB4_exception (select U1_ROB_exception (_ bv4 6)))
				(= U1_state_ROB4_done (select U1_ROB_done (_ bv4 6)))
				
				(= U1_state_ROB5_busy (select U1_ROB_busy (_ bv5 6)))
				(= U1_state_ROB5_op_type (select U1_ROB_op_type (_ bv5 6)))
				(= U1_state_ROB5_destination (select U1_ROB_destination (_ bv5 6)))
				(= U1_state_ROB5_result (select U1_ROB_result (_ bv5 6)))
				(= U1_state_ROB5_exception (select U1_ROB_exception (_ bv5 6)))
				(= U1_state_ROB5_done (select U1_ROB_done (_ bv5 6)))
				
				(= U1_state_ROB6_busy (select U1_ROB_busy (_ bv6 6)))
				(= U1_state_ROB6_op_type (select U1_ROB_op_type (_ bv6 6)))
				(= U1_state_ROB6_destination (select U1_ROB_destination (_ bv6 6)))
				(= U1_state_ROB6_result (select U1_ROB_result (_ bv6 6)))
				(= U1_state_ROB6_exception (select U1_ROB_exception (_ bv6 6)))
				(= U1_state_ROB6_done (select U1_ROB_done (_ bv6 6)))
				
				(= U1_state_ROB7_busy (select U1_ROB_busy (_ bv7 6)))
				(= U1_state_ROB7_op_type (select U1_ROB_op_type (_ bv7 6)))
				(= U1_state_ROB7_destination (select U1_ROB_destination (_ bv7 6)))
				(= U1_state_ROB7_result (select U1_ROB_result (_ bv7 6)))
				(= U1_state_ROB7_exception (select U1_ROB_exception (_ bv7 6)))
				(= U1_state_ROB7_done (select U1_ROB_done (_ bv7 6)))
				
				(= U1_state_RS0_op_type (select U1_RS_op_type (_ bv0 3)))
				(= U1_state_RS0_op (select U1_RS_op (_ bv0 3)))
				(= U1_state_RS0_ROB_dst (select U1_RS_ROB_dst (_ bv0 3)))
				(= U1_state_RS0_vj (select U1_RS_vj (_ bv0 3)))
				(= U1_state_RS0_vk (select U1_RS_vk (_ bv0 3)))
				(= U1_state_RS0_qj (select U1_RS_qj (_ bv0 3)))
				(= U1_state_RS0_qk (select U1_RS_qk (_ bv0 3)))
				(= U1_state_RS0_imm (select U1_RS_imm (_ bv0 3)))
				(= U1_state_RS0_dis (select U1_RS_dis (_ bv0 3)))
				(= U1_state_RS0_busy (select U1_RS_busy (_ bv0 3)))
				(= U1_state_RS0_Ltag (select U1_RS_Ltag (_ bv0 3)))
				
				(= U1_state_RS1_op_type (select U1_RS_op_type (_ bv1 3)))
				(= U1_state_RS1_op (select U1_RS_op (_ bv1 3)))
				(= U1_state_RS1_ROB_dst (select U1_RS_ROB_dst (_ bv1 3)))
				(= U1_state_RS1_vj (select U1_RS_vj (_ bv1 3)))
				(= U1_state_RS1_vk (select U1_RS_vk (_ bv1 3)))
				(= U1_state_RS1_qj (select U1_RS_qj (_ bv1 3)))
				(= U1_state_RS1_qk (select U1_RS_qk (_ bv1 3)))
				(= U1_state_RS1_imm (select U1_RS_imm (_ bv1 3)))
				(= U1_state_RS1_dis (select U1_RS_dis (_ bv1 3)))
				(= U1_state_RS1_busy (select U1_RS_busy (_ bv1 3)))
				(= U1_state_RS1_Ltag (select U1_RS_Ltag (_ bv1 3)))
				
				(= U1_state_RS2_op_type (select U1_RS_op_type (_ bv2 3)))
				(= U1_state_RS2_op (select U1_RS_op (_ bv2 3)))
				(= U1_state_RS2_ROB_dst (select U1_RS_ROB_dst (_ bv2 3)))
				(= U1_state_RS2_vj (select U1_RS_vj (_ bv2 3)))
				(= U1_state_RS2_vk (select U1_RS_vk (_ bv2 3)))
				(= U1_state_RS2_qj (select U1_RS_qj (_ bv2 3)))
				(= U1_state_RS2_qk (select U1_RS_qk (_ bv2 3)))
				(= U1_state_RS2_imm (select U1_RS_imm (_ bv2 3)))
				(= U1_state_RS2_dis (select U1_RS_dis (_ bv2 3)))
				(= U1_state_RS2_busy (select U1_RS_busy (_ bv2 3)))
				(= U1_state_RS2_Ltag (select U1_RS_Ltag (_ bv2 3)))
				
				(= U1_state_RS3_op_type (select U1_RS_op_type (_ bv3 3)))
				(= U1_state_RS3_op (select U1_RS_op (_ bv3 3)))
				(= U1_state_RS3_ROB_dst (select U1_RS_ROB_dst (_ bv3 3)))
				(= U1_state_RS3_vj (select U1_RS_vj (_ bv3 3)))
				(= U1_state_RS3_vk (select U1_RS_vk (_ bv3 3)))
				(= U1_state_RS3_qj (select U1_RS_qj (_ bv3 3)))
				(= U1_state_RS3_qk (select U1_RS_qk (_ bv3 3)))
				(= U1_state_RS3_imm (select U1_RS_imm (_ bv3 3)))
				(= U1_state_RS3_dis (select U1_RS_dis (_ bv3 3)))
				(= U1_state_RS3_busy (select U1_RS_busy (_ bv3 3)))
				(= U1_state_RS3_Ltag (select U1_RS_Ltag (_ bv3 3)))
				
				(= U1_state_RS4_op_type (select U1_RS_op_type (_ bv4 3)))
				(= U1_state_RS4_op (select U1_RS_op (_ bv4 3)))
				(= U1_state_RS4_ROB_dst (select U1_RS_ROB_dst (_ bv4 3)))
				(= U1_state_RS4_vj (select U1_RS_vj (_ bv4 3)))
				(= U1_state_RS4_vk (select U1_RS_vk (_ bv4 3)))
				(= U1_state_RS4_qj (select U1_RS_qj (_ bv4 3)))
				(= U1_state_RS4_qk (select U1_RS_qk (_ bv4 3)))
				(= U1_state_RS4_imm (select U1_RS_imm (_ bv4 3)))
				(= U1_state_RS4_dis (select U1_RS_dis (_ bv4 3)))
				(= U1_state_RS4_busy (select U1_RS_busy (_ bv4 3)))
				(= U1_state_RS4_Ltag (select U1_RS_Ltag (_ bv4 3)))
				
				(= U1_state_RS5_op_type (select U1_RS_op_type (_ bv5 3)))
				(= U1_state_RS5_op (select U1_RS_op (_ bv5 3)))
				(= U1_state_RS5_ROB_dst (select U1_RS_ROB_dst (_ bv5 3)))
				(= U1_state_RS5_vj (select U1_RS_vj (_ bv5 3)))
				(= U1_state_RS5_vk (select U1_RS_vk (_ bv5 3)))
				(= U1_state_RS5_qj (select U1_RS_qj (_ bv5 3)))
				(= U1_state_RS5_qk (select U1_RS_qk (_ bv5 3)))
				(= U1_state_RS5_imm (select U1_RS_imm (_ bv5 3)))
				(= U1_state_RS5_dis (select U1_RS_dis (_ bv5 3)))
				(= U1_state_RS5_busy (select U1_RS_busy (_ bv5 3)))
				(= U1_state_RS5_Ltag (select U1_RS_Ltag (_ bv5 3)))
				
				(= U1_state_RS6_op_type (select U1_RS_op_type (_ bv6 3)))
				(= U1_state_RS6_op (select U1_RS_op (_ bv6 3)))
				(= U1_state_RS6_ROB_dst (select U1_RS_ROB_dst (_ bv6 3)))
				(= U1_state_RS6_vj (select U1_RS_vj (_ bv6 3)))
				(= U1_state_RS6_vk (select U1_RS_vk (_ bv6 3)))
				(= U1_state_RS6_qj (select U1_RS_qj (_ bv6 3)))
				(= U1_state_RS6_qk (select U1_RS_qk (_ bv6 3)))
				(= U1_state_RS6_imm (select U1_RS_imm (_ bv6 3)))
				(= U1_state_RS6_dis (select U1_RS_dis (_ bv6 3)))
				(= U1_state_RS6_busy (select U1_RS_busy (_ bv6 3)))
				(= U1_state_RS6_Ltag (select U1_RS_Ltag (_ bv6 3)))
				
				(= U1_state_RS7_op_type (select U1_RS_op_type (_ bv7 3)))
				(= U1_state_RS7_op (select U1_RS_op (_ bv7 3)))
				(= U1_state_RS7_ROB_dst (select U1_RS_ROB_dst (_ bv7 3)))
				(= U1_state_RS7_vj (select U1_RS_vj (_ bv7 3)))
				(= U1_state_RS7_vk (select U1_RS_vk (_ bv7 3)))
				(= U1_state_RS7_qj (select U1_RS_qj (_ bv7 3)))
				(= U1_state_RS7_qk (select U1_RS_qk (_ bv7 3)))
				(= U1_state_RS7_imm (select U1_RS_imm (_ bv7 3)))
				(= U1_state_RS7_dis (select U1_RS_dis (_ bv7 3)))
				(= U1_state_RS7_busy (select U1_RS_busy (_ bv7 3)))
				(= U1_state_RS7_Ltag (select U1_RS_Ltag (_ bv7 3)))
				
				(= U1_state_LSQ0_op_type (select U1_LSQ_op_type (_ bv0 3)))
				(= U1_state_LSQ0_op (select U1_LSQ_op (_ bv0 3)))
				(= U1_state_LSQ0_ROB_dst (select U1_LSQ_ROB_dst (_ bv0 3)))
				(= U1_state_LSQ0_vj (select U1_LSQ_vj (_ bv0 3)))
				(= U1_state_LSQ0_vk (select U1_LSQ_vk (_ bv0 3)))
				(= U1_state_LSQ0_qj (select U1_LSQ_qj (_ bv0 3)))
				(= U1_state_LSQ0_qk (select U1_LSQ_qk (_ bv0 3)))
				(= U1_state_LSQ0_imm (select U1_LSQ_imm (_ bv0 3)))
				(= U1_state_LSQ0_dis (select U1_LSQ_dis (_ bv0 3)))
				(= U1_state_LSQ0_busy (select U1_LSQ_busy (_ bv0 3)))
				(= U1_state_LSQ0_Ltag (select U1_LSQ_Ltag (_ bv0 3)))
				
				(= U1_state_LSQ1_op_type (select U1_LSQ_op_type (_ bv1 3)))
				(= U1_state_LSQ1_op (select U1_LSQ_op (_ bv1 3)))
				(= U1_state_LSQ1_ROB_dst (select U1_LSQ_ROB_dst (_ bv1 3)))
				(= U1_state_LSQ1_vj (select U1_LSQ_vj (_ bv1 3)))
				(= U1_state_LSQ1_vk (select U1_LSQ_vk (_ bv1 3)))
				(= U1_state_LSQ1_qj (select U1_LSQ_qj (_ bv1 3)))
				(= U1_state_LSQ1_qk (select U1_LSQ_qk (_ bv1 3)))
				(= U1_state_LSQ1_imm (select U1_LSQ_imm (_ bv1 3)))
				(= U1_state_LSQ1_dis (select U1_LSQ_dis (_ bv1 3)))
				(= U1_state_LSQ1_busy (select U1_LSQ_busy (_ bv1 3)))
				(= U1_state_LSQ1_Ltag (select U1_LSQ_Ltag (_ bv1 3)))
				
				(= U1_state_LSQ2_op_type (select U1_LSQ_op_type (_ bv2 3)))
				(= U1_state_LSQ2_op (select U1_LSQ_op (_ bv2 3)))
				(= U1_state_LSQ2_ROB_dst (select U1_LSQ_ROB_dst (_ bv2 3)))
				(= U1_state_LSQ2_vj (select U1_LSQ_vj (_ bv2 3)))
				(= U1_state_LSQ2_vk (select U1_LSQ_vk (_ bv2 3)))
				(= U1_state_LSQ2_qj (select U1_LSQ_qj (_ bv2 3)))
				(= U1_state_LSQ2_qk (select U1_LSQ_qk (_ bv2 3)))
				(= U1_state_LSQ2_imm (select U1_LSQ_imm (_ bv2 3)))
				(= U1_state_LSQ2_dis (select U1_LSQ_dis (_ bv2 3)))
				(= U1_state_LSQ2_busy (select U1_LSQ_busy (_ bv2 3)))
				(= U1_state_LSQ2_Ltag (select U1_LSQ_Ltag (_ bv2 3)))
				
				(= U1_state_LSQ3_op_type (select U1_LSQ_op_type (_ bv3 3)))
				(= U1_state_LSQ3_op (select U1_LSQ_op (_ bv3 3)))
				(= U1_state_LSQ3_ROB_dst (select U1_LSQ_ROB_dst (_ bv3 3)))
				(= U1_state_LSQ3_vj (select U1_LSQ_vj (_ bv3 3)))
				(= U1_state_LSQ3_vk (select U1_LSQ_vk (_ bv3 3)))
				(= U1_state_LSQ3_qj (select U1_LSQ_qj (_ bv3 3)))
				(= U1_state_LSQ3_qk (select U1_LSQ_qk (_ bv3 3)))
				(= U1_state_LSQ3_imm (select U1_LSQ_imm (_ bv3 3)))
				(= U1_state_LSQ3_dis (select U1_LSQ_dis (_ bv3 3)))
				(= U1_state_LSQ3_busy (select U1_LSQ_busy (_ bv3 3)))
				(= U1_state_LSQ3_Ltag (select U1_LSQ_Ltag (_ bv3 3)))
				
				(= U1_state_LSQ4_op_type (select U1_LSQ_op_type (_ bv4 3)))
				(= U1_state_LSQ4_op (select U1_LSQ_op (_ bv4 3)))
				(= U1_state_LSQ4_ROB_dst (select U1_LSQ_ROB_dst (_ bv4 3)))
				(= U1_state_LSQ4_vj (select U1_LSQ_vj (_ bv4 3)))
				(= U1_state_LSQ4_vk (select U1_LSQ_vk (_ bv4 3)))
				(= U1_state_LSQ4_qj (select U1_LSQ_qj (_ bv4 3)))
				(= U1_state_LSQ4_qk (select U1_LSQ_qk (_ bv4 3)))
				(= U1_state_LSQ4_imm (select U1_LSQ_imm (_ bv4 3)))
				(= U1_state_LSQ4_dis (select U1_LSQ_dis (_ bv4 3)))
				(= U1_state_LSQ4_busy (select U1_LSQ_busy (_ bv4 3)))
				(= U1_state_LSQ4_Ltag (select U1_LSQ_Ltag (_ bv4 3)))
				
				(= U1_state_LSQ5_op_type (select U1_LSQ_op_type (_ bv5 3)))
				(= U1_state_LSQ5_op (select U1_LSQ_op (_ bv5 3)))
				(= U1_state_LSQ5_ROB_dst (select U1_LSQ_ROB_dst (_ bv5 3)))
				(= U1_state_LSQ5_vj (select U1_LSQ_vj (_ bv5 3)))
				(= U1_state_LSQ5_vk (select U1_LSQ_vk (_ bv5 3)))
				(= U1_state_LSQ5_qj (select U1_LSQ_qj (_ bv5 3)))
				(= U1_state_LSQ5_qk (select U1_LSQ_qk (_ bv5 3)))
				(= U1_state_LSQ5_imm (select U1_LSQ_imm (_ bv5 3)))
				(= U1_state_LSQ5_dis (select U1_LSQ_dis (_ bv5 3)))
				(= U1_state_LSQ5_busy (select U1_LSQ_busy (_ bv5 3)))
				(= U1_state_LSQ5_Ltag (select U1_LSQ_Ltag (_ bv5 3)))
				
				(= U1_state_LSQ6_op_type (select U1_LSQ_op_type (_ bv6 3)))
				(= U1_state_LSQ6_op (select U1_LSQ_op (_ bv6 3)))
				(= U1_state_LSQ6_ROB_dst (select U1_LSQ_ROB_dst (_ bv6 3)))
				(= U1_state_LSQ6_vj (select U1_LSQ_vj (_ bv6 3)))
				(= U1_state_LSQ6_vk (select U1_LSQ_vk (_ bv6 3)))
				(= U1_state_LSQ6_qj (select U1_LSQ_qj (_ bv6 3)))
				(= U1_state_LSQ6_qk (select U1_LSQ_qk (_ bv6 3)))
				(= U1_state_LSQ6_imm (select U1_LSQ_imm (_ bv6 3)))
				(= U1_state_LSQ6_dis (select U1_LSQ_dis (_ bv6 3)))
				(= U1_state_LSQ6_busy (select U1_LSQ_busy (_ bv6 3)))
				(= U1_state_LSQ6_Ltag (select U1_LSQ_Ltag (_ bv6 3)))
				
				(= U1_state_LSQ7_op_type (select U1_LSQ_op_type (_ bv7 3)))
				(= U1_state_LSQ7_op (select U1_LSQ_op (_ bv7 3)))
				(= U1_state_LSQ7_ROB_dst (select U1_LSQ_ROB_dst (_ bv7 3)))
				(= U1_state_LSQ7_vj (select U1_LSQ_vj (_ bv7 3)))
				(= U1_state_LSQ7_vk (select U1_LSQ_vk (_ bv7 3)))
				(= U1_state_LSQ7_qj (select U1_LSQ_qj (_ bv7 3)))
				(= U1_state_LSQ7_qk (select U1_LSQ_qk (_ bv7 3)))
				(= U1_state_LSQ7_imm (select U1_LSQ_imm (_ bv7 3)))
				(= U1_state_LSQ7_dis (select U1_LSQ_dis (_ bv7 3)))
				(= U1_state_LSQ7_busy (select U1_LSQ_busy (_ bv7 3)))
				(= U1_state_LSQ7_Ltag (select U1_LSQ_Ltag (_ bv7 3)))
				
				
				(= U2_state_Cache0_Tag (select U2_Cache_Tag (_ bv0 2)))
				(= U2_state_Cache1_Tag (select U2_Cache_Tag (_ bv1 2)))
				(= U2_state_Cache2_Tag (select U2_Cache_Tag (_ bv2 2)))
				(= U2_state_Cache3_Tag (select U2_Cache_Tag (_ bv3 2)))
				
				(= U2_state_Cache0_Data (select U2_Cache_Data (_ bv0 2)))
				(= U2_state_Cache1_Data (select U2_Cache_Data (_ bv1 2)))
				(= U2_state_Cache2_Data (select U2_Cache_Data (_ bv2 2)))
				(= U2_state_Cache3_Data (select U2_Cache_Data (_ bv3 2)))
				
				(= U2_state_Cache0_Valid (select U2_Cache_Valid (_ bv0 2)))
				(= U2_state_Cache1_Valid (select U2_Cache_Valid (_ bv1 2)))
				(= U2_state_Cache2_Valid (select U2_Cache_Valid (_ bv2 2)))
				(= U2_state_Cache3_Valid (select U2_Cache_Valid (_ bv3 2)))
				
				(= U2_state_IP U2_IP)
				(= U2_state_CP U2_CP)
				(= U2_state_PC U2_PC)
				(= U2_state_Main_Ltag U2_Main_Ltag)
				
				(= U2_state_ROB0_busy (select U2_ROB_busy (_ bv0 6)))
				(= U2_state_ROB0_op_type (select U2_ROB_op_type (_ bv0 6)))
				(= U2_state_ROB0_destination (select U2_ROB_destination (_ bv0 6)))
				(= U2_state_ROB0_result (select U2_ROB_result (_ bv0 6)))
				(= U2_state_ROB0_exception (select U2_ROB_exception (_ bv0 6)))
				(= U2_state_ROB0_done (select U2_ROB_done (_ bv0 6)))
				
				(= U2_state_ROB1_busy (select U2_ROB_busy (_ bv1 6)))
				(= U2_state_ROB1_op_type (select U2_ROB_op_type (_ bv1 6)))
				(= U2_state_ROB1_destination (select U2_ROB_destination (_ bv1 6)))
				(= U2_state_ROB1_result (select U2_ROB_result (_ bv1 6)))
				(= U2_state_ROB1_exception (select U2_ROB_exception (_ bv1 6)))
				(= U2_state_ROB1_done (select U2_ROB_done (_ bv1 6)))
				
				(= U2_state_ROB2_busy (select U2_ROB_busy (_ bv2 6)))
				(= U2_state_ROB2_op_type (select U2_ROB_op_type (_ bv2 6)))
				(= U2_state_ROB2_destination (select U2_ROB_destination (_ bv2 6)))
				(= U2_state_ROB2_result (select U2_ROB_result (_ bv2 6)))
				(= U2_state_ROB2_exception (select U2_ROB_exception (_ bv2 6)))
				(= U2_state_ROB2_done (select U2_ROB_done (_ bv2 6)))
				
				(= U2_state_ROB3_busy (select U2_ROB_busy (_ bv3 6)))
				(= U2_state_ROB3_op_type (select U2_ROB_op_type (_ bv3 6)))
				(= U2_state_ROB3_destination (select U2_ROB_destination (_ bv3 6)))
				(= U2_state_ROB3_result (select U2_ROB_result (_ bv3 6)))
				(= U2_state_ROB3_exception (select U2_ROB_exception (_ bv3 6)))
				(= U2_state_ROB3_done (select U2_ROB_done (_ bv3 6)))
				
				(= U2_state_ROB4_busy (select U2_ROB_busy (_ bv4 6)))
				(= U2_state_ROB4_op_type (select U2_ROB_op_type (_ bv4 6)))
				(= U2_state_ROB4_destination (select U2_ROB_destination (_ bv4 6)))
				(= U2_state_ROB4_result (select U2_ROB_result (_ bv4 6)))
				(= U2_state_ROB4_exception (select U2_ROB_exception (_ bv4 6)))
				(= U2_state_ROB4_done (select U2_ROB_done (_ bv4 6)))
				
				(= U2_state_ROB5_busy (select U2_ROB_busy (_ bv5 6)))
				(= U2_state_ROB5_op_type (select U2_ROB_op_type (_ bv5 6)))
				(= U2_state_ROB5_destination (select U2_ROB_destination (_ bv5 6)))
				(= U2_state_ROB5_result (select U2_ROB_result (_ bv5 6)))
				(= U2_state_ROB5_exception (select U2_ROB_exception (_ bv5 6)))
				(= U2_state_ROB5_done (select U2_ROB_done (_ bv5 6)))
				
				(= U2_state_ROB6_busy (select U2_ROB_busy (_ bv6 6)))
				(= U2_state_ROB6_op_type (select U2_ROB_op_type (_ bv6 6)))
				(= U2_state_ROB6_destination (select U2_ROB_destination (_ bv6 6)))
				(= U2_state_ROB6_result (select U2_ROB_result (_ bv6 6)))
				(= U2_state_ROB6_exception (select U2_ROB_exception (_ bv6 6)))
				(= U2_state_ROB6_done (select U2_ROB_done (_ bv6 6)))
				
				(= U2_state_ROB7_busy (select U2_ROB_busy (_ bv7 6)))
				(= U2_state_ROB7_op_type (select U2_ROB_op_type (_ bv7 6)))
				(= U2_state_ROB7_destination (select U2_ROB_destination (_ bv7 6)))
				(= U2_state_ROB7_result (select U2_ROB_result (_ bv7 6)))
				(= U2_state_ROB7_exception (select U2_ROB_exception (_ bv7 6)))
				(= U2_state_ROB7_done (select U2_ROB_done (_ bv7 6)))
				
				(= U2_state_RS0_op_type (select U2_RS_op_type (_ bv0 3)))
				(= U2_state_RS0_op (select U2_RS_op (_ bv0 3)))
				(= U2_state_RS0_ROB_dst (select U2_RS_ROB_dst (_ bv0 3)))
				(= U2_state_RS0_vj (select U2_RS_vj (_ bv0 3)))
				(= U2_state_RS0_vk (select U2_RS_vk (_ bv0 3)))
				(= U2_state_RS0_qj (select U2_RS_qj (_ bv0 3)))
				(= U2_state_RS0_qk (select U2_RS_qk (_ bv0 3)))
				(= U2_state_RS0_imm (select U2_RS_imm (_ bv0 3)))
				(= U2_state_RS0_dis (select U2_RS_dis (_ bv0 3)))
				(= U2_state_RS0_busy (select U2_RS_busy (_ bv0 3)))
				(= U2_state_RS0_Ltag (select U2_RS_Ltag (_ bv0 3)))
				
				(= U2_state_RS1_op_type (select U2_RS_op_type (_ bv1 3)))
				(= U2_state_RS1_op (select U2_RS_op (_ bv1 3)))
				(= U2_state_RS1_ROB_dst (select U2_RS_ROB_dst (_ bv1 3)))
				(= U2_state_RS1_vj (select U2_RS_vj (_ bv1 3)))
				(= U2_state_RS1_vk (select U2_RS_vk (_ bv1 3)))
				(= U2_state_RS1_qj (select U2_RS_qj (_ bv1 3)))
				(= U2_state_RS1_qk (select U2_RS_qk (_ bv1 3)))
				(= U2_state_RS1_imm (select U2_RS_imm (_ bv1 3)))
				(= U2_state_RS1_dis (select U2_RS_dis (_ bv1 3)))
				(= U2_state_RS1_busy (select U2_RS_busy (_ bv1 3)))
				(= U2_state_RS1_Ltag (select U2_RS_Ltag (_ bv1 3)))
				
				(= U2_state_RS2_op_type (select U2_RS_op_type (_ bv2 3)))
				(= U2_state_RS2_op (select U2_RS_op (_ bv2 3)))
				(= U2_state_RS2_ROB_dst (select U2_RS_ROB_dst (_ bv2 3)))
				(= U2_state_RS2_vj (select U2_RS_vj (_ bv2 3)))
				(= U2_state_RS2_vk (select U2_RS_vk (_ bv2 3)))
				(= U2_state_RS2_qj (select U2_RS_qj (_ bv2 3)))
				(= U2_state_RS2_qk (select U2_RS_qk (_ bv2 3)))
				(= U2_state_RS2_imm (select U2_RS_imm (_ bv2 3)))
				(= U2_state_RS2_dis (select U2_RS_dis (_ bv2 3)))
				(= U2_state_RS2_busy (select U2_RS_busy (_ bv2 3)))
				(= U2_state_RS2_Ltag (select U2_RS_Ltag (_ bv2 3)))
				
				(= U2_state_RS3_op_type (select U2_RS_op_type (_ bv3 3)))
				(= U2_state_RS3_op (select U2_RS_op (_ bv3 3)))
				(= U2_state_RS3_ROB_dst (select U2_RS_ROB_dst (_ bv3 3)))
				(= U2_state_RS3_vj (select U2_RS_vj (_ bv3 3)))
				(= U2_state_RS3_vk (select U2_RS_vk (_ bv3 3)))
				(= U2_state_RS3_qj (select U2_RS_qj (_ bv3 3)))
				(= U2_state_RS3_qk (select U2_RS_qk (_ bv3 3)))
				(= U2_state_RS3_imm (select U2_RS_imm (_ bv3 3)))
				(= U2_state_RS3_dis (select U2_RS_dis (_ bv3 3)))
				(= U2_state_RS3_busy (select U2_RS_busy (_ bv3 3)))
				(= U2_state_RS3_Ltag (select U2_RS_Ltag (_ bv3 3)))
				
				(= U2_state_RS4_op_type (select U2_RS_op_type (_ bv4 3)))
				(= U2_state_RS4_op (select U2_RS_op (_ bv4 3)))
				(= U2_state_RS4_ROB_dst (select U2_RS_ROB_dst (_ bv4 3)))
				(= U2_state_RS4_vj (select U2_RS_vj (_ bv4 3)))
				(= U2_state_RS4_vk (select U2_RS_vk (_ bv4 3)))
				(= U2_state_RS4_qj (select U2_RS_qj (_ bv4 3)))
				(= U2_state_RS4_qk (select U2_RS_qk (_ bv4 3)))
				(= U2_state_RS4_imm (select U2_RS_imm (_ bv4 3)))
				(= U2_state_RS4_dis (select U2_RS_dis (_ bv4 3)))
				(= U2_state_RS4_busy (select U2_RS_busy (_ bv4 3)))
				(= U2_state_RS4_Ltag (select U2_RS_Ltag (_ bv4 3)))
				
				(= U2_state_RS5_op_type (select U2_RS_op_type (_ bv5 3)))
				(= U2_state_RS5_op (select U2_RS_op (_ bv5 3)))
				(= U2_state_RS5_ROB_dst (select U2_RS_ROB_dst (_ bv5 3)))
				(= U2_state_RS5_vj (select U2_RS_vj (_ bv5 3)))
				(= U2_state_RS5_vk (select U2_RS_vk (_ bv5 3)))
				(= U2_state_RS5_qj (select U2_RS_qj (_ bv5 3)))
				(= U2_state_RS5_qk (select U2_RS_qk (_ bv5 3)))
				(= U2_state_RS5_imm (select U2_RS_imm (_ bv5 3)))
				(= U2_state_RS5_dis (select U2_RS_dis (_ bv5 3)))
				(= U2_state_RS5_busy (select U2_RS_busy (_ bv5 3)))
				(= U2_state_RS5_Ltag (select U2_RS_Ltag (_ bv5 3)))
				
				(= U2_state_RS6_op_type (select U2_RS_op_type (_ bv6 3)))
				(= U2_state_RS6_op (select U2_RS_op (_ bv6 3)))
				(= U2_state_RS6_ROB_dst (select U2_RS_ROB_dst (_ bv6 3)))
				(= U2_state_RS6_vj (select U2_RS_vj (_ bv6 3)))
				(= U2_state_RS6_vk (select U2_RS_vk (_ bv6 3)))
				(= U2_state_RS6_qj (select U2_RS_qj (_ bv6 3)))
				(= U2_state_RS6_qk (select U2_RS_qk (_ bv6 3)))
				(= U2_state_RS6_imm (select U2_RS_imm (_ bv6 3)))
				(= U2_state_RS6_dis (select U2_RS_dis (_ bv6 3)))
				(= U2_state_RS6_busy (select U2_RS_busy (_ bv6 3)))
				(= U2_state_RS6_Ltag (select U2_RS_Ltag (_ bv6 3)))
				
				(= U2_state_RS7_op_type (select U2_RS_op_type (_ bv7 3)))
				(= U2_state_RS7_op (select U2_RS_op (_ bv7 3)))
				(= U2_state_RS7_ROB_dst (select U2_RS_ROB_dst (_ bv7 3)))
				(= U2_state_RS7_vj (select U2_RS_vj (_ bv7 3)))
				(= U2_state_RS7_vk (select U2_RS_vk (_ bv7 3)))
				(= U2_state_RS7_qj (select U2_RS_qj (_ bv7 3)))
				(= U2_state_RS7_qk (select U2_RS_qk (_ bv7 3)))
				(= U2_state_RS7_imm (select U2_RS_imm (_ bv7 3)))
				(= U2_state_RS7_dis (select U2_RS_dis (_ bv7 3)))
				(= U2_state_RS7_busy (select U2_RS_busy (_ bv7 3)))
				(= U2_state_RS7_Ltag (select U2_RS_Ltag (_ bv7 3)))
				
				(= U2_state_LSQ0_op_type (select U2_LSQ_op_type (_ bv0 3)))
				(= U2_state_LSQ0_op (select U2_LSQ_op (_ bv0 3)))
				(= U2_state_LSQ0_ROB_dst (select U2_LSQ_ROB_dst (_ bv0 3)))
				(= U2_state_LSQ0_vj (select U2_LSQ_vj (_ bv0 3)))
				(= U2_state_LSQ0_vk (select U2_LSQ_vk (_ bv0 3)))
				(= U2_state_LSQ0_qj (select U2_LSQ_qj (_ bv0 3)))
				(= U2_state_LSQ0_qk (select U2_LSQ_qk (_ bv0 3)))
				(= U2_state_LSQ0_imm (select U2_LSQ_imm (_ bv0 3)))
				(= U2_state_LSQ0_dis (select U2_LSQ_dis (_ bv0 3)))
				(= U2_state_LSQ0_busy (select U2_LSQ_busy (_ bv0 3)))
				(= U2_state_LSQ0_Ltag (select U2_LSQ_Ltag (_ bv0 3)))
				
				(= U2_state_LSQ1_op_type (select U2_LSQ_op_type (_ bv1 3)))
				(= U2_state_LSQ1_op (select U2_LSQ_op (_ bv1 3)))
				(= U2_state_LSQ1_ROB_dst (select U2_LSQ_ROB_dst (_ bv1 3)))
				(= U2_state_LSQ1_vj (select U2_LSQ_vj (_ bv1 3)))
				(= U2_state_LSQ1_vk (select U2_LSQ_vk (_ bv1 3)))
				(= U2_state_LSQ1_qj (select U2_LSQ_qj (_ bv1 3)))
				(= U2_state_LSQ1_qk (select U2_LSQ_qk (_ bv1 3)))
				(= U2_state_LSQ1_imm (select U2_LSQ_imm (_ bv1 3)))
				(= U2_state_LSQ1_dis (select U2_LSQ_dis (_ bv1 3)))
				(= U2_state_LSQ1_busy (select U2_LSQ_busy (_ bv1 3)))
				(= U2_state_LSQ1_Ltag (select U2_LSQ_Ltag (_ bv1 3)))
				
				(= U2_state_LSQ2_op_type (select U2_LSQ_op_type (_ bv2 3)))
				(= U2_state_LSQ2_op (select U2_LSQ_op (_ bv2 3)))
				(= U2_state_LSQ2_ROB_dst (select U2_LSQ_ROB_dst (_ bv2 3)))
				(= U2_state_LSQ2_vj (select U2_LSQ_vj (_ bv2 3)))
				(= U2_state_LSQ2_vk (select U2_LSQ_vk (_ bv2 3)))
				(= U2_state_LSQ2_qj (select U2_LSQ_qj (_ bv2 3)))
				(= U2_state_LSQ2_qk (select U2_LSQ_qk (_ bv2 3)))
				(= U2_state_LSQ2_imm (select U2_LSQ_imm (_ bv2 3)))
				(= U2_state_LSQ2_dis (select U2_LSQ_dis (_ bv2 3)))
				(= U2_state_LSQ2_busy (select U2_LSQ_busy (_ bv2 3)))
				(= U2_state_LSQ2_Ltag (select U2_LSQ_Ltag (_ bv2 3)))
				
				(= U2_state_LSQ3_op_type (select U2_LSQ_op_type (_ bv3 3)))
				(= U2_state_LSQ3_op (select U2_LSQ_op (_ bv3 3)))
				(= U2_state_LSQ3_ROB_dst (select U2_LSQ_ROB_dst (_ bv3 3)))
				(= U2_state_LSQ3_vj (select U2_LSQ_vj (_ bv3 3)))
				(= U2_state_LSQ3_vk (select U2_LSQ_vk (_ bv3 3)))
				(= U2_state_LSQ3_qj (select U2_LSQ_qj (_ bv3 3)))
				(= U2_state_LSQ3_qk (select U2_LSQ_qk (_ bv3 3)))
				(= U2_state_LSQ3_imm (select U2_LSQ_imm (_ bv3 3)))
				(= U2_state_LSQ3_dis (select U2_LSQ_dis (_ bv3 3)))
				(= U2_state_LSQ3_busy (select U2_LSQ_busy (_ bv3 3)))
				(= U2_state_LSQ3_Ltag (select U2_LSQ_Ltag (_ bv3 3)))
				
				(= U2_state_LSQ4_op_type (select U2_LSQ_op_type (_ bv4 3)))
				(= U2_state_LSQ4_op (select U2_LSQ_op (_ bv4 3)))
				(= U2_state_LSQ4_ROB_dst (select U2_LSQ_ROB_dst (_ bv4 3)))
				(= U2_state_LSQ4_vj (select U2_LSQ_vj (_ bv4 3)))
				(= U2_state_LSQ4_vk (select U2_LSQ_vk (_ bv4 3)))
				(= U2_state_LSQ4_qj (select U2_LSQ_qj (_ bv4 3)))
				(= U2_state_LSQ4_qk (select U2_LSQ_qk (_ bv4 3)))
				(= U2_state_LSQ4_imm (select U2_LSQ_imm (_ bv4 3)))
				(= U2_state_LSQ4_dis (select U2_LSQ_dis (_ bv4 3)))
				(= U2_state_LSQ4_busy (select U2_LSQ_busy (_ bv4 3)))
				(= U2_state_LSQ4_Ltag (select U2_LSQ_Ltag (_ bv4 3)))
				
				(= U2_state_LSQ5_op_type (select U2_LSQ_op_type (_ bv5 3)))
				(= U2_state_LSQ5_op (select U2_LSQ_op (_ bv5 3)))
				(= U2_state_LSQ5_ROB_dst (select U2_LSQ_ROB_dst (_ bv5 3)))
				(= U2_state_LSQ5_vj (select U2_LSQ_vj (_ bv5 3)))
				(= U2_state_LSQ5_vk (select U2_LSQ_vk (_ bv5 3)))
				(= U2_state_LSQ5_qj (select U2_LSQ_qj (_ bv5 3)))
				(= U2_state_LSQ5_qk (select U2_LSQ_qk (_ bv5 3)))
				(= U2_state_LSQ5_imm (select U2_LSQ_imm (_ bv5 3)))
				(= U2_state_LSQ5_dis (select U2_LSQ_dis (_ bv5 3)))
				(= U2_state_LSQ5_busy (select U2_LSQ_busy (_ bv5 3)))
				(= U2_state_LSQ5_Ltag (select U2_LSQ_Ltag (_ bv5 3)))
				
				(= U2_state_LSQ6_op_type (select U2_LSQ_op_type (_ bv6 3)))
				(= U2_state_LSQ6_op (select U2_LSQ_op (_ bv6 3)))
				(= U2_state_LSQ6_ROB_dst (select U2_LSQ_ROB_dst (_ bv6 3)))
				(= U2_state_LSQ6_vj (select U2_LSQ_vj (_ bv6 3)))
				(= U2_state_LSQ6_vk (select U2_LSQ_vk (_ bv6 3)))
				(= U2_state_LSQ6_qj (select U2_LSQ_qj (_ bv6 3)))
				(= U2_state_LSQ6_qk (select U2_LSQ_qk (_ bv6 3)))
				(= U2_state_LSQ6_imm (select U2_LSQ_imm (_ bv6 3)))
				(= U2_state_LSQ6_dis (select U2_LSQ_dis (_ bv6 3)))
				(= U2_state_LSQ6_busy (select U2_LSQ_busy (_ bv6 3)))
				(= U2_state_LSQ6_Ltag (select U2_LSQ_Ltag (_ bv6 3)))
				
				(= U2_state_LSQ7_op_type (select U2_LSQ_op_type (_ bv7 3)))
				(= U2_state_LSQ7_op (select U2_LSQ_op (_ bv7 3)))
				(= U2_state_LSQ7_ROB_dst (select U2_LSQ_ROB_dst (_ bv7 3)))
				(= U2_state_LSQ7_vj (select U2_LSQ_vj (_ bv7 3)))
				(= U2_state_LSQ7_vk (select U2_LSQ_vk (_ bv7 3)))
				(= U2_state_LSQ7_qj (select U2_LSQ_qj (_ bv7 3)))
				(= U2_state_LSQ7_qk (select U2_LSQ_qk (_ bv7 3)))
				(= U2_state_LSQ7_imm (select U2_LSQ_imm (_ bv7 3)))
				(= U2_state_LSQ7_dis (select U2_LSQ_dis (_ bv7 3)))
				(= U2_state_LSQ7_busy (select U2_LSQ_busy (_ bv7 3)))
				(= U2_state_LSQ7_Ltag (select U2_LSQ_Ltag (_ bv7 3)))
				
				
				(= U3_state_Cache0_Tag (select U3_Cache_Tag (_ bv0 2)))
				(= U3_state_Cache1_Tag (select U3_Cache_Tag (_ bv1 2)))
				(= U3_state_Cache2_Tag (select U3_Cache_Tag (_ bv2 2)))
				(= U3_state_Cache3_Tag (select U3_Cache_Tag (_ bv3 2)))
				
				(= U3_state_Cache0_Data (select U3_Cache_Data (_ bv0 2)))
				(= U3_state_Cache1_Data (select U3_Cache_Data (_ bv1 2)))
				(= U3_state_Cache2_Data (select U3_Cache_Data (_ bv2 2)))
				(= U3_state_Cache3_Data (select U3_Cache_Data (_ bv3 2)))
				
				(= U3_state_Cache0_Valid (select U3_Cache_Valid (_ bv0 2)))
				(= U3_state_Cache1_Valid (select U3_Cache_Valid (_ bv1 2)))
				(= U3_state_Cache2_Valid (select U3_Cache_Valid (_ bv2 2)))
				(= U3_state_Cache3_Valid (select U3_Cache_Valid (_ bv3 2)))
				
				(= U3_state_IP U3_IP)
				(= U3_state_CP U3_CP)
				(= U3_state_PC U3_PC)
				(= U3_state_Main_Ltag U3_Main_Ltag)
				
				(= U3_state_ROB0_busy (select U3_ROB_busy (_ bv0 6)))
				(= U3_state_ROB0_op_type (select U3_ROB_op_type (_ bv0 6)))
				(= U3_state_ROB0_destination (select U3_ROB_destination (_ bv0 6)))
				(= U3_state_ROB0_result (select U3_ROB_result (_ bv0 6)))
				(= U3_state_ROB0_exception (select U3_ROB_exception (_ bv0 6)))
				(= U3_state_ROB0_done (select U3_ROB_done (_ bv0 6)))
				
				(= U3_state_ROB1_busy (select U3_ROB_busy (_ bv1 6)))
				(= U3_state_ROB1_op_type (select U3_ROB_op_type (_ bv1 6)))
				(= U3_state_ROB1_destination (select U3_ROB_destination (_ bv1 6)))
				(= U3_state_ROB1_result (select U3_ROB_result (_ bv1 6)))
				(= U3_state_ROB1_exception (select U3_ROB_exception (_ bv1 6)))
				(= U3_state_ROB1_done (select U3_ROB_done (_ bv1 6)))
				
				(= U3_state_ROB2_busy (select U3_ROB_busy (_ bv2 6)))
				(= U3_state_ROB2_op_type (select U3_ROB_op_type (_ bv2 6)))
				(= U3_state_ROB2_destination (select U3_ROB_destination (_ bv2 6)))
				(= U3_state_ROB2_result (select U3_ROB_result (_ bv2 6)))
				(= U3_state_ROB2_exception (select U3_ROB_exception (_ bv2 6)))
				(= U3_state_ROB2_done (select U3_ROB_done (_ bv2 6)))
				
				(= U3_state_ROB3_busy (select U3_ROB_busy (_ bv3 6)))
				(= U3_state_ROB3_op_type (select U3_ROB_op_type (_ bv3 6)))
				(= U3_state_ROB3_destination (select U3_ROB_destination (_ bv3 6)))
				(= U3_state_ROB3_result (select U3_ROB_result (_ bv3 6)))
				(= U3_state_ROB3_exception (select U3_ROB_exception (_ bv3 6)))
				(= U3_state_ROB3_done (select U3_ROB_done (_ bv3 6)))
				
				(= U3_state_ROB4_busy (select U3_ROB_busy (_ bv4 6)))
				(= U3_state_ROB4_op_type (select U3_ROB_op_type (_ bv4 6)))
				(= U3_state_ROB4_destination (select U3_ROB_destination (_ bv4 6)))
				(= U3_state_ROB4_result (select U3_ROB_result (_ bv4 6)))
				(= U3_state_ROB4_exception (select U3_ROB_exception (_ bv4 6)))
				(= U3_state_ROB4_done (select U3_ROB_done (_ bv4 6)))
				
				(= U3_state_ROB5_busy (select U3_ROB_busy (_ bv5 6)))
				(= U3_state_ROB5_op_type (select U3_ROB_op_type (_ bv5 6)))
				(= U3_state_ROB5_destination (select U3_ROB_destination (_ bv5 6)))
				(= U3_state_ROB5_result (select U3_ROB_result (_ bv5 6)))
				(= U3_state_ROB5_exception (select U3_ROB_exception (_ bv5 6)))
				(= U3_state_ROB5_done (select U3_ROB_done (_ bv5 6)))
				
				(= U3_state_ROB6_busy (select U3_ROB_busy (_ bv6 6)))
				(= U3_state_ROB6_op_type (select U3_ROB_op_type (_ bv6 6)))
				(= U3_state_ROB6_destination (select U3_ROB_destination (_ bv6 6)))
				(= U3_state_ROB6_result (select U3_ROB_result (_ bv6 6)))
				(= U3_state_ROB6_exception (select U3_ROB_exception (_ bv6 6)))
				(= U3_state_ROB6_done (select U3_ROB_done (_ bv6 6)))
				
				(= U3_state_ROB7_busy (select U3_ROB_busy (_ bv7 6)))
				(= U3_state_ROB7_op_type (select U3_ROB_op_type (_ bv7 6)))
				(= U3_state_ROB7_destination (select U3_ROB_destination (_ bv7 6)))
				(= U3_state_ROB7_result (select U3_ROB_result (_ bv7 6)))
				(= U3_state_ROB7_exception (select U3_ROB_exception (_ bv7 6)))
				(= U3_state_ROB7_done (select U3_ROB_done (_ bv7 6)))
				
				(= U3_state_RS0_op_type (select U3_RS_op_type (_ bv0 3)))
				(= U3_state_RS0_op (select U3_RS_op (_ bv0 3)))
				(= U3_state_RS0_ROB_dst (select U3_RS_ROB_dst (_ bv0 3)))
				(= U3_state_RS0_vj (select U3_RS_vj (_ bv0 3)))
				(= U3_state_RS0_vk (select U3_RS_vk (_ bv0 3)))
				(= U3_state_RS0_qj (select U3_RS_qj (_ bv0 3)))
				(= U3_state_RS0_qk (select U3_RS_qk (_ bv0 3)))
				(= U3_state_RS0_imm (select U3_RS_imm (_ bv0 3)))
				(= U3_state_RS0_dis (select U3_RS_dis (_ bv0 3)))
				(= U3_state_RS0_busy (select U3_RS_busy (_ bv0 3)))
				(= U3_state_RS0_Ltag (select U3_RS_Ltag (_ bv0 3)))
				
				(= U3_state_RS1_op_type (select U3_RS_op_type (_ bv1 3)))
				(= U3_state_RS1_op (select U3_RS_op (_ bv1 3)))
				(= U3_state_RS1_ROB_dst (select U3_RS_ROB_dst (_ bv1 3)))
				(= U3_state_RS1_vj (select U3_RS_vj (_ bv1 3)))
				(= U3_state_RS1_vk (select U3_RS_vk (_ bv1 3)))
				(= U3_state_RS1_qj (select U3_RS_qj (_ bv1 3)))
				(= U3_state_RS1_qk (select U3_RS_qk (_ bv1 3)))
				(= U3_state_RS1_imm (select U3_RS_imm (_ bv1 3)))
				(= U3_state_RS1_dis (select U3_RS_dis (_ bv1 3)))
				(= U3_state_RS1_busy (select U3_RS_busy (_ bv1 3)))
				(= U3_state_RS1_Ltag (select U3_RS_Ltag (_ bv1 3)))
				
				(= U3_state_RS2_op_type (select U3_RS_op_type (_ bv2 3)))
				(= U3_state_RS2_op (select U3_RS_op (_ bv2 3)))
				(= U3_state_RS2_ROB_dst (select U3_RS_ROB_dst (_ bv2 3)))
				(= U3_state_RS2_vj (select U3_RS_vj (_ bv2 3)))
				(= U3_state_RS2_vk (select U3_RS_vk (_ bv2 3)))
				(= U3_state_RS2_qj (select U3_RS_qj (_ bv2 3)))
				(= U3_state_RS2_qk (select U3_RS_qk (_ bv2 3)))
				(= U3_state_RS2_imm (select U3_RS_imm (_ bv2 3)))
				(= U3_state_RS2_dis (select U3_RS_dis (_ bv2 3)))
				(= U3_state_RS2_busy (select U3_RS_busy (_ bv2 3)))
				(= U3_state_RS2_Ltag (select U3_RS_Ltag (_ bv2 3)))
				
				(= U3_state_RS3_op_type (select U3_RS_op_type (_ bv3 3)))
				(= U3_state_RS3_op (select U3_RS_op (_ bv3 3)))
				(= U3_state_RS3_ROB_dst (select U3_RS_ROB_dst (_ bv3 3)))
				(= U3_state_RS3_vj (select U3_RS_vj (_ bv3 3)))
				(= U3_state_RS3_vk (select U3_RS_vk (_ bv3 3)))
				(= U3_state_RS3_qj (select U3_RS_qj (_ bv3 3)))
				(= U3_state_RS3_qk (select U3_RS_qk (_ bv3 3)))
				(= U3_state_RS3_imm (select U3_RS_imm (_ bv3 3)))
				(= U3_state_RS3_dis (select U3_RS_dis (_ bv3 3)))
				(= U3_state_RS3_busy (select U3_RS_busy (_ bv3 3)))
				(= U3_state_RS3_Ltag (select U3_RS_Ltag (_ bv3 3)))
				
				(= U3_state_RS4_op_type (select U3_RS_op_type (_ bv4 3)))
				(= U3_state_RS4_op (select U3_RS_op (_ bv4 3)))
				(= U3_state_RS4_ROB_dst (select U3_RS_ROB_dst (_ bv4 3)))
				(= U3_state_RS4_vj (select U3_RS_vj (_ bv4 3)))
				(= U3_state_RS4_vk (select U3_RS_vk (_ bv4 3)))
				(= U3_state_RS4_qj (select U3_RS_qj (_ bv4 3)))
				(= U3_state_RS4_qk (select U3_RS_qk (_ bv4 3)))
				(= U3_state_RS4_imm (select U3_RS_imm (_ bv4 3)))
				(= U3_state_RS4_dis (select U3_RS_dis (_ bv4 3)))
				(= U3_state_RS4_busy (select U3_RS_busy (_ bv4 3)))
				(= U3_state_RS4_Ltag (select U3_RS_Ltag (_ bv4 3)))
				
				(= U3_state_RS5_op_type (select U3_RS_op_type (_ bv5 3)))
				(= U3_state_RS5_op (select U3_RS_op (_ bv5 3)))
				(= U3_state_RS5_ROB_dst (select U3_RS_ROB_dst (_ bv5 3)))
				(= U3_state_RS5_vj (select U3_RS_vj (_ bv5 3)))
				(= U3_state_RS5_vk (select U3_RS_vk (_ bv5 3)))
				(= U3_state_RS5_qj (select U3_RS_qj (_ bv5 3)))
				(= U3_state_RS5_qk (select U3_RS_qk (_ bv5 3)))
				(= U3_state_RS5_imm (select U3_RS_imm (_ bv5 3)))
				(= U3_state_RS5_dis (select U3_RS_dis (_ bv5 3)))
				(= U3_state_RS5_busy (select U3_RS_busy (_ bv5 3)))
				(= U3_state_RS5_Ltag (select U3_RS_Ltag (_ bv5 3)))
				
				(= U3_state_RS6_op_type (select U3_RS_op_type (_ bv6 3)))
				(= U3_state_RS6_op (select U3_RS_op (_ bv6 3)))
				(= U3_state_RS6_ROB_dst (select U3_RS_ROB_dst (_ bv6 3)))
				(= U3_state_RS6_vj (select U3_RS_vj (_ bv6 3)))
				(= U3_state_RS6_vk (select U3_RS_vk (_ bv6 3)))
				(= U3_state_RS6_qj (select U3_RS_qj (_ bv6 3)))
				(= U3_state_RS6_qk (select U3_RS_qk (_ bv6 3)))
				(= U3_state_RS6_imm (select U3_RS_imm (_ bv6 3)))
				(= U3_state_RS6_dis (select U3_RS_dis (_ bv6 3)))
				(= U3_state_RS6_busy (select U3_RS_busy (_ bv6 3)))
				(= U3_state_RS6_Ltag (select U3_RS_Ltag (_ bv6 3)))
				
				(= U3_state_RS7_op_type (select U3_RS_op_type (_ bv7 3)))
				(= U3_state_RS7_op (select U3_RS_op (_ bv7 3)))
				(= U3_state_RS7_ROB_dst (select U3_RS_ROB_dst (_ bv7 3)))
				(= U3_state_RS7_vj (select U3_RS_vj (_ bv7 3)))
				(= U3_state_RS7_vk (select U3_RS_vk (_ bv7 3)))
				(= U3_state_RS7_qj (select U3_RS_qj (_ bv7 3)))
				(= U3_state_RS7_qk (select U3_RS_qk (_ bv7 3)))
				(= U3_state_RS7_imm (select U3_RS_imm (_ bv7 3)))
				(= U3_state_RS7_dis (select U3_RS_dis (_ bv7 3)))
				(= U3_state_RS7_busy (select U3_RS_busy (_ bv7 3)))
				(= U3_state_RS7_Ltag (select U3_RS_Ltag (_ bv7 3)))
				
				(= U3_state_LSQ0_op_type (select U3_LSQ_op_type (_ bv0 3)))
				(= U3_state_LSQ0_op (select U3_LSQ_op (_ bv0 3)))
				(= U3_state_LSQ0_ROB_dst (select U3_LSQ_ROB_dst (_ bv0 3)))
				(= U3_state_LSQ0_vj (select U3_LSQ_vj (_ bv0 3)))
				(= U3_state_LSQ0_vk (select U3_LSQ_vk (_ bv0 3)))
				(= U3_state_LSQ0_qj (select U3_LSQ_qj (_ bv0 3)))
				(= U3_state_LSQ0_qk (select U3_LSQ_qk (_ bv0 3)))
				(= U3_state_LSQ0_imm (select U3_LSQ_imm (_ bv0 3)))
				(= U3_state_LSQ0_dis (select U3_LSQ_dis (_ bv0 3)))
				(= U3_state_LSQ0_busy (select U3_LSQ_busy (_ bv0 3)))
				(= U3_state_LSQ0_Ltag (select U3_LSQ_Ltag (_ bv0 3)))
				
				(= U3_state_LSQ1_op_type (select U3_LSQ_op_type (_ bv1 3)))
				(= U3_state_LSQ1_op (select U3_LSQ_op (_ bv1 3)))
				(= U3_state_LSQ1_ROB_dst (select U3_LSQ_ROB_dst (_ bv1 3)))
				(= U3_state_LSQ1_vj (select U3_LSQ_vj (_ bv1 3)))
				(= U3_state_LSQ1_vk (select U3_LSQ_vk (_ bv1 3)))
				(= U3_state_LSQ1_qj (select U3_LSQ_qj (_ bv1 3)))
				(= U3_state_LSQ1_qk (select U3_LSQ_qk (_ bv1 3)))
				(= U3_state_LSQ1_imm (select U3_LSQ_imm (_ bv1 3)))
				(= U3_state_LSQ1_dis (select U3_LSQ_dis (_ bv1 3)))
				(= U3_state_LSQ1_busy (select U3_LSQ_busy (_ bv1 3)))
				(= U3_state_LSQ1_Ltag (select U3_LSQ_Ltag (_ bv1 3)))
				
				(= U3_state_LSQ2_op_type (select U3_LSQ_op_type (_ bv2 3)))
				(= U3_state_LSQ2_op (select U3_LSQ_op (_ bv2 3)))
				(= U3_state_LSQ2_ROB_dst (select U3_LSQ_ROB_dst (_ bv2 3)))
				(= U3_state_LSQ2_vj (select U3_LSQ_vj (_ bv2 3)))
				(= U3_state_LSQ2_vk (select U3_LSQ_vk (_ bv2 3)))
				(= U3_state_LSQ2_qj (select U3_LSQ_qj (_ bv2 3)))
				(= U3_state_LSQ2_qk (select U3_LSQ_qk (_ bv2 3)))
				(= U3_state_LSQ2_imm (select U3_LSQ_imm (_ bv2 3)))
				(= U3_state_LSQ2_dis (select U3_LSQ_dis (_ bv2 3)))
				(= U3_state_LSQ2_busy (select U3_LSQ_busy (_ bv2 3)))
				(= U3_state_LSQ2_Ltag (select U3_LSQ_Ltag (_ bv2 3)))
				
				(= U3_state_LSQ3_op_type (select U3_LSQ_op_type (_ bv3 3)))
				(= U3_state_LSQ3_op (select U3_LSQ_op (_ bv3 3)))
				(= U3_state_LSQ3_ROB_dst (select U3_LSQ_ROB_dst (_ bv3 3)))
				(= U3_state_LSQ3_vj (select U3_LSQ_vj (_ bv3 3)))
				(= U3_state_LSQ3_vk (select U3_LSQ_vk (_ bv3 3)))
				(= U3_state_LSQ3_qj (select U3_LSQ_qj (_ bv3 3)))
				(= U3_state_LSQ3_qk (select U3_LSQ_qk (_ bv3 3)))
				(= U3_state_LSQ3_imm (select U3_LSQ_imm (_ bv3 3)))
				(= U3_state_LSQ3_dis (select U3_LSQ_dis (_ bv3 3)))
				(= U3_state_LSQ3_busy (select U3_LSQ_busy (_ bv3 3)))
				(= U3_state_LSQ3_Ltag (select U3_LSQ_Ltag (_ bv3 3)))
				
				(= U3_state_LSQ4_op_type (select U3_LSQ_op_type (_ bv4 3)))
				(= U3_state_LSQ4_op (select U3_LSQ_op (_ bv4 3)))
				(= U3_state_LSQ4_ROB_dst (select U3_LSQ_ROB_dst (_ bv4 3)))
				(= U3_state_LSQ4_vj (select U3_LSQ_vj (_ bv4 3)))
				(= U3_state_LSQ4_vk (select U3_LSQ_vk (_ bv4 3)))
				(= U3_state_LSQ4_qj (select U3_LSQ_qj (_ bv4 3)))
				(= U3_state_LSQ4_qk (select U3_LSQ_qk (_ bv4 3)))
				(= U3_state_LSQ4_imm (select U3_LSQ_imm (_ bv4 3)))
				(= U3_state_LSQ4_dis (select U3_LSQ_dis (_ bv4 3)))
				(= U3_state_LSQ4_busy (select U3_LSQ_busy (_ bv4 3)))
				(= U3_state_LSQ4_Ltag (select U3_LSQ_Ltag (_ bv4 3)))
				
				(= U3_state_LSQ5_op_type (select U3_LSQ_op_type (_ bv5 3)))
				(= U3_state_LSQ5_op (select U3_LSQ_op (_ bv5 3)))
				(= U3_state_LSQ5_ROB_dst (select U3_LSQ_ROB_dst (_ bv5 3)))
				(= U3_state_LSQ5_vj (select U3_LSQ_vj (_ bv5 3)))
				(= U3_state_LSQ5_vk (select U3_LSQ_vk (_ bv5 3)))
				(= U3_state_LSQ5_qj (select U3_LSQ_qj (_ bv5 3)))
				(= U3_state_LSQ5_qk (select U3_LSQ_qk (_ bv5 3)))
				(= U3_state_LSQ5_imm (select U3_LSQ_imm (_ bv5 3)))
				(= U3_state_LSQ5_dis (select U3_LSQ_dis (_ bv5 3)))
				(= U3_state_LSQ5_busy (select U3_LSQ_busy (_ bv5 3)))
				(= U3_state_LSQ5_Ltag (select U3_LSQ_Ltag (_ bv5 3)))
				
				(= U3_state_LSQ6_op_type (select U3_LSQ_op_type (_ bv6 3)))
				(= U3_state_LSQ6_op (select U3_LSQ_op (_ bv6 3)))
				(= U3_state_LSQ6_ROB_dst (select U3_LSQ_ROB_dst (_ bv6 3)))
				(= U3_state_LSQ6_vj (select U3_LSQ_vj (_ bv6 3)))
				(= U3_state_LSQ6_vk (select U3_LSQ_vk (_ bv6 3)))
				(= U3_state_LSQ6_qj (select U3_LSQ_qj (_ bv6 3)))
				(= U3_state_LSQ6_qk (select U3_LSQ_qk (_ bv6 3)))
				(= U3_state_LSQ6_imm (select U3_LSQ_imm (_ bv6 3)))
				(= U3_state_LSQ6_dis (select U3_LSQ_dis (_ bv6 3)))
				(= U3_state_LSQ6_busy (select U3_LSQ_busy (_ bv6 3)))
				(= U3_state_LSQ6_Ltag (select U3_LSQ_Ltag (_ bv6 3)))
				
				(= U3_state_LSQ7_op_type (select U3_LSQ_op_type (_ bv7 3)))
				(= U3_state_LSQ7_op (select U3_LSQ_op (_ bv7 3)))
				(= U3_state_LSQ7_ROB_dst (select U3_LSQ_ROB_dst (_ bv7 3)))
				(= U3_state_LSQ7_vj (select U3_LSQ_vj (_ bv7 3)))
				(= U3_state_LSQ7_vk (select U3_LSQ_vk (_ bv7 3)))
				(= U3_state_LSQ7_qj (select U3_LSQ_qj (_ bv7 3)))
				(= U3_state_LSQ7_qk (select U3_LSQ_qk (_ bv7 3)))
				(= U3_state_LSQ7_imm (select U3_LSQ_imm (_ bv7 3)))
				(= U3_state_LSQ7_dis (select U3_LSQ_dis (_ bv7 3)))
				(= U3_state_LSQ7_busy (select U3_LSQ_busy (_ bv7 3)))
				(= U3_state_LSQ7_Ltag (select U3_LSQ_Ltag (_ bv7 3)))
				
				
				(= U4_state_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(= U4_state_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(= U4_state_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(= U4_state_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				
				(= U4_state_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(= U4_state_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(= U4_state_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(= U4_state_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				
				(= U4_state_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(= U4_state_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(= U4_state_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(= U4_state_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
				
				(= U4_state_IP U4_IP)
				(= U4_state_CP U4_CP)
				(= U4_state_PC U4_PC)
				(= U4_state_Main_Ltag U4_Main_Ltag)
				
				(= U4_state_ROB0_busy (select U4_ROB_busy (_ bv0 6)))
				(= U4_state_ROB0_op_type (select U4_ROB_op_type (_ bv0 6)))
				(= U4_state_ROB0_destination (select U4_ROB_destination (_ bv0 6)))
				(= U4_state_ROB0_result (select U4_ROB_result (_ bv0 6)))
				(= U4_state_ROB0_exception (select U4_ROB_exception (_ bv0 6)))
				(= U4_state_ROB0_done (select U4_ROB_done (_ bv0 6)))
				
				(= U4_state_ROB1_busy (select U4_ROB_busy (_ bv1 6)))
				(= U4_state_ROB1_op_type (select U4_ROB_op_type (_ bv1 6)))
				(= U4_state_ROB1_destination (select U4_ROB_destination (_ bv1 6)))
				(= U4_state_ROB1_result (select U4_ROB_result (_ bv1 6)))
				(= U4_state_ROB1_exception (select U4_ROB_exception (_ bv1 6)))
				(= U4_state_ROB1_done (select U4_ROB_done (_ bv1 6)))
				
				(= U4_state_ROB2_busy (select U4_ROB_busy (_ bv2 6)))
				(= U4_state_ROB2_op_type (select U4_ROB_op_type (_ bv2 6)))
				(= U4_state_ROB2_destination (select U4_ROB_destination (_ bv2 6)))
				(= U4_state_ROB2_result (select U4_ROB_result (_ bv2 6)))
				(= U4_state_ROB2_exception (select U4_ROB_exception (_ bv2 6)))
				(= U4_state_ROB2_done (select U4_ROB_done (_ bv2 6)))
				
				(= U4_state_ROB3_busy (select U4_ROB_busy (_ bv3 6)))
				(= U4_state_ROB3_op_type (select U4_ROB_op_type (_ bv3 6)))
				(= U4_state_ROB3_destination (select U4_ROB_destination (_ bv3 6)))
				(= U4_state_ROB3_result (select U4_ROB_result (_ bv3 6)))
				(= U4_state_ROB3_exception (select U4_ROB_exception (_ bv3 6)))
				(= U4_state_ROB3_done (select U4_ROB_done (_ bv3 6)))
				
				(= U4_state_ROB4_busy (select U4_ROB_busy (_ bv4 6)))
				(= U4_state_ROB4_op_type (select U4_ROB_op_type (_ bv4 6)))
				(= U4_state_ROB4_destination (select U4_ROB_destination (_ bv4 6)))
				(= U4_state_ROB4_result (select U4_ROB_result (_ bv4 6)))
				(= U4_state_ROB4_exception (select U4_ROB_exception (_ bv4 6)))
				(= U4_state_ROB4_done (select U4_ROB_done (_ bv4 6)))
				
				(= U4_state_ROB5_busy (select U4_ROB_busy (_ bv5 6)))
				(= U4_state_ROB5_op_type (select U4_ROB_op_type (_ bv5 6)))
				(= U4_state_ROB5_destination (select U4_ROB_destination (_ bv5 6)))
				(= U4_state_ROB5_result (select U4_ROB_result (_ bv5 6)))
				(= U4_state_ROB5_exception (select U4_ROB_exception (_ bv5 6)))
				(= U4_state_ROB5_done (select U4_ROB_done (_ bv5 6)))
				
				(= U4_state_ROB6_busy (select U4_ROB_busy (_ bv6 6)))
				(= U4_state_ROB6_op_type (select U4_ROB_op_type (_ bv6 6)))
				(= U4_state_ROB6_destination (select U4_ROB_destination (_ bv6 6)))
				(= U4_state_ROB6_result (select U4_ROB_result (_ bv6 6)))
				(= U4_state_ROB6_exception (select U4_ROB_exception (_ bv6 6)))
				(= U4_state_ROB6_done (select U4_ROB_done (_ bv6 6)))
				
				(= U4_state_ROB7_busy (select U4_ROB_busy (_ bv7 6)))
				(= U4_state_ROB7_op_type (select U4_ROB_op_type (_ bv7 6)))
				(= U4_state_ROB7_destination (select U4_ROB_destination (_ bv7 6)))
				(= U4_state_ROB7_result (select U4_ROB_result (_ bv7 6)))
				(= U4_state_ROB7_exception (select U4_ROB_exception (_ bv7 6)))
				(= U4_state_ROB7_done (select U4_ROB_done (_ bv7 6)))
				
				(= U4_state_RS0_op_type (select U4_RS_op_type (_ bv0 3)))
				(= U4_state_RS0_op (select U4_RS_op (_ bv0 3)))
				(= U4_state_RS0_ROB_dst (select U4_RS_ROB_dst (_ bv0 3)))
				(= U4_state_RS0_vj (select U4_RS_vj (_ bv0 3)))
				(= U4_state_RS0_vk (select U4_RS_vk (_ bv0 3)))
				(= U4_state_RS0_qj (select U4_RS_qj (_ bv0 3)))
				(= U4_state_RS0_qk (select U4_RS_qk (_ bv0 3)))
				(= U4_state_RS0_imm (select U4_RS_imm (_ bv0 3)))
				(= U4_state_RS0_dis (select U4_RS_dis (_ bv0 3)))
				(= U4_state_RS0_busy (select U4_RS_busy (_ bv0 3)))
				(= U4_state_RS0_Ltag (select U4_RS_Ltag (_ bv0 3)))
				
				(= U4_state_RS1_op_type (select U4_RS_op_type (_ bv1 3)))
				(= U4_state_RS1_op (select U4_RS_op (_ bv1 3)))
				(= U4_state_RS1_ROB_dst (select U4_RS_ROB_dst (_ bv1 3)))
				(= U4_state_RS1_vj (select U4_RS_vj (_ bv1 3)))
				(= U4_state_RS1_vk (select U4_RS_vk (_ bv1 3)))
				(= U4_state_RS1_qj (select U4_RS_qj (_ bv1 3)))
				(= U4_state_RS1_qk (select U4_RS_qk (_ bv1 3)))
				(= U4_state_RS1_imm (select U4_RS_imm (_ bv1 3)))
				(= U4_state_RS1_dis (select U4_RS_dis (_ bv1 3)))
				(= U4_state_RS1_busy (select U4_RS_busy (_ bv1 3)))
				(= U4_state_RS1_Ltag (select U4_RS_Ltag (_ bv1 3)))
				
				(= U4_state_RS2_op_type (select U4_RS_op_type (_ bv2 3)))
				(= U4_state_RS2_op (select U4_RS_op (_ bv2 3)))
				(= U4_state_RS2_ROB_dst (select U4_RS_ROB_dst (_ bv2 3)))
				(= U4_state_RS2_vj (select U4_RS_vj (_ bv2 3)))
				(= U4_state_RS2_vk (select U4_RS_vk (_ bv2 3)))
				(= U4_state_RS2_qj (select U4_RS_qj (_ bv2 3)))
				(= U4_state_RS2_qk (select U4_RS_qk (_ bv2 3)))
				(= U4_state_RS2_imm (select U4_RS_imm (_ bv2 3)))
				(= U4_state_RS2_dis (select U4_RS_dis (_ bv2 3)))
				(= U4_state_RS2_busy (select U4_RS_busy (_ bv2 3)))
				(= U4_state_RS2_Ltag (select U4_RS_Ltag (_ bv2 3)))
				
				(= U4_state_RS3_op_type (select U4_RS_op_type (_ bv3 3)))
				(= U4_state_RS3_op (select U4_RS_op (_ bv3 3)))
				(= U4_state_RS3_ROB_dst (select U4_RS_ROB_dst (_ bv3 3)))
				(= U4_state_RS3_vj (select U4_RS_vj (_ bv3 3)))
				(= U4_state_RS3_vk (select U4_RS_vk (_ bv3 3)))
				(= U4_state_RS3_qj (select U4_RS_qj (_ bv3 3)))
				(= U4_state_RS3_qk (select U4_RS_qk (_ bv3 3)))
				(= U4_state_RS3_imm (select U4_RS_imm (_ bv3 3)))
				(= U4_state_RS3_dis (select U4_RS_dis (_ bv3 3)))
				(= U4_state_RS3_busy (select U4_RS_busy (_ bv3 3)))
				(= U4_state_RS3_Ltag (select U4_RS_Ltag (_ bv3 3)))
				
				(= U4_state_RS4_op_type (select U4_RS_op_type (_ bv4 3)))
				(= U4_state_RS4_op (select U4_RS_op (_ bv4 3)))
				(= U4_state_RS4_ROB_dst (select U4_RS_ROB_dst (_ bv4 3)))
				(= U4_state_RS4_vj (select U4_RS_vj (_ bv4 3)))
				(= U4_state_RS4_vk (select U4_RS_vk (_ bv4 3)))
				(= U4_state_RS4_qj (select U4_RS_qj (_ bv4 3)))
				(= U4_state_RS4_qk (select U4_RS_qk (_ bv4 3)))
				(= U4_state_RS4_imm (select U4_RS_imm (_ bv4 3)))
				(= U4_state_RS4_dis (select U4_RS_dis (_ bv4 3)))
				(= U4_state_RS4_busy (select U4_RS_busy (_ bv4 3)))
				(= U4_state_RS4_Ltag (select U4_RS_Ltag (_ bv4 3)))
				
				(= U4_state_RS5_op_type (select U4_RS_op_type (_ bv5 3)))
				(= U4_state_RS5_op (select U4_RS_op (_ bv5 3)))
				(= U4_state_RS5_ROB_dst (select U4_RS_ROB_dst (_ bv5 3)))
				(= U4_state_RS5_vj (select U4_RS_vj (_ bv5 3)))
				(= U4_state_RS5_vk (select U4_RS_vk (_ bv5 3)))
				(= U4_state_RS5_qj (select U4_RS_qj (_ bv5 3)))
				(= U4_state_RS5_qk (select U4_RS_qk (_ bv5 3)))
				(= U4_state_RS5_imm (select U4_RS_imm (_ bv5 3)))
				(= U4_state_RS5_dis (select U4_RS_dis (_ bv5 3)))
				(= U4_state_RS5_busy (select U4_RS_busy (_ bv5 3)))
				(= U4_state_RS5_Ltag (select U4_RS_Ltag (_ bv5 3)))
				
				(= U4_state_RS6_op_type (select U4_RS_op_type (_ bv6 3)))
				(= U4_state_RS6_op (select U4_RS_op (_ bv6 3)))
				(= U4_state_RS6_ROB_dst (select U4_RS_ROB_dst (_ bv6 3)))
				(= U4_state_RS6_vj (select U4_RS_vj (_ bv6 3)))
				(= U4_state_RS6_vk (select U4_RS_vk (_ bv6 3)))
				(= U4_state_RS6_qj (select U4_RS_qj (_ bv6 3)))
				(= U4_state_RS6_qk (select U4_RS_qk (_ bv6 3)))
				(= U4_state_RS6_imm (select U4_RS_imm (_ bv6 3)))
				(= U4_state_RS6_dis (select U4_RS_dis (_ bv6 3)))
				(= U4_state_RS6_busy (select U4_RS_busy (_ bv6 3)))
				(= U4_state_RS6_Ltag (select U4_RS_Ltag (_ bv6 3)))
				
				(= U4_state_RS7_op_type (select U4_RS_op_type (_ bv7 3)))
				(= U4_state_RS7_op (select U4_RS_op (_ bv7 3)))
				(= U4_state_RS7_ROB_dst (select U4_RS_ROB_dst (_ bv7 3)))
				(= U4_state_RS7_vj (select U4_RS_vj (_ bv7 3)))
				(= U4_state_RS7_vk (select U4_RS_vk (_ bv7 3)))
				(= U4_state_RS7_qj (select U4_RS_qj (_ bv7 3)))
				(= U4_state_RS7_qk (select U4_RS_qk (_ bv7 3)))
				(= U4_state_RS7_imm (select U4_RS_imm (_ bv7 3)))
				(= U4_state_RS7_dis (select U4_RS_dis (_ bv7 3)))
				(= U4_state_RS7_busy (select U4_RS_busy (_ bv7 3)))
				(= U4_state_RS7_Ltag (select U4_RS_Ltag (_ bv7 3)))
				
				(= U4_state_LSQ0_op_type (select U4_LSQ_op_type (_ bv0 3)))
				(= U4_state_LSQ0_op (select U4_LSQ_op (_ bv0 3)))
				(= U4_state_LSQ0_ROB_dst (select U4_LSQ_ROB_dst (_ bv0 3)))
				(= U4_state_LSQ0_vj (select U4_LSQ_vj (_ bv0 3)))
				(= U4_state_LSQ0_vk (select U4_LSQ_vk (_ bv0 3)))
				(= U4_state_LSQ0_qj (select U4_LSQ_qj (_ bv0 3)))
				(= U4_state_LSQ0_qk (select U4_LSQ_qk (_ bv0 3)))
				(= U4_state_LSQ0_imm (select U4_LSQ_imm (_ bv0 3)))
				(= U4_state_LSQ0_dis (select U4_LSQ_dis (_ bv0 3)))
				(= U4_state_LSQ0_busy (select U4_LSQ_busy (_ bv0 3)))
				(= U4_state_LSQ0_Ltag (select U4_LSQ_Ltag (_ bv0 3)))
				
				(= U4_state_LSQ1_op_type (select U4_LSQ_op_type (_ bv1 3)))
				(= U4_state_LSQ1_op (select U4_LSQ_op (_ bv1 3)))
				(= U4_state_LSQ1_ROB_dst (select U4_LSQ_ROB_dst (_ bv1 3)))
				(= U4_state_LSQ1_vj (select U4_LSQ_vj (_ bv1 3)))
				(= U4_state_LSQ1_vk (select U4_LSQ_vk (_ bv1 3)))
				(= U4_state_LSQ1_qj (select U4_LSQ_qj (_ bv1 3)))
				(= U4_state_LSQ1_qk (select U4_LSQ_qk (_ bv1 3)))
				(= U4_state_LSQ1_imm (select U4_LSQ_imm (_ bv1 3)))
				(= U4_state_LSQ1_dis (select U4_LSQ_dis (_ bv1 3)))
				(= U4_state_LSQ1_busy (select U4_LSQ_busy (_ bv1 3)))
				(= U4_state_LSQ1_Ltag (select U4_LSQ_Ltag (_ bv1 3)))
				
				(= U4_state_LSQ2_op_type (select U4_LSQ_op_type (_ bv2 3)))
				(= U4_state_LSQ2_op (select U4_LSQ_op (_ bv2 3)))
				(= U4_state_LSQ2_ROB_dst (select U4_LSQ_ROB_dst (_ bv2 3)))
				(= U4_state_LSQ2_vj (select U4_LSQ_vj (_ bv2 3)))
				(= U4_state_LSQ2_vk (select U4_LSQ_vk (_ bv2 3)))
				(= U4_state_LSQ2_qj (select U4_LSQ_qj (_ bv2 3)))
				(= U4_state_LSQ2_qk (select U4_LSQ_qk (_ bv2 3)))
				(= U4_state_LSQ2_imm (select U4_LSQ_imm (_ bv2 3)))
				(= U4_state_LSQ2_dis (select U4_LSQ_dis (_ bv2 3)))
				(= U4_state_LSQ2_busy (select U4_LSQ_busy (_ bv2 3)))
				(= U4_state_LSQ2_Ltag (select U4_LSQ_Ltag (_ bv2 3)))
				
				(= U4_state_LSQ3_op_type (select U4_LSQ_op_type (_ bv3 3)))
				(= U4_state_LSQ3_op (select U4_LSQ_op (_ bv3 3)))
				(= U4_state_LSQ3_ROB_dst (select U4_LSQ_ROB_dst (_ bv3 3)))
				(= U4_state_LSQ3_vj (select U4_LSQ_vj (_ bv3 3)))
				(= U4_state_LSQ3_vk (select U4_LSQ_vk (_ bv3 3)))
				(= U4_state_LSQ3_qj (select U4_LSQ_qj (_ bv3 3)))
				(= U4_state_LSQ3_qk (select U4_LSQ_qk (_ bv3 3)))
				(= U4_state_LSQ3_imm (select U4_LSQ_imm (_ bv3 3)))
				(= U4_state_LSQ3_dis (select U4_LSQ_dis (_ bv3 3)))
				(= U4_state_LSQ3_busy (select U4_LSQ_busy (_ bv3 3)))
				(= U4_state_LSQ3_Ltag (select U4_LSQ_Ltag (_ bv3 3)))
				
				(= U4_state_LSQ4_op_type (select U4_LSQ_op_type (_ bv4 3)))
				(= U4_state_LSQ4_op (select U4_LSQ_op (_ bv4 3)))
				(= U4_state_LSQ4_ROB_dst (select U4_LSQ_ROB_dst (_ bv4 3)))
				(= U4_state_LSQ4_vj (select U4_LSQ_vj (_ bv4 3)))
				(= U4_state_LSQ4_vk (select U4_LSQ_vk (_ bv4 3)))
				(= U4_state_LSQ4_qj (select U4_LSQ_qj (_ bv4 3)))
				(= U4_state_LSQ4_qk (select U4_LSQ_qk (_ bv4 3)))
				(= U4_state_LSQ4_imm (select U4_LSQ_imm (_ bv4 3)))
				(= U4_state_LSQ4_dis (select U4_LSQ_dis (_ bv4 3)))
				(= U4_state_LSQ4_busy (select U4_LSQ_busy (_ bv4 3)))
				(= U4_state_LSQ4_Ltag (select U4_LSQ_Ltag (_ bv4 3)))
				
				(= U4_state_LSQ5_op_type (select U4_LSQ_op_type (_ bv5 3)))
				(= U4_state_LSQ5_op (select U4_LSQ_op (_ bv5 3)))
				(= U4_state_LSQ5_ROB_dst (select U4_LSQ_ROB_dst (_ bv5 3)))
				(= U4_state_LSQ5_vj (select U4_LSQ_vj (_ bv5 3)))
				(= U4_state_LSQ5_vk (select U4_LSQ_vk (_ bv5 3)))
				(= U4_state_LSQ5_qj (select U4_LSQ_qj (_ bv5 3)))
				(= U4_state_LSQ5_qk (select U4_LSQ_qk (_ bv5 3)))
				(= U4_state_LSQ5_imm (select U4_LSQ_imm (_ bv5 3)))
				(= U4_state_LSQ5_dis (select U4_LSQ_dis (_ bv5 3)))
				(= U4_state_LSQ5_busy (select U4_LSQ_busy (_ bv5 3)))
				(= U4_state_LSQ5_Ltag (select U4_LSQ_Ltag (_ bv5 3)))
				
				(= U4_state_LSQ6_op_type (select U4_LSQ_op_type (_ bv6 3)))
				(= U4_state_LSQ6_op (select U4_LSQ_op (_ bv6 3)))
				(= U4_state_LSQ6_ROB_dst (select U4_LSQ_ROB_dst (_ bv6 3)))
				(= U4_state_LSQ6_vj (select U4_LSQ_vj (_ bv6 3)))
				(= U4_state_LSQ6_vk (select U4_LSQ_vk (_ bv6 3)))
				(= U4_state_LSQ6_qj (select U4_LSQ_qj (_ bv6 3)))
				(= U4_state_LSQ6_qk (select U4_LSQ_qk (_ bv6 3)))
				(= U4_state_LSQ6_imm (select U4_LSQ_imm (_ bv6 3)))
				(= U4_state_LSQ6_dis (select U4_LSQ_dis (_ bv6 3)))
				(= U4_state_LSQ6_busy (select U4_LSQ_busy (_ bv6 3)))
				(= U4_state_LSQ6_Ltag (select U4_LSQ_Ltag (_ bv6 3)))
				
				(= U4_state_LSQ7_op_type (select U4_LSQ_op_type (_ bv7 3)))
				(= U4_state_LSQ7_op (select U4_LSQ_op (_ bv7 3)))
				(= U4_state_LSQ7_ROB_dst (select U4_LSQ_ROB_dst (_ bv7 3)))
				(= U4_state_LSQ7_vj (select U4_LSQ_vj (_ bv7 3)))
				(= U4_state_LSQ7_vk (select U4_LSQ_vk (_ bv7 3)))
				(= U4_state_LSQ7_qj (select U4_LSQ_qj (_ bv7 3)))
				(= U4_state_LSQ7_qk (select U4_LSQ_qk (_ bv7 3)))
				(= U4_state_LSQ7_imm (select U4_LSQ_imm (_ bv7 3)))
				(= U4_state_LSQ7_dis (select U4_LSQ_dis (_ bv7 3)))
				(= U4_state_LSQ7_busy (select U4_LSQ_busy (_ bv7 3)))
				(= U4_state_LSQ7_Ltag (select U4_LSQ_Ltag (_ bv7 3)))
			)
			
				
			(and 
				(=> (not (= #b000000 (select U4_LSQ_Ltag (_ bv0 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_LSQ_Ltag (_ bv0 3))))
						(= #b1 (select U4_LSQ_busy (_ bv0 3)))
					)
				)
				(=> (not (= #b000000 (select U4_LSQ_Ltag (_ bv1 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_LSQ_Ltag (_ bv1 3))))
						(= #b1 (select U4_LSQ_busy (_ bv1 3)))
					)
				)
				(=> (not (= #b000000 (select U4_LSQ_Ltag (_ bv2 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_LSQ_Ltag (_ bv2 3))))
						(= #b1 (select U4_LSQ_busy (_ bv2 3)))
					)
				)
				(=> (not (= #b000000 (select U4_LSQ_Ltag (_ bv3 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_LSQ_Ltag (_ bv3 3))))
						(= #b1 (select U4_LSQ_busy (_ bv3 3)))
					)
				)
				(=> (not (= #b000000 (select U4_LSQ_Ltag (_ bv4 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_LSQ_Ltag (_ bv4 3))))
						(= #b1 (select U4_LSQ_busy (_ bv4 3)))
					)
				)
				(=> (not (= #b000000 (select U4_LSQ_Ltag (_ bv5 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_LSQ_Ltag (_ bv5 3))))
						(= #b1 (select U4_LSQ_busy (_ bv5 3)))
					)
				)
				(=> (not (= #b000000 (select U4_LSQ_Ltag (_ bv6 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_LSQ_Ltag (_ bv6 3))))
						(= #b1 (select U4_LSQ_busy (_ bv6 3)))
					)
				)
				(=> (not (= #b000000 (select U4_LSQ_Ltag (_ bv7 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_LSQ_Ltag (_ bv7 3))))
						(= #b1 (select U4_LSQ_busy (_ bv7 3)))
					)
				)
				(=> (not (= #b000000 (select U4_RS_Ltag (_ bv0 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_RS_Ltag (_ bv0 3))))
						(= #b1 (select U4_RS_busy (_ bv0 3)))
					)
				)
				(=> (not (= #b000000 (select U4_RS_Ltag (_ bv1 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_RS_Ltag (_ bv1 3))))
						(= #b1 (select U4_RS_busy (_ bv1 3)))
					)
				)
				(=> (not (= #b000000 (select U4_RS_Ltag (_ bv2 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_RS_Ltag (_ bv2 3))))
						(= #b1 (select U4_RS_busy (_ bv2 3)))
					)
				)
				(=> (not (= #b000000 (select U4_RS_Ltag (_ bv3 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_RS_Ltag (_ bv3 3))))
						(= #b1 (select U4_RS_busy (_ bv3 3)))
					)
				)
				(=> (not (= #b000000 (select U4_RS_Ltag (_ bv4 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_RS_Ltag (_ bv4 3))))
						(= #b1 (select U4_RS_busy (_ bv4 3)))
					)
				)
				(=> (not (= #b000000 (select U4_RS_Ltag (_ bv5 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_RS_Ltag (_ bv5 3))))
						(= #b1 (select U4_RS_busy (_ bv5 3)))
					)
				)
				(=> (not (= #b000000 (select U4_RS_Ltag (_ bv6 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_RS_Ltag (_ bv6 3))))
						(= #b1 (select U4_RS_busy (_ bv6 3)))
					)
				)
				(=> (not (= #b000000 (select U4_RS_Ltag (_ bv7 3)))) 
					(and 
						(= Lfence (select U4_ROB_op_type (select U4_RS_Ltag (_ bv7 3))))
						(= #b1 (select U4_RS_busy (_ bv7 3)))
					)
				)
			)
			
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
	)
)
(check-sat)		

;(
(get-value (state_T_any_rob))
(get-value (state_T_any_rob_plus))
(get-value (T_state_Cache0_Tag))
(get-value (T_state_Cache0_Data))
(get-value (T_state_Cache0_Valid))
(get-value (T_state_Cache1_Tag))
(get-value (T_state_Cache1_Data))
(get-value (T_state_Cache1_Valid))
(get-value (T_state_Cache2_Tag))
(get-value (T_state_Cache2_Data))
(get-value (T_state_Cache2_Valid))
(get-value (T_state_Cache3_Tag))
(get-value (T_state_Cache3_Data))
(get-value (T_state_Cache3_Valid))

(get-value (T_state_IP))
(get-value (T_state_CP))
(get-value (T_state_PC))
(get-value (T_state_Main_Ltag))

(get-value (T_state_ROB0_busy))
(get-value (T_state_ROB0_op_type))
(get-value (T_state_ROB0_destination))
(get-value (T_state_ROB0_result))
(get-value (T_state_ROB0_exception))
(get-value (T_state_ROB0_done))

(get-value (T_state_ROB1_busy))
(get-value (T_state_ROB1_op_type))
(get-value (T_state_ROB1_destination))
(get-value (T_state_ROB1_result))
(get-value (T_state_ROB1_exception))
(get-value (T_state_ROB1_done))

(get-value (T_state_ROB2_busy))
(get-value (T_state_ROB2_op_type))
(get-value (T_state_ROB2_destination))
(get-value (T_state_ROB2_result))
(get-value (T_state_ROB2_exception))
(get-value (T_state_ROB2_done))

(get-value (T_state_ROB3_busy))
(get-value (T_state_ROB3_op_type))
(get-value (T_state_ROB3_destination))
(get-value (T_state_ROB3_result))
(get-value (T_state_ROB3_exception))
(get-value (T_state_ROB3_done))

(get-value (T_state_ROB4_busy))
(get-value (T_state_ROB4_op_type))
(get-value (T_state_ROB4_destination))
(get-value (T_state_ROB4_result))
(get-value (T_state_ROB4_exception))
(get-value (T_state_ROB4_done))

(get-value (T_state_ROB5_busy))
(get-value (T_state_ROB5_op_type))
(get-value (T_state_ROB5_destination))
(get-value (T_state_ROB5_result))
(get-value (T_state_ROB5_exception))
(get-value (T_state_ROB5_done))

(get-value (T_state_ROB6_busy))
(get-value (T_state_ROB6_op_type))
(get-value (T_state_ROB6_destination))
(get-value (T_state_ROB6_result))
(get-value (T_state_ROB6_exception))
(get-value (T_state_ROB6_done))

(get-value (T_state_ROB7_busy))
(get-value (T_state_ROB7_op_type))
(get-value (T_state_ROB7_destination))
(get-value (T_state_ROB7_result))
(get-value (T_state_ROB7_exception))
(get-value (T_state_ROB7_done))

(get-value (T_state_RS0_op_type))
(get-value (T_state_RS0_op))
(get-value (T_state_RS0_ROB_dst))
(get-value (T_state_RS0_vj))
(get-value (T_state_RS0_vk))
(get-value (T_state_RS0_qj))
(get-value (T_state_RS0_qk))
(get-value (T_state_RS0_imm))
(get-value (T_state_RS0_dis))
(get-value (T_state_RS0_busy))
(get-value (T_state_RS0_Ltag))

(get-value (T_state_RS1_op_type))
(get-value (T_state_RS1_op))
(get-value (T_state_RS1_ROB_dst))
(get-value (T_state_RS1_vj))
(get-value (T_state_RS1_vk))
(get-value (T_state_RS1_qj))
(get-value (T_state_RS1_qk))
(get-value (T_state_RS1_imm))
(get-value (T_state_RS1_dis))
(get-value (T_state_RS1_busy))
(get-value (T_state_RS1_Ltag))

(get-value (T_state_RS2_op_type))
(get-value (T_state_RS2_op))
(get-value (T_state_RS2_ROB_dst))
(get-value (T_state_RS2_vj))
(get-value (T_state_RS2_vk))
(get-value (T_state_RS2_qj))
(get-value (T_state_RS2_qk))
(get-value (T_state_RS2_imm))
(get-value (T_state_RS2_dis))
(get-value (T_state_RS2_busy))
(get-value (T_state_RS2_Ltag))

(get-value (T_state_RS3_op_type))
(get-value (T_state_RS3_op))
(get-value (T_state_RS3_ROB_dst))
(get-value (T_state_RS3_vj))
(get-value (T_state_RS3_vk))
(get-value (T_state_RS3_qj))
(get-value (T_state_RS3_qk))
(get-value (T_state_RS3_imm))
(get-value (T_state_RS3_dis))
(get-value (T_state_RS3_busy))
(get-value (T_state_RS3_Ltag))

(get-value (T_state_RS4_op_type))
(get-value (T_state_RS4_op))
(get-value (T_state_RS4_ROB_dst))
(get-value (T_state_RS4_vj))
(get-value (T_state_RS4_vk))
(get-value (T_state_RS4_qj))
(get-value (T_state_RS4_qk))
(get-value (T_state_RS4_imm))
(get-value (T_state_RS4_dis))
(get-value (T_state_RS4_busy))
(get-value (T_state_RS4_Ltag))

(get-value (T_state_RS5_op_type))
(get-value (T_state_RS5_op))
(get-value (T_state_RS5_ROB_dst))
(get-value (T_state_RS5_vj))
(get-value (T_state_RS5_vk))
(get-value (T_state_RS5_qj))
(get-value (T_state_RS5_qk))
(get-value (T_state_RS5_imm))
(get-value (T_state_RS5_dis))
(get-value (T_state_RS5_busy))
(get-value (T_state_RS5_Ltag))

(get-value (T_state_RS6_op_type))
(get-value (T_state_RS6_op))
(get-value (T_state_RS6_ROB_dst))
(get-value (T_state_RS6_vj))
(get-value (T_state_RS6_vk))
(get-value (T_state_RS6_qj))
(get-value (T_state_RS6_qk))
(get-value (T_state_RS6_imm))
(get-value (T_state_RS6_dis))
(get-value (T_state_RS6_busy))
(get-value (T_state_RS6_Ltag))

(get-value (T_state_RS7_op_type))
(get-value (T_state_RS7_op))
(get-value (T_state_RS7_ROB_dst))
(get-value (T_state_RS7_vj))
(get-value (T_state_RS7_vk))
(get-value (T_state_RS7_qj))
(get-value (T_state_RS7_qk))
(get-value (T_state_RS7_imm))
(get-value (T_state_RS7_dis))
(get-value (T_state_RS7_busy))
(get-value (T_state_RS7_Ltag))

(get-value (T_state_LSQ0_op_type))
(get-value (T_state_LSQ0_op))
(get-value (T_state_LSQ0_ROB_dst))
(get-value (T_state_LSQ0_vj))
(get-value (T_state_LSQ0_vk))
(get-value (T_state_LSQ0_qj))
(get-value (T_state_LSQ0_qk))
(get-value (T_state_LSQ0_imm))
(get-value (T_state_LSQ0_dis))
(get-value (T_state_LSQ0_busy))
(get-value (T_state_LSQ0_Ltag))

(get-value (T_state_LSQ1_op_type))
(get-value (T_state_LSQ1_op))
(get-value (T_state_LSQ1_ROB_dst))
(get-value (T_state_LSQ1_vj))
(get-value (T_state_LSQ1_vk))
(get-value (T_state_LSQ1_qj))
(get-value (T_state_LSQ1_qk))
(get-value (T_state_LSQ1_imm))
(get-value (T_state_LSQ1_dis))
(get-value (T_state_LSQ1_busy))
(get-value (T_state_LSQ1_Ltag))

(get-value (T_state_LSQ2_op_type))
(get-value (T_state_LSQ2_op))
(get-value (T_state_LSQ2_ROB_dst))
(get-value (T_state_LSQ2_vj))
(get-value (T_state_LSQ2_vk))
(get-value (T_state_LSQ2_qj))
(get-value (T_state_LSQ2_qk))
(get-value (T_state_LSQ2_imm))
(get-value (T_state_LSQ2_dis))
(get-value (T_state_LSQ2_busy))
(get-value (T_state_LSQ2_Ltag))

(get-value (T_state_LSQ3_op_type))
(get-value (T_state_LSQ3_op))
(get-value (T_state_LSQ3_ROB_dst))
(get-value (T_state_LSQ3_vj))
(get-value (T_state_LSQ3_vk))
(get-value (T_state_LSQ3_qj))
(get-value (T_state_LSQ3_qk))
(get-value (T_state_LSQ3_imm))
(get-value (T_state_LSQ3_dis))
(get-value (T_state_LSQ3_busy))
(get-value (T_state_LSQ3_Ltag))

(get-value (T_state_LSQ4_op_type))
(get-value (T_state_LSQ4_op))
(get-value (T_state_LSQ4_ROB_dst))
(get-value (T_state_LSQ4_vj))
(get-value (T_state_LSQ4_vk))
(get-value (T_state_LSQ4_qj))
(get-value (T_state_LSQ4_qk))
(get-value (T_state_LSQ4_imm))
(get-value (T_state_LSQ4_dis))
(get-value (T_state_LSQ4_busy))
(get-value (T_state_LSQ4_Ltag))

(get-value (T_state_LSQ5_op_type))
(get-value (T_state_LSQ5_op))
(get-value (T_state_LSQ5_ROB_dst))
(get-value (T_state_LSQ5_vj))
(get-value (T_state_LSQ5_vk))
(get-value (T_state_LSQ5_qj))
(get-value (T_state_LSQ5_qk))
(get-value (T_state_LSQ5_imm))
(get-value (T_state_LSQ5_dis))
(get-value (T_state_LSQ5_busy))
(get-value (T_state_LSQ5_Ltag))

(get-value (T_state_LSQ6_op_type))
(get-value (T_state_LSQ6_op))
(get-value (T_state_LSQ6_ROB_dst))
(get-value (T_state_LSQ6_vj))
(get-value (T_state_LSQ6_vk))
(get-value (T_state_LSQ6_qj))
(get-value (T_state_LSQ6_qk))
(get-value (T_state_LSQ6_imm))
(get-value (T_state_LSQ6_dis))
(get-value (T_state_LSQ6_busy))
(get-value (T_state_LSQ6_Ltag))

(get-value (T_state_LSQ7_op_type))
(get-value (T_state_LSQ7_op))
(get-value (T_state_LSQ7_ROB_dst))
(get-value (T_state_LSQ7_vj))
(get-value (T_state_LSQ7_vk))
(get-value (T_state_LSQ7_qj))
(get-value (T_state_LSQ7_qk))
(get-value (T_state_LSQ7_imm))
(get-value (T_state_LSQ7_dis))
(get-value (T_state_LSQ7_busy))
(get-value (T_state_LSQ7_Ltag))	

(get-value (U1_state_Cache0_Tag))
(get-value (U1_state_Cache0_Data))
(get-value (U1_state_Cache0_Valid))
(get-value (U1_state_Cache1_Tag))
(get-value (U1_state_Cache1_Data))
(get-value (U1_state_Cache1_Valid))
(get-value (U1_state_Cache2_Tag))
(get-value (U1_state_Cache2_Data))
(get-value (U1_state_Cache2_Valid))
(get-value (U1_state_Cache3_Tag))
(get-value (U1_state_Cache3_Data))
(get-value (U1_state_Cache3_Valid))

(get-value (U1_state_IP))
(get-value (U1_state_CP))
(get-value (U1_state_PC))
(get-value (U1_state_Main_Ltag))

(get-value (U1_state_ROB0_busy))
(get-value (U1_state_ROB0_op_type))
(get-value (U1_state_ROB0_destination))
(get-value (U1_state_ROB0_result))
(get-value (U1_state_ROB0_exception))
(get-value (U1_state_ROB0_done))

(get-value (U1_state_ROB1_busy))
(get-value (U1_state_ROB1_op_type))
(get-value (U1_state_ROB1_destination))
(get-value (U1_state_ROB1_result))
(get-value (U1_state_ROB1_exception))
(get-value (U1_state_ROB1_done))

(get-value (U1_state_ROB2_busy))
(get-value (U1_state_ROB2_op_type))
(get-value (U1_state_ROB2_destination))
(get-value (U1_state_ROB2_result))
(get-value (U1_state_ROB2_exception))
(get-value (U1_state_ROB2_done))

(get-value (U1_state_ROB3_busy))
(get-value (U1_state_ROB3_op_type))
(get-value (U1_state_ROB3_destination))
(get-value (U1_state_ROB3_result))
(get-value (U1_state_ROB3_exception))
(get-value (U1_state_ROB3_done))

(get-value (U1_state_ROB4_busy))
(get-value (U1_state_ROB4_op_type))
(get-value (U1_state_ROB4_destination))
(get-value (U1_state_ROB4_result))
(get-value (U1_state_ROB4_exception))
(get-value (U1_state_ROB4_done))

(get-value (U1_state_ROB5_busy))
(get-value (U1_state_ROB5_op_type))
(get-value (U1_state_ROB5_destination))
(get-value (U1_state_ROB5_result))
(get-value (U1_state_ROB5_exception))
(get-value (U1_state_ROB5_done))

(get-value (U1_state_ROB6_busy))
(get-value (U1_state_ROB6_op_type))
(get-value (U1_state_ROB6_destination))
(get-value (U1_state_ROB6_result))
(get-value (U1_state_ROB6_exception))
(get-value (U1_state_ROB6_done))

(get-value (U1_state_ROB7_busy))
(get-value (U1_state_ROB7_op_type))
(get-value (U1_state_ROB7_destination))
(get-value (U1_state_ROB7_result))
(get-value (U1_state_ROB7_exception))
(get-value (U1_state_ROB7_done))

(get-value (U1_state_RS0_op_type))
(get-value (U1_state_RS0_op))
(get-value (U1_state_RS0_ROB_dst))
(get-value (U1_state_RS0_vj))
(get-value (U1_state_RS0_vk))
(get-value (U1_state_RS0_qj))
(get-value (U1_state_RS0_qk))
(get-value (U1_state_RS0_imm))
(get-value (U1_state_RS0_dis))
(get-value (U1_state_RS0_busy))
(get-value (U1_state_RS0_Ltag))

(get-value (U1_state_RS1_op_type))
(get-value (U1_state_RS1_op))
(get-value (U1_state_RS1_ROB_dst))
(get-value (U1_state_RS1_vj))
(get-value (U1_state_RS1_vk))
(get-value (U1_state_RS1_qj))
(get-value (U1_state_RS1_qk))
(get-value (U1_state_RS1_imm))
(get-value (U1_state_RS1_dis))
(get-value (U1_state_RS1_busy))
(get-value (U1_state_RS1_Ltag))

(get-value (U1_state_RS2_op_type))
(get-value (U1_state_RS2_op))
(get-value (U1_state_RS2_ROB_dst))
(get-value (U1_state_RS2_vj))
(get-value (U1_state_RS2_vk))
(get-value (U1_state_RS2_qj))
(get-value (U1_state_RS2_qk))
(get-value (U1_state_RS2_imm))
(get-value (U1_state_RS2_dis))
(get-value (U1_state_RS2_busy))
(get-value (U1_state_RS2_Ltag))

(get-value (U1_state_RS3_op_type))
(get-value (U1_state_RS3_op))
(get-value (U1_state_RS3_ROB_dst))
(get-value (U1_state_RS3_vj))
(get-value (U1_state_RS3_vk))
(get-value (U1_state_RS3_qj))
(get-value (U1_state_RS3_qk))
(get-value (U1_state_RS3_imm))
(get-value (U1_state_RS3_dis))
(get-value (U1_state_RS3_busy))
(get-value (U1_state_RS3_Ltag))

(get-value (U1_state_RS4_op_type))
(get-value (U1_state_RS4_op))
(get-value (U1_state_RS4_ROB_dst))
(get-value (U1_state_RS4_vj))
(get-value (U1_state_RS4_vk))
(get-value (U1_state_RS4_qj))
(get-value (U1_state_RS4_qk))
(get-value (U1_state_RS4_imm))
(get-value (U1_state_RS4_dis))
(get-value (U1_state_RS4_busy))
(get-value (U1_state_RS4_Ltag))

(get-value (U1_state_RS5_op_type))
(get-value (U1_state_RS5_op))
(get-value (U1_state_RS5_ROB_dst))
(get-value (U1_state_RS5_vj))
(get-value (U1_state_RS5_vk))
(get-value (U1_state_RS5_qj))
(get-value (U1_state_RS5_qk))
(get-value (U1_state_RS5_imm))
(get-value (U1_state_RS5_dis))
(get-value (U1_state_RS5_busy))
(get-value (U1_state_RS5_Ltag))

(get-value (U1_state_RS6_op_type))
(get-value (U1_state_RS6_op))
(get-value (U1_state_RS6_ROB_dst))
(get-value (U1_state_RS6_vj))
(get-value (U1_state_RS6_vk))
(get-value (U1_state_RS6_qj))
(get-value (U1_state_RS6_qk))
(get-value (U1_state_RS6_imm))
(get-value (U1_state_RS6_dis))
(get-value (U1_state_RS6_busy))
(get-value (U1_state_RS6_Ltag))

(get-value (U1_state_RS7_op_type))
(get-value (U1_state_RS7_op))
(get-value (U1_state_RS7_ROB_dst))
(get-value (U1_state_RS7_vj))
(get-value (U1_state_RS7_vk))
(get-value (U1_state_RS7_qj))
(get-value (U1_state_RS7_qk))
(get-value (U1_state_RS7_imm))
(get-value (U1_state_RS7_dis))
(get-value (U1_state_RS7_busy))
(get-value (U1_state_RS7_Ltag))

(get-value (U1_state_LSQ0_op_type))
(get-value (U1_state_LSQ0_op))
(get-value (U1_state_LSQ0_ROB_dst))
(get-value (U1_state_LSQ0_vj))
(get-value (U1_state_LSQ0_vk))
(get-value (U1_state_LSQ0_qj))
(get-value (U1_state_LSQ0_qk))
(get-value (U1_state_LSQ0_imm))
(get-value (U1_state_LSQ0_dis))
(get-value (U1_state_LSQ0_busy))
(get-value (U1_state_LSQ0_Ltag))

(get-value (U1_state_LSQ1_op_type))
(get-value (U1_state_LSQ1_op))
(get-value (U1_state_LSQ1_ROB_dst))
(get-value (U1_state_LSQ1_vj))
(get-value (U1_state_LSQ1_vk))
(get-value (U1_state_LSQ1_qj))
(get-value (U1_state_LSQ1_qk))
(get-value (U1_state_LSQ1_imm))
(get-value (U1_state_LSQ1_dis))
(get-value (U1_state_LSQ1_busy))
(get-value (U1_state_LSQ1_Ltag))

(get-value (U1_state_LSQ2_op_type))
(get-value (U1_state_LSQ2_op))
(get-value (U1_state_LSQ2_ROB_dst))
(get-value (U1_state_LSQ2_vj))
(get-value (U1_state_LSQ2_vk))
(get-value (U1_state_LSQ2_qj))
(get-value (U1_state_LSQ2_qk))
(get-value (U1_state_LSQ2_imm))
(get-value (U1_state_LSQ2_dis))
(get-value (U1_state_LSQ2_busy))
(get-value (U1_state_LSQ2_Ltag))

(get-value (U1_state_LSQ3_op_type))
(get-value (U1_state_LSQ3_op))
(get-value (U1_state_LSQ3_ROB_dst))
(get-value (U1_state_LSQ3_vj))
(get-value (U1_state_LSQ3_vk))
(get-value (U1_state_LSQ3_qj))
(get-value (U1_state_LSQ3_qk))
(get-value (U1_state_LSQ3_imm))
(get-value (U1_state_LSQ3_dis))
(get-value (U1_state_LSQ3_busy))
(get-value (U1_state_LSQ3_Ltag))

(get-value (U1_state_LSQ4_op_type))
(get-value (U1_state_LSQ4_op))
(get-value (U1_state_LSQ4_ROB_dst))
(get-value (U1_state_LSQ4_vj))
(get-value (U1_state_LSQ4_vk))
(get-value (U1_state_LSQ4_qj))
(get-value (U1_state_LSQ4_qk))
(get-value (U1_state_LSQ4_imm))
(get-value (U1_state_LSQ4_dis))
(get-value (U1_state_LSQ4_busy))
(get-value (U1_state_LSQ4_Ltag))

(get-value (U1_state_LSQ5_op_type))
(get-value (U1_state_LSQ5_op))
(get-value (U1_state_LSQ5_ROB_dst))
(get-value (U1_state_LSQ5_vj))
(get-value (U1_state_LSQ5_vk))
(get-value (U1_state_LSQ5_qj))
(get-value (U1_state_LSQ5_qk))
(get-value (U1_state_LSQ5_imm))
(get-value (U1_state_LSQ5_dis))
(get-value (U1_state_LSQ5_busy))
(get-value (U1_state_LSQ5_Ltag))

(get-value (U1_state_LSQ6_op_type))
(get-value (U1_state_LSQ6_op))
(get-value (U1_state_LSQ6_ROB_dst))
(get-value (U1_state_LSQ6_vj))
(get-value (U1_state_LSQ6_vk))
(get-value (U1_state_LSQ6_qj))
(get-value (U1_state_LSQ6_qk))
(get-value (U1_state_LSQ6_imm))
(get-value (U1_state_LSQ6_dis))
(get-value (U1_state_LSQ6_busy))
(get-value (U1_state_LSQ6_Ltag))

(get-value (U1_state_LSQ7_op_type))
(get-value (U1_state_LSQ7_op))
(get-value (U1_state_LSQ7_ROB_dst))
(get-value (U1_state_LSQ7_vj))
(get-value (U1_state_LSQ7_vk))
(get-value (U1_state_LSQ7_qj))
(get-value (U1_state_LSQ7_qk))
(get-value (U1_state_LSQ7_imm))
(get-value (U1_state_LSQ7_dis))
(get-value (U1_state_LSQ7_busy))
(get-value (U1_state_LSQ7_Ltag))	

(get-value (U2_state_Cache0_Tag))
(get-value (U2_state_Cache0_Data))
(get-value (U2_state_Cache0_Valid))
(get-value (U2_state_Cache1_Tag))
(get-value (U2_state_Cache1_Data))
(get-value (U2_state_Cache1_Valid))
(get-value (U2_state_Cache2_Tag))
(get-value (U2_state_Cache2_Data))
(get-value (U2_state_Cache2_Valid))
(get-value (U2_state_Cache3_Tag))
(get-value (U2_state_Cache3_Data))
(get-value (U2_state_Cache3_Valid))

(get-value (U2_state_IP))
(get-value (U2_state_CP))
(get-value (U2_state_PC))
(get-value (U2_state_Main_Ltag))

(get-value (U2_state_ROB0_busy))
(get-value (U2_state_ROB0_op_type))
(get-value (U2_state_ROB0_destination))
(get-value (U2_state_ROB0_result))
(get-value (U2_state_ROB0_exception))
(get-value (U2_state_ROB0_done))

(get-value (U2_state_ROB1_busy))
(get-value (U2_state_ROB1_op_type))
(get-value (U2_state_ROB1_destination))
(get-value (U2_state_ROB1_result))
(get-value (U2_state_ROB1_exception))
(get-value (U2_state_ROB1_done))

(get-value (U2_state_ROB2_busy))
(get-value (U2_state_ROB2_op_type))
(get-value (U2_state_ROB2_destination))
(get-value (U2_state_ROB2_result))
(get-value (U2_state_ROB2_exception))
(get-value (U2_state_ROB2_done))

(get-value (U2_state_ROB3_busy))
(get-value (U2_state_ROB3_op_type))
(get-value (U2_state_ROB3_destination))
(get-value (U2_state_ROB3_result))
(get-value (U2_state_ROB3_exception))
(get-value (U2_state_ROB3_done))

(get-value (U2_state_ROB4_busy))
(get-value (U2_state_ROB4_op_type))
(get-value (U2_state_ROB4_destination))
(get-value (U2_state_ROB4_result))
(get-value (U2_state_ROB4_exception))
(get-value (U2_state_ROB4_done))

(get-value (U2_state_ROB5_busy))
(get-value (U2_state_ROB5_op_type))
(get-value (U2_state_ROB5_destination))
(get-value (U2_state_ROB5_result))
(get-value (U2_state_ROB5_exception))
(get-value (U2_state_ROB5_done))

(get-value (U2_state_ROB6_busy))
(get-value (U2_state_ROB6_op_type))
(get-value (U2_state_ROB6_destination))
(get-value (U2_state_ROB6_result))
(get-value (U2_state_ROB6_exception))
(get-value (U2_state_ROB6_done))

(get-value (U2_state_ROB7_busy))
(get-value (U2_state_ROB7_op_type))
(get-value (U2_state_ROB7_destination))
(get-value (U2_state_ROB7_result))
(get-value (U2_state_ROB7_exception))
(get-value (U2_state_ROB7_done))

(get-value (U2_state_RS0_op_type))
(get-value (U2_state_RS0_op))
(get-value (U2_state_RS0_ROB_dst))
(get-value (U2_state_RS0_vj))
(get-value (U2_state_RS0_vk))
(get-value (U2_state_RS0_qj))
(get-value (U2_state_RS0_qk))
(get-value (U2_state_RS0_imm))
(get-value (U2_state_RS0_dis))
(get-value (U2_state_RS0_busy))
(get-value (U2_state_RS0_Ltag))

(get-value (U2_state_RS1_op_type))
(get-value (U2_state_RS1_op))
(get-value (U2_state_RS1_ROB_dst))
(get-value (U2_state_RS1_vj))
(get-value (U2_state_RS1_vk))
(get-value (U2_state_RS1_qj))
(get-value (U2_state_RS1_qk))
(get-value (U2_state_RS1_imm))
(get-value (U2_state_RS1_dis))
(get-value (U2_state_RS1_busy))
(get-value (U2_state_RS1_Ltag))

(get-value (U2_state_RS2_op_type))
(get-value (U2_state_RS2_op))
(get-value (U2_state_RS2_ROB_dst))
(get-value (U2_state_RS2_vj))
(get-value (U2_state_RS2_vk))
(get-value (U2_state_RS2_qj))
(get-value (U2_state_RS2_qk))
(get-value (U2_state_RS2_imm))
(get-value (U2_state_RS2_dis))
(get-value (U2_state_RS2_busy))
(get-value (U2_state_RS2_Ltag))

(get-value (U2_state_RS3_op_type))
(get-value (U2_state_RS3_op))
(get-value (U2_state_RS3_ROB_dst))
(get-value (U2_state_RS3_vj))
(get-value (U2_state_RS3_vk))
(get-value (U2_state_RS3_qj))
(get-value (U2_state_RS3_qk))
(get-value (U2_state_RS3_imm))
(get-value (U2_state_RS3_dis))
(get-value (U2_state_RS3_busy))
(get-value (U2_state_RS3_Ltag))

(get-value (U2_state_RS4_op_type))
(get-value (U2_state_RS4_op))
(get-value (U2_state_RS4_ROB_dst))
(get-value (U2_state_RS4_vj))
(get-value (U2_state_RS4_vk))
(get-value (U2_state_RS4_qj))
(get-value (U2_state_RS4_qk))
(get-value (U2_state_RS4_imm))
(get-value (U2_state_RS4_dis))
(get-value (U2_state_RS4_busy))
(get-value (U2_state_RS4_Ltag))

(get-value (U2_state_RS5_op_type))
(get-value (U2_state_RS5_op))
(get-value (U2_state_RS5_ROB_dst))
(get-value (U2_state_RS5_vj))
(get-value (U2_state_RS5_vk))
(get-value (U2_state_RS5_qj))
(get-value (U2_state_RS5_qk))
(get-value (U2_state_RS5_imm))
(get-value (U2_state_RS5_dis))
(get-value (U2_state_RS5_busy))
(get-value (U2_state_RS5_Ltag))

(get-value (U2_state_RS6_op_type))
(get-value (U2_state_RS6_op))
(get-value (U2_state_RS6_ROB_dst))
(get-value (U2_state_RS6_vj))
(get-value (U2_state_RS6_vk))
(get-value (U2_state_RS6_qj))
(get-value (U2_state_RS6_qk))
(get-value (U2_state_RS6_imm))
(get-value (U2_state_RS6_dis))
(get-value (U2_state_RS6_busy))
(get-value (U2_state_RS6_Ltag))

(get-value (U2_state_RS7_op_type))
(get-value (U2_state_RS7_op))
(get-value (U2_state_RS7_ROB_dst))
(get-value (U2_state_RS7_vj))
(get-value (U2_state_RS7_vk))
(get-value (U2_state_RS7_qj))
(get-value (U2_state_RS7_qk))
(get-value (U2_state_RS7_imm))
(get-value (U2_state_RS7_dis))
(get-value (U2_state_RS7_busy))
(get-value (U2_state_RS7_Ltag))

(get-value (U2_state_LSQ0_op_type))
(get-value (U2_state_LSQ0_op))
(get-value (U2_state_LSQ0_ROB_dst))
(get-value (U2_state_LSQ0_vj))
(get-value (U2_state_LSQ0_vk))
(get-value (U2_state_LSQ0_qj))
(get-value (U2_state_LSQ0_qk))
(get-value (U2_state_LSQ0_imm))
(get-value (U2_state_LSQ0_dis))
(get-value (U2_state_LSQ0_busy))
(get-value (U2_state_LSQ0_Ltag))

(get-value (U2_state_LSQ1_op_type))
(get-value (U2_state_LSQ1_op))
(get-value (U2_state_LSQ1_ROB_dst))
(get-value (U2_state_LSQ1_vj))
(get-value (U2_state_LSQ1_vk))
(get-value (U2_state_LSQ1_qj))
(get-value (U2_state_LSQ1_qk))
(get-value (U2_state_LSQ1_imm))
(get-value (U2_state_LSQ1_dis))
(get-value (U2_state_LSQ1_busy))
(get-value (U2_state_LSQ1_Ltag))

(get-value (U2_state_LSQ2_op_type))
(get-value (U2_state_LSQ2_op))
(get-value (U2_state_LSQ2_ROB_dst))
(get-value (U2_state_LSQ2_vj))
(get-value (U2_state_LSQ2_vk))
(get-value (U2_state_LSQ2_qj))
(get-value (U2_state_LSQ2_qk))
(get-value (U2_state_LSQ2_imm))
(get-value (U2_state_LSQ2_dis))
(get-value (U2_state_LSQ2_busy))
(get-value (U2_state_LSQ2_Ltag))

(get-value (U2_state_LSQ3_op_type))
(get-value (U2_state_LSQ3_op))
(get-value (U2_state_LSQ3_ROB_dst))
(get-value (U2_state_LSQ3_vj))
(get-value (U2_state_LSQ3_vk))
(get-value (U2_state_LSQ3_qj))
(get-value (U2_state_LSQ3_qk))
(get-value (U2_state_LSQ3_imm))
(get-value (U2_state_LSQ3_dis))
(get-value (U2_state_LSQ3_busy))
(get-value (U2_state_LSQ3_Ltag))

(get-value (U2_state_LSQ4_op_type))
(get-value (U2_state_LSQ4_op))
(get-value (U2_state_LSQ4_ROB_dst))
(get-value (U2_state_LSQ4_vj))
(get-value (U2_state_LSQ4_vk))
(get-value (U2_state_LSQ4_qj))
(get-value (U2_state_LSQ4_qk))
(get-value (U2_state_LSQ4_imm))
(get-value (U2_state_LSQ4_dis))
(get-value (U2_state_LSQ4_busy))
(get-value (U2_state_LSQ4_Ltag))

(get-value (U2_state_LSQ5_op_type))
(get-value (U2_state_LSQ5_op))
(get-value (U2_state_LSQ5_ROB_dst))
(get-value (U2_state_LSQ5_vj))
(get-value (U2_state_LSQ5_vk))
(get-value (U2_state_LSQ5_qj))
(get-value (U2_state_LSQ5_qk))
(get-value (U2_state_LSQ5_imm))
(get-value (U2_state_LSQ5_dis))
(get-value (U2_state_LSQ5_busy))
(get-value (U2_state_LSQ5_Ltag))

(get-value (U2_state_LSQ6_op_type))
(get-value (U2_state_LSQ6_op))
(get-value (U2_state_LSQ6_ROB_dst))
(get-value (U2_state_LSQ6_vj))
(get-value (U2_state_LSQ6_vk))
(get-value (U2_state_LSQ6_qj))
(get-value (U2_state_LSQ6_qk))
(get-value (U2_state_LSQ6_imm))
(get-value (U2_state_LSQ6_dis))
(get-value (U2_state_LSQ6_busy))
(get-value (U2_state_LSQ6_Ltag))

(get-value (U2_state_LSQ7_op_type))
(get-value (U2_state_LSQ7_op))
(get-value (U2_state_LSQ7_ROB_dst))
(get-value (U2_state_LSQ7_vj))
(get-value (U2_state_LSQ7_vk))
(get-value (U2_state_LSQ7_qj))
(get-value (U2_state_LSQ7_qk))
(get-value (U2_state_LSQ7_imm))
(get-value (U2_state_LSQ7_dis))
(get-value (U2_state_LSQ7_busy))
(get-value (U2_state_LSQ7_Ltag))	

(get-value (U3_state_Cache0_Tag))
(get-value (U3_state_Cache0_Data))
(get-value (U3_state_Cache0_Valid))
(get-value (U3_state_Cache1_Tag))
(get-value (U3_state_Cache1_Data))
(get-value (U3_state_Cache1_Valid))
(get-value (U3_state_Cache2_Tag))
(get-value (U3_state_Cache2_Data))
(get-value (U3_state_Cache2_Valid))
(get-value (U3_state_Cache3_Tag))
(get-value (U3_state_Cache3_Data))
(get-value (U3_state_Cache3_Valid))

(get-value (U3_state_IP))
(get-value (U3_state_CP))
(get-value (U3_state_PC))
(get-value (U3_state_Main_Ltag))

(get-value (U3_state_ROB0_busy))
(get-value (U3_state_ROB0_op_type))
(get-value (U3_state_ROB0_destination))
(get-value (U3_state_ROB0_result))
(get-value (U3_state_ROB0_exception))
(get-value (U3_state_ROB0_done))

(get-value (U3_state_ROB1_busy))
(get-value (U3_state_ROB1_op_type))
(get-value (U3_state_ROB1_destination))
(get-value (U3_state_ROB1_result))
(get-value (U3_state_ROB1_exception))
(get-value (U3_state_ROB1_done))

(get-value (U3_state_ROB2_busy))
(get-value (U3_state_ROB2_op_type))
(get-value (U3_state_ROB2_destination))
(get-value (U3_state_ROB2_result))
(get-value (U3_state_ROB2_exception))
(get-value (U3_state_ROB2_done))

(get-value (U3_state_ROB3_busy))
(get-value (U3_state_ROB3_op_type))
(get-value (U3_state_ROB3_destination))
(get-value (U3_state_ROB3_result))
(get-value (U3_state_ROB3_exception))
(get-value (U3_state_ROB3_done))

(get-value (U3_state_ROB4_busy))
(get-value (U3_state_ROB4_op_type))
(get-value (U3_state_ROB4_destination))
(get-value (U3_state_ROB4_result))
(get-value (U3_state_ROB4_exception))
(get-value (U3_state_ROB4_done))

(get-value (U3_state_ROB5_busy))
(get-value (U3_state_ROB5_op_type))
(get-value (U3_state_ROB5_destination))
(get-value (U3_state_ROB5_result))
(get-value (U3_state_ROB5_exception))
(get-value (U3_state_ROB5_done))

(get-value (U3_state_ROB6_busy))
(get-value (U3_state_ROB6_op_type))
(get-value (U3_state_ROB6_destination))
(get-value (U3_state_ROB6_result))
(get-value (U3_state_ROB6_exception))
(get-value (U3_state_ROB6_done))

(get-value (U3_state_ROB7_busy))
(get-value (U3_state_ROB7_op_type))
(get-value (U3_state_ROB7_destination))
(get-value (U3_state_ROB7_result))
(get-value (U3_state_ROB7_exception))
(get-value (U3_state_ROB7_done))

(get-value (U3_state_RS0_op_type))
(get-value (U3_state_RS0_op))
(get-value (U3_state_RS0_ROB_dst))
(get-value (U3_state_RS0_vj))
(get-value (U3_state_RS0_vk))
(get-value (U3_state_RS0_qj))
(get-value (U3_state_RS0_qk))
(get-value (U3_state_RS0_imm))
(get-value (U3_state_RS0_dis))
(get-value (U3_state_RS0_busy))
(get-value (U3_state_RS0_Ltag))

(get-value (U3_state_RS1_op_type))
(get-value (U3_state_RS1_op))
(get-value (U3_state_RS1_ROB_dst))
(get-value (U3_state_RS1_vj))
(get-value (U3_state_RS1_vk))
(get-value (U3_state_RS1_qj))
(get-value (U3_state_RS1_qk))
(get-value (U3_state_RS1_imm))
(get-value (U3_state_RS1_dis))
(get-value (U3_state_RS1_busy))
(get-value (U3_state_RS1_Ltag))

(get-value (U3_state_RS2_op_type))
(get-value (U3_state_RS2_op))
(get-value (U3_state_RS2_ROB_dst))
(get-value (U3_state_RS2_vj))
(get-value (U3_state_RS2_vk))
(get-value (U3_state_RS2_qj))
(get-value (U3_state_RS2_qk))
(get-value (U3_state_RS2_imm))
(get-value (U3_state_RS2_dis))
(get-value (U3_state_RS2_busy))
(get-value (U3_state_RS2_Ltag))

(get-value (U3_state_RS3_op_type))
(get-value (U3_state_RS3_op))
(get-value (U3_state_RS3_ROB_dst))
(get-value (U3_state_RS3_vj))
(get-value (U3_state_RS3_vk))
(get-value (U3_state_RS3_qj))
(get-value (U3_state_RS3_qk))
(get-value (U3_state_RS3_imm))
(get-value (U3_state_RS3_dis))
(get-value (U3_state_RS3_busy))
(get-value (U3_state_RS3_Ltag))

(get-value (U3_state_RS4_op_type))
(get-value (U3_state_RS4_op))
(get-value (U3_state_RS4_ROB_dst))
(get-value (U3_state_RS4_vj))
(get-value (U3_state_RS4_vk))
(get-value (U3_state_RS4_qj))
(get-value (U3_state_RS4_qk))
(get-value (U3_state_RS4_imm))
(get-value (U3_state_RS4_dis))
(get-value (U3_state_RS4_busy))
(get-value (U3_state_RS4_Ltag))

(get-value (U3_state_RS5_op_type))
(get-value (U3_state_RS5_op))
(get-value (U3_state_RS5_ROB_dst))
(get-value (U3_state_RS5_vj))
(get-value (U3_state_RS5_vk))
(get-value (U3_state_RS5_qj))
(get-value (U3_state_RS5_qk))
(get-value (U3_state_RS5_imm))
(get-value (U3_state_RS5_dis))
(get-value (U3_state_RS5_busy))
(get-value (U3_state_RS5_Ltag))

(get-value (U3_state_RS6_op_type))
(get-value (U3_state_RS6_op))
(get-value (U3_state_RS6_ROB_dst))
(get-value (U3_state_RS6_vj))
(get-value (U3_state_RS6_vk))
(get-value (U3_state_RS6_qj))
(get-value (U3_state_RS6_qk))
(get-value (U3_state_RS6_imm))
(get-value (U3_state_RS6_dis))
(get-value (U3_state_RS6_busy))
(get-value (U3_state_RS6_Ltag))

(get-value (U3_state_RS7_op_type))
(get-value (U3_state_RS7_op))
(get-value (U3_state_RS7_ROB_dst))
(get-value (U3_state_RS7_vj))
(get-value (U3_state_RS7_vk))
(get-value (U3_state_RS7_qj))
(get-value (U3_state_RS7_qk))
(get-value (U3_state_RS7_imm))
(get-value (U3_state_RS7_dis))
(get-value (U3_state_RS7_busy))
(get-value (U3_state_RS7_Ltag))

(get-value (U3_state_LSQ0_op_type))
(get-value (U3_state_LSQ0_op))
(get-value (U3_state_LSQ0_ROB_dst))
(get-value (U3_state_LSQ0_vj))
(get-value (U3_state_LSQ0_vk))
(get-value (U3_state_LSQ0_qj))
(get-value (U3_state_LSQ0_qk))
(get-value (U3_state_LSQ0_imm))
(get-value (U3_state_LSQ0_dis))
(get-value (U3_state_LSQ0_busy))
(get-value (U3_state_LSQ0_Ltag))

(get-value (U3_state_LSQ1_op_type))
(get-value (U3_state_LSQ1_op))
(get-value (U3_state_LSQ1_ROB_dst))
(get-value (U3_state_LSQ1_vj))
(get-value (U3_state_LSQ1_vk))
(get-value (U3_state_LSQ1_qj))
(get-value (U3_state_LSQ1_qk))
(get-value (U3_state_LSQ1_imm))
(get-value (U3_state_LSQ1_dis))
(get-value (U3_state_LSQ1_busy))
(get-value (U3_state_LSQ1_Ltag))

(get-value (U3_state_LSQ2_op_type))
(get-value (U3_state_LSQ2_op))
(get-value (U3_state_LSQ2_ROB_dst))
(get-value (U3_state_LSQ2_vj))
(get-value (U3_state_LSQ2_vk))
(get-value (U3_state_LSQ2_qj))
(get-value (U3_state_LSQ2_qk))
(get-value (U3_state_LSQ2_imm))
(get-value (U3_state_LSQ2_dis))
(get-value (U3_state_LSQ2_busy))
(get-value (U3_state_LSQ2_Ltag))

(get-value (U3_state_LSQ3_op_type))
(get-value (U3_state_LSQ3_op))
(get-value (U3_state_LSQ3_ROB_dst))
(get-value (U3_state_LSQ3_vj))
(get-value (U3_state_LSQ3_vk))
(get-value (U3_state_LSQ3_qj))
(get-value (U3_state_LSQ3_qk))
(get-value (U3_state_LSQ3_imm))
(get-value (U3_state_LSQ3_dis))
(get-value (U3_state_LSQ3_busy))
(get-value (U3_state_LSQ3_Ltag))

(get-value (U3_state_LSQ4_op_type))
(get-value (U3_state_LSQ4_op))
(get-value (U3_state_LSQ4_ROB_dst))
(get-value (U3_state_LSQ4_vj))
(get-value (U3_state_LSQ4_vk))
(get-value (U3_state_LSQ4_qj))
(get-value (U3_state_LSQ4_qk))
(get-value (U3_state_LSQ4_imm))
(get-value (U3_state_LSQ4_dis))
(get-value (U3_state_LSQ4_busy))
(get-value (U3_state_LSQ4_Ltag))

(get-value (U3_state_LSQ5_op_type))
(get-value (U3_state_LSQ5_op))
(get-value (U3_state_LSQ5_ROB_dst))
(get-value (U3_state_LSQ5_vj))
(get-value (U3_state_LSQ5_vk))
(get-value (U3_state_LSQ5_qj))
(get-value (U3_state_LSQ5_qk))
(get-value (U3_state_LSQ5_imm))
(get-value (U3_state_LSQ5_dis))
(get-value (U3_state_LSQ5_busy))
(get-value (U3_state_LSQ5_Ltag))

(get-value (U3_state_LSQ6_op_type))
(get-value (U3_state_LSQ6_op))
(get-value (U3_state_LSQ6_ROB_dst))
(get-value (U3_state_LSQ6_vj))
(get-value (U3_state_LSQ6_vk))
(get-value (U3_state_LSQ6_qj))
(get-value (U3_state_LSQ6_qk))
(get-value (U3_state_LSQ6_imm))
(get-value (U3_state_LSQ6_dis))
(get-value (U3_state_LSQ6_busy))
(get-value (U3_state_LSQ6_Ltag))

(get-value (U3_state_LSQ7_op_type))
(get-value (U3_state_LSQ7_op))
(get-value (U3_state_LSQ7_ROB_dst))
(get-value (U3_state_LSQ7_vj))
(get-value (U3_state_LSQ7_vk))
(get-value (U3_state_LSQ7_qj))
(get-value (U3_state_LSQ7_qk))
(get-value (U3_state_LSQ7_imm))
(get-value (U3_state_LSQ7_dis))
(get-value (U3_state_LSQ7_busy))
(get-value (U3_state_LSQ7_Ltag))		

(get-value (U4_state_Cache0_Tag))
(get-value (U4_state_Cache0_Data))
(get-value (U4_state_Cache0_Valid))
(get-value (U4_state_Cache1_Tag))
(get-value (U4_state_Cache1_Data))
(get-value (U4_state_Cache1_Valid))
(get-value (U4_state_Cache2_Tag))
(get-value (U4_state_Cache2_Data))
(get-value (U4_state_Cache2_Valid))
(get-value (U4_state_Cache3_Tag))
(get-value (U4_state_Cache3_Data))
(get-value (U4_state_Cache3_Valid))

(get-value (U4_state_IP))
(get-value (U4_state_CP))
(get-value (U4_state_PC))
(get-value (U4_state_Main_Ltag))

(get-value (U4_state_ROB0_busy))
(get-value (U4_state_ROB0_op_type))
(get-value (U4_state_ROB0_destination))
(get-value (U4_state_ROB0_result))
(get-value (U4_state_ROB0_exception))
(get-value (U4_state_ROB0_done))

(get-value (U4_state_ROB1_busy))
(get-value (U4_state_ROB1_op_type))
(get-value (U4_state_ROB1_destination))
(get-value (U4_state_ROB1_result))
(get-value (U4_state_ROB1_exception))
(get-value (U4_state_ROB1_done))

(get-value (U4_state_ROB2_busy))
(get-value (U4_state_ROB2_op_type))
(get-value (U4_state_ROB2_destination))
(get-value (U4_state_ROB2_result))
(get-value (U4_state_ROB2_exception))
(get-value (U4_state_ROB2_done))

(get-value (U4_state_ROB3_busy))
(get-value (U4_state_ROB3_op_type))
(get-value (U4_state_ROB3_destination))
(get-value (U4_state_ROB3_result))
(get-value (U4_state_ROB3_exception))
(get-value (U4_state_ROB3_done))

(get-value (U4_state_ROB4_busy))
(get-value (U4_state_ROB4_op_type))
(get-value (U4_state_ROB4_destination))
(get-value (U4_state_ROB4_result))
(get-value (U4_state_ROB4_exception))
(get-value (U4_state_ROB4_done))

(get-value (U4_state_ROB5_busy))
(get-value (U4_state_ROB5_op_type))
(get-value (U4_state_ROB5_destination))
(get-value (U4_state_ROB5_result))
(get-value (U4_state_ROB5_exception))
(get-value (U4_state_ROB5_done))

(get-value (U4_state_ROB6_busy))
(get-value (U4_state_ROB6_op_type))
(get-value (U4_state_ROB6_destination))
(get-value (U4_state_ROB6_result))
(get-value (U4_state_ROB6_exception))
(get-value (U4_state_ROB6_done))

(get-value (U4_state_ROB7_busy))
(get-value (U4_state_ROB7_op_type))
(get-value (U4_state_ROB7_destination))
(get-value (U4_state_ROB7_result))
(get-value (U4_state_ROB7_exception))
(get-value (U4_state_ROB7_done))

(get-value (U4_state_RS0_op_type))
(get-value (U4_state_RS0_op))
(get-value (U4_state_RS0_ROB_dst))
(get-value (U4_state_RS0_vj))
(get-value (U4_state_RS0_vk))
(get-value (U4_state_RS0_qj))
(get-value (U4_state_RS0_qk))
(get-value (U4_state_RS0_imm))
(get-value (U4_state_RS0_dis))
(get-value (U4_state_RS0_busy))
(get-value (U4_state_RS0_Ltag))

(get-value (U4_state_RS1_op_type))
(get-value (U4_state_RS1_op))
(get-value (U4_state_RS1_ROB_dst))
(get-value (U4_state_RS1_vj))
(get-value (U4_state_RS1_vk))
(get-value (U4_state_RS1_qj))
(get-value (U4_state_RS1_qk))
(get-value (U4_state_RS1_imm))
(get-value (U4_state_RS1_dis))
(get-value (U4_state_RS1_busy))
(get-value (U4_state_RS1_Ltag))

(get-value (U4_state_RS2_op_type))
(get-value (U4_state_RS2_op))
(get-value (U4_state_RS2_ROB_dst))
(get-value (U4_state_RS2_vj))
(get-value (U4_state_RS2_vk))
(get-value (U4_state_RS2_qj))
(get-value (U4_state_RS2_qk))
(get-value (U4_state_RS2_imm))
(get-value (U4_state_RS2_dis))
(get-value (U4_state_RS2_busy))
(get-value (U4_state_RS2_Ltag))

(get-value (U4_state_RS3_op_type))
(get-value (U4_state_RS3_op))
(get-value (U4_state_RS3_ROB_dst))
(get-value (U4_state_RS3_vj))
(get-value (U4_state_RS3_vk))
(get-value (U4_state_RS3_qj))
(get-value (U4_state_RS3_qk))
(get-value (U4_state_RS3_imm))
(get-value (U4_state_RS3_dis))
(get-value (U4_state_RS3_busy))
(get-value (U4_state_RS3_Ltag))

(get-value (U4_state_RS4_op_type))
(get-value (U4_state_RS4_op))
(get-value (U4_state_RS4_ROB_dst))
(get-value (U4_state_RS4_vj))
(get-value (U4_state_RS4_vk))
(get-value (U4_state_RS4_qj))
(get-value (U4_state_RS4_qk))
(get-value (U4_state_RS4_imm))
(get-value (U4_state_RS4_dis))
(get-value (U4_state_RS4_busy))
(get-value (U4_state_RS4_Ltag))

(get-value (U4_state_RS5_op_type))
(get-value (U4_state_RS5_op))
(get-value (U4_state_RS5_ROB_dst))
(get-value (U4_state_RS5_vj))
(get-value (U4_state_RS5_vk))
(get-value (U4_state_RS5_qj))
(get-value (U4_state_RS5_qk))
(get-value (U4_state_RS5_imm))
(get-value (U4_state_RS5_dis))
(get-value (U4_state_RS5_busy))
(get-value (U4_state_RS5_Ltag))

(get-value (U4_state_RS6_op_type))
(get-value (U4_state_RS6_op))
(get-value (U4_state_RS6_ROB_dst))
(get-value (U4_state_RS6_vj))
(get-value (U4_state_RS6_vk))
(get-value (U4_state_RS6_qj))
(get-value (U4_state_RS6_qk))
(get-value (U4_state_RS6_imm))
(get-value (U4_state_RS6_dis))
(get-value (U4_state_RS6_busy))
(get-value (U4_state_RS6_Ltag))

(get-value (U4_state_RS7_op_type))
(get-value (U4_state_RS7_op))
(get-value (U4_state_RS7_ROB_dst))
(get-value (U4_state_RS7_vj))
(get-value (U4_state_RS7_vk))
(get-value (U4_state_RS7_qj))
(get-value (U4_state_RS7_qk))
(get-value (U4_state_RS7_imm))
(get-value (U4_state_RS7_dis))
(get-value (U4_state_RS7_busy))
(get-value (U4_state_RS7_Ltag))

(get-value (U4_state_LSQ0_op_type))
(get-value (U4_state_LSQ0_op))
(get-value (U4_state_LSQ0_ROB_dst))
(get-value (U4_state_LSQ0_vj))
(get-value (U4_state_LSQ0_vk))
(get-value (U4_state_LSQ0_qj))
(get-value (U4_state_LSQ0_qk))
(get-value (U4_state_LSQ0_imm))
(get-value (U4_state_LSQ0_dis))
(get-value (U4_state_LSQ0_busy))
(get-value (U4_state_LSQ0_Ltag))

(get-value (U4_state_LSQ1_op_type))
(get-value (U4_state_LSQ1_op))
(get-value (U4_state_LSQ1_ROB_dst))
(get-value (U4_state_LSQ1_vj))
(get-value (U4_state_LSQ1_vk))
(get-value (U4_state_LSQ1_qj))
(get-value (U4_state_LSQ1_qk))
(get-value (U4_state_LSQ1_imm))
(get-value (U4_state_LSQ1_dis))
(get-value (U4_state_LSQ1_busy))
(get-value (U4_state_LSQ1_Ltag))

(get-value (U4_state_LSQ2_op_type))
(get-value (U4_state_LSQ2_op))
(get-value (U4_state_LSQ2_ROB_dst))
(get-value (U4_state_LSQ2_vj))
(get-value (U4_state_LSQ2_vk))
(get-value (U4_state_LSQ2_qj))
(get-value (U4_state_LSQ2_qk))
(get-value (U4_state_LSQ2_imm))
(get-value (U4_state_LSQ2_dis))
(get-value (U4_state_LSQ2_busy))
(get-value (U4_state_LSQ2_Ltag))

(get-value (U4_state_LSQ3_op_type))
(get-value (U4_state_LSQ3_op))
(get-value (U4_state_LSQ3_ROB_dst))
(get-value (U4_state_LSQ3_vj))
(get-value (U4_state_LSQ3_vk))
(get-value (U4_state_LSQ3_qj))
(get-value (U4_state_LSQ3_qk))
(get-value (U4_state_LSQ3_imm))
(get-value (U4_state_LSQ3_dis))
(get-value (U4_state_LSQ3_busy))
(get-value (U4_state_LSQ3_Ltag))

(get-value (U4_state_LSQ4_op_type))
(get-value (U4_state_LSQ4_op))
(get-value (U4_state_LSQ4_ROB_dst))
(get-value (U4_state_LSQ4_vj))
(get-value (U4_state_LSQ4_vk))
(get-value (U4_state_LSQ4_qj))
(get-value (U4_state_LSQ4_qk))
(get-value (U4_state_LSQ4_imm))
(get-value (U4_state_LSQ4_dis))
(get-value (U4_state_LSQ4_busy))
(get-value (U4_state_LSQ4_Ltag))

(get-value (U4_state_LSQ5_op_type))
(get-value (U4_state_LSQ5_op))
(get-value (U4_state_LSQ5_ROB_dst))
(get-value (U4_state_LSQ5_vj))
(get-value (U4_state_LSQ5_vk))
(get-value (U4_state_LSQ5_qj))
(get-value (U4_state_LSQ5_qk))
(get-value (U4_state_LSQ5_imm))
(get-value (U4_state_LSQ5_dis))
(get-value (U4_state_LSQ5_busy))
(get-value (U4_state_LSQ5_Ltag))

(get-value (U4_state_LSQ6_op_type))
(get-value (U4_state_LSQ6_op))
(get-value (U4_state_LSQ6_ROB_dst))
(get-value (U4_state_LSQ6_vj))
(get-value (U4_state_LSQ6_vk))
(get-value (U4_state_LSQ6_qj))
(get-value (U4_state_LSQ6_qk))
(get-value (U4_state_LSQ6_imm))
(get-value (U4_state_LSQ6_dis))
(get-value (U4_state_LSQ6_busy))
(get-value (U4_state_LSQ6_Ltag))

(get-value (U4_state_LSQ7_op_type))
(get-value (U4_state_LSQ7_op))
(get-value (U4_state_LSQ7_ROB_dst))
(get-value (U4_state_LSQ7_vj))
(get-value (U4_state_LSQ7_vk))
(get-value (U4_state_LSQ7_qj))
(get-value (U4_state_LSQ7_qk))
(get-value (U4_state_LSQ7_imm))
(get-value (U4_state_LSQ7_dis))
(get-value (U4_state_LSQ7_busy))
(get-value (U4_state_LSQ7_Ltag))	

;)
			